sub HeaderTopMacro
{
	$_ .= << "EndOfText";
// 03.05.03 Fukushiro M. 1_xZkqqHx_iNhDiNoNiPjM_xHqqkZx_ ()
//#include <map>					// For map template.
#include "UtilErr.h"			// For FFMessageBox.
#include "MatrixControl.h"		// For CFCMatrixControl.
#include "ControlFDATmpl.h"		// For CFCControlFDATmpl.
#include "MultiControlTmpl.h"	// Super class.

typedef auto_ptr<FC${name}Rec>	${name}Auto;
typedef map<DWORD, ${name}Auto>	IdTo${name}Map;
EndOfText
} # HeaderTopMacro.

sub HeaderInnMacro
{
	$_ .= << "EndOfText";
// _xZkqqHx_iDiGiBfLiDfFiKnGjAjEiBeC_xHqqkZx_
public:
	virtual void	AppendRec ($type{$name} $pref{$type{$name}}, const FC${name}Rec& rec);
	virtual void	SetIdOrder (DWORD $pref{$type{$name}}Sz, const $type{$name} $pref{$type{$name}}\[\]);
	virtual void	GetIdOrder (FD$type{$name}Vector& v$pref{$type{$name}}) const;
	virtual const FC${name}Rec*	GetRec ($type{$name} $pref{$type{$name}}) const;
	virtual const wchar_t*	GetName (DWORD dwData) const;
	virtual BOOL	CanDeleteItem () const;
	virtual $type{$name}	FindRec (const FC${name}Rec& rec) const;
	virtual void	InsertItemRec ($type{$name}& $pref{$type{$name}}New, long& lIndexNew,
									const FC${name}Rec& rec, long lIndex = -1);

protected:
	virtual BOOL	OnInsertItem (long lIndex, DWORD dwId);
	virtual BOOL	OnChangeItem (long lIndex, DWORD dwId);
	virtual BOOL	OnDeleteItem (long lIndex, DWORD dwId);
	virtual long	GetFrontFixedItemSize () const;
	virtual	void	DrawItem (long lIndex, DWORD dwData, CRect* rIndex, CDC* pDC);
// 06.11.11 Fukushiro M. 1_xZkqqHx_iNhDjFmPiNfI_xHqqkZx_ ()
//	virtual	void	ItemSize (long& lW, long& lH, long lFrW, long lFrH) const;
	virtual	void	ItemSize (long& lW, long& lH) const;

// _xZkqqHx_iDiGiBfLiDfFjFmPjAjEiBeC_xHqqkZx_
protected:
	IdTo${name}Map	m_mpIdToRec;

EndOfText
} # HeaderInnMacro.

sub CppTopFuncMacro
{
	$l_name = &PFLowerToUpper($name);

	$_ .= << "EndOfText";

//----- 01.03.28 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
///*************************************************************************
// * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	${class}::${class}
// *
// * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDfCiDjDiDfIiDgHiDiJiDeOiDfOiBeC_xHqqkZx_
// *
// * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	01.03.07 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
// *************************************************************************/
//${class}::${class} ()
//{
//} // ${class}::${class}.
//
///*************************************************************************
// * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	${class}::~${class}
// *
// * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDgGiDfIiDgHiDiJiDeOiDfOiBeC_xHqqkZx_
// *
// * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	01.03.07 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
// *************************************************************************/
//${class}::~${class} ()
//{
//} // ${class}::~${class}.
//----- 01.03.28 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----

/////////////////////////////////////////////////////////////////////////////
// _xZkqqHx_iDiGiBfLiDfFiKnGjAjE_xHqqkZx_

EndOfText

	if ($not_use eq '')
	{
		$not_use = "IDS_NOT_USE";
	}
	$_ .= << "EndOfText";
/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	${class}::AppendRec
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iOhHjCoIiCmMiDiMiDfCiBfLiDgIiCmMiDfCiDhDiBfLiCpAjCmHiJmBiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	$pref{$type{$name}}	:_xZkqqHx_iDiMiDfCiBfLiDgI_xHqqkZx_ID_xZkqqHx_iCpAiOhHjCoIiBeC_xHqqkZx_
 *			rec		:_xZkqqHx_iDiMiDfCiBfLiDgIiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	01.03.07 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void ${class}::AppendRec ($type{$name} $pref{$type{$name}}, const FC${name}Rec& rec)
{
	m_mpIdToRec[$pref{$type{$name}}] = ${name}Auto(new FC${name}Rec(rec));
} // ${class}::AppendRec.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	${class}::SetIdOrder
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDiMiDfCiBfLiDgIiCmMjFfMiOkGiPiHiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	$pref{$type{$name}}Sz	:$pref{$type{$name}}_xZkqqHx_iCmMjEhKjHpBiDfEiDeDiDfJiCpAiOhHjCoIiBeC_xHqqkZx_
 *			$pref{$type{$name}}	:_xZkqqHx_iDiMiDfCiBfLiDgIiCmMiPiHjEnEiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	01.03.07 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void ${class}::SetIdOrder (DWORD $pref{$type{$name}}Sz, const $type{$name} $pref{$type{$name}}\[\])
{
	// _xZkqqHx_jBfDiCmEiCmMiDeBiDeDiDgFiDiAiCpAiNoNiPjMiBgJiDiMiDfCiBfLiDgIiCmNiNoNiPjMiClFiCmIiCkCiBgKiBeC_xHqqkZx_
	DeleteAllItems();
	// "_xZkqqHx_iOgHjHhAiClFiCmIiCkC_xHqqkZx_"_xZkqqHx_iCpAjAnNjCoIiBeC_xHqqkZx_
	AddItem(FD_${l_name}_UNUSE);
	for (DWORD dwC = 0; dwC != $pref{$type{$name}}Sz; dwC++)
		AddItem($pref{$type{$name}}\[dwC\]);
// 06.11.11 Fukushiro M. 1_xZkqqHx_iNhDjFmPiNfI_xHqqkZx_ ()
//	UpdateItemSize();
	UpdateScrollSize(TRUE);
} // ${class}::SetIdOrder.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	${class}::GetIdOrder
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDiMiDfCiBfLiDgIiCmMjFfMiOkGiPiHiCpAjFnEiClHiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	v$pref{$type{$name}}	:$pref{$type{$name}}_xZkqqHx_iCmMjFfMiOkGiPiHjEhKjHpBiCpAjFnEiClHiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	01.03.08 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void ${class}::GetIdOrder (FD$type{$name}Vector& v$pref{$type{$name}}) const
{
	v$pref{$type{$name}}.clear();
	for (long lIndex = 1; lIndex < GetItemCount(); lIndex++)
	{
		v$pref{$type{$name}}.push_back(GetItemData(lIndex));
	}
} // ${class}::GetIdOrder.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	${class}::GetRec
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iOhHjCoIiCmM_xHqqkZx_ID_xZkqqHx_iCmMiDiMiDfCiBfLiDgIiCpAjFnEiClHiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	$pref{$type{$name}}	:ID_xZkqqHx_iCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jFnEjCgM_xHqqkZx_>	_xZkqqHx_iDiMiDfCiBfLiDgIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	01.03.07 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
const FC${name}Rec* ${class}::GetRec ($type{$name} $pref{$type{$name}}) const
{
	return (*m_mpIdToRec.find($pref{$type{$name}})).second.get();
} // ${class}::GetRec.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	${class}::GetName
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iOhHjCoIiCmM_xHqqkZx_ID_xZkqqHx_iCmMiDiMiDfCiBfLiDgIiCmMjGlMjBePiCpAjFnEiClHiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	dwData	:_xZkqqHx_iDiMiDfCiBfLiDgI_xHqqkZx_ID_xZkqqHx_iCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jFnEjCgM_xHqqkZx_>	_xZkqqHx_jGlMjBePiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	01.03.07 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
const wchar_t* ${class}::GetName (DWORD dwData) const
{
	if (dwData != FD_${l_name}_UNUSE)
	//----- _xZkqqHx_iOgHjHhAiClFiCmIiCkC_xHqqkZx_ _xZkqqHx_iImIiKePiCmMiPoKiNiH_xHqqkZx_ -----
	{
		return GetRec(dwData)->m_szName;
	} else
	//----- _xZkqqHx_iOgHjHhAiClFiCmIiCkC_xHqqkZx_ _xZkqqHx_iCmMiPoKiNiH_xHqqkZx_ -----
	{
		// "_xZkqqHx_iOgHjHhAiClFiCmIiCkC_xHqqkZx_"_xZkqqHx_iCpAjFnEiClHiBeC_xHqqkZx_
		return GetResWString(${not_use});
	}
} // ${class}::GetName.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	${class}::CanDeleteItem
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iMlLiNnNiCmMiPpDjBnEiCmFiBeBiDeBiDeDiDgFiDiAiCpAiNoNiPjMiCmFiCkLiCoJiCkJiCmHiCkEiCkJiCpAjClCiCnHiCmEjFnEiClHiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jFnEjCgM_xHqqkZx_>	_xZkqqHx_iNoNiPjMiCmFiCkLiCoJiPoKiNiHiCmN_xHqqkZx_ TRUE_xZkqqHx_iBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	01.03.08 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
BOOL ${class}::CanDeleteItem () const
{
	if (!BASE_CLASS::CanDeleteItem()) return FALSE;
	//----- _xZkqqHx_jBeJjBpAiDeBiDeDiDgFiDiAiCmMiDiMiDfCiBfLiDgIiCkKiBeBjFjEjFgJiBeFiKmCiLkLjCiGiCmFiOgHiCoNiCoKiCmEiCkCiCmIiCkCiCkJiDgAiDeGiDgCiDeO_xHqqkZx_ -----
	for (long lIndex = 0; lIndex < GetItemCount(); lIndex++)
	{
		if (IsSelectionMark(lIndex))
		{
			$type{$name} $pref{$type{$name}} = GetItemData(lIndex);
			if (!g_pDoc->CanDelete${name}($pref{$type{$name}})) return FALSE;
		}
	}
	return TRUE;
} // ${class}::CanDeleteItem.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	${class}::FindRec
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iOhHjCoIiCmMiDiMiDfCiBfLiDgIiCpAiMjPiNpFiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	rec	:_xZkqqHx_iDiMiDfCiBfLiDgIiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jFnEjCgM_xHqqkZx_>	_xZkqqHx_iDiMiDfCiBfLiDgI_xHqqkZx_ID_xZkqqHx_iBeCjGkCjDgPjIfOiCmMiPoKiNiHiCmNiBeB_xHqqkZx_FD_${l_name}_UNSPECIFY_xZkqqHx_iBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	01.03.28 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
$type{$name} ${class}::FindRec (const FC${name}Rec& rec) const
{
	//----- _xZkqqHx_iKpJiCmJjDgPjIfOiClDiCoKiCmEiCkCiCoJiDiMiDfCiBfLiDgIiCpAiMjPiNpF_xHqqkZx_ -----
	IdTo${name}Map::const_iterator iMp;
	for (iMp = m_mpIdToRec.begin(); iMp != m_mpIdToRec.end(); iMp++)
		if (*(*iMp).second.get() == rec) return (*iMp).first;
	return FD_${l_name}_UNSPECIFY;
} // ${class}::FindRec.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	${class}::InsertItemRec
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDeBiDeDiDgFiDiAiCpAiBeBiDiMiDfCiBfLiDgIiClCiCmGjBhNjDpMiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	$pref{$type{$name}}New	:_xZkqqHx_jBhNjDpMiMoDiCmMiDiMiDfCiBfLiDgIiCmM_xHqqkZx_ID_xZkqqHx_iCpAjFnEiClHiBeC_xHqqkZx_
 *			lIndexNew			:_xZkqqHx_jBhNjDpMiMoDiCmMiDeBiDeDiDgFiDiAiCmMiDeDiDjDiDgGiDgCiDeOiDfIiCpAjFnEiClHiBeC_xHqqkZx_
 *			rec					:_xZkqqHx_jBhNjDpMiClHiCoJiDiMiDfCiBfLiDgIiCpAiOhHjCoIiBeC_xHqqkZx_
 *			lIndex				:_xZkqqHx_jBhNjDpMiImKjChFiCpAiOhHjCoIiBeC_xHqqkZx_-1_xZkqqHx_iCpAiOhHjCoIiClHiCoJiCmGiBeBiNmFiMoDiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	01.03.28 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void ${class}::InsertItemRec ($type{$name}& $pref{$type{$name}}New, long& lIndexNew,
									const FC${name}Rec& rec, long lIndex)
{
	//----- _xZkqqHx_iKpJiCmJjDgPjIfOiClDiCoKiCmEiCkCiCoJiDiMiDfCiBfLiDgIiCpAiMjPiNpF_xHqqkZx_ -----
	if (FindRec(rec) != FD_${l_name}_UNSPECIFY)
	{
		// "_xZkqqHx_jDkPiClGiDeBiDeDiDgFiDiAiCkKjDgPjIfOiNmPiCnNiCmFiClHiBeCjDgPjIfOiClFiCnMiClHiCkJiBeI_xHqqkZx_"
		if (FFMessageBox(IDS_MSG_IS_REGISTER_SAME, 0, MB_YESNOCANCEL) != IDYES)
			return;
	}
	lIndexNew = lIndex;
	if (lIndexNew < 0)
		lIndexNew = GetItemCount();
	if (lIndexNew < GetFrontFixedItemSize())
		lIndexNew = GetFrontFixedItemSize();
	if (GetItemCount() - GetBackFixedItemSize() < lIndexNew)
		lIndexNew = GetItemCount() - GetBackFixedItemSize();
	// _xZkqqHx_jAfGiClFiCkC_xHqqkZx_ID_xZkqqHx_iCpAiOoGjDlOiBeC_xHqqkZx_
	$pref{$type{$name}}New = GetNextFreeId();
	// _xZkqqHx_iDiMiDfCiBfLiDgIiCpAjAnNjCoIiBeC_xHqqkZx_
	AppendRec($pref{$type{$name}}New, rec);
	// _xZkqqHx_iDeBiDeDiDgFiDiAiCpAjBhNjDpMiBeC_xHqqkZx_
	InsertItem(lIndexNew, $pref{$type{$name}}New);
	// _xZkqqHx_jAfGiLeLjBhNjDpMiDeBiDeDiDgFiDiAiPfHiNiHiCmJjCmHiJmBiBeC_xHqqkZx_
	AddInsertedId($pref{$type{$name}}New);
} // ${class}::InsertItemRec.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	${class}::OnInsertItem
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDiBiDgKiDiFiBfLiBhFiDeBiDeDiDgFiDiAiCmMjBhNjDpMiBhGiCmMiOjOiCmJiOmAiNhDiClDiCoKiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	lIndex	:_xZkqqHx_jBhNjDpMiImKjChFiCmMiDeDiDjDiDgGiDgCiDeOiDfIiCpAiOhHjCoIiBeC_xHqqkZx_
 *			dwId	:_xZkqqHx_jBhNjDpMiClDiCoKiCoJiDeBiDeDiDgFiDiAiCmM_xHqqkZx_ID_xZkqqHx_iCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jFnEjCgM_xHqqkZx_>	_xZkqqHx_jBhNjDpMiDeBiDeDiDgFiDiAiCkKiNoMjAkMiCmFiCkLiClNiPoKiNiHiCmN_xHqqkZx_ TRUE_xZkqqHx_iBeBiPgPjHiIiCmIiCkCiPoKiNiHiCmN_xHqqkZx_ FALSE_xZkqqHx_iBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	01.03.06 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
BOOL ${class}::OnInsertItem (long lIndex, DWORD dwId)
{
	CFCDlg${name}Modify dlg;
	if (dlg.DoModal() != IDOK) return FALSE;
	//----- _xZkqqHx_iKpJiCmJjDgPjIfOiClDiCoKiCmEiCkCiCoJiDiMiDfCiBfLiDgIiCpAiMjPiNpF_xHqqkZx_ -----
	if (FindRec(dlg.Get${name}Rec()) != FD_${l_name}_UNSPECIFY)
	{
		// "_xZkqqHx_jDkPiClGiDeBiDeDiDgFiDiAiCkKjDgPjIfOiNmPiCnNiCmFiClHiBeCjDgPjIfOiClFiCnMiClHiCkJiBeI_xHqqkZx_"
		if (FFMessageBox(IDS_MSG_IS_REGISTER_SAME, 0, MB_YESNOCANCEL) != IDYES)
			return FALSE;
	}
	m_mpIdToRec[dwId] = ${name}Auto(new FC${name}Rec(dlg.Get${name}Rec()));
	return TRUE;
} // ${class}::OnInsertItem.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	${class}::OnChangeItem
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDiBiDgKiDiFiBfLiBhFiDeBiDeDiDgFiDiAiCmMjFmPiNfIiBhGiCmMiOjOiCmJiOmAiNhDiClDiCoKiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	lIndex	:_xZkqqHx_iDeBiDeDiDgFiDiAiCmMiDeDiDjDiDgGiDgCiDeOiDfIiCpAiOhHjCoIiBeC_xHqqkZx_
 *			dwId	:_xZkqqHx_iDeBiDeDiDgFiDiAiCmM_xHqqkZx_ID_xZkqqHx_iCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jFnEjCgM_xHqqkZx_>	_xZkqqHx_iDeBiDeDiDgFiDiAiCkKjFmPiNfIiCmFiCkLiClNiPoKiNiHiCmN_xHqqkZx_ TRUE_xZkqqHx_iBeBiPgPjHiIiCmIiCkCiPoKiNiHiCmN_xHqqkZx_ FALSE_xZkqqHx_iBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	01.03.06 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
BOOL ${class}::OnChangeItem (long lIndex, DWORD dwId)
{
	if (dwId == FD_${l_name}_UNSPECIFY || dwId == FD_${l_name}_UNUSE)
		return FALSE;
	CFCDlg${name}Modify dlg;
	dlg.Set${name}Rec(*GetRec(dwId));
	if (dlg.DoModal() != IDOK) return FALSE;
	*m_mpIdToRec[dwId].get() = dlg.Get${name}Rec();
	return TRUE;
} // ${class}::OnChangeItem.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	${class}::OnDeleteItem
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDiBiDgKiDiFiBfLiBhFiDeBiDeDiDgFiDiAiCmMiNoNiPjMiBhGiCmMiOjOiCmJiOmAiNhDiClDiCoKiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	lIndex	:_xZkqqHx_iDeBiDeDiDgFiDiAiCmMiDeDiDjDiDgGiDgCiDeOiDfIiCpAiOhHjCoIiBeC_xHqqkZx_
 *			dwId	:_xZkqqHx_iDeBiDeDiDgFiDiAiCmM_xHqqkZx_ID_xZkqqHx_iCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jFnEjCgM_xHqqkZx_>	_xZkqqHx_iDeBiDeDiDgFiDiAiCkKiNoNiPjMiCmFiCkLiClNiPoKiNiHiCmN_xHqqkZx_ TRUE_xZkqqHx_iBeBiPgPjHiIiCmIiCkCiPoKiNiHiCmN_xHqqkZx_ FALSE_xZkqqHx_iBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	01.03.06 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
BOOL ${class}::OnDeleteItem (long lIndex, DWORD dwId)
{
	if (dwId == FD_${l_name}_UNSPECIFY || dwId == FD_${l_name}_UNUSE)
		return FALSE;
	m_mpIdToRec.erase(dwId);
	return TRUE;
} // ${class}::OnDeleteItem.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	${class}::GetFrontFixedItemSize
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDeBiDeDiDgFiDiAiCmMjFmAiCnBiCmMjBePjFpLiCmMiCkEiClPiBeBiNoNiPjMiBeFiInKjDkOiCkKiCmFiCkLiCmIiCkCiMmFjCoIiDeBiDeDiDgFiDiA_xHqqkZx_
 *			_xZkqqHx_iCmMjAjEiCpAjFnEiClHiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jFnEjCgM_xHqqkZx_>	_xZkqqHx_iDeBiDeDiDgFiDiAjAjEiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	01.03.09 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
long ${class}::GetFrontFixedItemSize () const
{
	return ${FrontFixed};
} // ${class}::GetFrontFixedItemSize.

EndOfText

} # CppTopFuncMacro.

1;

