// TolBrFont.cpp : _xZkqqHx_iDeDiDjDiDhGiDiKiDiBiDjDiDgFiBfLiDfGiDiHiDjD_xHqqkZx_ _xZkqqHx_iDhEiDeAiDeDiDiL_xHqqkZx_
//

#include "stdafx.h"
#include <float.h>			// For DBL_MAX.
#include "DynamicDraw.h"
#include "RegData.h"		// For g_pReg.
#include "DynamicDrawView.h"// For g_pView.
#include "UtilWin.h"		// For FFAddString.
#include "UtilMath.h"		// For dbpt2str.
#include "UtilCoord.h"		// For mm2pnt.
#include "WndRichEdit.h"	// For GetRTFEditor.
#include "FrameWnd.h"		// For FFGetMainWnd().
#include "ToolBase.h"		// For GetCurrentTool().
#include "TolBrFont.h"		// This header.

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// _xZkqqHx_iDhLiDgCiDeOiDfIiCmMjFjNiBeC_xHqqkZx_
static const int s_nBoxWidth = 150;
// _xZkqqHx_iDgIiDiNiDgCiDhGiDfPiDeFiDjDiCmMjFjNiBeC_xHqqkZx_
static const int s_nDroppedWidth = 250;
// _xZkqqHx_iDgIiDiNiDgCiDhGiDfPiDeFiDjDiCmMiNiCiClDiBeC_xHqqkZx_
static const int s_nDroppedHeight = 500;

static const dblpnt s_dbptSizeList[] =
{
	7.0,
	8.0,
	9.0,
	10.0,
	10.5,
	11.0,
	12.0,
	14.0,
	16.0,
	18.0,
	20.0,
	22.0,
	24.0,
	26.0,
	28.0,
	36.0,
	48.0,
	72.0,
};

/////////////////////////////////////////////////////////////////////////////
// CFCTolBrFont

CFCTolBrFont::CFCTolBrFont ()
{
} // CFCTolBrFont::CFCTolBrFont.

CFCTolBrFont::~CFCTolBrFont ()
{
} // CFCTolBrFont::~CFCTolBrFont.

/////////////////////////////////////////////////////////////////////////////
// CFCTolBrFont _xZkqqHx_iDiGiBfLiDfFiKnGjAjEiBeC_xHqqkZx_

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	CFCTolBrFont::Initialize
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDgDiBfLiDiLiDgPiBfLiCpAiPiJiKpKiJlLiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jFnEjCgM_xHqqkZx_>	_xZkqqHx_jAlDiPoNiPeJjHlJiCmMiPoKiNiHiCmN_xHqqkZx_ TRUE_xZkqqHx_iBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.06.29 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
BOOL CFCTolBrFont::Initialize ()
{
	// Baseclass_xZkqqHx_iKnGjAjEiOmAiNhDiBeC_xHqqkZx_
	if (!BASE_CLASS::Initialize()) return FALSE;

	// _xZkqqHx_iJpMiNhDiDeMiBfLiCmG_xHqqkZx_ESC_xZkqqHx_iDeMiBfLiCpAiOoGjDlOiCmFiCkLiCoJiCoGiCkEiCmJiClHiCoJiBeC_xHqqkZx_
	m_cmbBothFontSize.AddKey(VK_RETURN);
	m_cmbBothFontSize.AddKey(VK_ESCAPE);
	// _xZkqqHx_jAjEjCgMiCpAiIlFiCkEiOhHjCoIiCmJiClHiCoJiBeC_xHqqkZx_
	m_cmbBothFontSize.SetIsNumber(TRUE);

	// _xZkqqHx_jEpBjFfHiPiAiCmMiDhEiDeIiDjDiDgHiCpAiOoGjDlOiBeC_xHqqkZx_
	FTFontCharSetMap mpExtCodeFontMap;	// [_xZkqqHx_iJhAiMoKiDhEiDeIiDjDiDgHjGlM_xHqqkZx_ -> _xZkqqHx_iOoNjHnOiDiKiDfIiDgH_xHqqkZx_]_xZkqqHx_iCmMiDiKiDfIiDgHiBeC_xHqqkZx_
	FFCollectFontName(&mpExtCodeFontMap, NULL);

	//----- _xZkqqHx_jEpBjFfHiPiAiDhEiDeIiDjDiDgHiCmMiDiKiDfIiDgHiCpAiDfCiDjDiDgHiDiNiBfLiDiLiCmJjAnNjCoI_xHqqkZx_ -----
	FTFontCharSetMap::iterator iAn;
	for (iAn = mpExtCodeFontMap.begin(); iAn != mpExtCodeFontMap.end(); iAn++)
		FFAddString(&m_cmbBothFontName ,(*iAn).first);

	wchar_t wcsBufff[100];
	long lC;
	for (lC = 0; lC != sizeof(s_dbptSizeList) / sizeof(s_dbptSizeList[0]); lC++)
		FFAddString(&m_cmbBothFontSize, dbpt2str(wcsBufff, s_dbptSizeList[lC]));

	m_cbbBothFontColor.UpdateItem();

//----- 06.10.04 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
////----- 05.07.03 Fukushiro M. _xZkqqHx_jCmHiJmBiOgO_xHqqkZx_ ()-----
//	// _xZkqqHx_iMlLiNnNiCmMiDhEiDeIiDjDiDgHiPoOjFpBiCpAiPiJiKpKiJlLiBeC_xHqqkZx_
//	memset(&m_fciBothFontInfo, 0, sizeof(m_fciBothFontInfo));
////----- 05.07.03 Fukushiro M. _xZkqqHx_jCmHiJmBiPeJ_xHqqkZx_ ()-----
//----- 06.10.04 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----

//----- 05.07.03 Fukushiro M. _xZkqqHx_jCmHiJmBiOgO_xHqqkZx_ ()-----
	// _xZkqqHx_iDgDiBfLiDiLiDgPiBfLiCmMiDhLiDfOiDjDiCpAiJjPiClFiClNiDiBiDgCiDfKiBfLiDfHiCkKiBeBiDgDiBfLiDiLiDgPiBfLiCmJiNhDiCkNiCoGiCkEiCmJiDeJiBfLiDgJiBfLiCpAjFmPiNfIiBeC_xHqqkZx_
	GetToolBarCtrl().SetOwner(this);
//----- 05.07.03 Fukushiro M. _xZkqqHx_jCmHiJmBiPeJ_xHqqkZx_ ()-----

	// _xZkqqHx_jAlDiPoNiPeJjHlJiBeC_xHqqkZx_
	return TRUE;
} // CFCTolBrFont::Initialize.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	CFCTolBrFont::GetCmbButtonInfo
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDfCiDjDiDhLiDhLiDgCiDeOiDfIiDhLiDfOiDjDiCmMiPoOjFpBiCpAjFnEiClHiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	lIndex	:_xZkqqHx_iPoOjFpBiCmMiDeDiDjDiDgGiDgCiDeOiDfIiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jFnEjCgM_xHqqkZx_>	_xZkqqHx_iDfCiDjDiDhLiDhLiDgCiDeOiDfIiDhLiDfOiDjDiCmMiPoOjFpBiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iJpAjAoA_xHqqkZx_>	_xZkqqHx_iClBiCoKiImIiPoDiDhLiDfOiDjDiCmMiPoOjFpBiCkKjGlDiCkCiPoKiNiHiCmNiBeB_xHqqkZx_FCCmbButtonInfo::pCmb = NULL
 *			_xZkqqHx_iCmMiPoOjFpBiCpAjFnEiClHiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.06.29 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
const CFCTolBrBase::FCCmbButtonInfo& CFCTolBrFont::GetCmbButtonInfo (long lIndex)
{
	static FCCmbButtonInfo s_info[] =
	{
		{	&m_cmbBothFontName,					// _xZkqqHx_iDfCiDjDiDhLiDhLiDgCiDeOiDfIjFmPjAjEiBeC_xHqqkZx_
			ID_CMB_BOTH_CODE_FONT_NAME,			// _xZkqqHx_iDfCiDjDiDhLiDhLiDgCiDeOiDfIiCmM_xHqqkZx_ID_xZkqqHx_iBeC_xHqqkZx_
			CBS_DROPDOWNLIST|CBS_SORT,			// _xZkqqHx_iDfCiDjDiDhLiDhLiDgCiDeOiDfIiCmMjCmHiJmBiDfIiDfOiDeDiDiLiBeC_xHqqkZx_WS_VISIBLE|WS_VSCROLL|WS_TABSTOP _xZkqqHx_iCmNjFfHiPiAiBeC_xHqqkZx_
			s_nBoxWidth,						// _xZkqqHx_iDfCiDjDiDhLiDhLiDgCiDeOiDfIiCmMjFjNiBeC_xHqqkZx_
			s_nDroppedWidth,					// _xZkqqHx_iDgIiDiNiDgCiDhGiDfPiDeFiDjDiCmMjFjNiBeC_xHqqkZx_
			s_nDroppedHeight },					// _xZkqqHx_iDgIiDiNiDgCiDhGiDfPiDeFiDjDiCmMiNiCiClDiBeC_xHqqkZx_

		{	&m_cmbBothFontSize,					// _xZkqqHx_iDfCiDjDiDhLiDhLiDgCiDeOiDfIjFmPjAjEiBeC_xHqqkZx_
			ID_CMB_BOTH_CODE_FONT_SIZE,			// _xZkqqHx_iDfCiDjDiDhLiDhLiDgCiDeOiDfIiCmM_xHqqkZx_ID_xZkqqHx_iBeC_xHqqkZx_
			CBS_DROPDOWN|CBS_AUTOHSCROLL,		// _xZkqqHx_iDfCiDjDiDhLiDhLiDgCiDeOiDfIiCmMjCmHiJmBiDfIiDfOiDeDiDiLiBeC_xHqqkZx_WS_VISIBLE|WS_VSCROLL|WS_TABSTOP _xZkqqHx_iCmNjFfHiPiAiBeC_xHqqkZx_
			70,									// _xZkqqHx_iDfCiDjDiDhLiDhLiDgCiDeOiDfIiCmMjFjNiBeC_xHqqkZx_
			70,									// _xZkqqHx_iDgIiDiNiDgCiDhGiDfPiDeFiDjDiCmMjFjNiBeC_xHqqkZx_
			s_nDroppedHeight },					// _xZkqqHx_iDgIiDiNiDgCiDhGiDfPiDeFiDjDiCmMiNiCiClDiBeC_xHqqkZx_

		{	&m_cbbBothFontColor,				// _xZkqqHx_iDfCiDjDiDhLiDhLiDgCiDeOiDfIjFmPjAjEiBeC_xHqqkZx_
			ID_CMB_BOTH_CODE_FONT_COLOR,		// _xZkqqHx_iDfCiDjDiDhLiDhLiDgCiDeOiDfIiCmM_xHqqkZx_ID_xZkqqHx_iBeC_xHqqkZx_
			CBS_DROPDOWNLIST|CBS_OWNERDRAWFIXED,// _xZkqqHx_iDfCiDjDiDhLiDhLiDgCiDeOiDfIiCmMjCmHiJmBiDfIiDfOiDeDiDiLiBeC_xHqqkZx_WS_VISIBLE|WS_VSCROLL|WS_TABSTOP _xZkqqHx_iCmNjFfHiPiAiBeC_xHqqkZx_
			58,									// _xZkqqHx_iDfCiDjDiDhLiDhLiDgCiDeOiDfIiCmMjFjNiBeC_xHqqkZx_
			250,								// _xZkqqHx_iDgIiDiNiDgCiDhGiDfPiDeFiDjDiCmMjFjNiBeC_xHqqkZx_
			500 },								// _xZkqqHx_iDgIiDiNiDgCiDhGiDfPiDeFiDjDiCmMiNiCiClDiBeC_xHqqkZx_

		{	NULL,								// _xZkqqHx_iDfCiDjDiDhLiDhLiDgCiDeOiDfIjFmPjAjEiBeC_xHqqkZx_
			0,									// _xZkqqHx_iDfCiDjDiDhLiDhLiDgCiDeOiDfIiCmM_xHqqkZx_ID_xZkqqHx_iBeC_xHqqkZx_
			0,									// _xZkqqHx_iDfCiDjDiDhLiDhLiDgCiDeOiDfIiCmMjCmHiJmBiDfIiDfOiDeDiDiLiBeC_xHqqkZx_WS_VISIBLE|WS_VSCROLL|WS_TABSTOP _xZkqqHx_iCmNjFfHiPiAiBeC_xHqqkZx_
			0,									// _xZkqqHx_iDfCiDjDiDhLiDhLiDgCiDeOiDfIiCmMjFjNiBeC_xHqqkZx_
			0,									// _xZkqqHx_iDgIiDiNiDgCiDhGiDfPiDeFiDjDiCmMjFjNiBeC_xHqqkZx_
			0 },								// _xZkqqHx_iDgIiDiNiDgCiDhGiDfPiDeFiDjDiCmMiNiCiClDiBeC_xHqqkZx_
	};
	return s_info[lIndex];
} // CFCTolBrFont::GetCmbButtonInfo.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	CFCTolBrFont::UpdateCmbFont
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDhEiDeIiDjDiDgHiCmJiKnGiClHiCoJiDfCiDjDiDgHiDiNiBfLiDiLiCpAiNfIjAfGiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.07.02 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void CFCTolBrFont::UpdateCmbFont ()
{
//----- 06.10.04 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
//	// _xZkqqHx_iMlLiNnNiCmMiDhEiDeIiDjDiDgHiPoOjFpBiCpAiOoGjDlOiBeC_xHqqkZx_
//	FCFontCharInfo fciStdFontInfo;	// _xZkqqHx_iMlLiNnNiCmMjFfHiPiAiDhEiDeIiDjDiDgHiBeC_xHqqkZx_
//	FCFontCharInfo fciExtFontInfo;	// _xZkqqHx_iMlLiNnNiCmMjFfHiPiAiKePiDhEiDeIiDjDiDgHiBeC_xHqqkZx_
//	if (g_pView->GetCurrentTool()->GetCurrentTextFont(fciExtFontInfo, fciStdFontInfo))
//	{
//		m_fciBothFontInfo = fciStdFontInfo;
//		m_fciBothFontInfo &= fciExtFontInfo;
//	} else
//	{
//		// _xZkqqHx_iMlLiNnNiCmMiDhEiDeIiDjDiDgHiPoOjFpBiCpAiPiJiKpKiJlLiBeC_xHqqkZx_
//		memset(&m_fciBothFontInfo, 0, sizeof(m_fciBothFontInfo));
//	}
//----- 06.10.04 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----

	// _xZkqqHx_iDhEiDeIiDjDiDgHjGlMiBeC_xHqqkZx_
//----- 06.10.04 Fukushiro M. _xZkqqHx_jFmPiNfIjBeP_xHqqkZx_ ()-----
//	WString wstrFontName;
//	if ((m_fciBothFontInfo.dwMask & FDFI_FLAG_FACENAME) == FDFI_FLAG_FACENAME)
//		wstrFontName = m_fciBothFontInfo.szFaceName;
//----- 06.10.04 Fukushiro M. _xZkqqHx_jFmPiNfIiMoD_xHqqkZx_ ()-----
	WString wstrFontName = g_pView->GetCurrentTextBothFontName();
//----- 06.10.04 Fukushiro M. _xZkqqHx_jFmPiNfIiPeJ_xHqqkZx_ ()-----

	// _xZkqqHx_iDhEiDeIiDjDiDgHiDfEiDeDiDfJiBeC_xHqqkZx_
//----- 06.10.04 Fukushiro M. _xZkqqHx_jFmPiNfIjBeP_xHqqkZx_ ()-----
//	mmetol mmFontSize = DBL_MAX;
//	if ((m_fciBothFontInfo.dwMask & FDFI_FLAG_HEIGHT) == FDFI_FLAG_HEIGHT)
//		mmFontSize = m_fciBothFontInfo.mmHeight;
//----- 06.10.04 Fukushiro M. _xZkqqHx_jFmPiNfIiMoD_xHqqkZx_ ()-----
	mmetol mmFontSize = g_pView->GetCurrentTextBothFontSize();
//----- 06.10.04 Fukushiro M. _xZkqqHx_jFmPiNfIiPeJ_xHqqkZx_ ()-----

	// _xZkqqHx_iDhEiDeIiDjDiDgHiDeKiDiJiBfLiBeC_xHqqkZx_
//----- 06.10.04 Fukushiro M. _xZkqqHx_jFmPiNfIjBeP_xHqqkZx_ ()-----
//	COLORREF colorRef = FD_COLOR_REF_UNSPECIFY;
//	if ((m_fciBothFontInfo.dwMask & FDFI_FLAG_COLORREF) == FDFI_FLAG_COLORREF)
//		colorRef = m_fciBothFontInfo.crColor;
//----- 06.10.04 Fukushiro M. _xZkqqHx_jFmPiNfIiMoD_xHqqkZx_ ()-----
	COLORREF colorRef = g_pView->GetCurrentTextBothFontColor();
//----- 06.10.04 Fukushiro M. _xZkqqHx_jFmPiNfIiPeJ_xHqqkZx_ ()-----

	// _xZkqqHx_iDiKiDfIiDgHiCkJiCoHjDkPiClGiDhEiDeIiDjDiDgHjGlMiCmMiDeDiDjDiDgGiDgCiDeOiDfIiCpAjCfEiClHiBeC_xHqqkZx_
	int iIndex = m_cmbBothFontName.FindStringExact(-1, WStrToTStr(wstrFontName));
	m_cmbBothFontName.SetCurSel(iIndex);

	if (mmFontSize == DBL_MAX)
	{
		FFSetWindowText(&m_cmbBothFontSize, L"");
	} else
	{
		dblpnt dbptFontSize = mm2pnt(mmFontSize);
		wchar_t wcsBufff[100];
		FFSetWindowText(&m_cmbBothFontSize, dbpt2str(wcsBufff, dbptFontSize));
	}
	m_cbbBothFontColor.SetCurColorRef(colorRef);
} // CFCTolBrFont::UpdateCmbFont.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	CFCTolBrFont::OnObjSelectChanged
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_jFjEjFgJiCmMjBeJjBpAiCkKjFmPiNfIiClDiCoKiClNiOjOiCmJiOmAiNhDiClDiCoKiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.07.02 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void CFCTolBrFont::OnObjSelectChanged ()
{
	// Baseclass_xZkqqHx_iKnGjAjEiOmAiNhDiBeC_xHqqkZx_
	BASE_CLASS::OnObjSelectChanged();
	UpdateCmbFont();
} // CFCTolBrFont::OnObjSelectChanged.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	CFCTolBrFont::OnTextSelectChanged
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_jFjEjFgJiCmMjBeJjBpAiCkKjFmPiNfIiClDiCoKiClNiPoKiNiHiBeBiIlNiCkCiCmNiDgFiDeMiDfIiDgHiCmMjBeJjBpAjEmNiImNiCkK_xHqqkZx_
 *			_xZkqqHx_jFmPiNfIiClDiCoKiClNiPoKiNiHiCmJiOmAiNhDiClDiCoKiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.07.02 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void CFCTolBrFont::OnTextSelectChanged ()
{
	// Baseclass_xZkqqHx_iKnGjAjEiOmAiNhDiBeC_xHqqkZx_
	BASE_CLASS::OnTextSelectChanged();
	UpdateCmbFont();
} // CFCTolBrFont::OnTextSelectChanged.

//----- 06.10.04 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
///*************************************************************************
// * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	CFCTolBrFont::GetCurrentTextBothFontName
// *
// * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iMlLiNnNiCmMiDgFiDeMiDfIiDgHiCmMiBeBjFfHiPiAiBeFjFfHiPiAiKePiDhEiDeIiDjDiDgHiLkEjCmKiCmMiBeBiDhEiDeIiDjDiDgHjGlMiCpAjFnEiClHiBeC_xHqqkZx_
// *
// * <_xZkqqHx_jFnEjCgM_xHqqkZx_>	_xZkqqHx_iDhEiDeIiDjDiDgHjGlMiBeCiLkEjCmKiCmMjCgMiCkKjGlDiCkCiPoKiNiHiCmNiLpDjFlGiOjKiCpAjFnEiClHiBeC_xHqqkZx_
// *
// * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.06.30 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
// *************************************************************************/
//const wchar_t* CFCTolBrFont::GetCurrentTextBothFontName () const
//{
//	//----- _xZkqqHx_jFfHiPiAiKePiCmMiDhEiDeIiDjDiDgHjGlMiCkKiOhHjCoIiClDiCoKiCmEiCkCiCoJiPoKiNiH_xHqqkZx_ -----
//	if ((m_fciBothFontInfo.dwMask & FDFI_FLAG_FACENAME) == FDFI_FLAG_FACENAME)
//		return m_fciBothFontInfo.szFaceName;
//	else
//		return L"";
//} // CFCTolBrFont::GetCurrentTextBothFontName.
//
///*************************************************************************
// * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	CFCTolBrFont::GetCurrentTextBothFontSize
// *
// * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iMlLiNnNiCmMiDgFiDeMiDfIiDgHiCmMiBeBjFfHiPiAiBeFjFfHiPiAiKePiDhEiDeIiDjDiDgHiLkEjCmKiCmMiBeBiDhEiDeIiDjDiDgHiDfEiDeDiDfJiCpAjFnEiClHiBeC_xHqqkZx_
// *
// * <_xZkqqHx_jFnEjCgM_xHqqkZx_>	_xZkqqHx_iDhEiDeIiDjDiDgHiDfEiDeDiDfJiBeCiLkEjCmKiCmMjCgMiCkKjGlDiCkCiPoKiNiHiCmN_xHqqkZx_ DBL_MAX _xZkqqHx_iCpAjFnEiClHiBeC_xHqqkZx_
// *
// * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.06.30 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
// *************************************************************************/
//mmetol CFCTolBrFont::GetCurrentTextBothFontSize () const
//{
//	if ((m_fciBothFontInfo.dwMask & FDFI_FLAG_HEIGHT) == FDFI_FLAG_HEIGHT)
//		return m_fciBothFontInfo.mmHeight;
//	else
//		return DBL_MAX;
//} // CFCTolBrFont::GetCurrentTextBothFontSize.
//
///*************************************************************************
// * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	CFCTolBrFont::GetCurrentTextBothFontWeight
// *
// * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iMlLiNnNiCmMiDgFiDeMiDfIiDgHiCmMiBeBjFfHiPiAiBeFjFfHiPiAiKePiDhEiDeIiDjDiDgHiLkEjCmKiCmMiBeBiDhEiDeIiDjDiDgHiCmMjBlOiClDiCpAjFnEiClHiBeC_xHqqkZx_
// *
// * <_xZkqqHx_jFnEjCgM_xHqqkZx_>	_xZkqqHx_jBlOiClDiBeCiLkEjCmKiCmMjCgMiCkKjGlDiCkCiPoKiNiHiCmN_xHqqkZx_WORD(-1);
// *
// * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.06.30 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
// *************************************************************************/
//WORD CFCTolBrFont::GetCurrentTextBothFontWeight () const
//{
//	if ((m_fciBothFontInfo.dwMask & FDFI_FLAG_WEIGHT) == FDFI_FLAG_WEIGHT)
//		return m_fciBothFontInfo.wWeight;
//	else
//		return WORD(-1);
//} // CFCTolBrFont::GetCurrentTextBothFontWeight.
//
///*************************************************************************
// * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	CFCTolBrFont::GetIsCurrentTextBothFontItalic
// *
// * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iMlLiNnNiCmMiDgFiDeMiDfIiDgHiCmMiBeBjFfHiPiAiBeFjFfHiPiAiKePiDhEiDeIiDjDiDgHiLkEjCmKiCmMiBeBiOmOjBmMiCkJiCmHiCkEiCkJiCpAjFnEiClHiBeC_xHqqkZx_
// *
// * <_xZkqqHx_jFnEjCgM_xHqqkZx_>	_xZkqqHx_iOmOjBmMiCmMiPoKiNiHiCmN_xHqqkZx_TRUE_xZkqqHx_iBeBiClLiCoKiImIiKePiCmMiPoKiNiHiCmN_xHqqkZx_FALSE_xZkqqHx_iBeC_xHqqkZx_
// *
// * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.06.30 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
// *************************************************************************/
//BOOL CFCTolBrFont::GetIsCurrentTextBothFontItalic () const
//{
//	if ((m_fciBothFontInfo.dwMask & FDFI_FLAG_ITALIC) == FDFI_FLAG_ITALIC)
//		return m_fciBothFontInfo.byItalic;
//	else
//		return FALSE;
//} // CFCTolBrFont::GetIsCurrentTextBothFontItalic.
//
///*************************************************************************
// * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	CFCTolBrFont::GetIsCurrentTextBothFontUnderline
// *
// * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iMlLiNnNiCmMiDgFiDeMiDfIiDgHiCmMiBeBjFfHiPiAiBeFjFfHiPiAiKePiDhEiDeIiDjDiDgHiLkEjCmKiCmMiBeBiOmOjBmMiCkJiCmHiCkEiCkJiCpAjFnEiClHiBeC_xHqqkZx_
// *
// * <_xZkqqHx_jFnEjCgM_xHqqkZx_>	_xZkqqHx_iOmOjBmMiCmMiPoKiNiHiCmN_xHqqkZx_TRUE_xZkqqHx_iBeBiClLiCoKiImIiKePiCmMiPoKiNiHiCmN_xHqqkZx_FALSE_xZkqqHx_iBeC_xHqqkZx_
// *
// * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.06.30 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
// *************************************************************************/
//BOOL CFCTolBrFont::GetIsCurrentTextBothFontUnderline () const
//{
//	if ((m_fciBothFontInfo.dwMask & FDFI_FLAG_UNDERLINE) == FDFI_FLAG_UNDERLINE)
//		return m_fciBothFontInfo.byUnderline;
//	else
//		return FALSE;
//} // CFCTolBrFont::GetIsCurrentTextBothFontUnderline.
//
///*************************************************************************
// * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	CFCTolBrFont::GetCurrentTextBothFontColor
// *
// * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iMlLiNnNiCmMiDgFiDeMiDfIiDgHiCmMiBeBjFfHiPiAiBeFjFfHiPiAiKePiDhEiDeIiDjDiDgHiLkEjCmKiCmMjFlGiOjKjAeGiCpAjFnEiClHiBeC_xHqqkZx_
// *
// * <_xZkqqHx_jFnEjCgM_xHqqkZx_>	_xZkqqHx_jFlGiOjKjAeGiBeCiLkEjCmKiCmMjAeGiCkKjGlDiCkCiPoKiNiHiCmN_xHqqkZx_ FD_COLOR_REF_UNSPECIFY_xZkqqHx_iBeC_xHqqkZx_
// *
// * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.07.01 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
// *************************************************************************/
//COLORREF CFCTolBrFont::GetCurrentTextBothFontColor () const
//{
//	if ((m_fciBothFontInfo.dwMask & FDFI_FLAG_COLORREF) == FDFI_FLAG_COLORREF)
//		return m_fciBothFontInfo.crColor;
//	else
//		return FD_COLOR_REF_UNSPECIFY;
//} // CFCTolBrFont::GetCurrentTextBothFontColor.
//
///*************************************************************************
// * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	CFCTolBrFont::SetCurrentTextBothFontName
// *
// * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iMlLiNnNiCmMiDgFiDeMiDfIiDgHiCmMiBeBjFfHiPiAiBeFjFfHiPiAiKePiDhEiDeIiDjDiDgHiLkEjCmKiCmMiBeBiDhEiDeIiDjDiDgHjGlMiCpAjAnNjCoIiClHiCoJiBeC_xHqqkZx_
// *
// * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	wcpFontName	:_xZkqqHx_iDhEiDeIiDjDiDgHjGlMiCpAiOhHjCoIiBeC_xHqqkZx_
// *
// * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.06.30 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
// *************************************************************************/
//void CFCTolBrFont::SetCurrentTextBothFontName (const wchar_t* wcpFontName)
//{
//	// _xZkqqHx_iDhEiDeIiDjDiDgHjFmPjAjEiCpAiPiJiKpKiJlLiBeC_xHqqkZx_
//	FCFontCharInfo fciStdFontInfo;	// _xZkqqHx_iMlLiNnNiCmMjFfHiPiAiDhEiDeIiDjDiDgHiBeC_xHqqkZx_
//	FCFontCharInfo fciExtFontInfo;	// _xZkqqHx_iMlLiNnNiCmMjFfHiPiAiKePiDhEiDeIiDjDiDgHiBeC_xHqqkZx_
//	memset(&fciStdFontInfo, 0, sizeof(fciStdFontInfo));
//	memset(&fciExtFontInfo, 0, sizeof(fciExtFontInfo));
//
//	//----- _xZkqqHx_jEpBjFfHiPiAiDhEiDeIiDjDiDgHiCmJiPoOjFpBiCpAjAnNjCoI_xHqqkZx_ -----
//	wcscpy(fciExtFontInfo.szFaceName, wcpFontName);
//	fciExtFontInfo.dwMask |= FDFI_FLAG_FACENAME;
//
//	// _xZkqqHx_jFfHiPiAiCmMiDhEiDeIiDjDiDgHiIoKjHjHiCpAiOoGjDlOiBeC_xHqqkZx_
//	WStringSet stStdCodeFontName;
//	FFCollectFontName(NULL, &stStdCodeFontName);
//	if (stStdCodeFontName.find(wcpFontName) != stStdCodeFontName.end())
//	//----- _xZkqqHx_jFfHiPiAiDhEiDeIiDjDiDgHiIoKjHjHiCmJiCoAjDkPiClGiDhEiDeIiDjDiDgHiCkKiCkAiCoJiPoKiNiH_xHqqkZx_ -----
//	{
//		//----- _xZkqqHx_jFfHiPiAiDhEiDeIiDjDiDgHiCmJiPoOjFpBiCpAjAnNjCoI_xHqqkZx_ -----
//		wcscpy(fciStdFontInfo.szFaceName, wcpFontName);
//		fciStdFontInfo.dwMask |= FDFI_FLAG_FACENAME;
//	}
//	// _xZkqqHx_iDhEiDeIiDjDiDgHiPoOjFpBiCpAjAnNjCoIiBeC_xHqqkZx_
//	g_pView->GetCurrentTool()->SetCurrentTextFont(fciExtFontInfo, fciStdFontInfo);
//	// _xZkqqHx_iDeHiDgGiDeCiDfOiCmJiDhEiDeIiBfLiDeKiDfIiCpAjGnPiClHiBeC_xHqqkZx_
//	FFGetMainWnd()->GetWnd()->SetFocus();
//} // CFCTolBrFont::SetCurrentTextBothFontName.
//
///*************************************************************************
// * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	CFCTolBrFont::SetCurrentTextBothFontSize
// *
// * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iMlLiNnNiCmMiDgFiDeMiDfIiDgHiCmMiBeBjFfHiPiAiBeFjFfHiPiAiKePiDhEiDeIiDjDiDgHiLkEjCmKiCmMiBeBiDhEiDeIiDjDiDgHiDfEiDeDiDfJiCpAjAnNjCoIiClHiCoJiBeC_xHqqkZx_
// *
// * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	mmFontSize	:_xZkqqHx_iDhEiDeIiDjDiDgHiDfEiDeDiDfJiCpAiOhHjCoIiBeC_xHqqkZx_
// *
// * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.06.30 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
// *************************************************************************/
//void CFCTolBrFont::SetCurrentTextBothFontSize (mmetol mmFontSize)
//{
//	// _xZkqqHx_iMlLiNnNiCmMiDhEiDeIiDjDiDgHiPoOjFpBiCpAiPiJiKpKiJlLiBeC_xHqqkZx_
//	FCFontCharInfo fciStdFontInfo;	// _xZkqqHx_iMlLiNnNiCmMjFfHiPiAiDhEiDeIiDjDiDgHiBeC_xHqqkZx_
//	FCFontCharInfo fciExtFontInfo;	// _xZkqqHx_iMlLiNnNiCmMjFfHiPiAiKePiDhEiDeIiDjDiDgHiBeC_xHqqkZx_
//	memset(&fciStdFontInfo, 0, sizeof(fciStdFontInfo));
//	memset(&fciExtFontInfo, 0, sizeof(fciExtFontInfo));
//	fciStdFontInfo.mmHeight = mmFontSize;
//	fciStdFontInfo.dwMask |= FDFI_FLAG_HEIGHT;
//	fciExtFontInfo.mmHeight = mmFontSize;
//	fciExtFontInfo.dwMask |= FDFI_FLAG_HEIGHT;
//	g_pView->GetCurrentTool()->SetCurrentTextFont(fciExtFontInfo, fciStdFontInfo);
//	// _xZkqqHx_iDeHiDgGiDeCiDfOiCmJiDhEiDeIiBfLiDeKiDfIiCpAjGnPiClHiBeC_xHqqkZx_
//	FFGetMainWnd()->GetWnd()->SetFocus();
//} // CFCTolBrFont::SetCurrentTextBothFontSize.
//
///*************************************************************************
// * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	CFCTolBrFont::SetCurrentTextBothFontWeight
// *
// * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iMlLiNnNiCmMiDgFiDeMiDfIiDgHiCmMiBeBjFfHiPiAiBeFjFfHiPiAiKePiDhEiDeIiDjDiDgHiLkEjCmKiCmMiBeBiDhEiDeIiDjDiDgHiCmMjBlOiClDiCpAjAnNjCoIiClHiCoJiBeC_xHqqkZx_
// *
// * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	wWeight	:_xZkqqHx_jBlOiClDiCpAiOhHjCoIiBeC_xHqqkZx_
// *
// * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.06.30 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
// *************************************************************************/
//void CFCTolBrFont::SetCurrentTextBothFontWeight (WORD wWeight)
//{
//	// _xZkqqHx_iMlLiNnNiCmMiDhEiDeIiDjDiDgHiPoOjFpBiCpAiPiJiKpKiJlLiBeC_xHqqkZx_
//	FCFontCharInfo fciStdFontInfo;	// _xZkqqHx_iMlLiNnNiCmMjFfHiPiAiDhEiDeIiDjDiDgHiBeC_xHqqkZx_
//	FCFontCharInfo fciExtFontInfo;	// _xZkqqHx_iMlLiNnNiCmMjFfHiPiAiKePiDhEiDeIiDjDiDgHiBeC_xHqqkZx_
//	memset(&fciStdFontInfo, 0, sizeof(fciStdFontInfo));
//	memset(&fciExtFontInfo, 0, sizeof(fciExtFontInfo));
//	fciStdFontInfo.wWeight = wWeight;
//	fciStdFontInfo.dwMask |= FDFI_FLAG_WEIGHT;
//	fciExtFontInfo.wWeight = wWeight;
//	fciExtFontInfo.dwMask |= FDFI_FLAG_WEIGHT;
//	g_pView->GetCurrentTool()->SetCurrentTextFont(fciExtFontInfo, fciStdFontInfo);
//	// _xZkqqHx_iDeHiDgGiDeCiDfOiCmJiDhEiDeIiBfLiDeKiDfIiCpAjGnPiClHiBeC_xHqqkZx_
//	FFGetMainWnd()->GetWnd()->SetFocus();
//} // CFCTolBrFont::SetCurrentTextBothFontWeight.
//
///*************************************************************************
// * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	CFCTolBrFont::SetIsCurrentTextBothFontItalic
// *
// * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iMlLiNnNiCmMiDgFiDeMiDfIiDgHiCmMiBeBjFfHiPiAiBeFjFfHiPiAiKePiDhEiDeIiDjDiDgHiLkEjCmKiCmMiBeBiOmOjBmMiCkJiCmHiCkEiCkJiCpAjAnNjCoIiClHiCoJiBeC_xHqqkZx_
// *
// * <_xZkqqHx_jFnEjCgM_xHqqkZx_>	bIsItalic	:_xZkqqHx_iOmOjBmMiCmMiPoKiNiHiCmN_xHqqkZx_TRUE_xZkqqHx_iCpAiOhHjCoIiBeC_xHqqkZx_
// *
// * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.06.30 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
// *************************************************************************/
//void CFCTolBrFont::SetIsCurrentTextBothFontItalic (BOOL bIsItalic)
//{
//	// _xZkqqHx_iMlLiNnNiCmMiDhEiDeIiDjDiDgHiPoOjFpBiCpAiPiJiKpKiJlLiBeC_xHqqkZx_
//	FCFontCharInfo fciStdFontInfo;	// _xZkqqHx_iMlLiNnNiCmMjFfHiPiAiDhEiDeIiDjDiDgHiBeC_xHqqkZx_
//	FCFontCharInfo fciExtFontInfo;	// _xZkqqHx_iMlLiNnNiCmMjFfHiPiAiKePiDhEiDeIiDjDiDgHiBeC_xHqqkZx_
//	memset(&fciStdFontInfo, 0, sizeof(fciStdFontInfo));
//	memset(&fciExtFontInfo, 0, sizeof(fciExtFontInfo));
//	fciStdFontInfo.byItalic = bIsItalic;
//	fciStdFontInfo.dwMask |= FDFI_FLAG_ITALIC;
//	fciExtFontInfo.byItalic = bIsItalic;
//	fciExtFontInfo.dwMask |= FDFI_FLAG_ITALIC;
//	g_pView->GetCurrentTool()->SetCurrentTextFont(fciExtFontInfo, fciStdFontInfo);
//	// _xZkqqHx_iDeHiDgGiDeCiDfOiCmJiDhEiDeIiBfLiDeKiDfIiCpAjGnPiClHiBeC_xHqqkZx_
//	FFGetMainWnd()->GetWnd()->SetFocus();
//} // CFCTolBrFont::SetIsCurrentTextBothFontItalic.
//
///*************************************************************************
// * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	CFCTolBrFont::SetIsCurrentTextBothFontUnderline
// *
// * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iMlLiNnNiCmMiDgFiDeMiDfIiDgHiCmMiBeBjFfHiPiAiBeFjFfHiPiAiKePiDhEiDeIiDjDiDgHiLkEjCmKiCmMiBeBiOmOjBmMiCkJiCmHiCkEiCkJiCpAjAnNjCoIiClHiCoJiBeC_xHqqkZx_
// *
// * <_xZkqqHx_jFnEjCgM_xHqqkZx_>	bIsUnderline	:_xZkqqHx_iOmOjBmMiCmMiPoKiNiHiCmN_xHqqkZx_TRUE_xZkqqHx_iCpAiOhHjCoIiBeC_xHqqkZx_
// *
// * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.06.30 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
// *************************************************************************/
//void CFCTolBrFont::SetIsCurrentTextBothFontUnderline (BOOL bIsUnderline)
//{
//	// _xZkqqHx_iMlLiNnNiCmMiDhEiDeIiDjDiDgHiPoOjFpBiCpAiPiJiKpKiJlLiBeC_xHqqkZx_
//	FCFontCharInfo fciStdFontInfo;	// _xZkqqHx_iMlLiNnNiCmMjFfHiPiAiDhEiDeIiDjDiDgHiBeC_xHqqkZx_
//	FCFontCharInfo fciExtFontInfo;	// _xZkqqHx_iMlLiNnNiCmMjFfHiPiAiKePiDhEiDeIiDjDiDgHiBeC_xHqqkZx_
//	memset(&fciStdFontInfo, 0, sizeof(fciStdFontInfo));
//	memset(&fciExtFontInfo, 0, sizeof(fciExtFontInfo));
//	fciStdFontInfo.byUnderline = bIsUnderline;
//	fciStdFontInfo.dwMask |= FDFI_FLAG_UNDERLINE;
//	fciExtFontInfo.byUnderline = bIsUnderline;
//	fciExtFontInfo.dwMask |= FDFI_FLAG_UNDERLINE;
//	g_pView->GetCurrentTool()->SetCurrentTextFont(fciExtFontInfo, fciStdFontInfo);
//	// _xZkqqHx_iDeHiDgGiDeCiDfOiCmJiDhEiDeIiBfLiDeKiDfIiCpAjGnPiClHiBeC_xHqqkZx_
//	FFGetMainWnd()->GetWnd()->SetFocus();
//} // CFCTolBrFont::SetIsCurrentTextBothFontUnderline.
//
///*************************************************************************
// * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	CFCTolBrFont::SetCurrentTextBothFontColor
// *
// * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iMlLiNnNiCmMiDgFiDeMiDfIiDgHiCmMiBeBjFfHiPiAiBeFjFfHiPiAiKePiDhEiDeIiDjDiDgHiLkEjCmKiCmMjFlGiOjKjAeGiCpAjAnNjCoIiClHiCoJiBeC_xHqqkZx_
// *
// * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	colorRef	:_xZkqqHx_jFlGiOjKjAeGiCpAiOhHjCoIiBeC_xHqqkZx_
// *
// * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.07.01 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
// *************************************************************************/
//void CFCTolBrFont::SetCurrentTextBothFontColor (COLORREF colorRef)
//{
//	// _xZkqqHx_iMlLiNnNiCmMiDhEiDeIiDjDiDgHiPoOjFpBiCpAiPiJiKpKiJlLiBeC_xHqqkZx_
//	FCFontCharInfo fciStdFontInfo;	// _xZkqqHx_iMlLiNnNiCmMjFfHiPiAiDhEiDeIiDjDiDgHiBeC_xHqqkZx_
//	FCFontCharInfo fciExtFontInfo;	// _xZkqqHx_iMlLiNnNiCmMjFfHiPiAiKePiDhEiDeIiDjDiDgHiBeC_xHqqkZx_
//	memset(&fciStdFontInfo, 0, sizeof(fciStdFontInfo));
//	memset(&fciExtFontInfo, 0, sizeof(fciExtFontInfo));
//	fciStdFontInfo.crColor = colorRef;
//	fciStdFontInfo.dwMask |= FDFI_FLAG_COLORREF;
//	fciExtFontInfo.crColor = colorRef;
//	fciExtFontInfo.dwMask |= FDFI_FLAG_COLORREF;
//	g_pView->GetCurrentTool()->SetCurrentTextFont(fciExtFontInfo, fciStdFontInfo);
//	// _xZkqqHx_iDeHiDgGiDeCiDfOiCmJiDhEiDeIiBfLiDeKiDfIiCpAjGnPiClHiBeC_xHqqkZx_
//	FFGetMainWnd()->GetWnd()->SetFocus();
//} // CFCTolBrFont::SetCurrentTextBothFontColor.
//----- 06.10.04 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----

/////////////////////////////////////////////////////////////////////////////
// CFCTolBrFont _xZkqqHx_iDiGiBfLiDfFiDeJiBfLiDgPiBfLiDiJiDeDiDgIiBeC_xHqqkZx_

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	CFCTolBrFont::OnUpdateCmdUI
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDgDiBfLiDiL_xHqqkZx_ _xZkqqHx_iDgPiBfLiCnMiClNiCmNiDfIiDgFiBfLiDfOiDfI_xHqqkZx_ _xZkqqHx_iDgPiBfLiCmMiPpDjBnEiCpAiNfIjAfGiClHiCoJiClNiCnPiCmJiBeB_xHqqkZx_
 *			_xZkqqHx_iDhEiDiMiBfLiDiAiDiPiBfLiDeOiCkKiMmEiCnBiPgPiClFiCnMiClHiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	pTarget	:_xZkqqHx_iDeBiDhGiDiKiDfAiBfLiDfGiDiHiDjDiCmMiDiBiDeDiDjD_xHqqkZx_ _xZkqqHx_iDhEiDiMiBfLiDiAiCnGiCmMiDhMiDeDiDjDiDfOiBeC_xHqqkZx_
 *			bDisableIfNoHndler :_xZkqqHx_iNfIjAfGiDgOiDjDiDgIiDiJiCpAiOjNiCmBiCmEiCkCiCmIiCkCiDfCiDjDiDgHiDiNiBfLiDiLiCpA_xHqqkZx_
 *								_xZkqqHx_iOkJjDkOjDeJiCmJiLnGiOhOiPpDjBnEiCmFjFfMiOkGiClHiCoJiCkJiCmHiCkEiCkJiCpAiOkGiClHiDhEiDiJiDePiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.06.29 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void CFCTolBrFont::OnUpdateCmdUI (CFrameWnd* pTarget, BOOL bDisableIfNoHndler)
{
	if (::IsWindow(m_hWnd))
	{
		m_cmbBothFontName.EnableWindow(g_pView->GetCurrentTool()->CanSetCurrentTextFont());
		m_cmbBothFontSize.EnableWindow(g_pView->GetCurrentTool()->CanSetCurrentTextFont());
		m_cbbBothFontColor.EnableWindow(g_pView->GetCurrentTool()->CanSetCurrentTextFont());

	}
	// Superclass_xZkqqHx_iKnGjAjEiOmAiNhDiBeC_xHqqkZx_
	BASE_CLASS::OnUpdateCmdUI(pTarget, bDisableIfNoHndler);
} // CFCTolBrFont::OnUpdateCmdUI.

BEGIN_MESSAGE_MAP(CFCTolBrFont, BASE_CLASS)
	//{{AFX_MSG_MAP(CFCTolBrFont)
		// _xZkqqHx_iDiBiDiC_xHqqkZx_ - ClassWizard _xZkqqHx_iCmNiClBiCmMiImKjChFiCmJiDhNiDgCiDhDiDjDiDePjHhAiCmMiDhNiDeOiDiNiCpAjCmHiJmBiCnMiClNiCmNiNoNiPjMiClFiCnMiClHiBeC_xHqqkZx_
	//}}AFX_MSG_MAP
	ON_CBN_SELCHANGE(ID_CMB_BOTH_CODE_FONT_NAME, OnSelchangeCmbBothCodeFontName)
	ON_CBN_SELCHANGE(ID_CMB_BOTH_CODE_FONT_SIZE, OnSelchangeCmbBothCodeFontSize)
	ON_CONTROL(CBBN_SELCHANGE, ID_CMB_BOTH_CODE_FONT_COLOR, OnSelchangeCmbBothCodeFontColor)
	ON_CBN_SETFOCUS(ID_CMB_BOTH_CODE_FONT_SIZE, OnSetfocusCmbBothCodeFontSize)
	ON_CBN_KILLFOCUS(ID_CMB_BOTH_CODE_FONT_SIZE, OnKillfocusCmbBothCodeFontSize)
	ON_MESSAGE(WM_USER_CMB_BOX_ON_KEY, OnUserCmbBoxOnKey)
END_MESSAGE_MAP()
//----- 06.10.04 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
//	ON_COMMAND(ID_TEXT_BOTH_CODE_FONT_BOLD, OnTextBothCodeFontBold)
//	ON_UPDATE_COMMAND_UI(ID_TEXT_BOTH_CODE_FONT_BOLD, OnUpdateTextBothCodeFontBold)
//	ON_COMMAND(ID_TEXT_BOTH_CODE_FONT_ITALIC, OnTextBothCodeFontItalic)
//	ON_UPDATE_COMMAND_UI(ID_TEXT_BOTH_CODE_FONT_ITALIC, OnUpdateTextBothCodeFontItalic)
//	ON_COMMAND(ID_TEXT_BOTH_CODE_FONT_UNDERLINE, OnTextBothCodeFontUnderline)
//	ON_UPDATE_COMMAND_UI(ID_TEXT_BOTH_CODE_FONT_UNDERLINE, OnUpdateTextBothCodeFontUnderline)
//----- 06.10.04 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----
//----- 06.10.04 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
//	ON_COMMAND(ID_TEXT_INFLATE_FONT_SIZE, OnTextInflateFontSize)
//	ON_UPDATE_COMMAND_UI(ID_TEXT_INFLATE_FONT_SIZE, OnUpdateTextInflateFontSize)
//	ON_COMMAND(ID_TEXT_DEFLATE_FONT_SIZE, OnTextDeflateFontSize)
//	ON_UPDATE_COMMAND_UI(ID_TEXT_DEFLATE_FONT_SIZE, OnUpdateTextDeflateFontSize)
//----- 06.10.04 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----

/////////////////////////////////////////////////////////////////////////////
// CFCTolBrFont _xZkqqHx_iDiBiDgCiDfKiBfLiDfH_xHqqkZx_ _xZkqqHx_iDgOiDjDiDgIiDiJ_xHqqkZx_

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	CFCTolBrFont::OnSelchangeCmbBothCodeFontName
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDgDiBfLiDiLiDgPiBfLiCmMiBeBiDhEiDeIiDjDiDgHjGlMiDfCiDjDiDhLiDhLiDgCiDeOiDfIiCkKjFmPiNfIiClDiCoKiClNiOjOiCmJiOmAiNhDiClDiCoKiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.06.29 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void CFCTolBrFont::OnSelchangeCmbBothCodeFontName ()
{
	WString wstr;
	int iSel = m_cmbBothFontName.GetCurSel();
	if (iSel == CB_ERR) return;
	FFGetLBText(&m_cmbBothFontName, iSel, wstr);
// 06.10.04 Fukushiro M. 1_xZkqqHx_iNhDjFmPiNfI_xHqqkZx_ ()
//	SetCurrentTextBothFontName(wstr);
	g_pView->SetCurrentTextBothFontName(wstr);
} // CFCTolBrFont::OnSelchangeCmbBothCodeFontName.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	CFCTolBrFont::OnSelchangeCmbBothCodeFontSize
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDgDiBfLiDiLiDgPiBfLiCmMiBeBiDhEiDeIiDjDiDgHiDfEiDeDiDfJiDfCiDjDiDhLiDhLiDgCiDeOiDfIiCkKjFmPiNfIiClDiCoKiClNiOjOiCmJiOmAiNhDiClDiCoKiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.06.29 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void CFCTolBrFont::OnSelchangeCmbBothCodeFontSize ()
{
	WString wstr;
	int iSel = m_cmbBothFontSize.GetCurSel();
	if (iSel == CB_ERR) return;
	FFGetLBText(&m_cmbBothFontSize, iSel, wstr);
	dblpnt dbptHeight = wcstod(wstr, NULL);
// 06.10.04 Fukushiro M. 1_xZkqqHx_iNhDjFmPiNfI_xHqqkZx_ ()
//	SetCurrentTextBothFontSize(pnt2mm(dbptHeight));
	g_pView->SetCurrentTextBothFontSize(pnt2mm(dbptHeight));
} // CFCTolBrFont::OnSelchangeCmbBothCodeFontSize.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	CFCTolBrFont::OnSelchangeCmbBothCodeFontColor
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDgDiBfLiDiLiDgPiBfLiCmMiBeBiDhEiDeIiDjDiDgHjAeGiDfCiDjDiDhLiDhLiDgCiDeOiDfIiCkKjFmPiNfIiClDiCoKiClNiOjOiCmJiOmAiNhDiClDiCoKiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.07.01 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void CFCTolBrFont::OnSelchangeCmbBothCodeFontColor ()
{
	WString wstr;
	COLORREF colorRef = m_cbbBothFontColor.GetCurColorRef();
	if (colorRef == FD_COLOR_REF_UNSPECIFY) return;
// 06.10.04 Fukushiro M. 1_xZkqqHx_iNhDjFmPiNfI_xHqqkZx_ ()
//	SetCurrentTextBothFontColor(colorRef);
	g_pView->SetCurrentTextBothFontColor(colorRef);
} // CFCTolBrFont::OnSelchangeCmbBothCodeFontColor.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	CFCTolBrFont::OnSetfocusCmbBothCodeFontSize
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDfCiDjDiDhLiDhLiDgCiDeOiDfIiCmJiDhEiDeIiBfLiDeKiDfIiCkKiCkAiClNiCmBiClNiCmGiCkLiCmJiOmAiNhDiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.06.29 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void CFCTolBrFont::OnSetfocusCmbBothCodeFontSize ()
{
	// _xZkqqHx_iDeBiDeOiDfKiDiJiDiMiBfLiDfOiCpAjGlDiMpIiCmJiClHiCoJiBeCiClBiCkEiClFiCmIiCkCiCmGiBeB_xHqqkZx_BS/DEL_xZkqqHx_iCkKjHiIiCmIiCkCiBeC_xHqqkZx_
	FFGetMainWnd()->SetIgnoreAccelTable(TRUE);
} // CFCTolBrFont::OnSetfocusCmbBothCodeFontSize.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	CFCTolBrFont::OnKillfocusCmbBothCodeFontSize
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDfCiDjDiDhLiDhLiDgCiDeOiDfIiCkJiCoHiDhEiDeIiBfLiDeKiDfIiCkKjDkGiClAiClNiCmGiCkLiCmJiOmAiNhDiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.06.29 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void CFCTolBrFont::OnKillfocusCmbBothCodeFontSize ()
{
	// IME_xZkqqHx_iCkK_xHqqkZx_ON_xZkqqHx_iCmJiCmIiCmBiCmEiCkCiClNiPoKiNiHiCmNjFmCiClGiCoJiBeC_xHqqkZx_
	::CloseImeStatus(m_cmbBothFontSize.m_hWnd);
	// _xZkqqHx_iDeBiDeOiDfKiDiJiDiMiBfLiDfOiCpAjHeMiMpIiCmJjGnPiClHiBeC_xHqqkZx_
	FFGetMainWnd()->SetIgnoreAccelTable(FALSE);
} // CFCTolBrFont::OnKillfocusCmbBothCodeFontSize.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	CFCTolBrFont::OnUserCmbBoxOnKey
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	CFCCmbBoxOnKey _xZkqqHx_iCmJjDgPjIfOiClDiCoKiClNiDeMiBfLiCkKjDpMjHmNiClDiCoKiClNiPoKiNiHiCmJiOmAiNhDiClDiCoKiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	wParam	:CFCCmbBoxOnKey_xZkqqHx_iCmMiDfCiDjDiDgHiDiNiBfLiDiL_xHqqkZx_ID_xZkqqHx_iCpAiOhHjCoIiBeC_xHqqkZx_
 *			lParam	:_xZkqqHx_jDpMjHmNiClDiCoKiClNiDeMiBfLiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jFnEjCgM_xHqqkZx_>	_xZkqqHx_iPoNiCmJ_xHqqkZx_1_xZkqqHx_iBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.06.29 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
LRESULT CFCTolBrFont::OnUserCmbBoxOnKey (WPARAM wParam, LPARAM lParam)
{
	ASSERT(wParam == ID_CMB_BOTH_CODE_FONT_SIZE);
	if (lParam == VK_RETURN)
	//----- _xZkqqHx_iDfCiDjDiDhLiDhLiDgCiDeOiDfIiCmJ_xHqqkZx_EMTER_xZkqqHx_iDeMiBfLiCkKjDpMjHmNiClDiCoKiClNiPoKiNiH_xHqqkZx_ -----
	{
		WString wstr;
		FFGetWindowText(&m_cmbBothFontSize, wstr);
		dblpnt dbptHeight = wcstod(wstr, NULL);
//----- 06.10.04 Fukushiro M. _xZkqqHx_jFmPiNfIjBeP_xHqqkZx_ ()-----
//		if (roughlesseq(dbptHeight, 0.0))
//			FFSetWindowText(&m_cmbBothFontSize, L"");
//		else
//			SetCurrentTextBothFontSize(pnt2mm(dbptHeight));
//----- 06.10.04 Fukushiro M. _xZkqqHx_jFmPiNfIiMoD_xHqqkZx_ ()-----
		if (roughlesseq(dbptHeight, 0.0))
			FFSetWindowText(&m_cmbBothFontSize, L"");
		else
			g_pView->SetCurrentTextBothFontSize(pnt2mm(dbptHeight));
//----- 06.10.04 Fukushiro M. _xZkqqHx_jFmPiNfIiPeJ_xHqqkZx_ ()-----
		FFGetMainWnd()->GetWnd()->SetFocus();
	} else
	if (lParam == VK_ESCAPE)
	//----- _xZkqqHx_iDfCiDjDiDhLiDhLiDgCiDeOiDfIiCmJ_xHqqkZx_ESC_xZkqqHx_iDeMiBfLiCkKjDpMjHmNiClDiCoKiClNiPoKiNiH_xHqqkZx_ -----
	{
		FFGetMainWnd()->GetWnd()->SetFocus();
	}
	return 1;
} // CFCTolBrFont::OnUserCmbBoxOnKey.

//----- 06.10.04 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
///*************************************************************************
// * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	CFCTolBrFont::OnTextBothCodeFontBold
// *
// * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iBhFjBlOiOjKiBhGiDfCiDhNiDjDiDgIiCkJiCoHiOmAiNhDiClDiCoKiCoJiBeC_xHqqkZx_
// *
// * <_xZkqqHx_iJpAjAoA_xHqqkZx_>	_xZkqqHx_iMlLiNnNiDgFiDeMiDfIiDgHiDeHiDgGiDeCiDfOiCmFjBeJjBpAiClFiCmEiCkCiCoJjEmNiImNiCpAjBlOiOjKiCmJiClFiClNiCoIiBeBjFfHiPiAiCmJ_xHqqkZx_
// *			_xZkqqHx_jGnPiClFiClNiCoIiClHiCoJiBeC_xHqqkZx_
// *
// * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.06.30 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
// *************************************************************************/
//void CFCTolBrFont::OnTextBothCodeFontBold ()
//{
//	if (GetCurrentTextBothFontWeight() != WORD(-1) &&
//		FW_REGULAR < GetCurrentTextBothFontWeight())
//		SetCurrentTextBothFontWeight(FW_REGULAR);
//	else
//		SetCurrentTextBothFontWeight(FW_BOLD);
//} // CFCTolBrFont::OnTextBothCodeFontBold.
//
///*************************************************************************
// * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	CFCTolBrFont::OnUpdateTextBothCodeFontBold
// *
// * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iBhFjBlOiOjKiBhGiDfCiDhNiDjDiDgIiCmMjHeMiMpIiBeFjGlDiMpIiCpAjAnNjCoIiClHiCoJiBeC_xHqqkZx_
// *
// * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.06.30 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
// *************************************************************************/
//void CFCTolBrFont::OnUpdateTextBothCodeFontBold (CCmdUI* pCmdUI)
//{
//	pCmdUI->Enable(	FFCanBasicOperate() &&
//					GetCurrentTool()->CanSetCurrentTextFont());
//	pCmdUI->SetRadio(	GetCurrentTextBothFontWeight() != WORD(-1) &&
//						FW_REGULAR < GetCurrentTextBothFontWeight());
//} // CFCTolBrFont::OnUpdateTextBothCodeFontBold.
//
///*************************************************************************
// * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	CFCTolBrFont::OnTextBothCodeFontItalic
// *
// * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDfCiDhNiDjDiDgIiBhFiDeDiDfOiDiKiDgCiDeOiBhGiCkJiCoHiOmAiNhDiClDiCoKiCoJiBeC_xHqqkZx_
// *
// * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.06.30 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
// *************************************************************************/
//void CFCTolBrFont::OnTextBothCodeFontItalic ()
//{
//	SetIsCurrentTextBothFontItalic(!GetIsCurrentTextBothFontItalic());
//} // CFCTolBrFont::OnTextBothCodeFontItalic.
//
///*************************************************************************
// * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	CFCTolBrFont::OnUpdateTextBothCodeFontItalic
// *
// * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDfCiDhNiDjDiDgIiBhFiDeDiDfOiDiKiDgCiDeOiBhGiCmMjHeMiMpIiBeFjGlDiMpIiCpAjAnNjCoIiClHiCoJiBeC_xHqqkZx_
// *
// * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.06.30 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
// *************************************************************************/
//void CFCTolBrFont::OnUpdateTextBothCodeFontItalic (CCmdUI* pCmdUI)
//{
//	pCmdUI->Enable(	FFCanBasicOperate() &&
//					GetCurrentTool()->CanSetCurrentTextFont());
//	pCmdUI->SetRadio(GetIsCurrentTextBothFontItalic());
//} // CFCTolBrFont::OnUpdateTextBothCodeFontItalic.
//
///*************************************************************************
// * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	CFCTolBrFont::OnTextBothCodeFontUnderline
// *
// * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDfCiDhNiDjDiDgIiBhFiJlKjApMiBhGiCkJiCoHiOmAiNhDiClDiCoKiCoJiBeC_xHqqkZx_
// *
// * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.06.30 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
// *************************************************************************/
//void CFCTolBrFont::OnTextBothCodeFontUnderline ()
//{
//	SetIsCurrentTextBothFontUnderline(!GetIsCurrentTextBothFontUnderline());
//} // CFCTolBrFont::OnTextBothCodeFontUnderline.
//
///*************************************************************************
// * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	CFCTolBrFont::OnUpdateTextBothCodeFontUnderline
// *
// * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDfCiDhNiDjDiDgIiBhFiJlKjApMiBhGiCmMjHeMiMpIiBeFjGlDiMpIiCpAjAnNjCoIiClHiCoJiBeC_xHqqkZx_
// *
// * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.06.30 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
// *************************************************************************/
//void CFCTolBrFont::OnUpdateTextBothCodeFontUnderline (CCmdUI* pCmdUI)
//{
//	pCmdUI->Enable(	FFCanBasicOperate() &&
//					g_pView->GetCurrentTool()->CanSetCurrentTextFont());
//	pCmdUI->SetRadio(GetIsCurrentTextBothFontUnderline());
//} // CFCTolBrFont::OnUpdateTextBothCodeFontUnderline.
//----- 06.10.04 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----

//----- 06.10.04 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
///*************************************************************************
// * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	CFCTolBrFont::OnTextInflateFontSize
// *
// * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDfCiDhNiDjDiDgIiBhFiDhEiDeIiDjDiDgHiCpAiKgHjBoFiBhGiCkJiCoHiOmAiNhDiClDiCoKiCoJiBeC_xHqqkZx_
// *
// * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.06.30 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
// *************************************************************************/
//void CFCTolBrFont::OnTextInflateFontSize ()
//{
//	g_pView->SendMessage(GetCurrentMessage()->message, GetCurrentMessage()->wParam, GetCurrentMessage()->lParam);
//} // CFCTolBrFont::OnTextInflateFontSize.
//
///*************************************************************************
// * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	CFCTolBrFont::OnUpdateTextInflateFontSize
// *
// * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDfCiDhNiDjDiDgIiBhFiDhEiDeIiDjDiDgHiCpAiCmMjHeMiMpIiBeFjGlDiMpIiCpAjAnNjCoIiClHiCoJiBeC_xHqqkZx_
// *
// * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.06.30 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
// *************************************************************************/
//void CFCTolBrFont::OnUpdateTextInflateFontSize (CCmdUI* pCmdUI)
//{
//	pCmdUI->Enable(	FFCanBasicOperate() &&
//					g_pView->GetCurrentTool()->CanSetCurrentTextFont());
//} // CFCTolBrFont::OnUpdateTextInflateFontSize.
//
///*************************************************************************
// * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	CFCTolBrFont::OnTextDeflateFontSize
// *
// * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDfCiDhNiDjDiDgIiBhFiDhEiDeIiDjDiDgHiCpAiPgLiPkMiBhGiCkJiCoHiOmAiNhDiClDiCoKiCoJiBeC_xHqqkZx_
// *
// * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.06.30 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
// *************************************************************************/
//void CFCTolBrFont::OnTextDeflateFontSize ()
//{
//	g_pView->SendMessage(GetCurrentMessage()->message, GetCurrentMessage()->wParam, GetCurrentMessage()->lParam);
//} // CFCTolBrFont::OnTextDeflateFontSize.
//
///*************************************************************************
// * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	CFCTolBrFont::OnUpdateTextDeflateFontSize
// *
// * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDfCiDhNiDjDiDgIiBhFiDhEiDeIiDjDiDgHiCpAiCmMjHeMiMpIiBeFjGlDiMpIiCpAjAnNjCoIiClHiCoJiBeC_xHqqkZx_
// *
// * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.06.30 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
// *************************************************************************/
//void CFCTolBrFont::OnUpdateTextDeflateFontSize (CCmdUI* pCmdUI)
//{
//	pCmdUI->Enable(	FFCanBasicOperate() &&
//					g_pView->GetCurrentTool()->CanSetCurrentTextFont());
//} // CFCTolBrFont::OnUpdateTextDeflateFontSize.
//----- 06.10.04 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----

