#include "stdafx.h"
#include "UtilDlg.h"		// For FFCommandStringToId.
#include "UtilStr.h"		// For FFExtractUntil.
#include "UtilErr.h"		// For FFThrowMiscUnknown().
#include "RegData.h"		// For g_pReg.
#include "UtilToolbar.h"	// This header.

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// _xZkqqHx_iDiMiDfHiDfIiDgHiDiKiLeMjIfOjHhAiDfKiDgCiDfGiDiHiDjDjGlMiBeC_xHqqkZx_
static const wchar_t* REG_TOOLBAR_SESSION = L"Toolbar";

//----- _xZkqqHx_iDgDiBfLiDiLiDgPiBfLjAnNjCoIjHhAiPoOjFpBiDgFiBfLiDhFiDiL_xHqqkZx_ -----
/*************************************************************************
 * <_xZkqqHx_iNfMjBkCjBmM_xHqqkZx_>	FCToolbarToApp
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDgDiBfLiDiLiDgPiBfL_xHqqkZx_ID_xZkqqHx_iCmGiBeBjHjIjHhAiClHiCoJiDeBiDhGiDiKiCmMjBmOiJjOiCpAiLeMjIfOiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	06.10.31 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
struct FCToolbarToApp
{
	UINT		m_uiToolbarId;	// _xZkqqHx_iDgDiBfLiDiLiDgPiBfL_xHqqkZx_ID_xZkqqHx_iBeC_xHqqkZx_
	WORD		m_wAppmode;		// _xZkqqHx_iClBiCmMiDgDiBfLiDiLiDgPiBfLiCpAiOgHjHhAiClHiCoJiDeBiDhGiDiKiDiCiBfLiDgIiBeC_xHqqkZx_
}; // struct FCToolbarToApp.

/*************************************************************************
 * <_xZkqqHx_jFmPjAjE_xHqqkZx_>	s_toolbarToApp
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDgDiBfLiDiLiDgPiBfL_xHqqkZx_ID_xZkqqHx_iCmGiBeBjHjIjHhAiClHiCoJiDeBiDhGiDiKiCmMjBmOiJjOiCpAiLeMjIfOiClFiClNiDgFiBfLiDhFiDiLiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	06.10.31 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
static const FCToolbarToApp s_toolbarToApp[] =
{
  {	ID_VIEW_TOOLBAR_ARROW_DUTY,		FD_APPMODE_ARROWEDITOR },	// _xZkqqHx_jGoOiIpDjAfFiCoJjFjBiCkCiDgDiBfLiDiLiDgPiBfL_xHqqkZx_
  {	ID_VIEW_TOOLBAR_ARROW_EDIT,		FD_APPMODE_ARROWEDITOR },	// _xZkqqHx_iDiBiDeDiDjDiDgDiBfLiDiLiDgPiBfL_xHqqkZx_
  {	ID_VIEW_TOOLBAR_ARROW_TOOLS,	FD_APPMODE_ARROWEDITOR },	// _xZkqqHx_iDgDiBfLiDiLiDhLiDgCiDeOiDfI_xHqqkZx_1_xZkqqHx_iDgDiBfLiDiLiDgPiBfL_xHqqkZx_
  {	ID_VIEW_TOOLBAR_ARROW_TOOLS2,	FD_APPMODE_ARROWEDITOR },	// _xZkqqHx_iDgDiBfLiDiLiDhLiDgCiDeOiDfI_xHqqkZx_2_xZkqqHx_iDgDiBfLiDiLiDgPiBfL_xHqqkZx_
  {	ID_VIEW_TOOLBAR_CHIP_DUTY,		FD_APPMODE_CHIPEDITOR },	// _xZkqqHx_iDgAiDgCiDhGjGpAiKiEiDgDiBfLiDiLiDgPiBfL_xHqqkZx_
  {	ID_VIEW_TOOLBAR_CHIP_EDIT,		FD_APPMODE_CHIPEDITOR },	// _xZkqqHx_iDiBiDeDiDjDiDgDiBfLiDiLiDgPiBfL_xHqqkZx_
  {	ID_VIEW_TOOLBAR_CHIP_TOOLS,		FD_APPMODE_CHIPEDITOR },	// _xZkqqHx_iDgDiBfLiDiLiDhLiDgCiDeOiDfI_xHqqkZx_1_xZkqqHx_iDgDiBfLiDiLiDgPiBfL_xHqqkZx_
  {	ID_VIEW_TOOLBAR_CHIP_TOOLS2,	FD_APPMODE_CHIPEDITOR },	// _xZkqqHx_iDgDiBfLiDiLiDhLiDgCiDeOiDfI_xHqqkZx_2_xZkqqHx_iDgDiBfLiDiLiDgPiBfL_xHqqkZx_
  {	ID_VIEW_TOOLBAR_COMDRW_TOOLS,	FD_APPMODE_DYNAMICDRAW|FD_APPMODE_HISTORICDRAW },	// _xZkqqHx_iDgDiBfLiDiLiDhLiDgCiDeOiDfI_xHqqkZx_1_xZkqqHx_iDgDiBfLiDiLiDgPiBfL_xHqqkZx_
  {	ID_VIEW_TOOLBAR_COMDRW_TOOLS2,	FD_APPMODE_DYNAMICDRAW|FD_APPMODE_HISTORICDRAW },	// _xZkqqHx_iDgDiBfLiDiLiDhLiDgCiDeOiDfI_xHqqkZx_2_xZkqqHx_iDgDiBfLiDiLiDgPiBfL_xHqqkZx_
  {	ID_VIEW_TOOLBAR_FONT,			FD_APPMODE_DYNAMICDRAW|FD_APPMODE_CHIPEDITOR|FD_APPMODE_HISTORICDRAW|FD_APPMODE_ARROWEDITOR },	// _xZkqqHx_iDhEiDeIiDjDiDgHiDgDiBfLiDiLiDgPiBfL_xHqqkZx_
  {	ID_VIEW_TOOLBAR_HIST_DRAW_MAIN,	FD_APPMODE_HISTORICDRAW },	// _xZkqqHx_iDiBiDeDiDjDiDgDiBfLiDiLiDgPiBfL_xHqqkZx_
  {	ID_VIEW_TOOLBAR_HIST_VIEW,		FD_APPMODE_HISTORYVIEWER },	// _xZkqqHx_iDiBiDeDiDjDiDgDiBfLiDiLiDgPiBfL_xHqqkZx_
  {	ID_VIEW_TOOLBAR_HIST_VIEW_TOOLS,FD_APPMODE_HISTORYVIEWER },	// _xZkqqHx_iDgDiBfLiDiLiDhLiDgCiDeOiDfIiDgDiBfLiDiLiDgPiBfL_xHqqkZx_
  {	ID_VIEW_TOOLBAR_HTREE_SEARCH,	FD_APPMODE_HISTORYVIEWER },	// _xZkqqHx_jHjKjHpAiMjPiNpFiDgDiBfLiDiLiDgPiBfL_xHqqkZx_
  {	ID_VIEW_TOOLBAR_LAYER,			FD_APPMODE_DYNAMICDRAW|FD_APPMODE_HISTORYVIEWER|FD_APPMODE_HISTORICDRAW },	// _xZkqqHx_iDiMiDeDiDiEiBfLiDgDiBfLiDiLiDgPiBfL_xHqqkZx_
  {	ID_VIEW_TOOLBAR_MAINFRAME,		FD_APPMODE_DYNAMICDRAW },	// _xZkqqHx_iDiBiDeDiDjDiDgDiBfLiDiLiDgPiBfL_xHqqkZx_
  {	ID_VIEW_TOOLBAR_OBJ_LABEL,		FD_APPMODE_DYNAMICDRAW|FD_APPMODE_HISTORYVIEWER|FD_APPMODE_HISTORICDRAW },	// _xZkqqHx_iDiJiDhIiDiLiDgDiBfLiDiLiDgPiBfL_xHqqkZx_
  {	ID_VIEW_TOOLBAR_PEN_BRUSH,		FD_APPMODE_DYNAMICDRAW|FD_APPMODE_CHIPEDITOR|FD_APPMODE_HISTORICDRAW|FD_APPMODE_ARROWEDITOR },	// _xZkqqHx_iDhJiDjD_xHqqkZx_/_xZkqqHx_iDhFiDiJiDfGiDgDiBfLiDiLiDgPiBfL_xHqqkZx_
  {	ID_VIEW_TOOLBAR_SHEET,			FD_APPMODE_DYNAMICDRAW|FD_APPMODE_HISTORYVIEWER|FD_APPMODE_HISTORICDRAW },	// _xZkqqHx_iDfGiBfLiDgHiDgDiBfLiDiLiDgPiBfL_xHqqkZx_
  {	ID_VIEW_TOOLBAR_TEXT,			FD_APPMODE_DYNAMICDRAW|FD_APPMODE_CHIPEDITOR|FD_APPMODE_HISTORICDRAW|FD_APPMODE_ARROWEDITOR },	// _xZkqqHx_iDgFiDeMiDfIiDgHiDgDiBfLiDiLiDgPiBfL_xHqqkZx_
}; // FCToolbarToApp s_toolbarToApp.

/*************************************************************************
 * <_xZkqqHx_jFmPjAjE_xHqqkZx_>	DEFAULT_TOOLBAR
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDgDiBfLiDiLiDgPiBfLiCmMiDfCiDhNiDjDiDgIjHpBiCmMiDgGiDhEiDeIiDiLiDgHjCgMiCpAiLeMjIfOiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	06.10.31 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
static const UINT DEFAULT_TOOLBAR[] =
{
//===================================
	// _xZkqqHx_jGoOiIpDjAfFiCoJjFjBiCkCiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	ID_VIEW_TOOLBAR_ARROW_DUTY,
//-----------------------------------
	ID_CMB_CURRENT_SHEET,
	ID_SEPARATOR,
	ID_ARROWEDIT_SET_DUTY,
	ID_ARROWEDIT_SET_FRAME,
	UINT(-1),
//===================================

//===================================
	// _xZkqqHx_iDiBiDeDiDjDiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	ID_VIEW_TOOLBAR_ARROW_EDIT,
//-----------------------------------
	ID_EDIT_CUT,
	ID_EDIT_COPY,
	ID_EDIT_PASTE,
	ID_SEPARATOR,
	ID_VIEW_REDRAW,
	ID_SEPARATOR,
	ID_VIEW_CMB_ZOOM,
	ID_SEPARATOR,
	ID_OPTION_IS_SNAP_EFFECTIVE,
	ID_OPTION_AUTO_ALTKEY,
	ID_OPTION_POP_HINT_ENABLE,
	ID_GRAPHICS_EDIT_COLOR_TABLE,
	ID_SEPARATOR,
	ID_APP_ABOUT,
	ID_CONTEXT_HELP,
	UINT(-1),
//===================================

//===================================
	// _xZkqqHx_iDgDiBfLiDiLiDhLiDgCiDeOiDfI_xHqqkZx_1_xZkqqHx_iDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	ID_VIEW_TOOLBAR_ARROW_TOOLS,
//-----------------------------------
	ID_TOOL_SELECT,
	ID_TOOL_ZOOM,
	ID_TOOL_ANY_EDIT,
	ID_TOOL_EDIT_RICH_TEXT,
	ID_TOOL_ROTATE,
	UINT(-1),
//===================================

//===================================
	// _xZkqqHx_iDgDiBfLiDiLiDhLiDgCiDeOiDfI_xHqqkZx_2_xZkqqHx_iDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	ID_VIEW_TOOLBAR_ARROW_TOOLS2,
//-----------------------------------
	ID_TOOL_LINE,
	ID_TOOL_RECT,
	ID_TOOL_RRECT,
	ID_TOOL_ARC,
	ID_SEPARATOR,
	ID_TOOL_POLYLINE,
	ID_TOOL_BEZILINE,
	ID_TOOL_WIDE_POLY,
	ID_TOOL_WIDE_BEZIER,
	ID_SEPARATOR,
	ID_TOOL_RICH_TEXT,
	ID_SEPARATOR,
	ID_OPTION_TOOL_LOCK,
	UINT(-1),
//===================================

//===================================
	// _xZkqqHx_iDgAiDgCiDhGjGpAiKiEiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	ID_VIEW_TOOLBAR_CHIP_DUTY,
//-----------------------------------
	ID_CHIPEDIT_CMB_MOLIP_DUTY_ID,
	ID_SEPARATOR,
	ID_CHIPEDIT_CMB_TEXT_DUTY_ID,
	ID_SEPARATOR,
	ID_CHIPEDIT_SET_DUTY,
	UINT(-1),
//===================================

//===================================
	// _xZkqqHx_iDiBiDeDiDjDiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	ID_VIEW_TOOLBAR_CHIP_EDIT,
//-----------------------------------
	ID_EDIT_CUT,
	ID_EDIT_COPY,
	ID_EDIT_PASTE,
	ID_SEPARATOR,
	ID_VIEW_REDRAW,
	ID_SEPARATOR,
	ID_VIEW_CMB_ZOOM,
	ID_SEPARATOR,
	ID_OPTION_IS_SNAP_EFFECTIVE,
	ID_OPTION_IS_ARROW_GAP_EFFECTIVE,
	ID_OPTION_AUTO_ALTKEY,
	ID_OPTION_POP_HINT_ENABLE,
	ID_GRAPHICS_EDIT_COLOR_TABLE,
	ID_SEPARATOR,
	ID_APP_ABOUT,
	ID_CONTEXT_HELP,
	UINT(-1),
//===================================

//===================================
	// _xZkqqHx_iDgDiBfLiDiLiDhLiDgCiDeOiDfI_xHqqkZx_1_xZkqqHx_iDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	ID_VIEW_TOOLBAR_CHIP_TOOLS,
//-----------------------------------
	ID_TOOL_SELECT,
	ID_TOOL_ZOOM,
	ID_TOOL_ANY_EDIT,
	ID_TOOL_EDIT_RICH_TEXT,
	ID_TOOL_ROTATE,
	ID_TOOL_LINK,
	ID_SEPARATOR,
	ID_TOOL_POLY_ARROW,
	ID_TOOL_BEZIER_ARROW,
	ID_TOOL_WIDE_POLY_ARROW,
	ID_TOOL_WIDE_BEZIER_ARROW,
	ID_SEPARATOR,
	ID_TOOL_BOX_POLY_ARROW,
	ID_TOOL_BOX_BEZIER_ARROW,
	UINT(-1),
//===================================

//===================================
	// _xZkqqHx_iDgDiBfLiDiLiDhLiDgCiDeOiDfI_xHqqkZx_2_xZkqqHx_iDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	ID_VIEW_TOOLBAR_CHIP_TOOLS2,
//-----------------------------------
	ID_TOOL_LINE,
	ID_TOOL_RECT,
	ID_TOOL_RRECT,
	ID_TOOL_ARC,
	ID_TOOL_TABLE,
	ID_SEPARATOR,
	ID_TOOL_POLYLINE,
	ID_TOOL_BEZILINE,
	ID_TOOL_WIDE_POLY,
	ID_TOOL_WIDE_BEZIER,
	ID_SEPARATOR,
	ID_TOOL_RICH_TEXT,
	ID_TOOL_TEXT_PUT,
	ID_TOOL_POINT,
	ID_SEPARATOR,
	ID_OPTION_TOOL_LOCK,
	UINT(-1),
//===================================

//===================================
	// _xZkqqHx_iDgDiBfLiDiLiDhLiDgCiDeOiDfI_xHqqkZx_1_xZkqqHx_iDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	ID_VIEW_TOOLBAR_COMDRW_TOOLS,
//-----------------------------------
	ID_TOOL_SELECT,
	ID_TOOL_ZOOM,
	ID_TOOL_ANY_EDIT,
	ID_TOOL_EDIT_RICH_TEXT,
	ID_TOOL_ROTATE,
	ID_TOOL_LINK,
	ID_SEPARATOR,
	ID_TOOL_POLY_ARROW,
	ID_TOOL_BEZIER_ARROW,
	ID_TOOL_WIDE_POLY_ARROW,
	ID_TOOL_WIDE_BEZIER_ARROW,
	ID_SEPARATOR,
	ID_TOOL_BOX_POLY_ARROW,
	ID_TOOL_BOX_BEZIER_ARROW,
	ID_SEPARATOR,
	ID_TOOL_PEN_LABEL_PUT,
	ID_TOOL_NOTE_LABEL_PUT,
	UINT(-1),
//===================================

//===================================
	// _xZkqqHx_iDgDiBfLiDiLiDhLiDgCiDeOiDfI_xHqqkZx_2_xZkqqHx_iDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	ID_VIEW_TOOLBAR_COMDRW_TOOLS2,
//-----------------------------------
	ID_TOOL_CHIP,
	ID_TOOL_CHIP_PUT,
	ID_SEPARATOR,
	ID_TOOL_LINE,
	ID_TOOL_RECT,
	ID_TOOL_RRECT,
	ID_TOOL_ARC,
	ID_TOOL_TABLE,
	ID_SEPARATOR,
	ID_TOOL_POLYLINE,
	ID_TOOL_BEZILINE,
	ID_TOOL_WIDE_POLY,
	ID_TOOL_WIDE_BEZIER,
	ID_SEPARATOR,
	ID_TOOL_RICH_TEXT,
	ID_TOOL_TEXT_PUT,
	ID_SEPARATOR,
	ID_OPTION_TOOL_LOCK,
	UINT(-1),
//===================================

//===================================
	// _xZkqqHx_iDhEiDeIiDjDiDgHiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	ID_VIEW_TOOLBAR_FONT,
//-----------------------------------
	ID_CMB_BOTH_CODE_FONT_NAME,
	ID_SEPARATOR,
	ID_CMB_BOTH_CODE_FONT_SIZE,
	ID_SEPARATOR,
	ID_TEXT_BOTH_CODE_FONT_BOLD,
	ID_TEXT_BOTH_CODE_FONT_ITALIC,
	ID_TEXT_BOTH_CODE_FONT_UNDERLINE,
	ID_SEPARATOR,
	ID_CMB_BOTH_CODE_FONT_COLOR,
	ID_SEPARATOR,
	ID_TEXT_INFLATE_FONT_SIZE,
	ID_TEXT_DEFLATE_FONT_SIZE,
	UINT(-1),
//===================================

//===================================
	// _xZkqqHx_iDiBiDeDiDjDiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	ID_VIEW_TOOLBAR_HIST_DRAW_MAIN,
//-----------------------------------
	ID_EDIT_CUT,
	ID_EDIT_COPY,
	ID_EDIT_PASTE,
	ID_SEPARATOR,
	ID_VIEW_CHIP_STORE_VISIBLE,
	ID_VIEW_HTREE_VISIBLE,
	ID_VIEW_REDRAW,
	ID_SEPARATOR,
	ID_VIEW_CMB_ZOOM,
	ID_SEPARATOR,
	ID_VIEW_COPY_POSITION,
	ID_VIEW_PASTE_POSITION,
	ID_SEPARATOR,
	ID_OPTION_IS_SNAP_EFFECTIVE,
	ID_OPTION_IS_ARROW_GAP_EFFECTIVE,
	ID_OPTION_AUTO_ALTKEY,
	ID_OPTION_POP_HINT_ENABLE,
	ID_GRAPHICS_EDIT_COLOR_TABLE,
	ID_SEPARATOR,
	ID_APP_ABOUT,
	ID_CONTEXT_HELP,
	UINT(-1),
//===================================

//===================================
	// _xZkqqHx_iDiBiDeDiDjDiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	ID_VIEW_TOOLBAR_HIST_VIEW,
//-----------------------------------
	ID_VIEW_PREV_DSM,
	ID_VIEW_APPEND_DSM,
	ID_VIEW_NEXT_DSM,
	ID_VIEW_DSM_PANEL,
	ID_SEPARATOR,
	ID_VIEW_HTREE_VISIBLE,
	ID_VIEW_REDRAW,
	ID_SEPARATOR,
	ID_VIEW_CMB_ZOOM,
	ID_SEPARATOR,
	ID_VIEW_COPY_POSITION,
	ID_VIEW_PASTE_POSITION,
	ID_SEPARATOR,
	ID_HTREE_USE_TIME_INDEX,
	ID_SEPARATOR,
	ID_OPTION_AUTO_ALTKEY,
	ID_OPTION_POP_HINT_ENABLE,
	ID_SEPARATOR,
	ID_APP_ABOUT,
	ID_CONTEXT_HELP,
	UINT(-1),
//===================================

//===================================
	// _xZkqqHx_iDgDiBfLiDiLiDhLiDgCiDeOiDfIiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	ID_VIEW_TOOLBAR_HIST_VIEW_TOOLS,
//-----------------------------------
	ID_TOOL_SELECT,
	ID_TOOL_ZOOM,
	ID_TOOL_LINK,
	ID_SEPARATOR,
	ID_TOOL_TIME_LABEL,
	ID_SEPARATOR,
	ID_OPTION_TOOL_LOCK,
	UINT(-1),
//===================================

//===================================
	// _xZkqqHx_jHjKjHpAiMjPiNpFiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	ID_VIEW_TOOLBAR_HTREE_SEARCH,
//-----------------------------------
	ID_HTREE_FIND_PANEL,
	ID_HTREE_FIND_RESULTS,
	ID_SEPARATOR,
	ID_HTREE_JUMP_NEXT_FIND_RESULT,
	ID_HTREE_JUMP_PREV_FIND_RESULT,
	ID_SEPARATOR,
	ID_HTREE_MOVE_SELECTION_BEFORE,
	ID_HTREE_MOVE_SELECTION_AFTER,
	UINT(-1),
//===================================

//===================================
	// _xZkqqHx_iDiMiDeDiDiEiBfLiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	ID_VIEW_TOOLBAR_LAYER,
//-----------------------------------
	ID_CMB_CURRENT_LAYER,
	ID_SEPARATOR,
	ID_OPTION_LAYER_ORDER,
	ID_OPTION_MOVE_IN_LOWER_LAYER,
	ID_OPTION_MOVE_IN_UPPER_LAYER,
	UINT(-1),
//===================================

//===================================
	// _xZkqqHx_iDiBiDeDiDjDiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	ID_VIEW_TOOLBAR_MAINFRAME,
//-----------------------------------
	ID_FILE_WIN_NEW,
	ID_FILE_OPEN,
	ID_FILE_SAVE,
	ID_SEPARATOR,
	ID_EDIT_CUT,
	ID_EDIT_COPY,
	ID_EDIT_PASTE,
	ID_SEPARATOR,
	ID_VIEW_CHIP_STORE_VISIBLE,
	ID_VIEW_REDRAW,
	ID_SEPARATOR,
	ID_VIEW_CMB_ZOOM,
	ID_SEPARATOR,
	ID_VIEW_COPY_POSITION,
	ID_VIEW_PASTE_POSITION,
	ID_SEPARATOR,
	ID_OPTION_IS_SNAP_EFFECTIVE,
	ID_OPTION_IS_ARROW_GAP_EFFECTIVE,
	ID_OPTION_AUTO_ALTKEY,
	ID_OPTION_POP_HINT_ENABLE,
	ID_GRAPHICS_EDIT_COLOR_TABLE,
	ID_SEPARATOR,
	ID_APP_ABOUT,
	ID_CONTEXT_HELP,
	UINT(-1),
//===================================

//===================================
	// _xZkqqHx_iDiJiDhIiDiLiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	ID_VIEW_TOOLBAR_OBJ_LABEL,
//-----------------------------------
	ID_CMB_LABEL_LIST,
	ID_SEPARATOR,
	ID_VIEW_OBJ_LABEL_SHOW_MODE,
	ID_VIEW_OBJ_LABEL_LIST,
	UINT(-1),
//===================================

//===================================
	// _xZkqqHx_iDhJiDjD_xHqqkZx_/_xZkqqHx_iDhFiDiJiDfGiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	ID_VIEW_TOOLBAR_PEN_BRUSH,
//-----------------------------------
	ID_GRAPHICS_EDIT_REGPEN_TABLE,
	ID_SEPARATOR,
	ID_CMB_OBJ_PEN_COLOR,
	ID_SEPARATOR,
	ID_CMB_OBJ_PEN_STYLE,
	ID_SEPARATOR,
	ID_CMB_OBJ_PEN_WEIGHT,
	ID_SEPARATOR,
	ID_CMB_OBJ_REG_PEN,
	ID_SEPARATOR,
	ID_GRAPHICS_EDIT_REGBRUSH_TABLE,
	ID_SEPARATOR,
	ID_CMB_OBJ_BRUSH_COLOR,
	ID_SEPARATOR,
	ID_CMB_OBJ_REG_BRUSH,
	UINT(-1),
//===================================

//===================================
	// _xZkqqHx_iDfGiBfLiDgHiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	ID_VIEW_TOOLBAR_SHEET,
//-----------------------------------
	ID_CMB_CURRENT_SHEET,
	ID_SEPARATOR,
	ID_OPTION_SHEET_ORDER,
	ID_OPTION_MOVE_IN_NEXT_SHEET,
	ID_OPTION_MOVE_IN_PREV_SHEET,
	UINT(-1),
//===================================

//===================================
	// _xZkqqHx_iDgFiDeMiDfIiDgHiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	ID_VIEW_TOOLBAR_TEXT,
//-----------------------------------
	ID_FORMAT_FONT,
	ID_TEXT_LINE,
	ID_TEXT_MARGIN,
	ID_SEPARATOR,
	ID_TEXT_ALIGN_LEFT,
	ID_TEXT_ALIGN_CENTER,
	ID_TEXT_ALIGN_RIGHT,
	ID_TEXT_ALIGN_LEFTRIGHT,
	ID_SEPARATOR,
	ID_TEXT_ALIGN_TOP,
	ID_TEXT_ALIGN_V_CENTER,
	ID_TEXT_ALIGN_BOTTOM,
//===================================
}; // DEFAULT_TOOLBAR.

/*************************************************************************
 * <_xZkqqHx_jFmPjAjE_xHqqkZx_>	POOL_TOOLBAR
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDgDiBfLiDiLiDgPiBfLiCmMjBeJjBpAiJmCjEfMiCmIiDfCiDhNiDjDiDgIiDhGiBfLiDiLiCpAiLeMjIfOiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	06.10.31 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
static const UINT POOL_TOOLBAR[] =
{
//----- 06.11.24 Fukushiro M. _xZkqqHx_jFmPiNfIjBeP_xHqqkZx_ ()-----
//	// _xZkqqHx_jGoOiIpDjAfFiCoJjFjBiCkCiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
//	ID_VIEW_TOOLBAR_ARROW_DUTY,
//	ID_CMB_CURRENT_SHEET,
//	ID_ARROWEDIT_SET_DUTY,
//	ID_ARROWEDIT_SET_FRAME,
//	UINT(-1),
//	// _xZkqqHx_iDiBiDeDiDjDiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
//	ID_VIEW_TOOLBAR_ARROW_EDIT,
//	ID_EDIT_CUT,
//	ID_EDIT_COPY,
//	ID_EDIT_PASTE,
//	ID_VIEW_REDRAW,
//	ID_VIEW_CMB_ZOOM,
//	ID_OPTION_IS_SNAP_EFFECTIVE,
//	ID_OPTION_AUTO_ALTKEY,
//	ID_OPTION_POP_HINT_ENABLE,
//	ID_GRAPHICS_EDIT_COLOR_TABLE,
//	ID_APP_ABOUT,
//	ID_CONTEXT_HELP,
//	UINT(-1),
//	// _xZkqqHx_iDgDiBfLiDiLiDhLiDgCiDeOiDfI_xHqqkZx_1_xZkqqHx_iDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
//	ID_VIEW_TOOLBAR_ARROW_TOOLS,
//	ID_TOOL_SELECT,
//	ID_TOOL_ZOOM,
//	ID_TOOL_ANY_EDIT,
//	ID_TOOL_EDIT_RICH_TEXT,
//	ID_TOOL_ROTATE,
//	ID_TOOL_LINE,
//	ID_TOOL_RECT,
//	ID_TOOL_RRECT,
//	ID_TOOL_ARC,
//	ID_TOOL_POLYLINE,
//	ID_TOOL_BEZILINE,
//	ID_TOOL_WIDE_POLY,
//	ID_TOOL_WIDE_BEZIER,
//	ID_TOOL_RICH_TEXT,
//	ID_OPTION_TOOL_LOCK,
//	UINT(-1),
//	// _xZkqqHx_iDgDiBfLiDiLiDhLiDgCiDeOiDfI_xHqqkZx_2_xZkqqHx_iDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
//	ID_VIEW_TOOLBAR_ARROW_TOOLS2,
//	ID_TOOL_SELECT,
//	ID_TOOL_ZOOM,
//	ID_TOOL_ANY_EDIT,
//	ID_TOOL_EDIT_RICH_TEXT,
//	ID_TOOL_ROTATE,
//	ID_TOOL_LINE,
//	ID_TOOL_RECT,
//	ID_TOOL_RRECT,
//	ID_TOOL_ARC,
//	ID_TOOL_POLYLINE,
//	ID_TOOL_BEZILINE,
//	ID_TOOL_WIDE_POLY,
//	ID_TOOL_WIDE_BEZIER,
//	ID_TOOL_RICH_TEXT,
//	ID_OPTION_TOOL_LOCK,
//	UINT(-1),
//	// _xZkqqHx_iDgAiDgCiDhGjGpAiKiEiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
//	ID_VIEW_TOOLBAR_CHIP_DUTY,
//	ID_CHIPEDIT_CMB_MOLIP_DUTY_ID,
//	ID_CHIPEDIT_CMB_TEXT_DUTY_ID,
//	ID_CHIPEDIT_SET_DUTY,
//	UINT(-1),
//	// _xZkqqHx_iDiBiDeDiDjDiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
//	ID_VIEW_TOOLBAR_CHIP_EDIT,
//	ID_EDIT_CUT,
//	ID_EDIT_COPY,
//	ID_EDIT_PASTE,
//	ID_VIEW_REDRAW,
//	ID_VIEW_CMB_ZOOM,
//	ID_OPTION_IS_SNAP_EFFECTIVE,
//	ID_OPTION_IS_ARROW_GAP_EFFECTIVE,
//	ID_OPTION_AUTO_ALTKEY,
//	ID_OPTION_POP_HINT_ENABLE,
//	ID_GRAPHICS_EDIT_COLOR_TABLE,
//	ID_APP_ABOUT,
//	ID_CONTEXT_HELP,
//	UINT(-1),
//	// _xZkqqHx_iDgDiBfLiDiLiDhLiDgCiDeOiDfI_xHqqkZx_1_xZkqqHx_iDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
//	ID_VIEW_TOOLBAR_CHIP_TOOLS,
//	ID_TOOL_SELECT,
//	ID_TOOL_ZOOM,
//	ID_TOOL_ANY_EDIT,
//	ID_TOOL_EDIT_RICH_TEXT,
//	ID_TOOL_ROTATE,
//	ID_TOOL_LINK,
//	ID_TOOL_POLY_ARROW,
//	ID_TOOL_BEZIER_ARROW,
//	ID_TOOL_WIDE_POLY_ARROW,
//	ID_TOOL_WIDE_BEZIER_ARROW,
//	ID_TOOL_BOX_POLY_ARROW,
//	ID_TOOL_BOX_BEZIER_ARROW,
//	ID_TOOL_LINE,
//	ID_TOOL_RECT,
//	ID_TOOL_RRECT,
//	ID_TOOL_ARC,
//	ID_TOOL_TABLE,
//	ID_TOOL_POLYLINE,
//	ID_TOOL_BEZILINE,
//	ID_TOOL_WIDE_POLY,
//	ID_TOOL_WIDE_BEZIER,
//	ID_TOOL_RICH_TEXT,
//	ID_TOOL_TEXT_PUT,
//	ID_TOOL_POINT,
//	ID_OPTION_TOOL_LOCK,
//	UINT(-1),
//	// _xZkqqHx_iDgDiBfLiDiLiDhLiDgCiDeOiDfI_xHqqkZx_2_xZkqqHx_iDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
//	ID_VIEW_TOOLBAR_CHIP_TOOLS2,
//	ID_TOOL_SELECT,
//	ID_TOOL_ZOOM,
//	ID_TOOL_ANY_EDIT,
//	ID_TOOL_EDIT_RICH_TEXT,
//	ID_TOOL_ROTATE,
//	ID_TOOL_LINK,
//	ID_TOOL_POLY_ARROW,
//	ID_TOOL_BEZIER_ARROW,
//	ID_TOOL_WIDE_POLY_ARROW,
//	ID_TOOL_WIDE_BEZIER_ARROW,
//	ID_TOOL_BOX_POLY_ARROW,
//	ID_TOOL_BOX_BEZIER_ARROW,
//	ID_TOOL_LINE,
//	ID_TOOL_RECT,
//	ID_TOOL_RRECT,
//	ID_TOOL_ARC,
//	ID_TOOL_TABLE,
//	ID_TOOL_POLYLINE,
//	ID_TOOL_BEZILINE,
//	ID_TOOL_WIDE_POLY,
//	ID_TOOL_WIDE_BEZIER,
//	ID_TOOL_RICH_TEXT,
//	ID_TOOL_TEXT_PUT,
//	ID_TOOL_POINT,
//	ID_OPTION_TOOL_LOCK,
//	UINT(-1),
//	// _xZkqqHx_iDgDiBfLiDiLiDhLiDgCiDeOiDfI_xHqqkZx_1_xZkqqHx_iDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
//	ID_VIEW_TOOLBAR_COMDRW_TOOLS,
//	ID_TOOL_SELECT,
//	ID_TOOL_ZOOM,
//	ID_TOOL_ANY_EDIT,
//	ID_TOOL_EDIT_RICH_TEXT,
//	ID_TOOL_ROTATE,
//	ID_TOOL_LINK,
//	ID_TOOL_POLY_ARROW,
//	ID_TOOL_BEZIER_ARROW,
//	ID_TOOL_WIDE_POLY_ARROW,
//	ID_TOOL_WIDE_BEZIER_ARROW,
//	ID_TOOL_BOX_POLY_ARROW,
//	ID_TOOL_BOX_BEZIER_ARROW,
//	ID_TOOL_PEN_LABEL_PUT,
//	ID_TOOL_NOTE_LABEL_PUT,
//	ID_TOOL_CHIP,
//	ID_TOOL_CHIP_PUT,
//	ID_TOOL_LINE,
//	ID_TOOL_RECT,
//	ID_TOOL_RRECT,
//	ID_TOOL_ARC,
//	ID_TOOL_TABLE,
//	ID_TOOL_POLYLINE,
//	ID_TOOL_BEZILINE,
//	ID_TOOL_WIDE_POLY,
//	ID_TOOL_WIDE_BEZIER,
//	ID_TOOL_RICH_TEXT,
//	ID_TOOL_TEXT_PUT,
//	ID_OPTION_TOOL_LOCK,
//	UINT(-1),
//	// _xZkqqHx_iDgDiBfLiDiLiDhLiDgCiDeOiDfI_xHqqkZx_2_xZkqqHx_iDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
//	ID_VIEW_TOOLBAR_COMDRW_TOOLS2,
//	ID_TOOL_SELECT,
//	ID_TOOL_ZOOM,
//	ID_TOOL_ANY_EDIT,
//	ID_TOOL_EDIT_RICH_TEXT,
//	ID_TOOL_ROTATE,
//	ID_TOOL_LINK,
//	ID_TOOL_POLY_ARROW,
//	ID_TOOL_BEZIER_ARROW,
//	ID_TOOL_WIDE_POLY_ARROW,
//	ID_TOOL_WIDE_BEZIER_ARROW,
//	ID_TOOL_BOX_POLY_ARROW,
//	ID_TOOL_BOX_BEZIER_ARROW,
//	ID_TOOL_PEN_LABEL_PUT,
//	ID_TOOL_NOTE_LABEL_PUT,
//	ID_TOOL_CHIP,
//	ID_TOOL_CHIP_PUT,
//	ID_TOOL_LINE,
//	ID_TOOL_RECT,
//	ID_TOOL_RRECT,
//	ID_TOOL_ARC,
//	ID_TOOL_TABLE,
//	ID_TOOL_POLYLINE,
//	ID_TOOL_BEZILINE,
//	ID_TOOL_WIDE_POLY,
//	ID_TOOL_WIDE_BEZIER,
//	ID_TOOL_RICH_TEXT,
//	ID_TOOL_TEXT_PUT,
//	ID_OPTION_TOOL_LOCK,
//	UINT(-1),
//	// _xZkqqHx_iDhEiDeIiDjDiDgHiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
//	ID_VIEW_TOOLBAR_FONT,
//	ID_CMB_BOTH_CODE_FONT_NAME,
//	ID_CMB_BOTH_CODE_FONT_SIZE,
//	ID_TEXT_BOTH_CODE_FONT_BOLD,
//	ID_TEXT_BOTH_CODE_FONT_ITALIC,
//	ID_TEXT_BOTH_CODE_FONT_UNDERLINE,
//	ID_CMB_BOTH_CODE_FONT_COLOR,
//	ID_TEXT_INFLATE_FONT_SIZE,
//	ID_TEXT_DEFLATE_FONT_SIZE,
//	UINT(-1),
//	// _xZkqqHx_iDiBiDeDiDjDiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
//	ID_VIEW_TOOLBAR_HIST_DRAW_MAIN,
//	ID_EDIT_CUT,
//	ID_EDIT_COPY,
//	ID_EDIT_PASTE,
//	ID_VIEW_CHIP_STORE_VISIBLE,
//	ID_VIEW_HTREE_VISIBLE,
//	ID_VIEW_REDRAW,
//	ID_VIEW_CMB_ZOOM,
//	ID_OPTION_IS_SNAP_EFFECTIVE,
//	ID_OPTION_IS_ARROW_GAP_EFFECTIVE,
//	ID_OPTION_AUTO_ALTKEY,
//	ID_OPTION_POP_HINT_ENABLE,
//	ID_GRAPHICS_EDIT_COLOR_TABLE,
//	ID_APP_ABOUT,
//	ID_CONTEXT_HELP,
//	UINT(-1),
//	// _xZkqqHx_iDiBiDeDiDjDiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
//	ID_VIEW_TOOLBAR_HIST_VIEW,
//	ID_VIEW_PREV_DSM,
//	ID_VIEW_APPEND_DSM,
//	ID_VIEW_NEXT_DSM,
//	ID_VIEW_DSM_PANEL,
//	ID_VIEW_HTREE_VISIBLE,
//	ID_VIEW_REDRAW,
//	ID_VIEW_CMB_ZOOM,
//	ID_VIEW_COPY_POSITION,
//	ID_VIEW_PASTE_POSITION,
//	ID_HTREE_USE_TIME_INDEX,
//	ID_OPTION_AUTO_ALTKEY,
//	ID_OPTION_POP_HINT_ENABLE,
//	ID_APP_ABOUT,
//	ID_CONTEXT_HELP,
//	UINT(-1),
//	// _xZkqqHx_iDgDiBfLiDiLiDhLiDgCiDeOiDfIiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
//	ID_VIEW_TOOLBAR_HIST_VIEW_TOOLS,
//	ID_TOOL_SELECT,
//	ID_TOOL_ZOOM,
//	ID_TOOL_LINK,
//	ID_TOOL_TIME_LABEL,
//	ID_OPTION_TOOL_LOCK,
//	UINT(-1),
//	// _xZkqqHx_jHjKjHpAiMjPiNpFiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
//	ID_VIEW_TOOLBAR_HTREE_SEARCH,
//	ID_HTREE_FIND_PANEL,
//	ID_HTREE_FIND_RESULTS,
//	ID_HTREE_JUMP_NEXT_FIND_RESULT,
//	ID_HTREE_JUMP_PREV_FIND_RESULT,
//	ID_HTREE_MOVE_SELECTION_BEFORE,
//	ID_HTREE_MOVE_SELECTION_AFTER,
//	UINT(-1),
//	// _xZkqqHx_iDiMiDeDiDiEiBfLiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
//	ID_VIEW_TOOLBAR_LAYER,
//	ID_CMB_CURRENT_LAYER,
//	ID_OPTION_LAYER_ORDER,
//	ID_OPTION_MOVE_IN_LOWER_LAYER,
//	ID_OPTION_MOVE_IN_UPPER_LAYER,
//	UINT(-1),
//	// _xZkqqHx_iDiBiDeDiDjDiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
//	ID_VIEW_TOOLBAR_MAINFRAME,
//	ID_FILE_WIN_NEW,
//	ID_FILE_OPEN,
//	ID_FILE_SAVE,
//	ID_EDIT_CUT,
//	ID_EDIT_COPY,
//	ID_EDIT_PASTE,
//	ID_VIEW_CHIP_STORE_VISIBLE,
//	ID_VIEW_REDRAW,
//	ID_VIEW_CMB_ZOOM,
//	ID_OPTION_IS_SNAP_EFFECTIVE,
//	ID_OPTION_IS_ARROW_GAP_EFFECTIVE,
//	ID_OPTION_AUTO_ALTKEY,
//	ID_OPTION_POP_HINT_ENABLE,
//	ID_GRAPHICS_EDIT_COLOR_TABLE,
//	ID_APP_ABOUT,
//	ID_CONTEXT_HELP,
//	UINT(-1),
//	// _xZkqqHx_iDiJiDhIiDiLiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
//	ID_VIEW_TOOLBAR_OBJ_LABEL,
//	ID_CMB_LABEL_LIST,
//	ID_VIEW_OBJ_LABEL_SHOW_MODE,
//	ID_VIEW_OBJ_LABEL_LIST,
//	ID_VIEW_COPY_POSITION,
//	ID_VIEW_PASTE_POSITION,
//	UINT(-1),
//	// _xZkqqHx_iDhJiDjD_xHqqkZx_/_xZkqqHx_iDhFiDiJiDfGiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
//	ID_VIEW_TOOLBAR_PEN_BRUSH,
//	ID_GRAPHICS_EDIT_REGPEN_TABLE,
//	ID_CMB_OBJ_PEN_COLOR,
//	ID_CMB_OBJ_PEN_STYLE,
//	ID_CMB_OBJ_PEN_WEIGHT,
//	ID_CMB_OBJ_REG_PEN,
//	ID_GRAPHICS_EDIT_REGBRUSH_TABLE,
//	ID_CMB_OBJ_BRUSH_COLOR,
//	ID_CMB_OBJ_REG_BRUSH,
//	UINT(-1),
//	// _xZkqqHx_iDfGiBfLiDgHiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
//	ID_VIEW_TOOLBAR_SHEET,
//	ID_CMB_CURRENT_SHEET,
//	ID_OPTION_SHEET_ORDER,
//	ID_OPTION_MOVE_IN_NEXT_SHEET,
//	ID_OPTION_MOVE_IN_PREV_SHEET,
//	UINT(-1),
//	// _xZkqqHx_iDgFiDeMiDfIiDgHiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
//	ID_VIEW_TOOLBAR_TEXT,
//	ID_FORMAT_FONT,
//	ID_TEXT_LINE,
//	ID_TEXT_MARGIN,
//	ID_TEXT_ALIGN_LEFT,
//	ID_TEXT_ALIGN_CENTER,
//	ID_TEXT_ALIGN_RIGHT,
//	ID_TEXT_ALIGN_LEFTRIGHT,
//	ID_TEXT_ALIGN_TOP,
//	ID_TEXT_ALIGN_V_CENTER,
//	ID_TEXT_ALIGN_BOTTOM,
//----- 06.11.24 Fukushiro M. _xZkqqHx_jFmPiNfIiMoD_xHqqkZx_ ()-----
//===================================
	// _xZkqqHx_jGoOiIpDjAfFiCoJjFjBiCkCiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	ID_VIEW_TOOLBAR_ARROW_DUTY,
//-----------------------------------
	ID_CMB_CURRENT_SHEET,
	ID_ARROWEDIT_SET_DUTY,
	ID_ARROWEDIT_SET_FRAME,
	UINT(-1),
//===================================

//===================================
	// _xZkqqHx_iDiBiDeDiDjDiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	ID_VIEW_TOOLBAR_ARROW_EDIT,
//-----------------------------------
	ID_VIEW_CMB_ZOOM,
	ID_ARROWEDIT_SET_DUTY,
	ID_ARROWEDIT_SET_FRAME,
	ID_EDIT_CUT,
	ID_EDIT_COPY,
	ID_EDIT_PASTE,
	ID_VIEW_REDRAW,
	ID_OPTION_IS_SNAP_EFFECTIVE,
	ID_OPTION_AUTO_ALTKEY,
	ID_OPTION_POP_HINT_ENABLE,
	ID_GRAPHICS_EDIT_COLOR_TABLE,
	ID_APP_ABOUT,
	ID_CONTEXT_HELP,
	ID_TOOL_SELECT,
	ID_TOOL_ZOOM,
	ID_TOOL_ANY_EDIT,
	ID_TOOL_EDIT_RICH_TEXT,
	ID_TOOL_ROTATE,
	ID_TOOL_LINE,
	ID_TOOL_RECT,
	ID_TOOL_RRECT,
	ID_TOOL_ARC,
	ID_TOOL_POLYLINE,
	ID_TOOL_BEZILINE,
	ID_TOOL_WIDE_POLY,
	ID_TOOL_WIDE_BEZIER,
	ID_TOOL_RICH_TEXT,
	ID_OPTION_TOOL_LOCK,
	ID_TEXT_BOTH_CODE_FONT_BOLD,
	ID_TEXT_BOTH_CODE_FONT_ITALIC,
	ID_TEXT_BOTH_CODE_FONT_UNDERLINE,
	ID_TEXT_INFLATE_FONT_SIZE,
	ID_TEXT_DEFLATE_FONT_SIZE,
	ID_GRAPHICS_EDIT_REGPEN_TABLE,
	ID_GRAPHICS_EDIT_REGBRUSH_TABLE,
	ID_FORMAT_FONT,
	ID_TEXT_LINE,
	ID_TEXT_MARGIN,
	ID_TEXT_ALIGN_LEFT,
	ID_TEXT_ALIGN_CENTER,
	ID_TEXT_ALIGN_RIGHT,
	ID_TEXT_ALIGN_LEFTRIGHT,
	ID_TEXT_ALIGN_TOP,
	ID_TEXT_ALIGN_V_CENTER,
	ID_TEXT_ALIGN_BOTTOM,
	UINT(-1),
//===================================

//===================================
	// _xZkqqHx_iDgDiBfLiDiLiDhLiDgCiDeOiDfI_xHqqkZx_1_xZkqqHx_iDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	ID_VIEW_TOOLBAR_ARROW_TOOLS,
//-----------------------------------
	ID_TOOL_SELECT,
	ID_TOOL_ZOOM,
	ID_TOOL_ANY_EDIT,
	ID_TOOL_EDIT_RICH_TEXT,
	ID_TOOL_ROTATE,
	ID_TOOL_LINE,
	ID_TOOL_RECT,
	ID_TOOL_RRECT,
	ID_TOOL_ARC,
	ID_TOOL_POLYLINE,
	ID_TOOL_BEZILINE,
	ID_TOOL_WIDE_POLY,
	ID_TOOL_WIDE_BEZIER,
	ID_TOOL_RICH_TEXT,
	ID_OPTION_TOOL_LOCK,
	UINT(-1),
//===================================

//===================================
	// _xZkqqHx_iDgDiBfLiDiLiDhLiDgCiDeOiDfI_xHqqkZx_2_xZkqqHx_iDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	ID_VIEW_TOOLBAR_ARROW_TOOLS2,
//-----------------------------------
	ID_TOOL_SELECT,
	ID_TOOL_ZOOM,
	ID_TOOL_ANY_EDIT,
	ID_TOOL_EDIT_RICH_TEXT,
	ID_TOOL_ROTATE,
	ID_TOOL_LINE,
	ID_TOOL_RECT,
	ID_TOOL_RRECT,
	ID_TOOL_ARC,
	ID_TOOL_POLYLINE,
	ID_TOOL_BEZILINE,
	ID_TOOL_WIDE_POLY,
	ID_TOOL_WIDE_BEZIER,
	ID_TOOL_RICH_TEXT,
	ID_OPTION_TOOL_LOCK,
	UINT(-1),
//===================================

//===================================
	// _xZkqqHx_iDgAiDgCiDhGjGpAiKiEiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	ID_VIEW_TOOLBAR_CHIP_DUTY,
//-----------------------------------
	ID_CHIPEDIT_CMB_MOLIP_DUTY_ID,
	ID_CHIPEDIT_CMB_TEXT_DUTY_ID,
	ID_CHIPEDIT_SET_DUTY,
	UINT(-1),
//===================================

//===================================
	// _xZkqqHx_iDiBiDeDiDjDiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	ID_VIEW_TOOLBAR_CHIP_EDIT,
//-----------------------------------
	ID_VIEW_CMB_ZOOM,
	ID_CHIPEDIT_SET_DUTY,
	ID_EDIT_CUT,
	ID_EDIT_COPY,
	ID_EDIT_PASTE,
	ID_VIEW_REDRAW,
	ID_OPTION_IS_SNAP_EFFECTIVE,
	ID_OPTION_IS_ARROW_GAP_EFFECTIVE,
	ID_OPTION_AUTO_ALTKEY,
	ID_OPTION_POP_HINT_ENABLE,
	ID_GRAPHICS_EDIT_COLOR_TABLE,
	ID_APP_ABOUT,
	ID_CONTEXT_HELP,
	ID_TOOL_SELECT,
	ID_TOOL_ZOOM,
	ID_TOOL_ANY_EDIT,
	ID_TOOL_EDIT_RICH_TEXT,
	ID_TOOL_ROTATE,
	ID_TOOL_LINK,
	ID_TOOL_POLY_ARROW,
	ID_TOOL_BEZIER_ARROW,
	ID_TOOL_WIDE_POLY_ARROW,
	ID_TOOL_WIDE_BEZIER_ARROW,
	ID_TOOL_BOX_POLY_ARROW,
	ID_TOOL_BOX_BEZIER_ARROW,
	ID_TOOL_LINE,
	ID_TOOL_RECT,
	ID_TOOL_RRECT,
	ID_TOOL_ARC,
	ID_TOOL_TABLE,
	ID_TOOL_POLYLINE,
	ID_TOOL_BEZILINE,
	ID_TOOL_WIDE_POLY,
	ID_TOOL_WIDE_BEZIER,
	ID_TOOL_RICH_TEXT,
	ID_TOOL_TEXT_PUT,
	ID_TOOL_POINT,
	ID_OPTION_TOOL_LOCK,
	ID_TEXT_BOTH_CODE_FONT_BOLD,
	ID_TEXT_BOTH_CODE_FONT_ITALIC,
	ID_TEXT_BOTH_CODE_FONT_UNDERLINE,
	ID_TEXT_INFLATE_FONT_SIZE,
	ID_TEXT_DEFLATE_FONT_SIZE,
	ID_GRAPHICS_EDIT_REGPEN_TABLE,
	ID_GRAPHICS_EDIT_REGBRUSH_TABLE,
	ID_FORMAT_FONT,
	ID_TEXT_LINE,
	ID_TEXT_MARGIN,
	ID_TEXT_ALIGN_LEFT,
	ID_TEXT_ALIGN_CENTER,
	ID_TEXT_ALIGN_RIGHT,
	ID_TEXT_ALIGN_LEFTRIGHT,
	ID_TEXT_ALIGN_TOP,
	ID_TEXT_ALIGN_V_CENTER,
	ID_TEXT_ALIGN_BOTTOM,
	UINT(-1),
//===================================

//===================================
	// _xZkqqHx_iDgDiBfLiDiLiDhLiDgCiDeOiDfI_xHqqkZx_1_xZkqqHx_iDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	ID_VIEW_TOOLBAR_CHIP_TOOLS,
//-----------------------------------
	ID_TOOL_SELECT,
	ID_TOOL_ZOOM,
	ID_TOOL_ANY_EDIT,
	ID_TOOL_EDIT_RICH_TEXT,
	ID_TOOL_ROTATE,
	ID_TOOL_LINK,
	ID_TOOL_POLY_ARROW,
	ID_TOOL_BEZIER_ARROW,
	ID_TOOL_WIDE_POLY_ARROW,
	ID_TOOL_WIDE_BEZIER_ARROW,
	ID_TOOL_BOX_POLY_ARROW,
	ID_TOOL_BOX_BEZIER_ARROW,
	ID_TOOL_LINE,
	ID_TOOL_RECT,
	ID_TOOL_RRECT,
	ID_TOOL_ARC,
	ID_TOOL_TABLE,
	ID_TOOL_POLYLINE,
	ID_TOOL_BEZILINE,
	ID_TOOL_WIDE_POLY,
	ID_TOOL_WIDE_BEZIER,
	ID_TOOL_RICH_TEXT,
	ID_TOOL_TEXT_PUT,
	ID_TOOL_POINT,
	ID_OPTION_TOOL_LOCK,
	UINT(-1),
//===================================

//===================================
	// _xZkqqHx_iDgDiBfLiDiLiDhLiDgCiDeOiDfI_xHqqkZx_2_xZkqqHx_iDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	ID_VIEW_TOOLBAR_CHIP_TOOLS2,
//-----------------------------------
	ID_TOOL_SELECT,
	ID_TOOL_ZOOM,
	ID_TOOL_ANY_EDIT,
	ID_TOOL_EDIT_RICH_TEXT,
	ID_TOOL_ROTATE,
	ID_TOOL_LINK,
	ID_TOOL_POLY_ARROW,
	ID_TOOL_BEZIER_ARROW,
	ID_TOOL_WIDE_POLY_ARROW,
	ID_TOOL_WIDE_BEZIER_ARROW,
	ID_TOOL_BOX_POLY_ARROW,
	ID_TOOL_BOX_BEZIER_ARROW,
	ID_TOOL_LINE,
	ID_TOOL_RECT,
	ID_TOOL_RRECT,
	ID_TOOL_ARC,
	ID_TOOL_TABLE,
	ID_TOOL_POLYLINE,
	ID_TOOL_BEZILINE,
	ID_TOOL_WIDE_POLY,
	ID_TOOL_WIDE_BEZIER,
	ID_TOOL_RICH_TEXT,
	ID_TOOL_TEXT_PUT,
	ID_TOOL_POINT,
	ID_OPTION_TOOL_LOCK,
	UINT(-1),
//===================================

//===================================
	// _xZkqqHx_iDgDiBfLiDiLiDhLiDgCiDeOiDfI_xHqqkZx_1_xZkqqHx_iDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	ID_VIEW_TOOLBAR_COMDRW_TOOLS,
//-----------------------------------
	ID_TOOL_SELECT,
	ID_TOOL_ZOOM,
	ID_TOOL_ANY_EDIT,
	ID_TOOL_EDIT_RICH_TEXT,
	ID_TOOL_ROTATE,
	ID_TOOL_LINK,
	ID_TOOL_POLY_ARROW,
	ID_TOOL_BEZIER_ARROW,
	ID_TOOL_WIDE_POLY_ARROW,
	ID_TOOL_WIDE_BEZIER_ARROW,
	ID_TOOL_BOX_POLY_ARROW,
	ID_TOOL_BOX_BEZIER_ARROW,
	ID_TOOL_PEN_LABEL_PUT,
	ID_TOOL_NOTE_LABEL_PUT,
	ID_TOOL_CHIP,
	ID_TOOL_CHIP_PUT,
	ID_TOOL_LINE,
	ID_TOOL_RECT,
	ID_TOOL_RRECT,
	ID_TOOL_ARC,
	ID_TOOL_TABLE,
	ID_TOOL_POLYLINE,
	ID_TOOL_BEZILINE,
	ID_TOOL_WIDE_POLY,
	ID_TOOL_WIDE_BEZIER,
	ID_TOOL_RICH_TEXT,
	ID_TOOL_TEXT_PUT,
	ID_OPTION_TOOL_LOCK,
	UINT(-1),
//===================================

//===================================
	// _xZkqqHx_iDgDiBfLiDiLiDhLiDgCiDeOiDfI_xHqqkZx_2_xZkqqHx_iDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	ID_VIEW_TOOLBAR_COMDRW_TOOLS2,
//-----------------------------------
	ID_TOOL_SELECT,
	ID_TOOL_ZOOM,
	ID_TOOL_ANY_EDIT,
	ID_TOOL_EDIT_RICH_TEXT,
	ID_TOOL_ROTATE,
	ID_TOOL_LINK,
	ID_TOOL_POLY_ARROW,
	ID_TOOL_BEZIER_ARROW,
	ID_TOOL_WIDE_POLY_ARROW,
	ID_TOOL_WIDE_BEZIER_ARROW,
	ID_TOOL_BOX_POLY_ARROW,
	ID_TOOL_BOX_BEZIER_ARROW,
	ID_TOOL_PEN_LABEL_PUT,
	ID_TOOL_NOTE_LABEL_PUT,
	ID_TOOL_CHIP,
	ID_TOOL_CHIP_PUT,
	ID_TOOL_LINE,
	ID_TOOL_RECT,
	ID_TOOL_RRECT,
	ID_TOOL_ARC,
	ID_TOOL_TABLE,
	ID_TOOL_POLYLINE,
	ID_TOOL_BEZILINE,
	ID_TOOL_WIDE_POLY,
	ID_TOOL_WIDE_BEZIER,
	ID_TOOL_RICH_TEXT,
	ID_TOOL_TEXT_PUT,
	ID_OPTION_TOOL_LOCK,
	UINT(-1),
//===================================

//===================================
	// _xZkqqHx_iDhEiDeIiDjDiDgHiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	ID_VIEW_TOOLBAR_FONT,
//-----------------------------------
	ID_CMB_BOTH_CODE_FONT_NAME,
	ID_CMB_BOTH_CODE_FONT_SIZE,
	ID_CMB_BOTH_CODE_FONT_COLOR,
	ID_TEXT_BOTH_CODE_FONT_BOLD,
	ID_TEXT_BOTH_CODE_FONT_ITALIC,
	ID_TEXT_BOTH_CODE_FONT_UNDERLINE,
	ID_TEXT_INFLATE_FONT_SIZE,
	ID_TEXT_DEFLATE_FONT_SIZE,
	UINT(-1),
//===================================

//===================================
	// _xZkqqHx_iDiBiDeDiDjDiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	ID_VIEW_TOOLBAR_HIST_DRAW_MAIN,
//-----------------------------------
	ID_VIEW_CMB_ZOOM,
	ID_TOOL_SELECT,
	ID_TOOL_ZOOM,
	ID_TOOL_ANY_EDIT,
	ID_TOOL_EDIT_RICH_TEXT,
	ID_TOOL_ROTATE,
	ID_TOOL_LINK,
	ID_TOOL_POLY_ARROW,
	ID_TOOL_BEZIER_ARROW,
	ID_TOOL_WIDE_POLY_ARROW,
	ID_TOOL_WIDE_BEZIER_ARROW,
	ID_TOOL_BOX_POLY_ARROW,
	ID_TOOL_BOX_BEZIER_ARROW,
	ID_TOOL_PEN_LABEL_PUT,
	ID_TOOL_NOTE_LABEL_PUT,
	ID_TOOL_CHIP,
	ID_TOOL_CHIP_PUT,
	ID_TOOL_LINE,
	ID_TOOL_RECT,
	ID_TOOL_RRECT,
	ID_TOOL_ARC,
	ID_TOOL_TABLE,
	ID_TOOL_POLYLINE,
	ID_TOOL_BEZILINE,
	ID_TOOL_WIDE_POLY,
	ID_TOOL_WIDE_BEZIER,
	ID_TOOL_RICH_TEXT,
	ID_TOOL_TEXT_PUT,
	ID_OPTION_TOOL_LOCK,
	ID_TEXT_BOTH_CODE_FONT_BOLD,
	ID_TEXT_BOTH_CODE_FONT_ITALIC,
	ID_TEXT_BOTH_CODE_FONT_UNDERLINE,
	ID_TEXT_INFLATE_FONT_SIZE,
	ID_TEXT_DEFLATE_FONT_SIZE,
	ID_EDIT_CUT,
	ID_EDIT_COPY,
	ID_EDIT_PASTE,
	ID_VIEW_CHIP_STORE_VISIBLE,
	ID_VIEW_HTREE_VISIBLE,
	ID_VIEW_REDRAW,
	ID_OPTION_IS_SNAP_EFFECTIVE,
	ID_OPTION_IS_ARROW_GAP_EFFECTIVE,
	ID_OPTION_AUTO_ALTKEY,
	ID_OPTION_POP_HINT_ENABLE,
	ID_GRAPHICS_EDIT_COLOR_TABLE,
	ID_APP_ABOUT,
	ID_CONTEXT_HELP,
	ID_OPTION_LAYER_ORDER,
	ID_OPTION_MOVE_IN_LOWER_LAYER,
	ID_OPTION_MOVE_IN_UPPER_LAYER,
	ID_VIEW_OBJ_LABEL_SHOW_MODE,
	ID_VIEW_OBJ_LABEL_LIST,
	ID_VIEW_COPY_POSITION,
	ID_VIEW_PASTE_POSITION,
	ID_GRAPHICS_EDIT_REGPEN_TABLE,
	ID_GRAPHICS_EDIT_REGBRUSH_TABLE,
	ID_OPTION_SHEET_ORDER,
	ID_OPTION_MOVE_IN_NEXT_SHEET,
	ID_OPTION_MOVE_IN_PREV_SHEET,
	ID_FORMAT_FONT,
	ID_TEXT_LINE,
	ID_TEXT_MARGIN,
	ID_TEXT_ALIGN_LEFT,
	ID_TEXT_ALIGN_CENTER,
	ID_TEXT_ALIGN_RIGHT,
	ID_TEXT_ALIGN_LEFTRIGHT,
	ID_TEXT_ALIGN_TOP,
	ID_TEXT_ALIGN_V_CENTER,
	ID_TEXT_ALIGN_BOTTOM,
	UINT(-1),
//===================================

//===================================
	// _xZkqqHx_iDiBiDeDiDjDiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	ID_VIEW_TOOLBAR_HIST_VIEW,
//-----------------------------------
	ID_VIEW_CMB_ZOOM,
	ID_VIEW_PREV_DSM,
	ID_VIEW_APPEND_DSM,
	ID_VIEW_NEXT_DSM,
	ID_VIEW_DSM_PANEL,
	ID_VIEW_HTREE_VISIBLE,
	ID_VIEW_REDRAW,
	ID_VIEW_COPY_POSITION,
	ID_VIEW_PASTE_POSITION,
	ID_HTREE_USE_TIME_INDEX,
	ID_OPTION_AUTO_ALTKEY,
	ID_OPTION_POP_HINT_ENABLE,
	ID_APP_ABOUT,
	ID_CONTEXT_HELP,
	ID_TOOL_SELECT,
	ID_TOOL_ZOOM,
	ID_TOOL_LINK,
	ID_TOOL_TIME_LABEL,
	ID_OPTION_TOOL_LOCK,
	ID_HTREE_FIND_PANEL,
	ID_HTREE_FIND_RESULTS,
	ID_HTREE_JUMP_NEXT_FIND_RESULT,
	ID_HTREE_JUMP_PREV_FIND_RESULT,
	ID_HTREE_MOVE_SELECTION_BEFORE,
	ID_HTREE_MOVE_SELECTION_AFTER,
	ID_OPTION_LAYER_ORDER,
	ID_OPTION_MOVE_IN_LOWER_LAYER,
	ID_OPTION_MOVE_IN_UPPER_LAYER,
	ID_VIEW_OBJ_LABEL_SHOW_MODE,
	ID_VIEW_OBJ_LABEL_LIST,
	ID_VIEW_COPY_POSITION,
	ID_VIEW_PASTE_POSITION,
	ID_OPTION_SHEET_ORDER,
	ID_OPTION_MOVE_IN_NEXT_SHEET,
	ID_OPTION_MOVE_IN_PREV_SHEET,
	UINT(-1),
//===================================

//===================================
	// _xZkqqHx_iDgDiBfLiDiLiDhLiDgCiDeOiDfIiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	ID_VIEW_TOOLBAR_HIST_VIEW_TOOLS,
//-----------------------------------
	ID_TOOL_SELECT,
	ID_TOOL_ZOOM,
	ID_TOOL_LINK,
	ID_TOOL_TIME_LABEL,
	ID_OPTION_TOOL_LOCK,
	UINT(-1),
//===================================

//===================================
	// _xZkqqHx_jHjKjHpAiMjPiNpFiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	ID_VIEW_TOOLBAR_HTREE_SEARCH,
//-----------------------------------
	ID_HTREE_FIND_PANEL,
	ID_HTREE_FIND_RESULTS,
	ID_HTREE_JUMP_NEXT_FIND_RESULT,
	ID_HTREE_JUMP_PREV_FIND_RESULT,
	ID_HTREE_MOVE_SELECTION_BEFORE,
	ID_HTREE_MOVE_SELECTION_AFTER,
	UINT(-1),
//===================================

//===================================
	// _xZkqqHx_iDiMiDeDiDiEiBfLiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	ID_VIEW_TOOLBAR_LAYER,
//-----------------------------------
	ID_CMB_CURRENT_LAYER,
	ID_OPTION_LAYER_ORDER,
	ID_OPTION_MOVE_IN_LOWER_LAYER,
	ID_OPTION_MOVE_IN_UPPER_LAYER,
	UINT(-1),
//===================================

//===================================
	// _xZkqqHx_iDiBiDeDiDjDiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	ID_VIEW_TOOLBAR_MAINFRAME,
//-----------------------------------
	ID_VIEW_CMB_ZOOM,
	ID_TOOL_SELECT,
	ID_TOOL_ZOOM,
	ID_TOOL_ANY_EDIT,
	ID_TOOL_EDIT_RICH_TEXT,
	ID_TOOL_ROTATE,
	ID_TOOL_LINK,
	ID_TOOL_POLY_ARROW,
	ID_TOOL_BEZIER_ARROW,
	ID_TOOL_WIDE_POLY_ARROW,
	ID_TOOL_WIDE_BEZIER_ARROW,
	ID_TOOL_BOX_POLY_ARROW,
	ID_TOOL_BOX_BEZIER_ARROW,
	ID_TOOL_PEN_LABEL_PUT,
	ID_TOOL_NOTE_LABEL_PUT,
	ID_TOOL_CHIP,
	ID_TOOL_CHIP_PUT,
	ID_TOOL_LINE,
	ID_TOOL_RECT,
	ID_TOOL_RRECT,
	ID_TOOL_ARC,
	ID_TOOL_TABLE,
	ID_TOOL_POLYLINE,
	ID_TOOL_BEZILINE,
	ID_TOOL_WIDE_POLY,
	ID_TOOL_WIDE_BEZIER,
	ID_TOOL_RICH_TEXT,
	ID_TOOL_TEXT_PUT,
	ID_OPTION_TOOL_LOCK,
	ID_TEXT_BOTH_CODE_FONT_BOLD,
	ID_TEXT_BOTH_CODE_FONT_ITALIC,
	ID_TEXT_BOTH_CODE_FONT_UNDERLINE,
	ID_TEXT_INFLATE_FONT_SIZE,
	ID_TEXT_DEFLATE_FONT_SIZE,
	ID_OPTION_LAYER_ORDER,
	ID_OPTION_MOVE_IN_LOWER_LAYER,
	ID_OPTION_MOVE_IN_UPPER_LAYER,
	ID_FILE_WIN_NEW,
	ID_FILE_OPEN,
	ID_FILE_SAVE,
	ID_EDIT_CUT,
	ID_EDIT_COPY,
	ID_EDIT_PASTE,
	ID_VIEW_CHIP_STORE_VISIBLE,
	ID_VIEW_REDRAW,
	ID_OPTION_IS_SNAP_EFFECTIVE,
	ID_OPTION_IS_ARROW_GAP_EFFECTIVE,
	ID_OPTION_AUTO_ALTKEY,
	ID_OPTION_POP_HINT_ENABLE,
	ID_GRAPHICS_EDIT_COLOR_TABLE,
	ID_APP_ABOUT,
	ID_CONTEXT_HELP,
	ID_VIEW_OBJ_LABEL_SHOW_MODE,
	ID_VIEW_OBJ_LABEL_LIST,
	ID_VIEW_COPY_POSITION,
	ID_VIEW_PASTE_POSITION,
	ID_GRAPHICS_EDIT_REGPEN_TABLE,
	ID_GRAPHICS_EDIT_REGBRUSH_TABLE,
	ID_OPTION_SHEET_ORDER,
	ID_OPTION_MOVE_IN_NEXT_SHEET,
	ID_OPTION_MOVE_IN_PREV_SHEET,
	ID_FORMAT_FONT,
	ID_TEXT_LINE,
	ID_TEXT_MARGIN,
	ID_TEXT_ALIGN_LEFT,
	ID_TEXT_ALIGN_CENTER,
	ID_TEXT_ALIGN_RIGHT,
	ID_TEXT_ALIGN_LEFTRIGHT,
	ID_TEXT_ALIGN_TOP,
	ID_TEXT_ALIGN_V_CENTER,
	ID_TEXT_ALIGN_BOTTOM,
	UINT(-1),
//===================================

//===================================
	// _xZkqqHx_iDiJiDhIiDiLiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	ID_VIEW_TOOLBAR_OBJ_LABEL,
//-----------------------------------
	ID_CMB_LABEL_LIST,
	ID_VIEW_OBJ_LABEL_SHOW_MODE,
	ID_VIEW_OBJ_LABEL_LIST,
	UINT(-1),
//===================================

//===================================
	// _xZkqqHx_iDhJiDjD_xHqqkZx_/_xZkqqHx_iDhFiDiJiDfGiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	ID_VIEW_TOOLBAR_PEN_BRUSH,
//-----------------------------------
	ID_CMB_OBJ_PEN_COLOR,
	ID_CMB_OBJ_PEN_STYLE,
	ID_CMB_OBJ_PEN_WEIGHT,
	ID_CMB_OBJ_REG_PEN,
	ID_CMB_OBJ_BRUSH_COLOR,
	ID_CMB_OBJ_REG_BRUSH,
	ID_GRAPHICS_EDIT_REGPEN_TABLE,
	ID_GRAPHICS_EDIT_REGBRUSH_TABLE,
	UINT(-1),
//===================================

//===================================
	// _xZkqqHx_iDfGiBfLiDgHiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	ID_VIEW_TOOLBAR_SHEET,
//-----------------------------------
	ID_CMB_CURRENT_SHEET,
	ID_OPTION_SHEET_ORDER,
	ID_OPTION_MOVE_IN_NEXT_SHEET,
	ID_OPTION_MOVE_IN_PREV_SHEET,
	UINT(-1),
//===================================

//===================================
	// _xZkqqHx_iDgFiDeMiDfIiDgHiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	ID_VIEW_TOOLBAR_TEXT,
//-----------------------------------
	ID_FORMAT_FONT,
	ID_TEXT_LINE,
	ID_TEXT_MARGIN,
	ID_TEXT_ALIGN_LEFT,
	ID_TEXT_ALIGN_CENTER,
	ID_TEXT_ALIGN_RIGHT,
	ID_TEXT_ALIGN_LEFTRIGHT,
	ID_TEXT_ALIGN_TOP,
	ID_TEXT_ALIGN_V_CENTER,
	ID_TEXT_ALIGN_BOTTOM,
//===================================
//----- 06.11.24 Fukushiro M. _xZkqqHx_jFmPiNfIiPeJ_xHqqkZx_ ()-----
}; // POOL_TOOLBAR.

/*************************************************************************
 * <_xZkqqHx_jFmPjAjE_xHqqkZx_>	DROPDOWN_LIST
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDgDiBfLiDiLiDgPiBfLiCmFjHjIjHhAiClDiCoKiCoJiDhGiDiLiDfPiDeFiDjDiDiKiDfIiDgHiCmMiIoKjHjHiCpAiLeMjIfOiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	06.10.31 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
static const UINT DROPDOWN_LIST[] =
{
	ID_VIEW_CMB_ZOOM,
	ID_CHIPEDIT_CMB_MOLIP_DUTY_ID,
	ID_CHIPEDIT_CMB_TEXT_DUTY_ID,
	ID_CMB_OBJ_PEN_COLOR,
	ID_CMB_OBJ_PEN_STYLE,
	ID_CMB_OBJ_PEN_WEIGHT,
	ID_CMB_OBJ_REG_PEN,
	ID_CMB_OBJ_BRUSH_COLOR,
	ID_CMB_OBJ_REG_BRUSH,
	ID_CMB_CURRENT_LAYER,
	ID_CMB_CURRENT_SHEET,
	ID_CMB_LABEL_LIST,
	ID_CMB_BOTH_CODE_FONT_NAME,
	ID_CMB_BOTH_CODE_FONT_SIZE,
	ID_CMB_BOTH_CODE_FONT_COLOR,
}; // DROPDOWN_LIST.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FFGetToolbarList
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iMlLiNnNiCmMiDeBiDhGiDiKiDfAiBfLiDfGiDiHiDjDiCmFjHjIjHhAiClDiCoKiCoJiDgDiBfLiDiLiDgPiBfLiCmM_xHqqkZx_ID_xZkqqHx_iIoKjHjHiCpAjFnEiClHiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	vToolbarId	:_xZkqqHx_iDgDiBfLiDiLiDgPiBfL_xHqqkZx_ID_xZkqqHx_jEhKjHpBiCpAjFnEiClHiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	06.10.27 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FFGetToolbarList (UINTVector& vToolbarId)
{
	const size_t szToolbarToAppCount = sizeof(s_toolbarToApp) / sizeof(s_toolbarToApp[0]);
	for (size_t sz = 0; sz != szToolbarToAppCount; sz++)
	{
		if (g_->appMode & s_toolbarToApp[sz].m_wAppmode)
			vToolbarId.push_back(s_toolbarToApp[sz].m_uiToolbarId);
	}
} // FFGetToolbarList.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FFGetToolbarCommandPoolList
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iOhHjCoIiClDiCoKiClNiDgDiBfLiDiLiDgPiBfLiCmFjHjIjHhAiJmCjEfMiCmIiDfCiDhNiDjDiDgIiIoKjHjHiCpAjFnEiClHiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	stCommandId	:_xZkqqHx_jHjIjHhAiJmCjEfMiCmIiDfCiDhNiDjDiDgIiIoKjHjHiCpAjFnEiClHiBeC_xHqqkZx_
 *			uiToolbarId	:_xZkqqHx_iDgDiBfLiDiLiDgPiBfL_xHqqkZx_ID_xZkqqHx_iCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	06.10.26 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FFGetToolbarCommandPoolList (UINTSet& stCommandId, UINT uiToolbarId)
{
	// _xZkqqHx_iDgDiBfLiDiLiDgPiBfL_xHqqkZx_ID -> _xZkqqHx_iDfCiDhNiDjDiDgIiIoKjHjH_xHqqkZx_ _xZkqqHx_iDgOiDgCiDfGiDiFiBeC_xHqqkZx_
	static map<UINT, UINTSet> s_ToolbarToCommandIdSet;
	if (s_ToolbarToCommandIdSet.empty())
	//----- _xZkqqHx_iDgDiBfLiDiLiDgPiBfL_xHqqkZx_ID -> _xZkqqHx_iDfCiDhNiDjDiDgIiIoKjHjH_xHqqkZx_ _xZkqqHx_iDgOiDgCiDfGiDiF_xHqqkZx_ _xZkqqHx_iCkKjGkCjAnNjCoIiCmMiPoKiNiH_xHqqkZx_ -----
	{
		const size_t szPoolToolbar = sizeof(POOL_TOOLBAR) / sizeof(POOL_TOOLBAR[0]);
		size_t sz = 0;
		for (;;)
		{
			UINT uiTmpId = POOL_TOOLBAR[sz];
			for (sz++; sz != szPoolToolbar; sz++)
			{
				if (POOL_TOOLBAR[sz] == UINT(-1)) break;
				s_ToolbarToCommandIdSet[uiTmpId].insert(POOL_TOOLBAR[sz]);
			}
			if (sz == szPoolToolbar) break;
			sz++;
		}
	}
	map<UINT, UINTSet>::const_iterator i = s_ToolbarToCommandIdSet.find(uiToolbarId);
	if (i == s_ToolbarToCommandIdSet.end())
		FFThrowMiscUnknown();
	stCommandId = i->second;
} // FFGetToolbarCommandPoolList.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FFGetDefaultToolbarCommandList
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iOhHjCoIiClDiCoKiClNiDgDiBfLiDiLiDgPiBfLiCmMiDgGiDhEiDeIiDiLiDgHiCmMiDfCiDhNiDjDiDgIiIoKjHjHiCpAjFnEiClHiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	vCommandId	:_xZkqqHx_jHjIjHhAiJmCjEfMiCmIiDfCiDhNiDjDiDgIiIoKjHjHiCpAjFnEiClHiBeC_xHqqkZx_
 *			uiToolbarId	:_xZkqqHx_iDgDiBfLiDiLiDgPiBfL_xHqqkZx_ID_xZkqqHx_iCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	06.10.26 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FFGetDefaultToolbarCommandList (UINTVector& vCommandId, UINT uiToolbarId)
{
	// _xZkqqHx_iDgDiBfLiDiLiDgPiBfL_xHqqkZx_ID -> _xZkqqHx_iDfCiDhNiDjDiDgIiIoKjHjH_xHqqkZx_ _xZkqqHx_iDgOiDgCiDfGiDiFiBeC_xHqqkZx_
	static map<UINT, UINTVector> s_ToolbarToDefaultIdVector;
	if (s_ToolbarToDefaultIdVector.empty())
	//----- _xZkqqHx_iDgDiBfLiDiLiDgPiBfL_xHqqkZx_ID -> _xZkqqHx_iDfCiDhNiDjDiDgIiIoKjHjH_xHqqkZx_ _xZkqqHx_iDgOiDgCiDfGiDiF_xHqqkZx_ _xZkqqHx_iCkKjGkCjAnNjCoIiCmMiPoKiNiH_xHqqkZx_ -----
	{
		const size_t szDefaultToolbar = sizeof(DEFAULT_TOOLBAR) / sizeof(DEFAULT_TOOLBAR[0]);
		size_t sz = 0;
		for (;;)
		{
			UINT uiTmpId = DEFAULT_TOOLBAR[sz];
			for (sz++; sz != szDefaultToolbar; sz++)
			{
				if (DEFAULT_TOOLBAR[sz] == UINT(-1)) break;
				if (DEFAULT_TOOLBAR[sz] == ID_SEPARATOR)
					s_ToolbarToDefaultIdVector[uiTmpId].push_back(ID_SEPARATOR);
				else
					s_ToolbarToDefaultIdVector[uiTmpId].push_back(DEFAULT_TOOLBAR[sz]);
			}
			if (sz == szDefaultToolbar) break;
			sz++;
		}
	}
	map<UINT, UINTVector>::const_iterator i = s_ToolbarToDefaultIdVector.find(uiToolbarId);
	if (i == s_ToolbarToDefaultIdVector.end())
		FFThrowMiscUnknown();
	vCommandId = i->second;
} // FFGetDefaultToolbarCommandList.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FFGetToolbarCommandList
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iOhHjCoIiClDiCoKiClNiDgDiBfLiDiLiDgPiBfLiCmMiMlLiNnNiCmMiDfCiDhNiDjDiDgIiIoKjHjHiCpAjFnEiClHiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	vCommandId	:_xZkqqHx_jHjIjHhAiJmCjEfMiCmIiDfCiDhNiDjDiDgIiIoKjHjHiCpAjFnEiClHiBeC_xHqqkZx_
 *			uiToolbarId	:_xZkqqHx_iDgDiBfLiDiLiDgPiBfL_xHqqkZx_ID_xZkqqHx_iCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	06.10.29 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FFGetToolbarCommandList (UINTVector& vCommandId, UINT uiToolbarId)
{
	vCommandId.clear();
	// _xZkqqHx_iDiMiDfHiDfIiDgHiDiKiCkJiCoHiDfCiDhNiDjDiDgIjHpBjFlGiOjKjHpBiCpAiOoGjDlOiBeC_xHqqkZx_
	WString wstrCommandList;
	if (g_pReg->LoadRegString(REG_TOOLBAR_SESSION, FFFormatString(L"%lu", uiToolbarId), wstrCommandList) &&
		!wstrCommandList.IsEmpty())
	//----- _xZkqqHx_iDiMiDfHiDfIiDgHiDiKiCmJiLeMjIfOiCkKiCkAiCoJiPoKiNiH_xHqqkZx_ -----
	{
		// _xZkqqHx_iDfCiDhNiDjDiDgIjHpBjFlGiOjKjHpBiCkJiCoHiDfCiDhNiDjDiDgIiCpAiIoKiCmCiClIiCmCiOoGiCoIiPgPiClHiBeC_xHqqkZx_
		for (;;)
		{
			WString wstrCommandId = FFExtractUntil(wstrCommandList, L',');
			if (wstrCommandId.IsEmpty()) break;
			long lCommandId = wcstol(wstrCommandId, NULL, 10);
			if (lCommandId == -1)
			{
				vCommandId.push_back(ID_SEPARATOR);
			} else
			{
				vCommandId.push_back(UINT(lCommandId));
			}
		}
	} else
	//----- _xZkqqHx_iDiMiDfHiDfIiDgHiDiKiCmJiLeMjIfOiCkKjGlDiCkCiPoKiNiH_xHqqkZx_ -----
	{
		// _xZkqqHx_iDgGiDhEiDeIiDiLiDgHjAnNjCoIiCpAiOoGjDlOiBeC_xHqqkZx_
		FFGetDefaultToolbarCommandList(vCommandId, uiToolbarId);
	}
} // FFGetToolbarCommandList.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FFSetToolbarCommandList
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iOhHjCoIiClDiCoKiClNiDgDiBfLiDiLiDgPiBfLiCmMiMlLiNnNiCmMiDfCiDhNiDjDiDgIiIoKjHjHiCpAjAnNjCoIiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	uiToolbarId		:_xZkqqHx_iDgDiBfLiDiLiDgPiBfL_xHqqkZx_ID_xZkqqHx_iCpAiOhHjCoIiBeC_xHqqkZx_
 *			aCommandIdList	:_xZkqqHx_jHjIjHhAiJmCjEfMiCmIiDfCiDhNiDjDiDgIiIoKjHjHiCpAiOhHjCoIiBeC_xHqqkZx_
 *			lCommandIdListCount
 *							:aCommandIdList_xZkqqHx_iCmMjEhKjHpBiDfEiDeDiDfJiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	06.10.29 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FFSetToolbarCommandList (UINT uiToolbarId, const UINT* aCommandIdList, long lCommandIdListCount)
{
	WString wstrCommandIdList;
	long lIndex;
	for (lIndex = 0; lIndex != lCommandIdListCount; lIndex++)
		wstrCommandIdList += FFFormatString(L"%lu,", aCommandIdList[lIndex]);
	if (!wstrCommandIdList.IsEmpty())
		wstrCommandIdList.ChopLast();
	g_pReg->SaveRegString(REG_TOOLBAR_SESSION, FFFormatString(L"%lu", uiToolbarId), wstrCommandIdList);
} // FFSetToolbarCommandList.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FFIsToolbarDropdown
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iOhHjCoIiClDiCoKiClNiDfCiDhNiDjDiDgI_xHqqkZx_ID_xZkqqHx_iCkKiBeBiDgDiBfLiDiLiDgPiBfLiCmMiDhGiDiLiDfPiDeFiDjDiDiBiDgKiDiFiBfLiCkJiCmHiCkEiCkJ_xHqqkZx_
 *			_xZkqqHx_iCpAjClCiCnHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	uiCommandId		:_xZkqqHx_iDfCiDhNiDjDiDgI_xHqqkZx_ID_xZkqqHx_iCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jFnEjCgM_xHqqkZx_>	_xZkqqHx_iDhGiDiLiDfPiDeFiDjDiDiBiDgKiDiFiBfLiCmMiPoKiNiHiCmN_xHqqkZx_TRUE_xZkqqHx_iBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	06.10.26 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
BOOL FFIsToolbarDropdown (UINT uiCommandId)
{
	static UINTSet s_stDropdownId;
	if (s_stDropdownId.empty())
	{
		const size_t szDropdownCount = sizeof(DROPDOWN_LIST) / sizeof(DROPDOWN_LIST[0]);
		for (UINT uiC = 0; uiC != szDropdownCount; uiC++)
			s_stDropdownId.insert(DROPDOWN_LIST[uiC]);
	}
	return (s_stDropdownId.find(uiCommandId) != s_stDropdownId.end());
} // FFIsToolbarDropdown.

