#ifndef __AfxRes_h
#define __AfxRes_h

// File commands
#define FD_ID_FILE_NEW                     0xE100
#define FD_ID_FILE_OPEN                    0xE101
#define FD_ID_FILE_CLOSE                   0xE102
#define FD_ID_FILE_SAVE                    0xE103
#define FD_ID_FILE_SAVE_AS                 0xE104
#define FD_ID_FILE_PAGE_SETUP              0xE105
#define FD_ID_FILE_PRINT_SETUP             0xE106
#define FD_ID_FILE_PRINT                   0xE107
#define FD_ID_FILE_PRINT_DIRECT            0xE108
#define FD_ID_FILE_PRINT_PREVIEW           0xE109
#define FD_ID_FILE_UPDATE                  0xE10A
#define FD_ID_FILE_SAVE_COPY_AS            0xE10B
#define FD_ID_FILE_SEND_MAIL               0xE10C
#define FD_ID_FILE_MRU_FIRST               0xE110
#define FD_ID_FILE_MRU_FILE1               0xE110
#define FD_ID_FILE_MRU_FILE2               0xE111
#define FD_ID_FILE_MRU_FILE3               0xE112
#define FD_ID_FILE_MRU_FILE4               0xE113
#define FD_ID_FILE_MRU_FILE5               0xE114
#define FD_ID_FILE_MRU_FILE6               0xE115
#define FD_ID_FILE_MRU_FILE7               0xE116
#define FD_ID_FILE_MRU_FILE8               0xE117
#define FD_ID_FILE_MRU_FILE9               0xE118
#define FD_ID_FILE_MRU_FILE10              0xE119
#define FD_ID_FILE_MRU_FILE11              0xE11A
#define FD_ID_FILE_MRU_FILE12              0xE11B
#define FD_ID_FILE_MRU_FILE13              0xE11C
#define FD_ID_FILE_MRU_FILE14              0xE11D
#define FD_ID_FILE_MRU_FILE15              0xE11E
#define FD_ID_FILE_MRU_FILE16              0xE11F
#define FD_ID_FILE_MRU_LAST                0xE11F

// Edit commands
#define FD_ID_EDIT_CLEAR                   0xE120
#define FD_ID_EDIT_CLEAR_ALL               0xE121
#define FD_ID_EDIT_COPY                    0xE122
#define FD_ID_EDIT_CUT                     0xE123
#define FD_ID_EDIT_FIND                    0xE124
#define FD_ID_EDIT_PASTE                   0xE125
#define FD_ID_EDIT_PASTE_LINK              0xE126
#define FD_ID_EDIT_PASTE_SPECIAL           0xE127
#define FD_ID_EDIT_REPEAT                  0xE128
#define FD_ID_EDIT_REPLACE                 0xE129
#define FD_ID_EDIT_SELECT_ALL              0xE12A
#define FD_ID_EDIT_UNDO                    0xE12B
#define FD_ID_EDIT_REDO                    0xE12C

// Window commands
#define FD_ID_WINDOW_NEW                   0xE130
#define FD_ID_WINDOW_ARRANGE               0xE131
#define FD_ID_WINDOW_CASCADE               0xE132
#define FD_ID_WINDOW_TILE_HORZ             0xE133
#define FD_ID_WINDOW_TILE_VERT             0xE134
#define FD_ID_WINDOW_SPLIT                 0xE135
#ifndef RC_INVOKED      // code only
#endif //!RC_INVOKED

// Help and App commands
#define FD_ID_APP_ABOUT                    0xE140
#define FD_ID_APP_EXIT                     0xE141
#define FD_ID_HELP_INDEX                   0xE142
#define FD_ID_HELP_FINDER                  0xE143
#define FD_ID_HELP_USING                   0xE144
#define FD_ID_CONTEXT_HELP                 0xE145
// special commands for processing help
#define FD_ID_HELP                         0xE146
#define FD_ID_DEFAULT_HELP                 0xE147

// Misc
#define FD_ID_NEXT_PANE                    0xE150
#define FD_ID_PREV_PANE                    0xE151

// Format
#define FD_ID_FORMAT_FONT                  0xE160

// OLE commands
#define FD_ID_OLE_INSERT_NEW               0xE200
#define FD_ID_OLE_EDIT_LINKS               0xE201
#define FD_ID_OLE_EDIT_CONVERT             0xE202
#define FD_ID_OLE_EDIT_CHANGE_ICON         0xE203
#define FD_ID_OLE_EDIT_PROPERTIES          0xE204
#define FD_ID_OLE_VERB_FIRST               0xE210

// for print preview dialog bar

// View commands (same number used as IDW used for control bar)
#define FD_ID_VIEW_TOOLBAR                 0xE800
#define FD_ID_VIEW_STATUS_BAR              0xE801
#define FD_ID_VIEW_REBAR                   0xE804
#define FD_ID_VIEW_AUTOARRANGE             0xE805
// E810 -> E81F must be kept in order for RANGE macros
#define FD_ID_VIEW_SMALLICON               0xE810
#define FD_ID_VIEW_LARGEICON               0xE811
#define FD_ID_VIEW_LIST                   0xE812
#define FD_ID_VIEW_DETAILS                 0xE813
#define FD_ID_VIEW_LINEUP                  0xE814
#define FD_ID_VIEW_BYNAME                  0xE815
// E800 -> E8FF reserved for other control bar commands

// RecordForm commands
#define FD_ID_RECORD_FIRST                 0xE900
#define FD_ID_RECORD_LAST                  0xE901
#define FD_ID_RECORD_NEXT                  0xE902
#define FD_ID_RECORD_PREV                  0xE903

// Property Sheet control id's (determined with Spy++)
#define FD_ID_APPLY_NOW                    0x3021
#define FD_ID_WIZBACK                      0x3023
#define FD_ID_WIZNEXT                      0x3024
#define FD_ID_WIZFINISH                    0x3025

#endif//__AfxRes_h

