/*
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS"
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is "SVG Export" plug-in for DynamicDraw.

The Initial Developer of the Original Code is FUKUSHIRO Masayuki.

Copyright (C) 2001,2002  FUKUSHIRO Masayuki ( yt3m-fksr@asahi-net.or.jp ), 
HIROSAWA Masashi ( hirosawa@cam.hi-ho.ne.jp ). 
All Rights Reserved.

Contributor(s):

Alternatively, the contents of this file may be used under the terms
of the GNU General Public License Version 2 (the "GPL"), in which case
the provisions of the GPL are applicable instead of those above.  If you
wish to allow use of your version of this file only under the terms of
the GPL and not to allow others to use your version of this file under
the MPL, indicate your decision by deleting the provisions above and
replace them with the notice and other provisions required by the
GPL.

Alternatively, the contents of this file may be used under the terms
of the New BSD License (the "BSDL"), in which case the provisions
of the BSDL are applicable instead of those above.  If you wish
to allow use of your version of this file only under the terms of
the BSDL and not to allow others to use your version of this file under
the MPL, indicate your decision by deleting the provisions above and
replace them with the notice and other provisions required by the BSDL.

If you do not delete the provisions above, a recipient may use
your version of this file under any of the MPL, the GPL or the BSDL.
*/

#ifndef SVGCOLOR_H
#define SVGCOLOR_H

struct SvgColorName {
	char *name;
	COLORREF color; // ABGR_xZkqqHx_iCmMiPiH_xHqqkZx_
};

// "rgb(ddd,ddd,ddd)"_xZkqqHx_iCmMjFlGiOjKjHpBjClHiBeC_xHqqkZx_(SVG_RGBSTR_MAXLEN+1)_xZkqqHx_iCmMjEhKjHpBiCpAiKgNjFnLiClFiCmEiCkIiCkPiCmOiCoGiCkCiBeC_xHqqkZx_
#define SVG_RGBSTR_MAXLEN 16

char* getExportSvgColorStr( const COLORREF color, char *colorStr );

#ifndef RGBA
#	define RGBA(r,g,b,a)          ((COLORREF)( ( (BYTE)(r) | ((WORD)((BYTE)(g))<<8)) | (((DWORD)(BYTE)(b))<<16) | ( ((BYTE)(a)) << 24 ) ) )
#endif

//#define GetRValue(rgb)      ((BYTE)(rgb))
//#define GetGValue(rgb)      ((BYTE)(((WORD)(rgb)) >> 8))
//#define GetBValue(rgb)      ((BYTE)((rgb)>>16))

#ifndef RGBA_GETALPHA
#	define RGBA_GETALPHA(rgb)      ((rgb) >> 24)
#endif

#ifndef RGBA_SETALPHA
#	define RGBA_SETALPHA(rgba, x) (((x) << 24) | ((rgba) & 0x00ffffff))
#endif

#define GetRGB(rgba)       ((rgba) & 0x00ffffff)
#define RGB2RGBA(rgb)        ((rgb) | 0xff000000)


#endif // SVGCOLOR_H
