#include "stdafx.h"
#include "DynamicDraw.h"
#include <math.h>
#include "DynamicDrawView.h"	// For g_pView.
#include "FoundDoc.h"			// For g_pDoc.
#include "ObjTable.h"			// For FCObjTable.
#include "LinkManager.h"		// For g_pDoc->LinkManager().
#include "UtilCoord.h"			// For mm2lg.etc.
#include "UtilStdLib.h"			// For FFInsert.
#include "UtilMisc.h"			// For FD_HIT_TEST_MARGIN.
#include "Arrow.h"				// For FCStdArrow.
#include "UtilGraph.h"			// For FCEditDraw.
#include "UtilErr.h"			// For FFThrowMiscUnknown.
#include "RegData.h"			// For GetOptiRegColor.
#include "FrameWnd.h"			// For FFGetMainWnd().
//----- 05.07.15 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
//#include "ProObjFigurePen.h"	// For CFCProObjFigurePen.
//#include "ProObjFigureBrush.h"	// For CFCProObjFigureBrush.
//#include "ProTableText.h"		// For CFCProTableText.
//#include "ProObjTextRectSizeLimit.h"	// For CFCProObjTextRectSizeLimit.
//#include "PrsObjProperty.h"		// For CFCPrsObjProperty.
//----- 05.07.15 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----
#include "ObjTextRect.h"		// For FCObjTextRect.
#include "ObjLine.h"			// For FCObjLine.
#include "ToolTableEdit.h"		// This header.

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


//                                                                                 _xZkqqHx_iEkA_xHqqkZx_RuledEditWidth
//                       _xZkqqHx_iEkBiEjPiEkC_xHqqkZx_      _xZkqqHx_iEkBiEjPiEkC_xHqqkZx_          _xZkqqHx_iEkBiEjPiEkC_xHqqkZx_                  _xZkqqHx_iEjPiEjPiEjPiEkJ_xHqqkZx_
//         _xZkqqHx_iBfOiEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_Cv_xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_Cv_xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_Cv_xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkAiBfP_xHqqkZx_          _xZkqqHx_iBkK_xHqqkZx_
//       _xZkqqHx_iBfO_xHqqkZx_A0_xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_A1_xZkqqHx_iBfP_xHqqkZx_        _xZkqqHx_iBkL_xHqqkZx_  _xZkqqHx_iBkL_xHqqkZx_RuledEditGap
//       _xZkqqHx_iEjPiEjPiEkD_xHqqkZx_          _xZkqqHx_iEkEiEkGiEkD_xHqqkZx_      _xZkqqHx_iEkEiEkGiEkD_xHqqkZx_          _xZkqqHx_iEkEiEkGiEkD_xHqqkZx_          _xZkqqHx_iEkEiEjPiEjP_xHqqkZx_  _xZkqqHx_iEjPiEjPiEjPiEkIiEjPiEkJ_xHqqkZx_
//             _xZkqqHx_iEkBiEjPiEjPiEjPiEkC_xHqqkZx_  _xZkqqHx_iEkFiEjPiEjPiEjPiEjPiEjPiEkJiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEkH_xHqqkZx_  _xZkqqHx_iEkBiEjPiEjPiEjPiEkC_xHqqkZx_        _xZkqqHx_iEjPiEjPiEjPiEkGiEjPiEkJ_xHqqkZx_
//             _xZkqqHx_iEkA_xHqqkZx_  B0  _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_     Ev   Dv      Ev      Dv  _xZkqqHx_iEkA_xHqqkZx_  B1  _xZkqqHx_iEkA_xHqqkZx_              _xZkqqHx_iBkK_xHqqkZx_
//             _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_              _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iBkL_xHqqkZx_  _xZkqqHx_iBkL_xHqqkZx_CellEditWidth
//             _xZkqqHx_iEkEiEjPiEjPiEjPiEkD_xHqqkZx_  _xZkqqHx_iEkEiEjPiEjPiEjPiEjPiEjPiEkIiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEkD_xHqqkZx_  _xZkqqHx_iEkEiEjPiEjPiEjPiEkD_xHqqkZx_        _xZkqqHx_iEjPiEkJiEjPiEkI_xHqqkZx_
//     _xZkqqHx_iEkBiEjPiEjPiEkC_xHqqkZx_                                                      _xZkqqHx_iEkBiEjPiEjPiEkC_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_CellEditGap
//     _xZkqqHx_iEkA_xHqqkZx_ Ch _xZkqqHx_iEkFiEkGiEjPiEjPiEjPiEkC_xHqqkZx_  _xZkqqHx_iEkBiEjPiEjP_xHqqkZx_Fh_xZkqqHx_iEjPiEjPiEkGiEjPiEjPiEjP_xHqqkZx_Fh_xZkqqHx_iEjPiEjPiEjPiEkC_xHqqkZx_  _xZkqqHx_iEkBiEjPiEjPiEjPiEkGiEkH_xHqqkZx_ Ch _xZkqqHx_iEkAiEjPiEkJ_xHqqkZx_
//     _xZkqqHx_iEkEiEjPiEjPiEkDiEkA_xHqqkZx_  Eh  _xZkqqHx_iEkA_xHqqkZx_  Fv    G     Fv      G       Fv  _xZkqqHx_iEkA_xHqqkZx_  Eh  _xZkqqHx_iEkAiEkEiEjPiEjPiEkD_xHqqkZx_  _xZkqqHx_iBkK_xHqqkZx_
//     _xZkqqHx_iEkBiEjPiEjPiEkCiEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_              _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkAiEkBiEjPiEjPiEkC_xHqqkZx_
//     _xZkqqHx_iEkA_xHqqkZx_ Ch _xZkqqHx_iEkFiEkJiEjP_xHqqkZx_Dh_xZkqqHx_iEjPiEkH_xHqqkZx_  _xZkqqHx_iEkFiEjPiEjP_xHqqkZx_Fh_xZkqqHx_iEjPiEjPiEkJiEjPiEjPiEjP_xHqqkZx_Fh_xZkqqHx_iEjPiEjPiEjPiEkH_xHqqkZx_  _xZkqqHx_iEkFiEjP_xHqqkZx_Dh_xZkqqHx_iEjPiEkJiEkH_xHqqkZx_ Ch _xZkqqHx_iEkA_xHqqkZx_
//     _xZkqqHx_iEkEiEjPiEjPiEkDiEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_              _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkAiEkEiEjPiEjPiEkD_xHqqkZx_
//             _xZkqqHx_iEkA_xHqqkZx_  Eh  _xZkqqHx_iEkA_xHqqkZx_  Fv    G     Fv      G       Fv  _xZkqqHx_iEkA_xHqqkZx_  Eh  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iBkL_xHqqkZx_RuledHandle
//     _xZkqqHx_iEkBiEjPiEjPiEkCiEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_              _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkAiEkBiEjPiEjPiEkCiEjPiEkJ_xHqqkZx_
//     _xZkqqHx_iEkA_xHqqkZx_ Ch _xZkqqHx_iEkFiEkJiEjP_xHqqkZx_Dh_xZkqqHx_iEjPiEkH_xHqqkZx_  _xZkqqHx_iEkFiEjPiEjP_xHqqkZx_Fh_xZkqqHx_iEjPiEjPiEkJiEjPiEjPiEjP_xHqqkZx_Fh_xZkqqHx_iEjPiEjPiEjPiEkH_xHqqkZx_  _xZkqqHx_iEkFiEjP_xHqqkZx_Dh_xZkqqHx_iEjPiEkJiEkH_xHqqkZx_ Ch _xZkqqHx_iEkAiEjPiEkJ_xHqqkZx_
//     _xZkqqHx_iEkEiEjPiEjPiEkDiEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_              _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkAiEkEiEjPiEjPiEkD_xHqqkZx_  _xZkqqHx_iBkK_xHqqkZx_
//             _xZkqqHx_iEkA_xHqqkZx_  Eh  _xZkqqHx_iEkA_xHqqkZx_  Fv    G     Fv      G       Fv  _xZkqqHx_iEkA_xHqqkZx_  Eh  _xZkqqHx_iEkA_xHqqkZx_        
//             _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_              _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_        
//     _xZkqqHx_iEkBiEjPiEjPiEkCiEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_              _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkAiEkBiEjPiEjPiEkC_xHqqkZx_
//     _xZkqqHx_iEkA_xHqqkZx_ Ch _xZkqqHx_iEkFiEkIiEjP_xHqqkZx_Dh_xZkqqHx_iEjPiEkD_xHqqkZx_  _xZkqqHx_iEkEiEjPiEjP_xHqqkZx_Fh_xZkqqHx_iEjPiEjPiEkIiEjPiEjPiEjP_xHqqkZx_Fh_xZkqqHx_iEjPiEjPiEjPiEkD_xHqqkZx_  _xZkqqHx_iEkEiEjP_xHqqkZx_Dh_xZkqqHx_iEjPiEkIiEkH_xHqqkZx_ Ch _xZkqqHx_iEkA_xHqqkZx_
//     _xZkqqHx_iEkEiEjPiEjPiEkD_xHqqkZx_                                                      _xZkqqHx_iEkEiEjPiEjPiEkD_xHqqkZx_
//             _xZkqqHx_iEkBiEjPiEjPiEjPiEkC_xHqqkZx_  _xZkqqHx_iEkBiEjPiEjPiEjPiEjPiEjPiEkGiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEkC_xHqqkZx_  _xZkqqHx_iEkBiEjPiEjPiEjPiEkC_xHqqkZx_        
//             _xZkqqHx_iEkA_xHqqkZx_  B3  _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_     Ev   Dv      Ev      Dv  _xZkqqHx_iEkA_xHqqkZx_  B2  _xZkqqHx_iEkA_xHqqkZx_        
//             _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_              _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_        
//             _xZkqqHx_iEkEiEjPiEjPiEjPiEkD_xHqqkZx_  _xZkqqHx_iEkFiEjPiEjPiEjPiEjPiEjPiEkJiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEkH_xHqqkZx_  _xZkqqHx_iEkEiEjPiEjPiEjPiEkD_xHqqkZx_        
//       _xZkqqHx_iEjPiEjPiEkC_xHqqkZx_          _xZkqqHx_iEkBiEkIiEkC_xHqqkZx_      _xZkqqHx_iEkBiEkIiEkC_xHqqkZx_          _xZkqqHx_iEkBiEkIiEkC_xHqqkZx_          _xZkqqHx_iEkBiEjPiEjP_xHqqkZx_  
//       _xZkqqHx_iBfP_xHqqkZx_A3_xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_Cv_xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_Cv_xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_Cv_xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_A2_xZkqqHx_iBfO_xHqqkZx_  
//     _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iBfPiEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkAiBfO_xHqqkZx_    
//     _xZkqqHx_iEkA_xHqqkZx_                _xZkqqHx_iEkEiEjPiEkD_xHqqkZx_      _xZkqqHx_iEkEiEjPiEkD_xHqqkZx_          _xZkqqHx_iEkEiEjPiEkD_xHqqkZx_                  
//     _xZkqqHx_iEkA_xHqqkZx_    _xZkqqHx_iEkAiEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_
//     _xZkqqHx_iEkA_xHqqkZx_    _xZkqqHx_iEkAiEkA_xHqqkZx_    _xZkqqHx_iBkIiEkJiEjPiEkJiBkJ_xHqqkZx_
//     _xZkqqHx_iEkA_xHqqkZx_    _xZkqqHx_iEkAiEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_    CellEditGap
//     _xZkqqHx_iEkA_xHqqkZx_    _xZkqqHx_iEkAiEkFiBkJiEjPiBkIiEkH_xHqqkZx_
//     _xZkqqHx_iEkA_xHqqkZx_    _xZkqqHx_iEkAiEkA_xHqqkZx_CellEditWidth
//     _xZkqqHx_iEkA_xHqqkZx_    _xZkqqHx_iEkAiEkA_xHqqkZx_
//     _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iBkIiEkJiEkJiBkJiEjP_xHqqkZx_
//     _xZkqqHx_iEkA_xHqqkZx_    _xZkqqHx_iEkA_xHqqkZx_  RuledEditGap
//     _xZkqqHx_iEkFiBkJiBkIiEkH_xHqqkZx_
//      RuledEditWidth
//
//
//
//                       _xZkqqHx_iEkBiEjPiEkC_xHqqkZx_      _xZkqqHx_iEkBiEjPiEkC_xHqqkZx_          _xZkqqHx_iEkBiEjPiEkC_xHqqkZx_                  _xZkqqHx_iEjPiEjP_xHqqkZx_ A_TOP0
//         _xZkqqHx_iBfOiEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_Cv_xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_Cv_xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_Cv_xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkAiBfP_xHqqkZx_    
//       _xZkqqHx_iBfO_xHqqkZx_A0_xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_A1_xZkqqHx_iBfP_xHqqkZx_  
//       _xZkqqHx_iEjPiEjPiEkD_xHqqkZx_          _xZkqqHx_iEkEiEkGiEkD_xHqqkZx_      _xZkqqHx_iEkEiEkGiEkD_xHqqkZx_          _xZkqqHx_iEkEiEkGiEkD_xHqqkZx_          _xZkqqHx_iEkEiEjPiEjP_xHqqkZx_  _xZkqqHx_iEjPiEjP_xHqqkZx_ A_TOP1
//             _xZkqqHx_iEkBiEjPiEjPiEjPiEkC_xHqqkZx_  _xZkqqHx_iEkFiEjPiEjPiEjPiEjPiEjPiEkJiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEkH_xHqqkZx_  _xZkqqHx_iEkBiEjPiEjPiEjPiEkC_xHqqkZx_        _xZkqqHx_iEjPiEjP_xHqqkZx_ B_TOP0
//             _xZkqqHx_iEkA_xHqqkZx_  B0  _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_     Ev   Dv      Ev      Dv  _xZkqqHx_iEkA_xHqqkZx_  B1  _xZkqqHx_iEkA_xHqqkZx_        
//             _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_              _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_        
//             _xZkqqHx_iEkEiEjPiEjPiEjPiEkD_xHqqkZx_  _xZkqqHx_iEkEiEjPiEjPiEjPiEjPiEjPiEkIiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEkD_xHqqkZx_  _xZkqqHx_iEkEiEjPiEjPiEjPiEkD_xHqqkZx_        _xZkqqHx_iEjPiEjP_xHqqkZx_ B_TOP1
//     _xZkqqHx_iEkBiEjPiEjPiEkC_xHqqkZx_                                                      _xZkqqHx_iEkBiEjPiEjPiEkC_xHqqkZx_
//     _xZkqqHx_iEkA_xHqqkZx_ Ch _xZkqqHx_iEkFiEkGiEjPiEjPiEjPiEkC_xHqqkZx_  _xZkqqHx_iEkBiEjPiEjP_xHqqkZx_Fh_xZkqqHx_iEjPiEjPiEkGiEjPiEjPiEjP_xHqqkZx_Fh_xZkqqHx_iEjPiEjPiEjPiEkC_xHqqkZx_  _xZkqqHx_iEkBiEjPiEjPiEjPiEkGiEkH_xHqqkZx_ Ch _xZkqqHx_iEkA_xHqqkZx_
//     _xZkqqHx_iEkEiEjPiEjPiEkDiEkA_xHqqkZx_  Eh  _xZkqqHx_iEkA_xHqqkZx_  Fv    G     Fv      G       Fv  _xZkqqHx_iEkA_xHqqkZx_  Eh  _xZkqqHx_iEkAiEkEiEjPiEjPiEkD_xHqqkZx_
//     _xZkqqHx_iEkBiEjPiEjPiEkCiEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_              _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkAiEkBiEjPiEjPiEkC_xHqqkZx_
//     _xZkqqHx_iEkA_xHqqkZx_ Ch _xZkqqHx_iEkFiEkJiEjP_xHqqkZx_Dh_xZkqqHx_iEjPiEkH_xHqqkZx_  _xZkqqHx_iEkFiEjPiEjP_xHqqkZx_Fh_xZkqqHx_iEjPiEjPiEkJiEjPiEjPiEjP_xHqqkZx_Fh_xZkqqHx_iEjPiEjPiEjPiEkH_xHqqkZx_  _xZkqqHx_iEkFiEjP_xHqqkZx_Dh_xZkqqHx_iEjPiEkJiEkH_xHqqkZx_ Ch _xZkqqHx_iEkA_xHqqkZx_
//     _xZkqqHx_iEkEiEjPiEjPiEkDiEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_              _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkAiEkEiEjPiEjPiEkD_xHqqkZx_
//             _xZkqqHx_iEkA_xHqqkZx_  Eh  _xZkqqHx_iEkA_xHqqkZx_  Fv    G     Fv      G       Fv  _xZkqqHx_iEkA_xHqqkZx_  Eh  _xZkqqHx_iEkA_xHqqkZx_        
//     _xZkqqHx_iEkBiEjPiEjPiEkCiEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_              _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkAiEkBiEjPiEjPiEkC_xHqqkZx_
//     _xZkqqHx_iEkA_xHqqkZx_ Ch _xZkqqHx_iEkFiEkJiEjP_xHqqkZx_Dh_xZkqqHx_iEjPiEkH_xHqqkZx_  _xZkqqHx_iEkFiEjPiEjP_xHqqkZx_Fh_xZkqqHx_iEjPiEjPiEkJiEjPiEjPiEjP_xHqqkZx_Fh_xZkqqHx_iEjPiEjPiEjPiEkH_xHqqkZx_  _xZkqqHx_iEkFiEjP_xHqqkZx_Dh_xZkqqHx_iEjPiEkJiEkH_xHqqkZx_ Ch _xZkqqHx_iEkA_xHqqkZx_
//     _xZkqqHx_iEkEiEjPiEjPiEkDiEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_              _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkAiEkEiEjPiEjPiEkD_xHqqkZx_
//             _xZkqqHx_iEkA_xHqqkZx_  Eh  _xZkqqHx_iEkA_xHqqkZx_  Fv    G     Fv      G       Fv  _xZkqqHx_iEkA_xHqqkZx_  Eh  _xZkqqHx_iEkA_xHqqkZx_        
//             _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_              _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_        
//     _xZkqqHx_iEkBiEjPiEjPiEkCiEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_              _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkAiEkBiEjPiEjPiEkC_xHqqkZx_
//     _xZkqqHx_iEkA_xHqqkZx_ Ch _xZkqqHx_iEkFiEkIiEjP_xHqqkZx_Dh_xZkqqHx_iEjPiEkD_xHqqkZx_  _xZkqqHx_iEkEiEjPiEjP_xHqqkZx_Fh_xZkqqHx_iEjPiEjPiEkIiEjPiEjPiEjP_xHqqkZx_Fh_xZkqqHx_iEjPiEjPiEjPiEkD_xHqqkZx_  _xZkqqHx_iEkEiEjP_xHqqkZx_Dh_xZkqqHx_iEjPiEkIiEkH_xHqqkZx_ Ch _xZkqqHx_iEkA_xHqqkZx_
//     _xZkqqHx_iEkEiEjPiEjPiEkD_xHqqkZx_                                                      _xZkqqHx_iEkEiEjPiEjPiEkD_xHqqkZx_
//             _xZkqqHx_iEkBiEjPiEjPiEjPiEkC_xHqqkZx_  _xZkqqHx_iEkBiEjPiEjPiEjPiEjPiEjPiEkGiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEkC_xHqqkZx_  _xZkqqHx_iEkBiEjPiEjPiEjPiEkC_xHqqkZx_        _xZkqqHx_iEjPiEjP_xHqqkZx_ B_BTM0
//             _xZkqqHx_iEkA_xHqqkZx_  B3  _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_     Ev   Dv      Ev      Dv  _xZkqqHx_iEkA_xHqqkZx_  B2  _xZkqqHx_iEkA_xHqqkZx_        
//             _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_              _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_        
//             _xZkqqHx_iEkEiEjPiEjPiEjPiEkD_xHqqkZx_  _xZkqqHx_iEkFiEjPiEjPiEjPiEjPiEjPiEkJiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEkH_xHqqkZx_  _xZkqqHx_iEkEiEjPiEjPiEjPiEkD_xHqqkZx_        _xZkqqHx_iEjPiEjP_xHqqkZx_ B_BTM1
//       _xZkqqHx_iEjPiEjPiEkC_xHqqkZx_          _xZkqqHx_iEkBiEkIiEkC_xHqqkZx_      _xZkqqHx_iEkBiEkIiEkC_xHqqkZx_          _xZkqqHx_iEkBiEkIiEkC_xHqqkZx_          _xZkqqHx_iEkBiEjPiEjP_xHqqkZx_  _xZkqqHx_iEjPiEjP_xHqqkZx_ A_BTM0
//       _xZkqqHx_iBfP_xHqqkZx_A3_xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_Cv_xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_Cv_xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_Cv_xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_A2_xZkqqHx_iBfO_xHqqkZx_  
//     _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iBfPiEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkAiBfO_xHqqkZx_    
//     _xZkqqHx_iEkA_xHqqkZx_                _xZkqqHx_iEkEiEjPiEkD_xHqqkZx_      _xZkqqHx_iEkEiEjPiEkD_xHqqkZx_          _xZkqqHx_iEkEiEjPiEkD_xHqqkZx_                  _xZkqqHx_iEjPiEjP_xHqqkZx_ A_BTM1
//     _xZkqqHx_iEkA_xHqqkZx_    _xZkqqHx_iEkAiEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_                                  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkAiEkA_xHqqkZx_    _xZkqqHx_iEkA_xHqqkZx_
//     _xZkqqHx_iEkA_xHqqkZx_    _xZkqqHx_iEkAiEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_                                  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkAiEkA_xHqqkZx_    _xZkqqHx_iEkA_xHqqkZx_
//   A_LFT0 A_LFT1     _xZkqqHx_iEkA_xHqqkZx_                                B_RIT0   B_RIT1   _xZkqqHx_iEkA_xHqqkZx_
//             _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_                                            _xZkqqHx_iEkA_xHqqkZx_    _xZkqqHx_iEkA_xHqqkZx_
//           B_LFT0  B_LFT1                                        A_RIT0 A_RIT1
//
//

static const long FD_CELL_EDIT_GAP = 10;
static const long FD_CELL_EDIT_WIDTH = 20;
static const long FD_RULED_EDIT_GAP = 5;
static const long FD_RULED_EDIT_WIDTH = 20;
static const long FD_RULED_HANDLE = 12;
static const long FD_TABLE_EDIT_MARGIN = FD_CELL_EDIT_GAP + FD_CELL_EDIT_WIDTH + FD_RULED_EDIT_GAP + FD_RULED_EDIT_WIDTH;

#define LG_A_LFT0(lgrtFrame) (lgrtFrame.left - FD_TABLE_EDIT_MARGIN)
#define LG_A_LFT1(lgrtFrame) (lgrtFrame.left - (FD_CELL_EDIT_GAP + FD_CELL_EDIT_WIDTH + FD_RULED_EDIT_GAP))
#define LG_A_RIT0(lgrtFrame) (lgrtFrame.right + (FD_CELL_EDIT_GAP + FD_CELL_EDIT_WIDTH + FD_RULED_EDIT_GAP))
#define LG_A_RIT1(lgrtFrame) (lgrtFrame.right + FD_TABLE_EDIT_MARGIN)

#define LG_B_LFT0(lgrtFrame) (lgrtFrame.left - (FD_CELL_EDIT_GAP + FD_CELL_EDIT_WIDTH))
#define LG_B_LFT1(lgrtFrame) (lgrtFrame.left - FD_CELL_EDIT_GAP)
#define LG_B_RIT0(lgrtFrame) (lgrtFrame.right + FD_CELL_EDIT_GAP)
#define LG_B_RIT1(lgrtFrame) (lgrtFrame.right + (FD_CELL_EDIT_GAP + FD_CELL_EDIT_WIDTH))

#define LG_A_TOP0(lgrtFrame) (lgrtFrame.top - FD_TABLE_EDIT_MARGIN)
#define LG_A_TOP1(lgrtFrame) (lgrtFrame.top - (FD_CELL_EDIT_GAP + FD_CELL_EDIT_WIDTH + FD_RULED_EDIT_GAP))
#define LG_A_BTM0(lgrtFrame) (lgrtFrame.bottom + (FD_CELL_EDIT_GAP + FD_CELL_EDIT_WIDTH + FD_RULED_EDIT_GAP))
#define LG_A_BTM1(lgrtFrame) (lgrtFrame.bottom + FD_TABLE_EDIT_MARGIN)

#define LG_B_TOP0(lgrtFrame) (lgrtFrame.top - (FD_CELL_EDIT_GAP + FD_CELL_EDIT_WIDTH))
#define LG_B_TOP1(lgrtFrame) (lgrtFrame.top - FD_CELL_EDIT_GAP)
#define LG_B_BTM0(lgrtFrame) (lgrtFrame.bottom + FD_CELL_EDIT_GAP)
#define LG_B_BTM1(lgrtFrame) (lgrtFrame.bottom + (FD_CELL_EDIT_GAP + FD_CELL_EDIT_WIDTH))

#define MM_A_LFT0(mmrtFrame) (mmrtFrame.left - lg2mm(FD_TABLE_EDIT_MARGIN))
#define MM_A_LFT1(mmrtFrame) (mmrtFrame.left - lg2mm((FD_CELL_EDIT_GAP + FD_CELL_EDIT_WIDTH + FD_RULED_EDIT_GAP)))
#define MM_A_RIT0(mmrtFrame) (mmrtFrame.right + lg2mm((FD_CELL_EDIT_GAP + FD_CELL_EDIT_WIDTH + FD_RULED_EDIT_GAP)))
#define MM_A_RIT1(mmrtFrame) (mmrtFrame.right + lg2mm(FD_TABLE_EDIT_MARGIN))

#define MM_B_LFT0(mmrtFrame) (mmrtFrame.left - lg2mm((FD_CELL_EDIT_GAP + FD_CELL_EDIT_WIDTH)))
#define MM_B_LFT1(mmrtFrame) (mmrtFrame.left - lg2mm(FD_CELL_EDIT_GAP))
#define MM_B_RIT0(mmrtFrame) (mmrtFrame.right + lg2mm(FD_CELL_EDIT_GAP))
#define MM_B_RIT1(mmrtFrame) (mmrtFrame.right + lg2mm((FD_CELL_EDIT_GAP + FD_CELL_EDIT_WIDTH)))

#define MM_A_TOP0(mmrtFrame) (mmrtFrame.top - lg2mm(FD_TABLE_EDIT_MARGIN))
#define MM_A_TOP1(mmrtFrame) (mmrtFrame.top - lg2mm((FD_CELL_EDIT_GAP + FD_CELL_EDIT_WIDTH + FD_RULED_EDIT_GAP)))
#define MM_A_BTM0(mmrtFrame) (mmrtFrame.bottom + lg2mm((FD_CELL_EDIT_GAP + FD_CELL_EDIT_WIDTH + FD_RULED_EDIT_GAP)))
#define MM_A_BTM1(mmrtFrame) (mmrtFrame.bottom + lg2mm(FD_TABLE_EDIT_MARGIN))

#define MM_B_TOP0(mmrtFrame) (mmrtFrame.top - lg2mm((FD_CELL_EDIT_GAP + FD_CELL_EDIT_WIDTH)))
#define MM_B_TOP1(mmrtFrame) (mmrtFrame.top - lg2mm(FD_CELL_EDIT_GAP))
#define MM_B_BTM0(mmrtFrame) (mmrtFrame.bottom + lg2mm(FD_CELL_EDIT_GAP))
#define MM_B_BTM1(mmrtFrame) (mmrtFrame.bottom + lg2mm((FD_CELL_EDIT_GAP + FD_CELL_EDIT_WIDTH)))

/////////////////////////////////////////////////////////////////////////
// FCToolTableEdit_xZkqqHx_iDiBiDjDiDgPiKnGjAjEiBeC_xHqqkZx_

//----- 06.12.09 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
///*************************************************************************
// * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::OnDraw
// *
// * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	View_xZkqqHx_iCmM_xHqqkZx_OnDraw_xZkqqHx_iCkJiCoHiOmAiNhDiClDiCoKiCoJiBeC_xHqqkZx_
// *
// * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	pDC		:_xZkqqHx_jFfMiOkGjHhAiDgGiDgPiDeDiDfIiDfCiDjDiDgFiDeMiDfIiDgHiCpAiOhHjCoIiBeC_xHqqkZx_
// *			pmmrtRgn:_xZkqqHx_iDiKiBfLiDfHiDiHiDjDjEhKjHpBiCpAiOhHjCoIiBeCiOgHiCoNiCmIiCkCiPoKiNiHiCmN_xHqqkZx_NULL_xZkqqHx_iCpAiOhHjCoIiBeC_xHqqkZx_
// *			lRgnSize:pmmrtRgn_xZkqqHx_iCmMjEhKjHpBiDfEiDeDiDfJiCpAiOhHjCoIiBeC_xHqqkZx_
// *
// * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.01.28 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
// *************************************************************************/
//void FCToolTableEdit::OnDraw (CDC* pDC)
////void FCToolTableEdit::OnDraw (CDC* pDC, const DBLRect* pmmrtRgn, long lRgnSize)
//{
//	// FDA_xZkqqHx_iCmMiMlLiNnNiCmMiPpDjBnEiBeC_xHqqkZx_
//	switch (GetCurrentState())
//	{
//	case STATE_MOVING_RULED:		// _xZkqqHx_iMhCjApMiInKjDkOjCiGiBeC_xHqqkZx_
//	  {
//		// Superclass_xZkqqHx_iKnGjAjEiOmAiNhDiBeC_xHqqkZx_
//		BASE_CLASS::OnDraw(pDC);
//		// _xZkqqHx_iInKjDkOjCiGiCmMjApMiCpAjFgAiJoGiBeC_xHqqkZx_
//		DrawMovingRuled(pDC);
//		break;
//	  }
//	default:	// STATE_ENTER_MOVE_RULED:	// _xZkqqHx_iMhCjApMiInKjDkOjDpMiMpLiBeC_xHqqkZx_
//				// STATE_EXIT_MOVE_RULED:	// _xZkqqHx_iMhCjApMiInKjDkOiPgPiMpLiBeC_xHqqkZx_
//				// STATE_START_MOVE_RULED:	// _xZkqqHx_iMhCjApMiInKjDkOiKeKiOgOiBeC_xHqqkZx_
//				// STATE_STOP_MOVE_RULED:	// _xZkqqHx_iMhCjApMiInKjDkOiPeJjHlJiBeC_xHqqkZx_
//		// Superclass_xZkqqHx_iKnGjAjEiOmAiNhDiBeC_xHqqkZx_
//		BASE_CLASS::OnDraw(pDC);
//	}
//} // FCToolTableEdit::OnDraw.
//----- 06.12.09 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::OnObjectProperties
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iJeFiDhLiDfOiDjDiDeOiDiKiDgCiDeOiCmJiCoGiCmBiCmEjFfMiOkGiClDiCoKiCoJiDiBiDgKiDiFiBfLiCmMiDhGiDiNiDhAiDgFiDeC_xHqqkZx_
 *          _xZkqqHx_jBeJjBpAiCmFiOmAiNhDiClDiCoKiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.01.31 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::OnObjectProperties ()
{
	if (m_stSelectedCell.empty() &&
		m_stSelectedHorzRuled.empty() &&
		m_stSelectedVertRuled.empty())
	//----- _xZkqqHx_jFfMiCmMiDfKiDiLiBeFiMhCjApMiCkKjBeJjBpAiClDiCoKiCmEiCkCiCmIiCkCiPoKiNiH_xHqqkZx_ -----
	{
		// Superclass_xZkqqHx_iKnGjAjEiCpAiOmAiNhDiClFiCmEiPeJjHlJiBeC_xHqqkZx_
		BASE_CLASS::OnObjectProperties();
		return;
	}
//----- 05.07.15 Fukushiro M. _xZkqqHx_jCmHiJmBiOgO_xHqqkZx_ ()-----
	// _xZkqqHx_iCkCiClPiCmOiCpBiPoDiCmJjFfMiOkGiClHiCoJiDhGiDiNiDhAiDgFiDeCiDhJiBfLiDfHiCpAiOhHjCoIiBeC_xHqqkZx_
	DWORD dwFrontPage = 0;
	// _xZkqqHx_iNmFiMoDiCmJiDhBiDgCiDgHiClFiClNiDeHiDiKiDeBiCkKiMhCjApMiCmMiPoKiNiHiCmNiMhCjApMiDhGiDiNiDhAiDgFiDeCiCpAiDeBiDeOiDgFiDeCiDhFiCmJiBeC_xHqqkZx_
	switch (m_areaHit)
	{
	case AREA_RULED_SEL_HORZ:			// _xZkqqHx_jAiFjFlNiMhCjApMjBeJjBpAiDeHiDiKiDeBiBeC_xHqqkZx_
	case AREA_RULED_SEL_VERT:			// _xZkqqHx_jAiCjClMiMhCjApMjBeJjBpAiDeHiDiKiDeBiBeC_xHqqkZx_
	case AREA_RULED_SEL_ALL:			// _xZkqqHx_jBfDiMhCjApMiDeHiDiKiDeBiBeC_xHqqkZx_
	case AREA_RULED_SEL_MATRIX_HORZ:	// _xZkqqHx_jAiFjFlNiMhCjApMjBeJjBpAiDhNiDgHiDiKiDgCiDeOiDfIiDeHiDiKiDeBiBeC_xHqqkZx_
	case AREA_RULED_SEL_MATRIX_VERT:	// _xZkqqHx_jAiCjClMiMhCjApMjBeJjBpAiDhNiDgHiDiKiDgCiDeOiDfIiDeHiDiKiDeBiBeC_xHqqkZx_
		dwFrontPage = IDD_PRO_FIGURE_PEN;
		break;
	case AREA_CELL_SEL_LINE:	// _xZkqqHx_iDfKiDiLiNhDiDeHiDiKiDeBiBeC_xHqqkZx_
	case AREA_CELL_SEL_COLUMN:	// _xZkqqHx_iDfKiDiLjHpBiDeHiDiKiDeBiBeC_xHqqkZx_
	case AREA_CELL_SEL_ALL:		// _xZkqqHx_jBfDiDfKiDiLiDeHiDiKiDeBiBeC_xHqqkZx_
	case AREA_CELL_SEL_MATRIX:	// _xZkqqHx_iDfKiDiLiDhNiDgHiDiKiDgCiDeOiDfIiDeHiDiKiDeBiBeC_xHqqkZx_
		dwFrontPage = IDD_PRO_FIGURE_BRUSH;
		break;
	}
	// _xZkqqHx_iDhGiDiNiDhAiDgFiDeCiDfGiBfLiDgHjFfMiOkGiBeC_xHqqkZx_
	FCObjTable::OnTableProperties(	ID_OBJECT_PROPERTIES,
									FALSE,
									m_pSelectedObjTable,
									&m_stSelectedCell,
									&m_stSelectedHorzRuled,
									&m_stSelectedVertRuled,
									dwFrontPage);
//----- 05.07.15 Fukushiro M. _xZkqqHx_jCmHiJmBiPeJ_xHqqkZx_ ()-----

//----- 05.07.15 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
//	// _xZkqqHx_jBeJjBpAjCiGiCmMjFjEjFgJiCmMiPfHiNiHiBeC_xHqqkZx_
//	ObjDynabaseVector vObj;
//	vObj.push_back(m_pSelectedObjTable);
//	// ID_OBJECT_PROPERTIES = "_xZkqqHx_jFjEjFgJiCmMiDhGiDiNiDhAiDgFiDeC_xHqqkZx_"
//	CFCPrsObjProperty sheet(ID_OBJECT_PROPERTIES);
//	CPropertyPageVector vPropPage;
//	CPropertyPageVector::const_iterator iPN;
//	// _xZkqqHx_iDhGiDiNiDhAiDgFiDeCiDfGiBfLiDgHiCmJiDfOiBfLiDfBiDgCiDgHiCmMjFjEjFgJiCpAjAnNjCoIiBeC_xHqqkZx_
//	sheet.SetTargetObject(&vObj);
//	// _xZkqqHx_iDhGiDiNiDhAiDgFiDeCiDhJiBfLiDfHiCpAiNoMjAkMiBeC_xHqqkZx_
//	(*vObj.begin())->CreatePropertyPage(vPropPage, vObj);
//	// _xZkqqHx_iDhJiBfLiDfHiCpAiDhGiDiNiDhAiDgFiDeCiDfGiBfLiDgHiCmJjCmHiJmBiBeC_xHqqkZx_
//	for (iPN = vPropPage.begin(); iPN != vPropPage.end(); ++iPN)
//		sheet.AddPage(*iPN);
//
//	// _xZkqqHx_jFfMiCmMiMhCjApMiDhGiDiNiDhAiDgFiDeCiDhJiBfLiDfHiBeC_xHqqkZx_
//	CFCProObjFigurePen prpTableRuled;
//	if (!m_stSelectedHorzRuled.empty() ||
//		!m_stSelectedVertRuled.empty())
//	//----- _xZkqqHx_jFfMiCmMiMhCjApMiCkKjBeJjBpAiClDiCoKiCmEiCkCiCoJiPoKiNiH_xHqqkZx_ -----
//	{
//		set<FCFrontSide>::const_iterator iFs;
//		// _xZkqqHx_jBeJjBpAiClDiCoKiClNiMhCjApMiCpAjAnNjCoIiBeC_xHqqkZx_
//		for (iFs = m_stSelectedHorzRuled.begin(); iFs != m_stSelectedHorzRuled.end(); iFs++)
//			prpTableRuled.AppendTargetObject(m_pSelectedObjTable->GetRuled(TRUE, *iFs));
//		for (iFs = m_stSelectedVertRuled.begin(); iFs != m_stSelectedVertRuled.end(); iFs++)
//			prpTableRuled.AppendTargetObject(m_pSelectedObjTable->GetRuled(FALSE, *iFs));
//		// _xZkqqHx_iNmFiMoDiCmJjFfMiMhCjApMiDhGiDiNiDhAiDgFiDeCiDhJiBfLiDfHiCpAjCmHiJmBiBeC_xHqqkZx_
//		sheet.AddPage(&prpTableRuled);
//
//		// _xZkqqHx_iNmFiMoDiCmJiDhBiDgCiDgHiClFiClNiDeHiDiKiDeBiCkKiMhCjApMiCmMiPoKiNiHiCmNiMhCjApMiDhGiDiNiDhAiDgFiDeCiCpAiDeBiDeOiDgFiDeCiDhFiCmJiBeC_xHqqkZx_
//		switch (m_areaHit)
//		{
//		case AREA_RULED_SEL_HORZ:			// _xZkqqHx_jAiFjFlNiMhCjApMjBeJjBpAiDeHiDiKiDeBiBeC_xHqqkZx_
//		case AREA_RULED_SEL_VERT:			// _xZkqqHx_jAiCjClMiMhCjApMjBeJjBpAiDeHiDiKiDeBiBeC_xHqqkZx_
//		case AREA_RULED_SEL_ALL:			// _xZkqqHx_jBfDiMhCjApMiDeHiDiKiDeBiBeC_xHqqkZx_
//		case AREA_RULED_SEL_MATRIX_HORZ:	// _xZkqqHx_jAiFjFlNiMhCjApMjBeJjBpAiDhNiDgHiDiKiDgCiDeOiDfIiDeHiDiKiDeBiBeC_xHqqkZx_
//		case AREA_RULED_SEL_MATRIX_VERT:	// _xZkqqHx_jAiCjClMiMhCjApMjBeJjBpAiDhNiDgHiDiKiDgCiDeOiDfIiDeHiDiKiDeBiBeC_xHqqkZx_
//			sheet.SetActivePage(&prpTableRuled);
//			break;
//		}
//	}
//
//	// _xZkqqHx_jFfMiCmMiDfKiDiLiDhGiDiNiDhAiDgFiDeCiDhJiBfLiDfHiBeC_xHqqkZx_
//	CFCProObjFigureBrush prpTableCell;
//	CFCProTableText prpTableText;
//	CFCProObjTextRectSizeLimit prpSizeLimit;
//	if (!m_stSelectedCell.empty())
//	//----- _xZkqqHx_jFfMiCmMiDfKiDiLiCkKjBeJjBpAiClDiCoKiCmEiCkCiCoJiPoKiNiH_xHqqkZx_ -----
//	{
//		set<FCLineColumn>::const_iterator iLc;
//		// _xZkqqHx_jBeJjBpAiClDiCoKiClNiDfKiDiLiCpAjAnNjCoIiBeC_xHqqkZx_
//		for (iLc = m_stSelectedCell.begin(); iLc != m_stSelectedCell.end(); iLc++)
//		{
//			prpTableCell.AppendTargetObject(m_pSelectedObjTable->GetCell(*iLc));
//			prpTableText.AppendTargetObject(m_pSelectedObjTable->GetCell(*iLc));
//			prpSizeLimit.AppendTargetObject(m_pSelectedObjTable->GetCell(*iLc));
//		}
//		// _xZkqqHx_iNmFiMoDiCmJjFfMiDfKiDiLiDhGiDiNiDhAiDgFiDeCiDhJiBfLiDfHiCpAjCmHiJmBiBeC_xHqqkZx_
//		sheet.AddPage(&prpTableCell);
//		sheet.AddPage(&prpTableText);
//		if (g_pReg->GetIsExpertMode())
//			sheet.AddPage(&prpSizeLimit);
//
//		// _xZkqqHx_iNmFiMoDiCmJiDhBiDgCiDgHiClFiClNiDeHiDiKiDeBiCkKiDfKiDiLiCmMiPoKiNiHiCmNiDfKiDiLiDhGiDiNiDhAiDgFiDeCiCpAiDeBiDeOiDgFiDeCiDhFiCmJiBeC_xHqqkZx_
//		switch (m_areaHit)
//		{
//		case AREA_CELL_SEL_LINE:	// _xZkqqHx_iDfKiDiLiNhDiDeHiDiKiDeBiBeC_xHqqkZx_
//		case AREA_CELL_SEL_COLUMN:	// _xZkqqHx_iDfKiDiLjHpBiDeHiDiKiDeBiBeC_xHqqkZx_
//		case AREA_CELL_SEL_ALL:		// _xZkqqHx_jBfDiDfKiDiLiDeHiDiKiDeBiBeC_xHqqkZx_
//		case AREA_CELL_SEL_MATRIX:	// _xZkqqHx_iDfKiDiLiDhNiDgHiDiKiDgCiDeOiDfIiDeHiDiKiDeBiBeC_xHqqkZx_
//			sheet.SetActivePage(&prpTableCell);
//			break;
//		}
//	}
//
//	// _xZkqqHx_iDhGiDiNiDhAiDgFiDeCiDfGiBfLiDgHiCpAiDhMiDgCiDhGiDeBiDgCiDhGiBeC_xHqqkZx_
//	sheet.DoModal();
//	// _xZkqqHx_iDhGiDiNiDhAiDgFiDeCiDhJiBfLiDfHiCpAiJpAjFpKiBeC_xHqqkZx_
//	for (iPN = vPropPage.begin(); iPN != vPropPage.end(); ++iPN)
//		delete *iPN;
//----- 05.07.15 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----
} // FCToolTableEdit::OnObjectProperties.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::Select
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iClBiCmMiDgDiBfLiDiLiCkKjBeJjBpAiClDiCoKiClNiCmGiCkLiBeBiDfCiBfLiDiLiClDiCoKiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	pDC	: CDC*
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.01.28 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::Select (CDC* pDC)
{
	// _xZkqqHx_jFmPjAjEiPiJiKpKiJlLiBeC_xHqqkZx_BASE_CLASS::Select _xZkqqHx_iCmJiCoGiCmBiCmE_xHqqkZx_
	// FCToolTableEdit::DrawSelectMark _xZkqqHx_iCkKiOmAiNhDiClDiCoKiCoJiClNiCnPiBeB_xHqqkZx_
	// BASE_CLASS::Select _xZkqqHx_iCmMjBePiCmJiPiJiKpKiJlLiClHiCoJjFeLjHhGiCkKiCkAiCoJiBeC_xHqqkZx_
	m_pHitObj = NULL;			// _xZkqqHx_iDhBiDgCiDgHiClFiClNjFfMjFjEjFgJiBeC_xHqqkZx_
	m_areaHit = AREA_NONE;		// _xZkqqHx_iDhBiDgCiDgHiClFiClNiDeHiDiKiDeBiBeC_xHqqkZx_
	m_lHitFrontRuledIndex = -1;	// _xZkqqHx_iDhBiDgCiDgHiClFiClNiMhCjApMiBeC_xHqqkZx_
	m_lHitSideRuledIndex = -1;	// _xZkqqHx_iDhBiDgCiDgHiClFiClNiMhCjApMiBeC_xHqqkZx_
	m_lHitLineCellIndex = -1;	// _xZkqqHx_iDhBiDgCiDgHiClFiClNiNhDiBeC_xHqqkZx_
	m_lHitColumnCellIndex = -1;	// _xZkqqHx_iDhBiDgCiDgHiClFiClNjHpBiBeC_xHqqkZx_
	// _xZkqqHx_iDfKiDiLjBeJjBpAiCmJiKnGiClHiCoJjFmPjAjEiCpAiDeOiDiKiDeBiClHiCoJiBeC_xHqqkZx_
	ClearCellSelectionInfo();

	// Superclass_xZkqqHx_iKnGjAjEiCpAiOmAiNhDiBeC_xHqqkZx_
	BASE_CLASS::Select(pDC);

} // FCToolTableEdit::Select.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::DrawSelectMark
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_jFjEjFgJiCmMjFfMiOkGiOjOiCmMjBeJjBpAiDhNiBfLiDeOiCpAjFfMiOkGiBgJjEpBjFfMiOkGiBgKiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	pDC	:_xZkqqHx_jFfMiOkGjHhAiDgGiDgPiDeDiDfIiDfCiDjDiDgFiDeMiDfIiDgHiBeC_xHqqkZx_
 *			pObj:_xZkqqHx_jFfMiOkGiClHiCoJjFjEjFgJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iJpAjAoA_xHqqkZx_>	_xZkqqHx_jFnCiPfHjApMiCpAiImIiJlKiCmJiOkGiClHiBeC_xHqqkZx_
 *
 *                 _xZkqqHx_iEkMiEkKiEkKiEkN_xHqqkZx_          _xZkqqHx_iEkMiEkKiEkN_xHqqkZx_        _xZkqqHx_iEkMiEkKiEkN_xHqqkZx_          _xZkqqHx_iEkMiEkKiEkN_xHqqkZx_          _xZkqqHx_iEkMiEkKiEkKiEkN_xHqqkZx_
 *                 _xZkqqHx_iEkL_xHqqkZx_    _xZkqqHx_iEkL_xHqqkZx_          _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_        _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_          _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_          _xZkqqHx_iEkL_xHqqkZx_    _xZkqqHx_iEkL_xHqqkZx_
 *                 _xZkqqHx_iEkL_xHqqkZx_    _xZkqqHx_iEkL_xHqqkZx_          _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_        _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_          _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_          _xZkqqHx_iEkL_xHqqkZx_    _xZkqqHx_iEkL_xHqqkZx_
 *                 _xZkqqHx_iEkPiEkKiEkKiEkO_xHqqkZx_          _xZkqqHx_iEkPiElBiEkO_xHqqkZx_        _xZkqqHx_iEkPiElBiEkO_xHqqkZx_          _xZkqqHx_iEkPiElBiEkO_xHqqkZx_          _xZkqqHx_iEkPiEkKiEkKiEkO_xHqqkZx_
 *                         _xZkqqHx_iEkMiEkKiEkKiEkKiEkN_xHqqkZx_  _xZkqqHx_iElAiEkKiEkKiEkKiEkKiEkKiEkKiElEiEkKiEkKiEkKiEkKiEkKiEkKiEkKiElC_xHqqkZx_  _xZkqqHx_iEkMiEkKiEkKiEkKiEkN_xHqqkZx_  
 *                         _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_            _xZkqqHx_iEkL_xHqqkZx_              _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  
 *                         _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_            _xZkqqHx_iEkL_xHqqkZx_              _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  
 *                         _xZkqqHx_iEkPiEkKiEkKiEkKiEkO_xHqqkZx_  _xZkqqHx_iEkPiEkKiEkKiEkKiEkKiEkKiEkKiElDiEkKiEkKiEkKiEkKiEkKiEkKiEkKiEkO_xHqqkZx_  _xZkqqHx_iEkPiEkKiEkKiEkKiEkO_xHqqkZx_  
 *                 _xZkqqHx_iEkMiEkKiEkKiEkN_xHqqkZx_                                                        _xZkqqHx_iEkMiEkKiEkKiEkN_xHqqkZx_
 *                 _xZkqqHx_iEkL_xHqqkZx_    _xZkqqHx_iElAiElBiEkKiEkKiEkKiEkN_xHqqkZx_  _xZkqqHx_iEkMiEkKiEkKiEkKiEkKiEkKiEkKiElBiEkKiEkKiEkKiEkKiEkKiEkKiEkKiEkN_xHqqkZx_  _xZkqqHx_iEkMiEkKiEkKiEkKiElBiElC_xHqqkZx_    _xZkqqHx_iEkL_xHqqkZx_
 *                 _xZkqqHx_iEkPiEkKiEkKiEkOiEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_            _xZkqqHx_iEkL_xHqqkZx_              _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkLiEkPiEkKiEkKiEkO_xHqqkZx_
 *                         _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_            _xZkqqHx_iEkL_xHqqkZx_              _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  
 *                 _xZkqqHx_iEkMiEkKiEkKiEkNiEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_            _xZkqqHx_iEkL_xHqqkZx_              _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkLiEkMiEkKiEkKiEkN_xHqqkZx_
 *                 _xZkqqHx_iEkL_xHqqkZx_    _xZkqqHx_iElAiElEiEkKiEkKiEkKiElC_xHqqkZx_  _xZkqqHx_iElAiEkKiEkKiEkKiEkKiEkKiEkKiElEiEkKiEkKiEkKiEkKiEkKiEkKiEkKiElC_xHqqkZx_  _xZkqqHx_iElAiEkKiEkKiEkKiElEiElC_xHqqkZx_    _xZkqqHx_iEkL_xHqqkZx_
 *                 _xZkqqHx_iEkPiEkKiEkKiEkOiEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_            _xZkqqHx_iEkL_xHqqkZx_              _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkLiEkPiEkKiEkKiEkO_xHqqkZx_
 *                         _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_            _xZkqqHx_iEkL_xHqqkZx_              _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  
 *                         _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_            _xZkqqHx_iEkL_xHqqkZx_              _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  
 *                 _xZkqqHx_iEkMiEkKiEkKiEkNiEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_            _xZkqqHx_iEkL_xHqqkZx_              _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkLiEkMiEkKiEkKiEkN_xHqqkZx_
 *                 _xZkqqHx_iEkL_xHqqkZx_    _xZkqqHx_iElAiElEiEkKiEkKiEkKiElC_xHqqkZx_  _xZkqqHx_iElAiEkKiEkKiEkKiEkKiEkKiEkKiElEiEkKiEkKiEkKiEkKiEkKiEkKiEkKiElC_xHqqkZx_  _xZkqqHx_iElAiEkKiEkKiEkKiElEiElC_xHqqkZx_    _xZkqqHx_iEkL_xHqqkZx_
 *                 _xZkqqHx_iEkPiEkKiEkKiEkOiEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_            _xZkqqHx_iEkL_xHqqkZx_              _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkLiEkPiEkKiEkKiEkO_xHqqkZx_
 *        EditRuledHandle  _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_            _xZkqqHx_iEkL_xHqqkZx_              _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  
 *             _xZkqqHx_iBkL_xHqqkZx_          _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_            _xZkqqHx_iEkL_xHqqkZx_              _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  
 *             _xZkqqHx_iEkJiEjPiEkMiEkKiEkKiEkNiEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_            _xZkqqHx_iEkL_xHqqkZx_              _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkLiEkMiEkKiEkKiEkN_xHqqkZx_
 *             _xZkqqHx_iEkJiEjPiEkL_xHqqkZx_    _xZkqqHx_iElAiElDiEkKiEkKiEkKiEkO_xHqqkZx_  _xZkqqHx_iEkPiEkKiEkKiEkKiEkKiEkKiEkKiElDiEkKiEkKiEkKiEkKiEkKiEkKiEkKiEkO_xHqqkZx_  _xZkqqHx_iEkPiEkKiEkKiEkKiElDiElC_xHqqkZx_    _xZkqqHx_iEkL_xHqqkZx_
 *             _xZkqqHx_iBkK_xHqqkZx_  _xZkqqHx_iEkPiEkKiEkKiEkOiEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_                                _xZkqqHx_iBkK_xHqqkZx_        _xZkqqHx_iEkPiEkKiEkKiEkO_xHqqkZx_
 *                 _xZkqqHx_iEkA_xHqqkZx_    _xZkqqHx_iEkAiEkA_xHqqkZx_    _xZkqqHx_iBkIiEkJiEjPiEkJiBkJ_xHqqkZx_                            _xZkqqHx_iDfKiDiLjFnCiPfHjApM_xHqqkZx_
 *                 _xZkqqHx_iEkA_xHqqkZx_    _xZkqqHx_iEkAiEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_EditCellGap
 *                 _xZkqqHx_iEkA_xHqqkZx_    _xZkqqHx_iEkAiEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_
 *                 _xZkqqHx_iEkA_xHqqkZx_    _xZkqqHx_iEkAiEkJiBkJiEjPiEjPiEjPiBkIiEkJiEjP_xHqqkZx_
 *                 _xZkqqHx_iEkA_xHqqkZx_    _xZkqqHx_iEkA_xHqqkZx_            _xZkqqHx_iEkA_xHqqkZx_EditCellLength
 *                 _xZkqqHx_iEkA_xHqqkZx_    _xZkqqHx_iEkA_xHqqkZx_            _xZkqqHx_iEkA_xHqqkZx_
 *                 _xZkqqHx_iEkA_xHqqkZx_    _xZkqqHx_iEkFiBkJiEjPiEjPiEjPiEjPiBkIiEkH_xHqqkZx_
 *                 _xZkqqHx_iEkA_xHqqkZx_      EditRuledGap_xZkqqHx_iEkA_xHqqkZx_
 *                 _xZkqqHx_iEkFiBkJiEjPiEjPiEjPiEjPiEjPiEjPiEjPiBkIiEkH_xHqqkZx_
 *                    EditRuledLength
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.01.28 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::DrawSelectMark (CDC* pDC, FCObjDynabase* pObj)
{
	// _xZkqqHx_jFfMjFjEjFgJiCmFiCmIiCkCiPoKiNiHiCmNjFgAiJoGiClJiClIjFjMiLeBiBeC_xHqqkZx_
	if (!pObj->IsKindOf(FDOJ_TABLE)) return;

	TRACE(_T("FCToolTableEdit::DrawSelectMark %d\n"), m_lHitFrontRuledIndex);

	FCObjTable* pObjTable = (FCObjTable*)pObj;
	// _xZkqqHx_iPeDjAlDjApMjFgAiJoGjHhAiDeOiDiJiDfIiCpAiNoMjAkMiBeC_xHqqkZx_
	FCEditDraw eDraw(pDC, 0);
	// _xZkqqHx_iDfOiBfLiDfBiDgCiDgHiCmMjFfMjFjEjFgJiCmMiDhEiDiMiBfLiDiAiCpAiOoGjDlOiBeC_xHqqkZx_
	const CRect lgrtFrame = mm2lg(pObjTable->GetResizeFrame());

	//////////////////////////////////////////////////////////////////////////
	// _xZkqqHx_jAiFjFlNiMhCjApMiCpAjFgAiJoGiBeC_xHqqkZx_

	long lgY;
	mmetol mmY;
	for (long lHorzRuledIndex = 0;
		 pObjTable->GetHorzRuledY(mmY, lHorzRuledIndex); lHorzRuledIndex++)
	{
		lgY = mm2lg(mmY);
		// _xZkqqHx_iNlGjBkEiMhCjApMjFnCiPfHjApMiCpAjFgAiJoGiBeC_xHqqkZx_
		eDraw.Line(	&CPoint(LG_A_LFT1(lgrtFrame), lgY),
					&CPoint(LG_B_LFT1(lgrtFrame), lgY));
		// _xZkqqHx_iJeFjBkEiMhCjApMjFnCiPfHjApMiCpAjFgAiJoGiBeC_xHqqkZx_
		eDraw.Line(	&CPoint(LG_B_RIT0(lgrtFrame), lgY),
					&CPoint(LG_A_RIT0(lgrtFrame), lgY));
		// _xZkqqHx_iNlGjBkEiMhCjApMjFnCiPfHjApMiBgJiOePiKhAiBgKiCpAjFgAiJoGiBeC_xHqqkZx_
		eDraw.Line(	&CPoint(LG_A_LFT0(lgrtFrame), lgY - FD_RULED_HANDLE),
					&CPoint(LG_A_LFT1(lgrtFrame), lgY),
					&CPoint(LG_A_LFT0(lgrtFrame), lgY + FD_RULED_HANDLE),
					&CPoint(LG_A_LFT0(lgrtFrame), lgY - FD_RULED_HANDLE));
		// _xZkqqHx_iJeFjBkEiMhCjApMjFnCiPfHjApMiBgJiOePiKhAiBgKiCpAjFgAiJoGiBeC_xHqqkZx_
		eDraw.Line(	&CPoint(LG_A_RIT1(lgrtFrame), lgY - FD_RULED_HANDLE),
					&CPoint(LG_A_RIT0(lgrtFrame), lgY),
					&CPoint(LG_A_RIT1(lgrtFrame), lgY + FD_RULED_HANDLE),
					&CPoint(LG_A_RIT1(lgrtFrame), lgY - FD_RULED_HANDLE));
	}
	// _xZkqqHx_iNlGjBkEiDfKiDiLjFnCiPfHjApMiCpAjFgAiJoGiBeC_xHqqkZx_
	eDraw.Line(	&CPoint(LG_B_LFT0(lgrtFrame), lgrtFrame.top),
				&CPoint(LG_B_LFT0(lgrtFrame), lgY));
	eDraw.Line(	&CPoint(LG_B_LFT1(lgrtFrame), lgrtFrame.top),
				&CPoint(LG_B_LFT1(lgrtFrame), lgY));
	// _xZkqqHx_iJeFjBkEiDfKiDiLjFnCiPfHjApMiCpAjFgAiJoGiBeC_xHqqkZx_
	eDraw.Line(	&CPoint(LG_B_RIT1(lgrtFrame), lgrtFrame.top),
				&CPoint(LG_B_RIT1(lgrtFrame), lgY));
	eDraw.Line(	&CPoint(LG_B_RIT0(lgrtFrame), lgrtFrame.top),
				&CPoint(LG_B_RIT0(lgrtFrame), lgY));

	//////////////////////////////////////////////////////////////////////////
	// _xZkqqHx_jAiCjClMiMhCjApMiCpAjFgAiJoGiBeC_xHqqkZx_

	long lgX;
	mmetol mmX;
	for (long lVertRuledIndex = 0;
		 pObjTable->GetVertRuledX(mmX, lVertRuledIndex); lVertRuledIndex++)
	{
		lgX = mm2lg(mmX);
		// _xZkqqHx_iPoDjBkEiMhCjApMjFnCiPfHjApMiCpAjFgAiJoGiBeC_xHqqkZx_
		eDraw.Line(	&CPoint(lgX, LG_A_TOP1(lgrtFrame)),
					&CPoint(lgX, LG_B_TOP1(lgrtFrame)));
		// _xZkqqHx_iJlKjBkEiMhCjApMjFnCiPfHjApMiCpAjFgAiJoGiBeC_xHqqkZx_
		eDraw.Line(	&CPoint(lgX, LG_B_BTM0(lgrtFrame)),
					&CPoint(lgX, LG_A_BTM0(lgrtFrame)));

		// _xZkqqHx_iPoDjBkEiMhCjApMjFnCiPfHjApMiBgJiOePiKhAiBgKiCpAjFgAiJoGiBeC_xHqqkZx_
		eDraw.Line(	&CPoint(lgX - FD_RULED_HANDLE, LG_A_TOP0(lgrtFrame)),
					&CPoint(lgX, LG_A_TOP1(lgrtFrame)),
					&CPoint(lgX + FD_RULED_HANDLE, LG_A_TOP0(lgrtFrame)),
					&CPoint(lgX - FD_RULED_HANDLE, LG_A_TOP0(lgrtFrame)));
		// _xZkqqHx_iJlKjBkEiMhCjApMjFnCiPfHjApMiBgJiOePiKhAiBgKiCpAjFgAiJoGiBeC_xHqqkZx_
		eDraw.Line(	&CPoint(lgX - FD_RULED_HANDLE, LG_A_BTM1(lgrtFrame)),
					&CPoint(lgX, LG_A_BTM0(lgrtFrame)),
					&CPoint(lgX + FD_RULED_HANDLE, LG_A_BTM1(lgrtFrame)),
					&CPoint(lgX - FD_RULED_HANDLE, LG_A_BTM1(lgrtFrame)));
	}
	// _xZkqqHx_iPoDjBkEiDfKiDiLjFnCiPfHjApMiCpAjFgAiJoGiBeC_xHqqkZx_
	eDraw.Line(	&CPoint(lgrtFrame.left, LG_B_TOP0(lgrtFrame)),
				&CPoint(lgX, LG_B_TOP0(lgrtFrame)));
	eDraw.Line(	&CPoint(lgrtFrame.left, LG_B_TOP1(lgrtFrame)),
				&CPoint(lgX, LG_B_TOP1(lgrtFrame)));
	// _xZkqqHx_iJlKjBkEiDfKiDiLjFnCiPfHjApMiCpAjFgAiJoGiBeC_xHqqkZx_
	eDraw.Line(	&CPoint(lgrtFrame.left, LG_B_BTM0(lgrtFrame)),
				&CPoint(lgX, LG_B_BTM0(lgrtFrame)));
	eDraw.Line(	&CPoint(lgrtFrame.left, LG_B_BTM1(lgrtFrame)),
				&CPoint(lgX, LG_B_BTM1(lgrtFrame)));


	// _xZkqqHx_iOgMiLpHiDfKiDiLjFnCiPfHjApMiBgJiDhLiDgCiDeOiDfIiBgKiCpAjFgAiJoGiBeC_xHqqkZx_
	eDraw.RectLine(CRect(	LG_B_LFT0(lgrtFrame),
							LG_B_TOP0(lgrtFrame),
							LG_B_LFT1(lgrtFrame),
							LG_B_TOP1(lgrtFrame)));
	eDraw.RectLine(CRect(	LG_B_RIT0(lgrtFrame),
							LG_B_TOP0(lgrtFrame),
							LG_B_RIT1(lgrtFrame),
							LG_B_TOP1(lgrtFrame)));
	eDraw.RectLine(CRect(	LG_B_RIT0(lgrtFrame),
							LG_B_BTM0(lgrtFrame),
							LG_B_RIT1(lgrtFrame),
							LG_B_BTM1(lgrtFrame)));
	eDraw.RectLine(CRect(	LG_B_LFT0(lgrtFrame),
							LG_B_BTM0(lgrtFrame),
							LG_B_LFT1(lgrtFrame),
							LG_B_BTM1(lgrtFrame)));


	// _xZkqqHx_iOgMiLpHiMhCjApMjFnCiPfHjApMiBgJiOePiKhAiBgKiCpAjFgAiJoGiBeC_xHqqkZx_
	eDraw.Line(	&CPoint(LG_A_LFT0(lgrtFrame), LG_A_TOP1(lgrtFrame)),
				&CPoint(LG_A_LFT1(lgrtFrame), LG_A_TOP0(lgrtFrame)),
				&CPoint(LG_A_LFT1(lgrtFrame), LG_A_TOP1(lgrtFrame)),
				&CPoint(LG_A_LFT0(lgrtFrame), LG_A_TOP1(lgrtFrame)));

	eDraw.Line(	&CPoint(LG_A_RIT1(lgrtFrame), LG_A_TOP1(lgrtFrame)),
				&CPoint(LG_A_RIT0(lgrtFrame), LG_A_TOP0(lgrtFrame)),
				&CPoint(LG_A_RIT0(lgrtFrame), LG_A_TOP1(lgrtFrame)),
				&CPoint(LG_A_RIT1(lgrtFrame), LG_A_TOP1(lgrtFrame)));

	eDraw.Line(	&CPoint(LG_A_RIT1(lgrtFrame), LG_A_BTM0(lgrtFrame)),
				&CPoint(LG_A_RIT0(lgrtFrame), LG_A_BTM1(lgrtFrame)),
				&CPoint(LG_A_RIT0(lgrtFrame), LG_A_BTM0(lgrtFrame)),
				&CPoint(LG_A_RIT1(lgrtFrame), LG_A_BTM0(lgrtFrame)));

	eDraw.Line(	&CPoint(LG_A_LFT0(lgrtFrame), LG_A_BTM0(lgrtFrame)),
				&CPoint(LG_A_LFT1(lgrtFrame), LG_A_BTM1(lgrtFrame)),
				&CPoint(LG_A_LFT1(lgrtFrame), LG_A_BTM0(lgrtFrame)),
				&CPoint(LG_A_LFT0(lgrtFrame), LG_A_BTM0(lgrtFrame)));

	// _xZkqqHx_jBeJjBpAiCpAjFgAiJoGiBeC_xHqqkZx_
	DrawSelectedCell(pDC, pObjTable);
} // FCToolTableEdit::DrawSelectedMark.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::OnRemoveSelectObj
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iOhHjCoIiClDiCoKiClNjFjEjFgJiCpAjEpBjBeJjBpAiPpDjBnEiCmJiClHiCoJiBeCiDgDiBfLiDiLiCkKjDmGiOkJiCmMiDgFiBfLiDhFiDiLiCmF_xHqqkZx_
 *			_xZkqqHx_jBeJjBpAjFjEjFgJiCpAiKmHjHjNiClFiCmEiCkCiCoJiPoKiNiHiCmNiBeBiClLiClBiCkJiCoHjFjEjFgJiCpAiNoNiPjMiClHiCoJiBeC_xHqqkZx_
 *			_xZkqqHx_iJoGjGmKjFfMiOkGiCpAjEpBjBeJjBpAiPpDjBnEiCmJjFmPiNfIiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	pDC	:_xZkqqHx_jFfMiOkGjHhAiDgGiDgPiDeDiDfIiDfCiDjDiDgFiDeMiDfIiDgHiBeCjFfMiOkGjFmPiNfIiClFiCmIiCkCiPoKiNiHiCmN_xHqqkZx_NULL_xZkqqHx_iBeC_xHqqkZx_
 *			pObj:_xZkqqHx_jBeJjBpAiClHiCoJjFjEjFgJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jCiNiInD_xHqqkZx_>	CFCDynamicDrawView::RemoveSelectObj_xZkqqHx_iCkJiCoHiCmMjAoKjHhAiKnGjAjEiBeC_xHqqkZx_
 *			CFCDynamicDrawView_xZkqqHx_iCmMjBeJjBpAiDgFiBfLiDhFiDiLiCmNjFmPiNfIiClFiCmIiCkCiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.01.28 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::OnRemoveSelectObj (CDC* pDC, FCObjDynabase* pObj)
{
	// Superclass_xZkqqHx_iKnGjAjEiOmAiNhDiBeC_xHqqkZx_
	BASE_CLASS::OnRemoveSelectObj(pDC, pObj);
	// _xZkqqHx_jBeJjBpAiDfKiDiLiPoOjFpBiCkJiCoHjBmOiJjOiClHiCoJiPoOjFpBiCpAiNoNiPjMiBeC_xHqqkZx_
	// BASE_CLASS::OnRemoveSelectObj _xZkqqHx_iCkJiCoH_xHqqkZx_ DrawSelectedMark _xZkqqHx_iCkK_xHqqkZx_
	// _xZkqqHx_iOmAiNhDiClDiCoKiCoJiCmMiCmFiBeBiMoDiCkJiCoHiNoNiPjMiBeC_xHqqkZx_

	if (pObj == m_pSelectedObjTable)
	//----- _xZkqqHx_iDfKiDiLjBeJjBpAjCiGiCmMjFfMjFjEjFgJiCkKjBeJjBpAiJpAiPjMiClDiCoKiCoJiPoKiNiH_xHqqkZx_ -----
	{
		// _xZkqqHx_iDfKiDiLjBeJjBpAiCmJiKnGiClHiCoJjFmPjAjEiCpAiDeOiDiKiDeBiClHiCoJiBeC_xHqqkZx_
		ClearCellSelectionInfo();
	}
} // FCToolTableEdit::OnRemoveSelectObj.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::GetSelectLocalObjVector
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iClBiCmMiDgDiBfLiDiLiCmFiDiNiBfLiDeKiDiLiCmJjBeJjBpAiClDiCoKiCmEiCkCiCoJjFjEjFgJiCpAjFnEiClHiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.02.22 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
const ObjDynabaseVector& FCToolTableEdit::GetSelectLocalObjVector () const
{
	return m_vSelectedCellRuledObj;
} // FCToolTableEdit::GetSelectLocalObjVector.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::CanDelete
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iJlNiCkJiClFiCoHiNoNiPjMiJmCjEfMiCmIiCoAiCmMiCpAjBeJjBpAjCiGiCmFiCkAiCoJiCkJiCmHiCkEiCkJiCpAjElLjCgGiClHiCoJiBeC_xHqqkZx_
 *			_xZkqqHx_iNoNiPjMiDiBiDgKiDiFiBfLiCmMjHeMiMpIiBfOjGlDiMpIiCpAjAnIiCoIjBnGiCkGiCoJiClNiCnPiCmJiOgHiCoNiCoKiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jFnEjCgM_xHqqkZx_>	TRUE	: _xZkqqHx_iNoNiPjMiJmCjEfMiCmIjBeJjBpAjFkIiCkKjHeMiCoJiBeC_xHqqkZx_
 *			FALSE	: _xZkqqHx_iNoNiPjMiJmCjEfMiCmIjBeJjBpAjFkIiCkKjGlDiCkCiBeC_xHqqkZx_
 *************************************************************************/
BOOL FCToolTableEdit::CanDelete () const
{
	return CanDeleteRichText();
} // FCToolTableEdit::CanDelete.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::OnDelete
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_jBeJjBpAjFkIiCpAiNoNiPjMiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	pDC	:_xZkqqHx_jFgAiJoGjHhAiDgGiDgPiDeDiDfIiDfCiDjDiDgFiDeMiDfIiDgHiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.08.15 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::OnDelete (CDC* pDC)
{
	OnDeleteRichText();
} // FCToolTableEdit::OnDelete.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::CanObjectTableInsertLine
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDfCiDhNiDjDiDgIiBhFjFfMjFjEjFgJiCmJiNhDiCpAjBhNjDpMiBhGiCkKiOmAiNhDiJmCjEfMiCkJiCmHiCkEiCkJiCpAjFnEiClHiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jFnEjCgM_xHqqkZx_>	_xZkqqHx_iJmCjEfMiCmIiPoKiNiHiCmN_xHqqkZx_TRUE_xZkqqHx_iBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.01.30 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
BOOL FCToolTableEdit::CanObjectTableInsertLine () const
{
	if (!m_stSelectedCell.empty()) return TRUE;
	return BASE_CLASS::CanObjectTableInsertLine();
} // FCToolTableEdit::CanObjectTableInsertLine.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::OnObjectTableInsertLine
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDfCiDhNiDjDiDgIiBhFjFfMjFjEjFgJiCmJiNhDiCpAjBhNjDpMiBhGiCpAiOmAiNhDiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.01.30 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::OnObjectTableInsertLine ()
{
	// _xZkqqHx_iCnMiClIiBeBiMlLiNnNjBeJjBpAiClDiCoKiCmEiCkCiCoJiDfKiDiLiCkJiCoHiBeBiNhDiDeDiDjDiDgGiDgCiDeOiDfIiCmMiDiKiDfIiDgHiCpAjCiKiPgPiBeC_xHqqkZx_
	// _xZkqqHx_iClLiCmMiDiKiDfIiDgHiCkKjBhNjDpMiImKjChFiCmGiCmIiCoJiBeC_xHqqkZx_
	longSet stLineIndex;
	set<FCLineColumn>::const_iterator iLc;
	for (iLc = m_stSelectedCell.begin(); iLc != m_stSelectedCell.end(); iLc++)
		stLineIndex.insert((*iLc).GetLineIndex());

	// _xZkqqHx_iDfCiDhNiDjDiDgIiDfKiDgCiDfGiDiHiDjDiCmMiKeKiOgOiBeC_xHqqkZx_
	g_pDoc->SessionBegin();
//----- 06.02.23 Fukushiro M. _xZkqqHx_jCmHiJmBiOgO_xHqqkZx_ ()-----
	// _xZkqqHx_iInKjDkOjBePiCmMjAnNjCoIiBeC_xHqqkZx_
// 06.06.13 Fukushiro M. 1_xZkqqHx_iNhDjFmPiNfI_xHqqkZx_ ()
//	LocalObjMovedBefore(GetSelectLocalObjVector());
	TbLocalObjMovedBefore();
//----- 06.02.23 Fukushiro M. _xZkqqHx_jCmHiJmBiPeJ_xHqqkZx_ ()-----

	// _xZkqqHx_iNhDiCpAjBhNjDpMiBeCjBhNjDpMiImKjChFiDiKiDfIiDgHiCmNiDiLiBfLiDhGiCpAiLhEiJpBiClFiCmJiClHiCoJiBeC_xHqqkZx_
	longSet::reverse_iterator rIdx;
	for (rIdx = stLineIndex.rbegin(); rIdx != stLineIndex.rend(); rIdx++)
	{
		// _xZkqqHx_iNhDiCpAjBhNjDpMiBeC_xHqqkZx_
		InsertLine(*rIdx);
	}
//----- 06.02.23 Fukushiro M. _xZkqqHx_jCmHiJmBiOgO_xHqqkZx_ ()-----
	// _xZkqqHx_iInKjDkOiMoDiCmMjAnNjCoIiBeC_xHqqkZx_
	LocalObjMovedAfter();
//----- 06.02.23 Fukushiro M. _xZkqqHx_jCmHiJmBiPeJ_xHqqkZx_ ()-----

	// _xZkqqHx_iDfCiDhNiDjDiDgIiDfKiDgCiDfGiDiHiDjDiCmMiPeJjHlJiBeC_xHqqkZx_
	g_pDoc->SessionEnd();
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
//	// _xZkqqHx_jBeJjBpAjFjEjFgJiCmMjFmPiNfIiCpAiClBiCmMiDgDiBfLiDiLiCmJjCmKjCgNiBeC_xHqqkZx_
//	OnSelectObjModified();
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
//	// _xZkqqHx_iMmFjHeMiDiKiBfLiDfHiDiHiDjDiCpAjAnNjCoIiBeCjFnCiPfHjApMjFkKiCpAiKgHjCkDiClHiCoJiBeC_xHqqkZx_
//	g_pView->AppendToLastRgn(m_pSelectedObjTable->GetResizeFrame().ExtendRect(lg2mm(FD_TABLE_EDIT_MARGIN + 1)));
//	// _xZkqqHx_iMmFjHeMiDiKiBfLiDfHiDiHiDjDiCpAiNmEjFgAiJoGiBeC_xHqqkZx_
//	g_pView->SendRgnRedraw();
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----
} // FCToolTableEdit::OnObjectTableInsertLine.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::CanObjectTableAddLine
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDfCiDhNiDjDiDgIiBhFjFfMjFjEjFgJiCmJiNhDiCpAjCmHiJmBiBhGiCkKiOmAiNhDiJmCjEfMiCkJiCmHiCkEiCkJiCpAjFnEiClHiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jFnEjCgM_xHqqkZx_>	_xZkqqHx_iJmCjEfMiCmIiPoKiNiHiCmN_xHqqkZx_TRUE_xZkqqHx_iBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.02.08 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
BOOL FCToolTableEdit::CanObjectTableAddLine () const
{
	if (!m_stSelectedCell.empty()) return TRUE;
	return BASE_CLASS::CanObjectTableAddLine();
} // FCToolTableEdit::CanObjectTableAddLine.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::OnObjectTableAddLine
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDfCiDhNiDjDiDgIiBhFjFfMjFjEjFgJiCmJiNhDiCpAjCmHiJmBiBhGiCpAiOmAiNhDiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.02.08 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::OnObjectTableAddLine ()
{
	// _xZkqqHx_iCnMiClIiBeBiMlLiNnNjBeJjBpAiClDiCoKiCmEiCkCiCoJiDfKiDiLiCkJiCoHiBeBiNhDiDeDiDjDiDgGiDgCiDeOiDfIiCmMiDiKiDfIiDgHiCpAjCiKiPgPiBeC_xHqqkZx_
	// _xZkqqHx_iClLiCmMiDiKiDfIiDgHiCkKjCmHiJmBiImKjChFiCmGiCmIiCoJiBeC_xHqqkZx_
	longSet stLineIndex;
	set<FCLineColumn>::const_iterator iLc;
	for (iLc = m_stSelectedCell.begin(); iLc != m_stSelectedCell.end(); iLc++)
		stLineIndex.insert((*iLc).GetLineIndex());
	// _xZkqqHx_iDfCiDhNiDjDiDgIiDfKiDgCiDfGiDiHiDjDiCmMiKeKiOgOiBeC_xHqqkZx_
	g_pDoc->SessionBegin();
//----- 06.02.23 Fukushiro M. _xZkqqHx_jCmHiJmBiOgO_xHqqkZx_ ()-----
	// _xZkqqHx_iInKjDkOjBePiCmMjAnNjCoIiBeC_xHqqkZx_
// 06.06.13 Fukushiro M. 1_xZkqqHx_iNhDjFmPiNfI_xHqqkZx_ ()
//	LocalObjMovedBefore(GetSelectLocalObjVector());
	TbLocalObjMovedBefore();
//----- 06.02.23 Fukushiro M. _xZkqqHx_jCmHiJmBiPeJ_xHqqkZx_ ()-----
	// _xZkqqHx_iNhDiCpAjCmHiJmBiBeCjCmHiJmBiImKjChFiDiKiDfIiDgHiCmNiDiLiBfLiDhGiCpAiLhEiJpBiClFiCmJiClHiCoJiBeC_xHqqkZx_
	longSet::reverse_iterator rIdx;
	for (rIdx = stLineIndex.rbegin(); rIdx != stLineIndex.rend(); rIdx++)
	{
		// _xZkqqHx_iNhDiCpAjCmHiJmBiBeC_xHqqkZx_
		InsertLine(*rIdx + 1);
	}
//----- 06.02.23 Fukushiro M. _xZkqqHx_jCmHiJmBiOgO_xHqqkZx_ ()-----
	// _xZkqqHx_iInKjDkOiMoDiCmMjAnNjCoIiBeC_xHqqkZx_
	LocalObjMovedAfter();
//----- 06.02.23 Fukushiro M. _xZkqqHx_jCmHiJmBiPeJ_xHqqkZx_ ()-----
	// _xZkqqHx_iDfCiDhNiDjDiDgIiDfKiDgCiDfGiDiHiDjDiCmMiPeJjHlJiBeC_xHqqkZx_
	g_pDoc->SessionEnd();
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
//	// _xZkqqHx_jBeJjBpAjFjEjFgJiCmMjFmPiNfIiCpAiClBiCmMiDgDiBfLiDiLiCmJjCmKjCgNiBeC_xHqqkZx_
//	OnSelectObjModified();
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
//	// _xZkqqHx_iMmFjHeMiDiKiBfLiDfHiDiHiDjDiCpAjAnNjCoIiBeCjFnCiPfHjApMjFkKiCpAiKgHjCkDiClHiCoJiBeC_xHqqkZx_
//	g_pView->AppendToLastRgn(m_pSelectedObjTable->GetResizeFrame().ExtendRect(lg2mm(FD_TABLE_EDIT_MARGIN + 1)));
//	// _xZkqqHx_iMmFjHeMiDiKiBfLiDfHiDiHiDjDiCpAiNmEjFgAiJoGiBeC_xHqqkZx_
//	g_pView->SendRgnRedraw();
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----
} // FCToolTableEdit::OnObjectTableAddLine.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::CanObjectTableInsertColumn
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDfCiDhNiDjDiDgIiBhFjFfMjFjEjFgJiCmJjHpBiCpAjBhNjDpMiBhGiCkKiOmAiNhDiJmCjEfMiCkJiCmHiCkEiCkJiCpAjFnEiClHiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jFnEjCgM_xHqqkZx_>	_xZkqqHx_iJmCjEfMiCmIiPoKiNiHiCmN_xHqqkZx_TRUE_xZkqqHx_iBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.01.30 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
BOOL FCToolTableEdit::CanObjectTableInsertColumn () const
{
	if (!m_stSelectedCell.empty()) return TRUE;
	return BASE_CLASS::CanObjectTableInsertColumn();
} // FCToolTableEdit::CanObjectTableInsertColumn.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::OnObjectTableInsertColumn
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDfCiDhNiDjDiDgIiBhFjFfMjFjEjFgJiCmJjHpBiCpAjBhNjDpMiBhGiCpAiOmAiNhDiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.01.30 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::OnObjectTableInsertColumn ()
{
	// _xZkqqHx_iCnMiClIiBeBiMlLiNnNjBeJjBpAiClDiCoKiCmEiCkCiCoJiDfKiDiLiCkJiCoHiBeBjHpBiDeDiDjDiDgGiDgCiDeOiDfIiCmMiDiKiDfIiDgHiCpAjCiKiPgPiBeC_xHqqkZx_
	// _xZkqqHx_iClLiCmMiDiKiDfIiDgHiCkKjBhNjDpMiImKjChFiCmGiCmIiCoJiBeC_xHqqkZx_
	longSet stColumnIndex;
	set<FCLineColumn>::const_iterator iLc;
	for (iLc = m_stSelectedCell.begin(); iLc != m_stSelectedCell.end(); iLc++)
		stColumnIndex.insert((*iLc).GetColumnIndex());
	// _xZkqqHx_iDfCiDhNiDjDiDgIiDfKiDgCiDfGiDiHiDjDiCmMiKeKiOgOiBeC_xHqqkZx_
	g_pDoc->SessionBegin();
//----- 06.02.23 Fukushiro M. _xZkqqHx_jCmHiJmBiOgO_xHqqkZx_ ()-----
	// _xZkqqHx_iInKjDkOjBePiCmMjAnNjCoIiBeC_xHqqkZx_
// 06.06.13 Fukushiro M. 1_xZkqqHx_iNhDjFmPiNfI_xHqqkZx_ ()
//	LocalObjMovedBefore(GetSelectLocalObjVector());
	TbLocalObjMovedBefore();
//----- 06.02.23 Fukushiro M. _xZkqqHx_jCmHiJmBiPeJ_xHqqkZx_ ()-----
	// _xZkqqHx_jHpBiCpAjBhNjDpMiBeCjBhNjDpMiImKjChFiDiKiDfIiDgHiCmNiDiLiBfLiDhGiCpAiLhEiJpBiClFiCmJiClHiCoJiBeC_xHqqkZx_
	longSet::reverse_iterator rIdx;
	for (rIdx = stColumnIndex.rbegin(); rIdx != stColumnIndex.rend(); rIdx++)
	{
		// _xZkqqHx_jHpBiCpAjBhNjDpMiBeC_xHqqkZx_
		InsertColumn(*rIdx);
	}
//----- 06.02.23 Fukushiro M. _xZkqqHx_jCmHiJmBiOgO_xHqqkZx_ ()-----
	// _xZkqqHx_iInKjDkOiMoDiCmMjAnNjCoIiBeC_xHqqkZx_
	LocalObjMovedAfter();
//----- 06.02.23 Fukushiro M. _xZkqqHx_jCmHiJmBiPeJ_xHqqkZx_ ()-----
	// _xZkqqHx_iDfCiDhNiDjDiDgIiDfKiDgCiDfGiDiHiDjDiCmMiPeJjHlJiBeC_xHqqkZx_
	g_pDoc->SessionEnd();
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
//	// _xZkqqHx_jBeJjBpAjFjEjFgJiCmMjFmPiNfIiCpAiClBiCmMiDgDiBfLiDiLiCmJjCmKjCgNiBeC_xHqqkZx_
//	OnSelectObjModified();
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
//	// _xZkqqHx_iMmFjHeMiDiKiBfLiDfHiDiHiDjDiCpAjAnNjCoIiBeCjFnCiPfHjApMjFkKiCpAiKgHjCkDiClHiCoJiBeC_xHqqkZx_
//	g_pView->AppendToLastRgn(m_pSelectedObjTable->GetResizeFrame().ExtendRect(lg2mm(FD_TABLE_EDIT_MARGIN + 1)));
//	// _xZkqqHx_iMmFjHeMiDiKiBfLiDfHiDiHiDjDiCpAiNmEjFgAiJoGiBeC_xHqqkZx_
//	g_pView->SendRgnRedraw();
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----
} // FCToolTableEdit::OnObjectTableInsertColumn.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::CanObjectTableAddColumn
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDfCiDhNiDjDiDgIiBhFjFfMjFjEjFgJiCmJjHpBiCpAjCmHiJmBiBhGiCkKiOmAiNhDiJmCjEfMiCkJiCmHiCkEiCkJiCpAjFnEiClHiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jFnEjCgM_xHqqkZx_>	_xZkqqHx_iJmCjEfMiCmIiPoKiNiHiCmN_xHqqkZx_TRUE_xZkqqHx_iBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.02.08 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
BOOL FCToolTableEdit::CanObjectTableAddColumn () const
{
	if (!m_stSelectedCell.empty()) return TRUE;
	return BASE_CLASS::CanObjectTableAddColumn();
} // FCToolTableEdit::CanObjectTableAddColumn.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::OnObjectTableAddColumn
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDfCiDhNiDjDiDgIiBhFjFfMjFjEjFgJiCmJjHpBiCpAjCmHiJmBiBhGiCpAiOmAiNhDiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.02.08 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::OnObjectTableAddColumn ()
{
	// _xZkqqHx_iCnMiClIiBeBiMlLiNnNjBeJjBpAiClDiCoKiCmEiCkCiCoJiDfKiDiLiCkJiCoHiBeBjHpBiDeDiDjDiDgGiDgCiDeOiDfIiCmMiDiKiDfIiDgHiCpAjCiKiPgPiBeC_xHqqkZx_
	// _xZkqqHx_iClLiCmMiDiKiDfIiDgHiCkKjCmHiJmBiImKjChFiCmGiCmIiCoJiBeC_xHqqkZx_
	longSet stColumnIndex;
	set<FCLineColumn>::const_iterator iLc;
	for (iLc = m_stSelectedCell.begin(); iLc != m_stSelectedCell.end(); iLc++)
		stColumnIndex.insert((*iLc).GetColumnIndex());
	// _xZkqqHx_iDfCiDhNiDjDiDgIiDfKiDgCiDfGiDiHiDjDiCmMiKeKiOgOiBeC_xHqqkZx_
	g_pDoc->SessionBegin();
//----- 06.02.23 Fukushiro M. _xZkqqHx_jCmHiJmBiOgO_xHqqkZx_ ()-----
	// _xZkqqHx_iInKjDkOjBePiCmMjAnNjCoIiBeC_xHqqkZx_
// 06.06.13 Fukushiro M. 1_xZkqqHx_iNhDjFmPiNfI_xHqqkZx_ ()
//	LocalObjMovedBefore(GetSelectLocalObjVector());
	TbLocalObjMovedBefore();
//----- 06.02.23 Fukushiro M. _xZkqqHx_jCmHiJmBiPeJ_xHqqkZx_ ()-----
	// _xZkqqHx_jHpBiCpAjCmHiJmBiBeCjCmHiJmBiImKjChFiDiKiDfIiDgHiCmNiDiLiBfLiDhGiCpAiLhEiJpBiClFiCmJiClHiCoJiBeC_xHqqkZx_
	longSet::reverse_iterator rIdx;
	for (rIdx = stColumnIndex.rbegin(); rIdx != stColumnIndex.rend(); rIdx++)
	{
		// _xZkqqHx_jHpBiCpAjCmHiJmBiBeC_xHqqkZx_
		InsertColumn(*rIdx + 1);
	}
//----- 06.02.23 Fukushiro M. _xZkqqHx_jCmHiJmBiOgO_xHqqkZx_ ()-----
	// _xZkqqHx_iInKjDkOiMoDiCmMjAnNjCoIiBeC_xHqqkZx_
	LocalObjMovedAfter();
//----- 06.02.23 Fukushiro M. _xZkqqHx_jCmHiJmBiPeJ_xHqqkZx_ ()-----
	// _xZkqqHx_iDfCiDhNiDjDiDgIiDfKiDgCiDfGiDiHiDjDiCmMiPeJjHlJiBeC_xHqqkZx_
	g_pDoc->SessionEnd();
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
//	// _xZkqqHx_jBeJjBpAjFjEjFgJiCmMjFmPiNfIiCpAiClBiCmMiDgDiBfLiDiLiCmJjCmKjCgNiBeC_xHqqkZx_
//	OnSelectObjModified();
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
//	// _xZkqqHx_iMmFjHeMiDiKiBfLiDfHiDiHiDjDiCpAjAnNjCoIiBeCjFnCiPfHjApMjFkKiCpAiKgHjCkDiClHiCoJiBeC_xHqqkZx_
//	g_pView->AppendToLastRgn(m_pSelectedObjTable->GetResizeFrame().ExtendRect(lg2mm(FD_TABLE_EDIT_MARGIN + 1)));
//	// _xZkqqHx_iMmFjHeMiDiKiBfLiDfHiDiHiDjDiCpAiNmEjFgAiJoGiBeC_xHqqkZx_
//	g_pView->SendRgnRedraw();
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----
} // FCToolTableEdit::OnObjectTableAddColumn.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::CanObjectTableDeleteLine
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDfCiDhNiDjDiDgIiBhFjFfMjFjEjFgJiCmMiNhDiCpAiNoNiPjMiBhGiCkKiOmAiNhDiJmCjEfMiCkJiCmHiCkEiCkJiCpAjFnEiClHiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jFnEjCgM_xHqqkZx_>	_xZkqqHx_iJmCjEfMiCmIiPoKiNiHiCmN_xHqqkZx_TRUE_xZkqqHx_iBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.02.08 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
BOOL FCToolTableEdit::CanObjectTableDeleteLine () const
{
	if (m_pSelectedObjTable != NULL &&
		!m_stSelectedCell.empty())
	//----- _xZkqqHx_iNoNiPjMjBmOiPnLiCmMiNhDiCkKiOhHjCoIiClDiCoKiCmEiCkCiCoJiPoKiNiH_xHqqkZx_ -----
	{
		// _xZkqqHx_iNoNiPjMiClHiCnHiCkLiNhDiCpAiLiBiCnPiCoJiBeC_xHqqkZx_
		longSet stLineIndex;
		set<FCLineColumn>::const_iterator iLc;
		for (iLc = m_stSelectedCell.begin(); iLc != m_stSelectedCell.end(); iLc++)
			stLineIndex.insert((*iLc).GetLineIndex());
		// _xZkqqHx_iMlLiNnNiCmMiNhDjAjEiCkJiCoHiNoNiPjMiClHiCnHiCkLiNhDjAjEiCpAiIpIiCkCiClNiOgDiCoIiCkKiCePiCmFiCmIiCkPiCoKiCmO_xHqqkZx_TRUE_xZkqqHx_iBeC_xHqqkZx_
		if (m_pSelectedObjTable->GetLineCount() - stLineIndex.size() != 0)
			return TRUE;
	}
	return BASE_CLASS::CanObjectTableDeleteLine();
} // FCToolTableEdit::CanObjectTableDeleteLine.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::OnObjectTableDeleteLine
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDfCiDhNiDjDiDgIiBhFjFfMjFjEjFgJiCmMiNhDiCpAiNoNiPjMiBhGiCpAiOmAiNhDiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.02.08 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::OnObjectTableDeleteLine ()
{
	// _xZkqqHx_iCnMiClIiBeBiMlLiNnNjBeJjBpAiClDiCoKiCmEiCkCiCoJiDfKiDiLiCkJiCoHiBeBiNhDiDeDiDjDiDgGiDgCiDeOiDfIiCmMiDiKiDfIiDgHiCpAjCiKiPgPiBeC_xHqqkZx_
	// _xZkqqHx_iClLiCmMiDiKiDfIiDgHiCkKiNoNiPjMiImKjChFiCmGiCmIiCoJiBeC_xHqqkZx_
	longSet stLineIndex;
	set<FCLineColumn>::const_iterator iLc;
	for (iLc = m_stSelectedCell.begin(); iLc != m_stSelectedCell.end(); iLc++)
		stLineIndex.insert((*iLc).GetLineIndex());
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
//	// _xZkqqHx_iMmFjHeMiDiKiBfLiDfHiDiHiDjDiCpAjAnNjCoIiBeCjFnCiPfHjApMjFkKiCpAiKgHjCkDiClHiCoJiBeC_xHqqkZx_
//	g_pView->AppendToLastRgn(m_pSelectedObjTable->GetResizeFrame().ExtendRect(lg2mm(FD_TABLE_EDIT_MARGIN + 1)));
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----
	// _xZkqqHx_iDfCiDhNiDjDiDgIiDfKiDgCiDfGiDiHiDjDiCmMiKeKiOgOiBeC_xHqqkZx_
	g_pDoc->SessionBegin();
//----- 06.02.23 Fukushiro M. _xZkqqHx_jCmHiJmBiOgO_xHqqkZx_ ()-----
	// _xZkqqHx_iInKjDkOjBePiCmMjAnNjCoIiBeC_xHqqkZx_
// 06.06.13 Fukushiro M. 1_xZkqqHx_iNhDjFmPiNfI_xHqqkZx_ ()
//	LocalObjMovedBefore(GetSelectLocalObjVector());
	TbLocalObjMovedBefore();
//----- 06.02.23 Fukushiro M. _xZkqqHx_jCmHiJmBiPeJ_xHqqkZx_ ()-----
	// _xZkqqHx_iNhDiCpAiNoNiPjMiBeCiNoNiPjMiImKjChFiDiKiDfIiDgHiCmNiDiLiBfLiDhGiCpAiLhEiJpBiClFiCmJiClHiCoJiBeC_xHqqkZx_
	longSet::reverse_iterator rIdx;
	for (rIdx = stLineIndex.rbegin(); rIdx != stLineIndex.rend(); rIdx++)
	{
		// _xZkqqHx_iNhDiCpAiNoNiPjMiBeC_xHqqkZx_
		DeleteLine(*rIdx);
	}
//----- 06.02.23 Fukushiro M. _xZkqqHx_jCmHiJmBiOgO_xHqqkZx_ ()-----
	// _xZkqqHx_iInKjDkOiMoDiCmMjAnNjCoIiBeC_xHqqkZx_
	LocalObjMovedAfter();
//----- 06.02.23 Fukushiro M. _xZkqqHx_jCmHiJmBiPeJ_xHqqkZx_ ()-----
	// _xZkqqHx_iDfCiDhNiDjDiDgIiDfKiDgCiDfGiDiHiDjDiCmMiPeJjHlJiBeC_xHqqkZx_
	g_pDoc->SessionEnd();
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
//	// _xZkqqHx_jBeJjBpAjFjEjFgJiCmMjFmPiNfIiCpAiClBiCmMiDgDiBfLiDiLiCmJjCmKjCgNiBeC_xHqqkZx_
//	OnSelectObjModified();
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
//	// _xZkqqHx_iMmFjHeMiDiKiBfLiDfHiDiHiDjDiCpAjAnNjCoIiBeCjFnCiPfHjApMjFkKiCpAiKgHjCkDiClHiCoJiBeC_xHqqkZx_
//	g_pView->AppendToLastRgn(m_pSelectedObjTable->GetResizeFrame().ExtendRect(lg2mm(FD_TABLE_EDIT_MARGIN + 1)));
//	// _xZkqqHx_iMmFjHeMiDiKiBfLiDfHiDiHiDjDiCpAiNmEjFgAiJoGiBeC_xHqqkZx_
//	g_pView->SendRgnRedraw();
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----
} // FCToolTableEdit::OnObjectTableDeleteLine.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::CanObjectTableDeleteColumn
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDfCiDhNiDjDiDgIiBhFjFfMjFjEjFgJiCmMjHpBiCpAiNoNiPjMiBhGiCkKiOmAiNhDiJmCjEfMiCkJiCmHiCkEiCkJiCpAjFnEiClHiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jFnEjCgM_xHqqkZx_>	_xZkqqHx_iJmCjEfMiCmIiPoKiNiHiCmN_xHqqkZx_TRUE_xZkqqHx_iBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.02.08 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
BOOL FCToolTableEdit::CanObjectTableDeleteColumn () const
{
	if (m_pSelectedObjTable != NULL &&
		!m_stSelectedCell.empty())
	//----- _xZkqqHx_iNoNiPjMjBmOiPnLiCmMjHpBiCkKiOhHjCoIiClDiCoKiCmEiCkCiCoJiPoKiNiH_xHqqkZx_ -----
	{
		// _xZkqqHx_iNoNiPjMiClHiCnHiCkLjHpBiCpAiLiBiCnPiCoJiBeC_xHqqkZx_
		longSet stColumnIndex;
		set<FCLineColumn>::const_iterator iLc;
		for (iLc = m_stSelectedCell.begin(); iLc != m_stSelectedCell.end(); iLc++)
			stColumnIndex.insert((*iLc).GetColumnIndex());
		// _xZkqqHx_iMlLiNnNiCmMjHpBjAjEiCkJiCoHiNoNiPjMiClHiCnHiCkLjHpBjAjEiCpAiIpIiCkCiClNiOgDiCoIiCkKiCePiCmFiCmIiCkPiCoKiCmO_xHqqkZx_TRUE_xZkqqHx_iBeC_xHqqkZx_
		if (m_pSelectedObjTable->GetColumnCount() - stColumnIndex.size() != 0)
			return TRUE;
	}
	return BASE_CLASS::CanObjectTableDeleteColumn();
} // FCToolTableEdit::CanObjectTableDeleteColumn.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::OnObjectTableDeleteColumn
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDfCiDhNiDjDiDgIiBhFjFfMjFjEjFgJiCmMjHpBiCpAiNoNiPjMiBhGiCpAiOmAiNhDiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.02.08 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::OnObjectTableDeleteColumn ()
{
	// _xZkqqHx_iCnMiClIiBeBiMlLiNnNjBeJjBpAiClDiCoKiCmEiCkCiCoJiDfKiDiLiCkJiCoHiBeBjHpBiDeDiDjDiDgGiDgCiDeOiDfIiCmMiDiKiDfIiDgHiCpAjCiKiPgPiBeC_xHqqkZx_
	// _xZkqqHx_iClLiCmMiDiKiDfIiDgHiCkKiNoNiPjMiImKjChFiCmGiCmIiCoJiBeC_xHqqkZx_
	longSet stColumnIndex;
	set<FCLineColumn>::const_iterator iLc;
	for (iLc = m_stSelectedCell.begin(); iLc != m_stSelectedCell.end(); iLc++)
		stColumnIndex.insert((*iLc).GetColumnIndex());
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
//	// _xZkqqHx_iMmFjHeMiDiKiBfLiDfHiDiHiDjDiCpAjAnNjCoIiBeCjFnCiPfHjApMjFkKiCpAiKgHjCkDiClHiCoJiBeC_xHqqkZx_
//	g_pView->AppendToLastRgn(m_pSelectedObjTable->GetResizeFrame().ExtendRect(lg2mm(FD_TABLE_EDIT_MARGIN + 1)));
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----
	// _xZkqqHx_iDfCiDhNiDjDiDgIiDfKiDgCiDfGiDiHiDjDiCmMiKeKiOgOiBeC_xHqqkZx_
	g_pDoc->SessionBegin();
//----- 06.02.23 Fukushiro M. _xZkqqHx_jCmHiJmBiOgO_xHqqkZx_ ()-----
	// _xZkqqHx_iInKjDkOjBePiCmMjAnNjCoIiBeC_xHqqkZx_
// 06.06.13 Fukushiro M. 1_xZkqqHx_iNhDjFmPiNfI_xHqqkZx_ ()
//	LocalObjMovedBefore(GetSelectLocalObjVector());
	TbLocalObjMovedBefore();
//----- 06.02.23 Fukushiro M. _xZkqqHx_jCmHiJmBiPeJ_xHqqkZx_ ()-----
	// _xZkqqHx_jHpBiCpAiNoNiPjMiBeCiNoNiPjMiImKjChFiDiKiDfIiDgHiCmNiDiLiBfLiDhGiCpAiLhEiJpBiClFiCmJiClHiCoJiBeC_xHqqkZx_
	longSet::reverse_iterator rIdx;
	for (rIdx = stColumnIndex.rbegin(); rIdx != stColumnIndex.rend(); rIdx++)
	{
		// _xZkqqHx_jHpBiCpAiNoNiPjMiBeC_xHqqkZx_
		DeleteColumn(*rIdx);
	}
//----- 06.02.23 Fukushiro M. _xZkqqHx_jCmHiJmBiOgO_xHqqkZx_ ()-----
	// _xZkqqHx_iInKjDkOiMoDiCmMjAnNjCoIiBeC_xHqqkZx_
	LocalObjMovedAfter();
//----- 06.02.23 Fukushiro M. _xZkqqHx_jCmHiJmBiPeJ_xHqqkZx_ ()-----
	// _xZkqqHx_iDfCiDhNiDjDiDgIiDfKiDgCiDfGiDiHiDjDiCmMiPeJjHlJiBeC_xHqqkZx_
	g_pDoc->SessionEnd();
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
//	// _xZkqqHx_jBeJjBpAjFjEjFgJiCmMjFmPiNfIiCpAiClBiCmMiDgDiBfLiDiLiCmJjCmKjCgNiBeC_xHqqkZx_
//	OnSelectObjModified();
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
//	// _xZkqqHx_iMmFjHeMiDiKiBfLiDfHiDiHiDjDiCpAjAnNjCoIiBeCjFnCiPfHjApMjFkKiCpAiKgHjCkDiClHiCoJiBeC_xHqqkZx_
//	g_pView->AppendToLastRgn(m_pSelectedObjTable->GetResizeFrame().ExtendRect(lg2mm(FD_TABLE_EDIT_MARGIN + 1)));
//	// _xZkqqHx_iMmFjHeMiDiKiBfLiDfHiDiHiDjDiCpAiNmEjFgAiJoGiBeC_xHqqkZx_
//	g_pView->SendRgnRedraw();
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----
} // FCToolTableEdit::OnObjectTableDeleteColumn.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::CanObjectTableMergeCell
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDfCiDhNiDjDiDgIiBhFjFfMjFjEjFgJiCmMiDfKiDiLiCpAiMiLiNiHiBhGiCkKiOmAiNhDiJmCjEfMiCkJiCmHiCkEiCkJiCpAjFnEiClHiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jFnEjCgM_xHqqkZx_>	_xZkqqHx_iJmCjEfMiCmIiPoKiNiHiCmN_xHqqkZx_TRUE_xZkqqHx_iBeC_xHqqkZx_
 *
 * <_xZkqqHx_iJpAjAoA_xHqqkZx_>	_xZkqqHx_iJlKjAhNiCmMjDfPjApMjFjEjFkKiCpAjBeJjBpAiClFiCmEiCkCiCoJiPoKiNiHiCpAiNgMiCkGiCmEiCnNiCoJiBeC_xHqqkZx_
 *			_xZkqqHx_iClBiCmMiPoKiNiHiBeBjBeJjBpAjCiGiCmMiDfKiDiLiCmN_xHqqkZx_[0,2][0,3][1,2][2,2]_xZkqqHx_iCmFiCkAiCoJiBeC_xHqqkZx_
 *			_xZkqqHx_jBeJjBpAiDiKiDfIiDgHiNmFiPiJiCmMiDfKiDiLiCmNiNlGiPoDiCmFiCkAiCoJiCkKiBeBiNmFiMoDiCmMiDfKiDiLiCmNiJeFiJlKiCmGiCmN_xHqqkZx_
 *			_xZkqqHx_iMmAiCoHiCmIiCkCiBeCiBgJjHoBiCkGiCmOiJlKjAhNiCmFjBfDiCmEiCmMiDfKiDiLiCpAjBeJjBpAiClFiClNiPoKiNiHiBeBiNmFiMoDiCmM_xHqqkZx_
 *			_xZkqqHx_iDfKiDiLiCmN_xHqqkZx_[2,2]_xZkqqHx_iCmFiCmNiCmIiCkN_xHqqkZx_[3,1]_xZkqqHx_iCmFiCkAiCoJiBgK_xHqqkZx_
 *			_xZkqqHx_iClBiCmMiClNiCnPiBeBjBeJjBpAjCiGiCmMiDfKiDiLiCpAjBfDiCmEiDfKiDiLiDhFiDiNiDgCiDeOiCmJjFkKiJpAiClFiBeBiClLiCmM_xHqqkZx_
 *			_xZkqqHx_iDfKiDiLiDhFiDiNiDgCiDeOiPfHiNiHiCkKjAlDiKgNiCmJiLoJiMgAiCpAiNfMjAkMiClHiCoJiCkJjClCiCnHiCoJjFeLjHhGiCkKiCkAiCoJiBeC_xHqqkZx_
 *
 *                  0              1              2              3          
 *                                                                          
 *          _xZkqqHx_iEkBiEjPiEjP_xHqqkZx_[0,0]_xZkqqHx_iEjPiEjPiEjPiEjPiEjP_xHqqkZx_[0,1]_xZkqqHx_iEjPiEjPiEkGiBgDiBgD_xHqqkZx_[0,2]_xZkqqHx_iBgDiBgDiEkGiBgDiBgD_xHqqkZx_[0,3]_xZkqqHx_iBgDiBgDiEkC_xHqqkZx_  
 *          _xZkqqHx_iEkA_xHqqkZx_                            _xZkqqHx_iBeG_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_  
 *     0   [0,0]  [0,0]          [0,1]   [2,0]  [0,2]   [3,0]  [0,3]   [4,0]
 *          _xZkqqHx_iEkA_xHqqkZx_                            _xZkqqHx_iBeG_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_  
 *          _xZkqqHx_iEkFiEjPiEjP_xHqqkZx_[1,0]_xZkqqHx_iEjPiEjPiEkGiEjPiEjP_xHqqkZx_[1,1]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[1,2]_xZkqqHx_iEjPiEjPiEkH_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_  
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_  
 *     1   [0,1]  [1,0]   [1,1]  [1,1]   [2,1]  [1,2]   [3,1]          [4,1]
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_  
 *          _xZkqqHx_iEkFiEjPiEjP_xHqqkZx_[2,0]_xZkqqHx_iEjPiEjPiEkH_xHqqkZx_             _xZkqqHx_iEkFiEjPiEjP_xHqqkZx_[2,2]_xZkqqHx_iEjPiEjPiEkIiEjPiEjP_xHqqkZx_[2,3]_xZkqqHx_iEjPiEjPiEkH_xHqqkZx_  
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_                            _xZkqqHx_iBeG_xHqqkZx_  
 *     2   [0,2]  [2,0]   [1,2]          [2,2]  [2,2]                  [4,2]
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_                            _xZkqqHx_iBeG_xHqqkZx_  
 *          _xZkqqHx_iEkFiEjPiEjP_xHqqkZx_[3,0]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[3,1]_xZkqqHx_iEjPiEjPiEkH_xHqqkZx_                            _xZkqqHx_iBeG_xHqqkZx_  
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_                            _xZkqqHx_iBeG_xHqqkZx_  
 *     3   [0,3]  [3,0]   [1,3]  [3,1]   [2,3]                         [4,3]
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_                            _xZkqqHx_iBeG_xHqqkZx_  
 *          _xZkqqHx_iEkEiEjPiEjP_xHqqkZx_[4,0]_xZkqqHx_iEjPiEjPiEkIiEjPiEjP_xHqqkZx_[4,1]_xZkqqHx_iEjPiEjPiEkIiBgDiBgD_xHqqkZx_[4,2]_xZkqqHx_iBgDiBgDiBgDiBgDiBgD_xHqqkZx_[4,3]_xZkqqHx_iBgDiBgDiEkD_xHqqkZx_  
 *
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.02.10 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
BOOL FCToolTableEdit::CanObjectTableMergeCell () const
{
	if (m_pSelectedObjTable != NULL &&
		2 <= m_stSelectedCell.size())
	//----- _xZkqqHx_iMiLiNiHjBmOiPnLiCkKiCfBiDfKiDiLiImIiPoDiOhHjCoIiClDiCoKiCmEiCkCiCoJiPoKiNiH_xHqqkZx_ -----
	{
		set<FCLineColumn> stCellBlock;
		set<FCLineColumn>::const_iterator iLc;
		for (iLc = m_stSelectedCell.begin(); iLc != m_stSelectedCell.end(); iLc++)
		{
			FCLineColumn cellBlockFrom;
			FCLineColumn cellBlockUntil;
			m_pSelectedObjTable->GetCellBlock(*iLc, &cellBlockFrom, &cellBlockUntil);
			for (long lLineIndex = cellBlockFrom.GetLineIndex();
				 lLineIndex <= cellBlockUntil.GetLineIndex(); lLineIndex++)
				for (long lColumnIndex = cellBlockFrom.GetColumnIndex();
					 lColumnIndex <= cellBlockUntil.GetColumnIndex(); lColumnIndex++)
					stCellBlock.insert(FCLineColumn(lLineIndex, lColumnIndex));
		}
		long lLineMin = (*stCellBlock.begin()).GetLineIndex();
		long lLineMax = (*stCellBlock.rbegin()).GetLineIndex();
		long lColumnMin = (*stCellBlock.begin()).GetColumnIndex();
		long lColumnMax = (*stCellBlock.rbegin()).GetColumnIndex();

		for (long lLineIndex = lLineMin; lLineIndex <= lLineMax; lLineIndex++)
			for (long lColumnIndex = lColumnMin; lColumnIndex <= lColumnMax; lColumnIndex++)
				if (stCellBlock.erase(FCLineColumn(lLineIndex, lColumnIndex)) != 1)
					return FALSE;
		if (!stCellBlock.empty()) return FALSE;
		return TRUE;
	}
	return BASE_CLASS::CanObjectTableDeleteColumn();
} // FCToolTableEdit::CanObjectTableMergeCell.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::OnObjectTableMergeCell
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDfCiDhNiDjDiDgIiBhFjFfMjFjEjFgJiCmMiDfKiDiLiCpAiMiLiNiHiBhGiCpAiOmAiNhDiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.02.10 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::OnObjectTableMergeCell ()
{
	//----- _xZkqqHx_jBeJjBpAiClDiCoKiCmEiCkCiCoJiDfKiDiLiCkJiCoHiBeBiClLiCoKiCpAiImNiCnOiDfKiDiLiCmMjEmNiImNiCpAiLiBiCnPiCoJ_xHqqkZx_ -----
	//		_xZkqqHx_iJlKjAhNiCmMiHeBiCkKjBeJjBpAjEmNiImNiCmMiPoKiNiHiBeB_xHqqkZx_m_stSelectedCell.begin() _xZkqqHx_iCmN_xHqqkZx_[_xZkqqHx_iBkG_xHqqkZx_1]_xZkqqHx_iBeB_xHqqkZx_
	//		m_stSelectedCell.rbegin() _xZkqqHx_iCmN_xHqqkZx_[_xZkqqHx_iBkG_xHqqkZx_2]_xZkqqHx_iCmGiCmIiCoIiBeBjBeJjBpAiDfKiDiLiPfHiNiHiCmM_xHqqkZx_
	//		_xZkqqHx_iNmFiPiJiCmGiNmFiMoDiCpAjClCiCnHiCmEiCoAjBeJjBpAjEmNiImN_xHqqkZx_(_xZkqqHx_iBkG_xHqqkZx_1_xZkqqHx_iBgAiBkG_xHqqkZx_4)_xZkqqHx_iCpAiLiBiCnPiCoJiClBiCmGiCmNiPgPjHiIiCmIiCkCiBeC_xHqqkZx_
	//		_xZkqqHx_iClBiCmMiClNiCnPiBeBjBeJjBpAiClDiCoKiCmEiCkCiCoJjBfDiCmEiCmMiDfKiDiLiCkJiCoHiNhDiBeBjHpBiCmMiNmFiPkMiBeFiNmFjBoFjCgM_xHqqkZx_
	//		_xZkqqHx_iCpAiLiBiCnPiCoJiBeC_xHqqkZx_
	//
	//		_xZkqqHx_iEkBiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEkGiEjPiEjPiEjPiEjPiEkGiEjPiEjPiEjPiEjPiEkC_xHqqkZx_  
	//		_xZkqqHx_iEkA_xHqqkZx_                  _xZkqqHx_iEkA_xHqqkZx_        _xZkqqHx_iEkA_xHqqkZx_        _xZkqqHx_iEkA_xHqqkZx_  
	//		_xZkqqHx_iEkA_xHqqkZx_                  _xZkqqHx_iEkA_xHqqkZx_        _xZkqqHx_iEkA_xHqqkZx_        _xZkqqHx_iEkA_xHqqkZx_  
	//		_xZkqqHx_iEkFiEjPiEjPiEjPiEjPiEkGiEjPiEjPiEjPiEjPiEkIiEjPiEjPiEjPiEjPiEkIiEjPiEjPiEjPiEjPiEkH_xHqqkZx_  
	//		_xZkqqHx_iEkA_xHqqkZx_        _xZkqqHx_iEkAiEkBiBgDiBgDiBgDiBgDiBgDiHeBiBgDiBgDiBgDiBgDiBgDiBgDiEkCiEkA_xHqqkZx_  
	//		_xZkqqHx_iEkA_xHqqkZx_        _xZkqqHx_iEkAiBeG_xHqqkZx_[_xZkqqHx_iBkG_xHqqkZx_1] _xZkqqHx_iEkA_xHqqkZx_ [_xZkqqHx_iBkG_xHqqkZx_3]          _xZkqqHx_iBeGiEkA_xHqqkZx_  
	//		_xZkqqHx_iEkFiEjPiEjPiEjPiEjPiEkJiBeGiEjPiEjPiEjPiEkH_xHqqkZx_                _xZkqqHx_iBeGiEkA_xHqqkZx_  
	//		_xZkqqHx_iEkA_xHqqkZx_        _xZkqqHx_iEkAiBeG_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_                _xZkqqHx_iBeGiEkA_xHqqkZx_  
	//		_xZkqqHx_iEkA_xHqqkZx_        _xZkqqHx_iEkAiBeG_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_                _xZkqqHx_iBeGiEkA_xHqqkZx_  
	//		_xZkqqHx_iEkFiEjPiEjPiEjPiEjPiEkJiBeGiEjPiEjPiEjPiEkH_xHqqkZx_                _xZkqqHx_iBeGiEkA_xHqqkZx_  
	//		_xZkqqHx_iEkA_xHqqkZx_        _xZkqqHx_iEkAiBeG_xHqqkZx_[_xZkqqHx_iBkG_xHqqkZx_2] _xZkqqHx_iEkA_xHqqkZx_           [_xZkqqHx_iBkG_xHqqkZx_4]_xZkqqHx_iBeGiEkA_xHqqkZx_  
	//		_xZkqqHx_iEkA_xHqqkZx_        _xZkqqHx_iEkAiEkEiBgDiBgDiBgDiBgDiBgDiBgDiBgDiBgDiBgDiBgDiBgDiBgDiEkDiEkA_xHqqkZx_  
	//		_xZkqqHx_iEkEiEjPiEjPiEjPiEjPiEkIiEjPiEjPiEjPiEjPiEkIiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEkD_xHqqkZx_  
	
	FCLineColumn cellIndexFrom = *m_stSelectedCell.begin();
	FCLineColumn cellIndexUntil = *m_stSelectedCell.begin();
	set<FCLineColumn>::const_iterator iLc = m_stSelectedCell.begin();
	for (iLc++; iLc != m_stSelectedCell.end(); iLc++)
	{
		if ((*iLc).GetLineIndex() < cellIndexFrom.GetLineIndex())
			cellIndexFrom.SetLineIndex((*iLc).GetLineIndex());
		if (cellIndexUntil.GetLineIndex() < (*iLc).GetLineIndex())
			cellIndexUntil.SetLineIndex((*iLc).GetLineIndex());
		if ((*iLc).GetColumnIndex() < cellIndexFrom.GetColumnIndex())
			cellIndexFrom.SetColumnIndex((*iLc).GetColumnIndex());
		if (cellIndexUntil.GetColumnIndex() < (*iLc).GetColumnIndex())
			cellIndexUntil.SetColumnIndex((*iLc).GetColumnIndex());
	}
	// _xZkqqHx_jBeJjBpAjEmNiImNiCmJiDfKiDiLiDhFiDiNiDgCiDeOiCpAiNgMjHlGiClFiCmEiBeBiNmFiPeJjDeJiCmIjBeJjBpAjEmNiImNiCpAiLiBiCnPiCoJiBeC_xHqqkZx_
	// m_stSelectedCell _xZkqqHx_iCmNiKpJiCmJiDfKiDiLiDhFiDiNiDgCiDeOiCpAiNgMjHlGiClFiCmEjBeJjBpAiClDiCoKiCmEiCkCiCoJiCkKiBeB_xHqqkZx_
	// _xZkqqHx_iOmAiDeBiDgIiDiMiDfIiCmIiCmMiCmFiBeBiPoDjAhNiCmMiCoGiCkEiCmIjHoBiCmFiCmN_xHqqkZx_[_xZkqqHx_iBkG_xHqqkZx_4]_xZkqqHx_iCmMiCoGiCkEiCmIiNoNiPjMiClDiCoKiClNiDfKiDiL_xHqqkZx_
	// _xZkqqHx_iCmNiKnMiCnMiCoKiCmEiCkCiCmIiCkCiBeC_xHqqkZx_GetIncludedRuled _xZkqqHx_iCmNiJlMjBhKiDeBiDgIiDiMiDfIiCpAjFeLjHhGiCmGiClHiCoJiCmMiCmFiBeB_xHqqkZx_
	// GetFinalCellBlock _xZkqqHx_iCmFiJlMjBhKiDeBiDgIiDiMiDfIiCpAiLiBiCnPiCoJiBeC_xHqqkZx_
	FCLineColumn cellIndexFromFinal;
	FCLineColumn cellIndexUntilFinal;
	m_pSelectedObjTable->GetFinalCellBlock(	cellIndexFromFinal,
											cellIndexUntilFinal,
											cellIndexFrom,
											cellIndexUntil);
	set<FCFrontSide> stHorzRuled;
	set<FCFrontSide> stVertRuled;
	m_pSelectedObjTable->GetIncludedRuled(stHorzRuled, stVertRuled, cellIndexFromFinal, cellIndexUntilFinal);
	set<FCLineColumn> stCell = m_stSelectedCell;
	// _xZkqqHx_jAfGiClFiCkCiDfKiDiLiDhFiDiNiDgCiDeOiCmMiNlGiPoDiDfKiDiLiCmNiNoNiPjMiClFiCmIiCkCiBeC_xHqqkZx_
	stCell.erase(cellIndexFromFinal);

	// _xZkqqHx_jBeJjBpAiClDiCoKiCmEiCkCiCoJiDfKiDiLiCpAiNmFiPiJiClOiCkPiOgDiClFiCmEiJpAiPjMiBeC_xHqqkZx_
	RemoveSelectCell(stCell);
	// _xZkqqHx_jBeJjBpAiClDiCoKiCmEiCkCiCoJjAiFjFlNiMhCjApMiCpAiJpAiPjMiBeC_xHqqkZx_
	RemoveSelectRuled(TRUE, stHorzRuled);
	// _xZkqqHx_jBeJjBpAiClDiCoKiCmEiCkCiCoJjAiCjClMiMhCjApMiCpAiJpAiPjMiBeC_xHqqkZx_
	RemoveSelectRuled(FALSE, stVertRuled);

	// _xZkqqHx_iDfCiDhNiDjDiDgIiDfKiDgCiDfGiDiHiDjDiCmMiKeKiOgOiBeC_xHqqkZx_
	g_pDoc->SessionBegin();
//----- 06.02.23 Fukushiro M. _xZkqqHx_jCmHiJmBiOgO_xHqqkZx_ ()-----
	// _xZkqqHx_iInKjDkOjBePiCmMjAnNjCoIiBeC_xHqqkZx_
// 06.06.13 Fukushiro M. 1_xZkqqHx_iNhDjFmPiNfI_xHqqkZx_ ()
//	LocalObjMovedBefore(GetSelectLocalObjVector());
	TbLocalObjMovedBefore();
//----- 06.02.23 Fukushiro M. _xZkqqHx_jCmHiJmBiPeJ_xHqqkZx_ ()-----
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
//	// _xZkqqHx_jFmPiNfIjBePiCmMiMmFjHeMiDiKiBfLiDfHiDiHiDjDiCpAjAnNjCoIiBeC_xHqqkZx_
//	g_pView->AddRgn(m_pSelectedObjTable);
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----
	// _xZkqqHx_iDfCiDhNiDjDiDgIiOmAiNhDiBeC_xHqqkZx_
	g_pDoc->CmdMergeTableCell(m_pSelectedObjTable, stCell, stHorzRuled, stVertRuled);

//----- 06.02.23 Fukushiro M. _xZkqqHx_jCmHiJmBiOgO_xHqqkZx_ ()-----
	// _xZkqqHx_iInKjDkOiMoDiCmMjAnNjCoIiBeC_xHqqkZx_
	LocalObjMovedAfter();
//----- 06.02.23 Fukushiro M. _xZkqqHx_jCmHiJmBiPeJ_xHqqkZx_ ()-----
	// _xZkqqHx_iDfCiDhNiDjDiDgIiDfKiDgCiDfGiDiHiDjDiCmMiPeJjHlJiBeC_xHqqkZx_
	g_pDoc->SessionEnd();
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
//	// _xZkqqHx_jBeJjBpAjFjEjFgJiCmMjFmPiNfIiCpAiClBiCmMiDgDiBfLiDiLiCmJjCmKjCgNiBeC_xHqqkZx_
//	OnSelectObjModified();
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
//	// _xZkqqHx_iMmFjHeMiDiKiBfLiDfHiDiHiDjDiCpAiNmEjFgAiJoGiBeC_xHqqkZx_
//	g_pView->SendRgnRedraw();
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----
} // FCToolTableEdit::OnObjectTableMergeCell.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::CanObjectTableSplitCell
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDfCiDhNiDjDiDgIiBhFjFfMjFjEjFgJiCmMiDfKiDiLiCpAjFkKiKiEiBhGiCkKiOmAiNhDiJmCjEfMiCkJiCmHiCkEiCkJiCpAjFnEiClHiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jFnEjCgM_xHqqkZx_>	_xZkqqHx_iJmCjEfMiCmIiPoKiNiHiCmN_xHqqkZx_TRUE_xZkqqHx_iBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.08.14 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
BOOL FCToolTableEdit::CanObjectTableSplitCell () const
{
	if (m_pSelectedObjTable != NULL &&
		m_stSelectedCell.size() == 1)
	//----- _xZkqqHx_jFkKiKiEjBmOiPnLiCkKiCfAiDfKiDiLiOhHjCoIiClDiCoKiCmEiCkCiCoJiPoKiNiH_xHqqkZx_ -----
	{
		FCLineColumn cellBlockFrom;
		FCLineColumn cellBlockUntil;
		m_pSelectedObjTable->GetCellBlock(	*m_stSelectedCell.begin(),
											&cellBlockFrom, &cellBlockUntil);
		if (cellBlockFrom.GetLineIndex() == cellBlockUntil.GetLineIndex() &&
			cellBlockFrom.GetColumnIndex() == cellBlockUntil.GetColumnIndex())
			return FALSE;
		return TRUE;
	}
	return BASE_CLASS::CanObjectTableSplitCell();
} // FCToolTableEdit::CanObjectTableSplitCell.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::OnObjectTableSplitCell
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDfCiDhNiDjDiDgIiBhFjFfMjFjEjFgJiCmMiDfKiDiLiCpAjFkKiKiEiBhGiCpAiOmAiNhDiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.08.14 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::OnObjectTableSplitCell ()
{
	// _xZkqqHx_iDfCiDhNiDjDiDgIiDfKiDgCiDfGiDiHiDjDiCmMiKeKiOgOiBeC_xHqqkZx_
	g_pDoc->SessionBegin();
//----- 06.02.23 Fukushiro M. _xZkqqHx_jCmHiJmBiOgO_xHqqkZx_ ()-----
	// _xZkqqHx_iInKjDkOjBePiCmMjAnNjCoIiBeC_xHqqkZx_
// 06.06.13 Fukushiro M. 1_xZkqqHx_iNhDjFmPiNfI_xHqqkZx_ ()
//	LocalObjMovedBefore(GetSelectLocalObjVector());
	TbLocalObjMovedBefore();
//----- 06.02.23 Fukushiro M. _xZkqqHx_jCmHiJmBiPeJ_xHqqkZx_ ()-----
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
//	// _xZkqqHx_jFmPiNfIjBePiCmMiMmFjHeMiDiKiBfLiDfHiDiHiDjDiCpAjAnNjCoIiBeC_xHqqkZx_
//	g_pView->AddRgn(m_pSelectedObjTable);
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----
	// _xZkqqHx_iDfCiDhNiDjDiDgIiOmAiNhDiBeC_xHqqkZx_
	g_pDoc->CmdSplitTableCell(m_pSelectedObjTable, *m_stSelectedCell.begin());
//----- 06.02.23 Fukushiro M. _xZkqqHx_jCmHiJmBiOgO_xHqqkZx_ ()-----
	// _xZkqqHx_iInKjDkOiMoDiCmMjAnNjCoIiBeC_xHqqkZx_
	LocalObjMovedAfter();
//----- 06.02.23 Fukushiro M. _xZkqqHx_jCmHiJmBiPeJ_xHqqkZx_ ()-----
	// _xZkqqHx_iDfCiDhNiDjDiDgIiDfKiDgCiDfGiDiHiDjDiCmMiPeJjHlJiBeC_xHqqkZx_
	g_pDoc->SessionEnd();
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
//	// _xZkqqHx_jBeJjBpAjFjEjFgJiCmMjFmPiNfIiCpAiClBiCmMiDgDiBfLiDiLiCmJjCmKjCgNiBeC_xHqqkZx_
//	OnSelectObjModified();
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
//	// _xZkqqHx_iMmFjHeMiDiKiBfLiDfHiDiHiDjDiCpAiNmEjFgAiJoGiBeC_xHqqkZx_
//	g_pView->SendRgnRedraw();
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----
} // FCToolTableEdit::OnObjectTableSplitCell.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::CanHandle
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iOhHjCoIiClDiCoKiClNjFjEjFgJiCkKiClBiCmMiDgDiBfLiDiLiCmFiIlFiCkGiCoJiCkJiCmHiCkEiCkJiCpAjFnEiClHiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	pObj	:_xZkqqHx_jFjEjFgJiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jFnEjCgM_xHqqkZx_>	_xZkqqHx_iJmCjEfMiCmMiPoKiNiHiCmN_xHqqkZx_ TRUE_xZkqqHx_iBeBjFhDiJmCjEfMiCmMiPoKiNiHiCmN_xHqqkZx_ FALSE _xZkqqHx_iCpAjFnEiClHiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.01.28 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
BOOL FCToolTableEdit::CanHandle (const FCObjDynabase* pObj) const
{
	if (!pObj->IsKindOf(FDOJ_TABLE)) return FALSE;
	// Superclass_xZkqqHx_iKnGjAjEiOmAiNhDiBeC_xHqqkZx_
	return BASE_CLASS::CanHandle(pObj);
} // FCToolTableEdit::CanHandle.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::IsObjectCommandEnable
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDfCiDhNiDjDiDgI_xHqqkZx_ ID_OBJECT_XXX _xZkqqHx_iCmMjCoIjAkLjDeJiCmIjHeMiMpIiBeFjGlDiMpIiCpAjFnEiClHiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	dwCmdID	:_xZkqqHx_iDfCiDhNiDjDiDgI_xHqqkZx_ID_xZkqqHx_iCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jFnEjCgM_xHqqkZx_>	_xZkqqHx_jHeMiMpIiCmMiPoKiNiH_xHqqkZx_ TRUE_xZkqqHx_iBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.01.31 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
BOOL FCToolTableEdit::IsObjectCommandEnable (DWORD dwCmdID) const
{
	switch (dwCmdID)
	{
	case ID_OBJECT_TABLE_INSERT_LINE:
	case ID_OBJECT_TABLE_ADD_LINE:
	case ID_OBJECT_TABLE_INSERT_COLUMN:
	case ID_OBJECT_TABLE_ADD_COLUMN:
	case ID_OBJECT_TABLE_DELETE_LINE:
	case ID_OBJECT_TABLE_DELETE_COLUMN:
	case ID_OBJECT_TABLE_MERGE_CELL:
	case ID_OBJECT_TABLE_SPLIT_CELL:
		return TRUE;
	default:
		return BASE_CLASS::IsObjectCommandEnable(dwCmdID);
	}
} // FCToolTableEdit::IsObjectCommandEnable.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::CheckHitRuled
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDhNiDeFiDfIiImKjChFiCkKiMhCjApMjFnCiPfHjApMiCmJiDhBiDgCiDgHiClFiCmEiCkCiCoJiCkJiCmHiCkEiCkJiCpAjClCiCnHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jFnEjCgM_xHqqkZx_>	_xZkqqHx_iDhBiDgCiDgHiPpDjBnEiCpAjFnEiClHiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iJpAjAoA_xHqqkZx_>	_xZkqqHx_jFnCiPfHjApMiCpAiImIiJlKiCmJiOkGiClHiBeC_xHqqkZx_
 *
 *                            _xZkqqHx_iEkBiEjPiEkC_xHqqkZx_      _xZkqqHx_iEkBiEjPiEkC_xHqqkZx_          _xZkqqHx_iEkBiEjPiEkC_xHqqkZx_                  
 *              _xZkqqHx_iBfOiEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_Cv_xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_Cv_xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_Cv_xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkAiBfP_xHqqkZx_    
 *            _xZkqqHx_iBfO_xHqqkZx_A0_xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_A1_xZkqqHx_iBfP_xHqqkZx_  
 *            _xZkqqHx_iEjPiEjPiEkD_xHqqkZx_          _xZkqqHx_iEkEiEkGiEkD_xHqqkZx_      _xZkqqHx_iEkEiEkGiEkD_xHqqkZx_          _xZkqqHx_iEkEiEkGiEkD_xHqqkZx_          _xZkqqHx_iEkEiEjPiEjP_xHqqkZx_  
 *                  _xZkqqHx_iEkBiEjPiEjPiEjPiEkC_xHqqkZx_  _xZkqqHx_iEkFiEjPiEjPiEjPiEjPiEjPiEkJiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEkH_xHqqkZx_  _xZkqqHx_iEkBiEjPiEjPiEjPiEkC_xHqqkZx_        
 *                  _xZkqqHx_iEkA_xHqqkZx_  B0  _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_     Ev   Dv      Ev      Dv  _xZkqqHx_iEkA_xHqqkZx_  B1  _xZkqqHx_iEkA_xHqqkZx_        
 *                  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_              _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_        
 *                  _xZkqqHx_iEkEiEjPiEjPiEjPiEkD_xHqqkZx_  _xZkqqHx_iEkEiEjPiEjPiEjPiEjPiEjPiEkIiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEkD_xHqqkZx_  _xZkqqHx_iEkEiEjPiEjPiEjPiEkD_xHqqkZx_        
 *          _xZkqqHx_iEkBiEjPiEjPiEkC_xHqqkZx_                                                      _xZkqqHx_iEkBiEjPiEjPiEkC_xHqqkZx_
 *          _xZkqqHx_iEkA_xHqqkZx_ Ch _xZkqqHx_iEkFiEkGiEjPiEjPiEjPiEkC_xHqqkZx_  _xZkqqHx_iEkBiEjPiEjP_xHqqkZx_Fh_xZkqqHx_iEjPiEjPiEkGiEjPiEjPiEjP_xHqqkZx_Fh_xZkqqHx_iEjPiEjPiEjPiEkC_xHqqkZx_  _xZkqqHx_iEkBiEjPiEjPiEjPiEkGiEkH_xHqqkZx_ Ch _xZkqqHx_iEkA_xHqqkZx_
 *          _xZkqqHx_iEkEiEjPiEjPiEkDiEkA_xHqqkZx_  Eh  _xZkqqHx_iEkA_xHqqkZx_  Fv    G     Fv      G       Fv  _xZkqqHx_iEkA_xHqqkZx_  Eh  _xZkqqHx_iEkAiEkEiEjPiEjPiEkD_xHqqkZx_
 *          _xZkqqHx_iEkBiEjPiEjPiEkCiEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_              _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkAiEkBiEjPiEjPiEkC_xHqqkZx_
 *          _xZkqqHx_iEkA_xHqqkZx_ Ch _xZkqqHx_iEkFiEkJiEjP_xHqqkZx_Dh_xZkqqHx_iEjPiEkH_xHqqkZx_  _xZkqqHx_iEkFiEjPiEjP_xHqqkZx_Fh_xZkqqHx_iEjPiEjPiEkJiEjPiEjPiEjP_xHqqkZx_Fh_xZkqqHx_iEjPiEjPiEjPiEkH_xHqqkZx_  _xZkqqHx_iEkFiEjP_xHqqkZx_Dh_xZkqqHx_iEjPiEkJiEkH_xHqqkZx_ Ch _xZkqqHx_iEkA_xHqqkZx_
 *          _xZkqqHx_iEkEiEjPiEjPiEkDiEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_              _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkAiEkEiEjPiEjPiEkD_xHqqkZx_
 *                  _xZkqqHx_iEkA_xHqqkZx_  Eh  _xZkqqHx_iEkA_xHqqkZx_  Fv    G     Fv      G       Fv  _xZkqqHx_iEkA_xHqqkZx_  Eh  _xZkqqHx_iEkA_xHqqkZx_        
 *          _xZkqqHx_iEkBiEjPiEjPiEkCiEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_              _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkAiEkBiEjPiEjPiEkC_xHqqkZx_
 *          _xZkqqHx_iEkA_xHqqkZx_ Ch _xZkqqHx_iEkFiEkJiEjP_xHqqkZx_Dh_xZkqqHx_iEjPiEkH_xHqqkZx_  _xZkqqHx_iEkFiEjPiEjP_xHqqkZx_Fh_xZkqqHx_iEjPiEjPiEkJiEjPiEjPiEjP_xHqqkZx_Fh_xZkqqHx_iEjPiEjPiEjPiEkH_xHqqkZx_  _xZkqqHx_iEkFiEjP_xHqqkZx_Dh_xZkqqHx_iEjPiEkJiEkH_xHqqkZx_ Ch _xZkqqHx_iEkA_xHqqkZx_
 *          _xZkqqHx_iEkEiEjPiEjPiEkDiEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_              _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkAiEkEiEjPiEjPiEkD_xHqqkZx_
 *                  _xZkqqHx_iEkA_xHqqkZx_  Eh  _xZkqqHx_iEkA_xHqqkZx_  Fv    G     Fv      G       Fv  _xZkqqHx_iEkA_xHqqkZx_  Eh  _xZkqqHx_iEkA_xHqqkZx_        
 *                  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_              _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_        
 *          _xZkqqHx_iEkBiEjPiEjPiEkCiEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_              _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkAiEkBiEjPiEjPiEkC_xHqqkZx_
 *          _xZkqqHx_iEkA_xHqqkZx_ Ch _xZkqqHx_iEkFiEkIiEjP_xHqqkZx_Dh_xZkqqHx_iEjPiEkD_xHqqkZx_  _xZkqqHx_iEkEiEjPiEjP_xHqqkZx_Fh_xZkqqHx_iEjPiEjPiEkIiEjPiEjPiEjP_xHqqkZx_Fh_xZkqqHx_iEjPiEjPiEjPiEkD_xHqqkZx_  _xZkqqHx_iEkEiEjP_xHqqkZx_Dh_xZkqqHx_iEjPiEkIiEkH_xHqqkZx_ Ch _xZkqqHx_iEkA_xHqqkZx_
 *          _xZkqqHx_iEkEiEjPiEjPiEkD_xHqqkZx_                                                      _xZkqqHx_iEkEiEjPiEjPiEkD_xHqqkZx_
 *                  _xZkqqHx_iEkBiEjPiEjPiEjPiEkC_xHqqkZx_  _xZkqqHx_iEkBiEjPiEjPiEjPiEjPiEjPiEkGiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEkC_xHqqkZx_  _xZkqqHx_iEkBiEjPiEjPiEjPiEkC_xHqqkZx_        
 *                  _xZkqqHx_iEkA_xHqqkZx_  B3  _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_     Ev   Dv      Ev      Dv  _xZkqqHx_iEkA_xHqqkZx_  B2  _xZkqqHx_iEkA_xHqqkZx_        
 *                  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_              _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_        
 *                  _xZkqqHx_iEkEiEjPiEjPiEjPiEkD_xHqqkZx_  _xZkqqHx_iEkFiEjPiEjPiEjPiEjPiEjPiEkJiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEkH_xHqqkZx_  _xZkqqHx_iEkEiEjPiEjPiEjPiEkD_xHqqkZx_        
 *            _xZkqqHx_iEjPiEjPiEkC_xHqqkZx_          _xZkqqHx_iEkBiEkIiEkC_xHqqkZx_      _xZkqqHx_iEkBiEkIiEkC_xHqqkZx_          _xZkqqHx_iEkBiEkIiEkC_xHqqkZx_          _xZkqqHx_iEkBiEjPiEjP_xHqqkZx_  
 *            _xZkqqHx_iBfP_xHqqkZx_A3_xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_Cv_xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_Cv_xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_Cv_xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_A2_xZkqqHx_iBfO_xHqqkZx_  
 *              _xZkqqHx_iBfPiEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkAiBfO_xHqqkZx_    
 *                            _xZkqqHx_iEkEiEjPiEkD_xHqqkZx_      _xZkqqHx_iEkEiEjPiEkD_xHqqkZx_          _xZkqqHx_iEkEiEjPiEkD_xHqqkZx_                  
 *
 *           An:_xZkqqHx_jBfDiMhCjApMjBeJjBpAjHmMiIoGiBgJ_xHqqkZx_AREA_RULED_SEL_ALL_xZkqqHx_iBgK_xHqqkZx_
 *           Bn:_xZkqqHx_jBfDiDfKiDiLjBeJjBpAjHmMiIoGiBgJ_xHqqkZx_AREA_CELL_SEL_ALL_xZkqqHx_iBgK_xHqqkZx_
 *           Cv:_xZkqqHx_jAiCjClMiMhCjApMjBeJjBpAjHmMiIoGiBgJ_xHqqkZx_AREA_RULED_SEL_VERT_xZkqqHx_iBgK_xHqqkZx_
 *           Ch:_xZkqqHx_jAiFjFlNiMhCjApMjBeJjBpAjHmMiIoGiBgJ_xHqqkZx_AREA_RULED_SEL_HORZ_xZkqqHx_iBgK_xHqqkZx_
 *           Dv:_xZkqqHx_jAiCjClMiMhCjApMiInKjDkOjHmMiIoGiBgJ_xHqqkZx_AREA_RULED_MOVE_VERT_xZkqqHx_iBgK_xHqqkZx_
 *           Dh:_xZkqqHx_jAiFjFlNiMhCjApMiInKjDkOjHmMiIoGiBgJ_xHqqkZx_AREA_RULED_MOVE_HORZ_xZkqqHx_iBgK_xHqqkZx_
 *           Ev:_xZkqqHx_jAiCjClMiDfKiDiLjBeJjBpAjHmMiIoGiBgJ_xHqqkZx_AREA_CELL_SEL_LINE_xZkqqHx_iBgK_xHqqkZx_
 *           Eh:_xZkqqHx_jAiFjFlNiDfKiDiLjBeJjBpAjHmMiIoGiBgJ_xHqqkZx_AREA_CELL_SEL_COLUMN_xZkqqHx_iBgK_xHqqkZx_
 *           Fv:_xZkqqHx_jCfAjDmGjAiCjClMiMhCjApMjBeJjBpAjHmMiIoGiBgJ_xHqqkZx_AREA_RULED_SEL_MATRIX_VERT_xZkqqHx_iBgK_xHqqkZx_
 *           Fh:_xZkqqHx_jCfAjDmGjAiFjFlNiMhCjApMjBeJjBpAjHmMiIoGiBgJ_xHqqkZx_AREA_RULED_SEL_MATRIX_HORZ_xZkqqHx_iBgK_xHqqkZx_
 *           G :_xZkqqHx_jCfAjDmGiDfKiDiLjBeJjBpAjHmMiIoGiBgJ_xHqqkZx_AREA_CELL_SEL_MATRIX_xZkqqHx_iBgK_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.06.04 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
FCToolTableEdit::Area FCToolTableEdit::CheckHitRuled ()
{
	m_pHitObj = NULL;			// _xZkqqHx_iDhBiDgCiDgHiClFiClNjFfMjFjEjFgJiBeC_xHqqkZx_
	m_areaHit = AREA_NONE;		// _xZkqqHx_iDhBiDgCiDgHiClFiClNiDeHiDiKiDeBiBeC_xHqqkZx_
	m_lHitFrontRuledIndex = -1;	// _xZkqqHx_iDhBiDgCiDgHiClFiClNiMhCjApMiCmMiOlCjFpLiMpMiDeDiDjDiDgGiDgCiDeOiDfIiBeC_xHqqkZx_
	m_lHitSideRuledIndex = -1;	// _xZkqqHx_iDhBiDgCiDgHiClFiClNiMhCjApMiCmMiOlCjAiCjApMjFpLiMpMiDeDiDjDiDgGiDgCiDeOiDfIiBeC_xHqqkZx_

	// _xZkqqHx_iMlLiNnNiCmMiDhNiDeFiDfIiNmAjFfHiCmJiDhBiDgCiDgHiClHiCoJjFnCiPfHiDgOiDjDiDgIiDiLiCpAjClCiCnHiCoJiBeC_xHqqkZx_
	set<FCHandleId> stIds;
	CheckHitHandle(stIds, m_mmptMsc);

	ObjDynabaseVector::const_reverse_iterator rObj;
	for (rObj = g_pView->SelectObjVector().rbegin();
		 rObj != g_pView->SelectObjVector().rend(); rObj++)
	{
		// An:_xZkqqHx_jBfDiMhCjApMjBeJjBpAjHmMiIoGiBgJ_xHqqkZx_AREA_RULED_SEL_ALL_xZkqqHx_iBgKiCmMiDhBiDgCiDgHiCpAjClCiCnHiCoJiBeC_xHqqkZx_
		set<FCHandleId>::const_iterator iHid;
		iHid = stIds.find(FCHandleId((*rObj)->GetObjID(), AREA_RULED_SEL_ALL, -1, -1));
		if (iHid != stIds.end())
		{
			m_pHitObj = (FCObjTable*)*rObj;			// _xZkqqHx_iDhBiDgCiDgHiClFiClNjFfMjFjEjFgJiBeC_xHqqkZx_
			m_areaHit = Area((*iHid).second);		// _xZkqqHx_iDhBiDgCiDgHiClFiClNiDeHiDiKiDeBiBeC_xHqqkZx_
			m_lHitFrontRuledIndex = (*iHid).third;	// _xZkqqHx_iDhBiDgCiDgHiClFiClNiMhCjApMiCmMiOlCjFpLiMpMiDeDiDjDiDgGiDgCiDeOiDfIiBeC_xHqqkZx_
			m_lHitSideRuledIndex = (*iHid).fourth;	// _xZkqqHx_iDhBiDgCiDgHiClFiClNiMhCjApMiCmMiOlCjAiCjApMjFpLiMpMiDeDiDjDiDgGiDgCiDeOiDfIiBeC_xHqqkZx_
			break;
		}

		// Cv:_xZkqqHx_jAiCjClMiMhCjApMjBeJjBpAjHmMiIoGiBgJ_xHqqkZx_AREA_RULED_SEL_VERT_xZkqqHx_iBgKiCmMiDhBiDgCiDgHiCpAjClCiCnHiCoJiBeC_xHqqkZx_
		iHid = stIds.lower_bound(FCHandleId((*rObj)->GetObjID(), AREA_RULED_SEL_VERT, -1, -1));
		if ((*iHid).first == (*rObj)->GetObjID() &&
			(*iHid).second == AREA_RULED_SEL_VERT)
		{
			m_pHitObj = (FCObjTable*)*rObj;			// _xZkqqHx_iDhBiDgCiDgHiClFiClNjFfMjFjEjFgJiBeC_xHqqkZx_
			m_areaHit = Area((*iHid).second);		// _xZkqqHx_iDhBiDgCiDgHiClFiClNiDeHiDiKiDeBiBeC_xHqqkZx_
			m_lHitFrontRuledIndex = (*iHid).third;	// _xZkqqHx_iDhBiDgCiDgHiClFiClNiMhCjApMiCmMiOlCjFpLiMpMiDeDiDjDiDgGiDgCiDeOiDfIiBeC_xHqqkZx_
			m_lHitSideRuledIndex = (*iHid).fourth;	// _xZkqqHx_iDhBiDgCiDgHiClFiClNiMhCjApMiCmMiOlCjAiCjApMjFpLiMpMiDeDiDjDiDgGiDgCiDeOiDfIiBeC_xHqqkZx_
			break;
		}

		// Ch:_xZkqqHx_jAiFjFlNiMhCjApMjBeJjBpAjHmMiIoGiBgJ_xHqqkZx_AREA_RULED_SEL_HORZ_xZkqqHx_iBgKiCmMiDhBiDgCiDgHiCpAjClCiCnHiCoJiBeC_xHqqkZx_
		iHid = stIds.lower_bound(FCHandleId((*rObj)->GetObjID(), AREA_RULED_SEL_HORZ, -1, -1));
		if ((*iHid).first == (*rObj)->GetObjID() &&
			(*iHid).second == AREA_RULED_SEL_HORZ)
		{
			m_pHitObj = (FCObjTable*)*rObj;			// _xZkqqHx_iDhBiDgCiDgHiClFiClNjFfMjFjEjFgJiBeC_xHqqkZx_
			m_areaHit = Area((*iHid).second);		// _xZkqqHx_iDhBiDgCiDgHiClFiClNiDeHiDiKiDeBiBeC_xHqqkZx_
			m_lHitFrontRuledIndex = (*iHid).third;	// _xZkqqHx_iDhBiDgCiDgHiClFiClNiMhCjApMiCmMiOlCjFpLiMpMiDeDiDjDiDgGiDgCiDeOiDfIiBeC_xHqqkZx_
			m_lHitSideRuledIndex = (*iHid).fourth;	// _xZkqqHx_iDhBiDgCiDgHiClFiClNiMhCjApMiCmMiOlCjAiCjApMjFpLiMpMiDeDiDjDiDgGiDgCiDeOiDfIiBeC_xHqqkZx_
			break;
		}

		// Dv:_xZkqqHx_jAiCjClMiMhCjApMiInKjDkOjHmMiIoGiBgJ_xHqqkZx_AREA_RULED_MOVE_VERT_xZkqqHx_iBgKiCmMiDhBiDgCiDgHiCpAjClCiCnHiCoJiBeC_xHqqkZx_
		iHid = stIds.lower_bound(FCHandleId((*rObj)->GetObjID(), AREA_RULED_MOVE_VERT, -1, -1));
		if ((*iHid).first == (*rObj)->GetObjID() &&
			(*iHid).second == AREA_RULED_MOVE_VERT)
		{
			m_pHitObj = (FCObjTable*)*rObj;			// _xZkqqHx_iDhBiDgCiDgHiClFiClNjFfMjFjEjFgJiBeC_xHqqkZx_
			m_areaHit = Area((*iHid).second);		// _xZkqqHx_iDhBiDgCiDgHiClFiClNiDeHiDiKiDeBiBeC_xHqqkZx_
			m_lHitFrontRuledIndex = (*iHid).third;	// _xZkqqHx_iDhBiDgCiDgHiClFiClNiMhCjApMiCmMiOlCjFpLiMpMiDeDiDjDiDgGiDgCiDeOiDfIiBeC_xHqqkZx_
			m_lHitSideRuledIndex = (*iHid).fourth;	// _xZkqqHx_iDhBiDgCiDgHiClFiClNiMhCjApMiCmMiOlCjAiCjApMjFpLiMpMiDeDiDjDiDgGiDgCiDeOiDfIiBeC_xHqqkZx_
			break;
		}

		// Dh:_xZkqqHx_jAiFjFlNiMhCjApMiInKjDkOjHmMiIoGiBgJ_xHqqkZx_AREA_RULED_MOVE_HORZ_xZkqqHx_iBgKiCmMiDhBiDgCiDgHiCpAjClCiCnHiCoJiBeC_xHqqkZx_
		iHid = stIds.lower_bound(FCHandleId((*rObj)->GetObjID(), AREA_RULED_MOVE_HORZ, -1, -1));
		if ((*iHid).first == (*rObj)->GetObjID() &&
			(*iHid).second == AREA_RULED_MOVE_HORZ)
		{
			m_pHitObj = (FCObjTable*)*rObj;			// _xZkqqHx_iDhBiDgCiDgHiClFiClNjFfMjFjEjFgJiBeC_xHqqkZx_
			m_areaHit = Area((*iHid).second);		// _xZkqqHx_iDhBiDgCiDgHiClFiClNiDeHiDiKiDeBiBeC_xHqqkZx_
			m_lHitFrontRuledIndex = (*iHid).third;	// _xZkqqHx_iDhBiDgCiDgHiClFiClNiMhCjApMiCmMiOlCjFpLiMpMiDeDiDjDiDgGiDgCiDeOiDfIiBeC_xHqqkZx_
			m_lHitSideRuledIndex = (*iHid).fourth;	// _xZkqqHx_iDhBiDgCiDgHiClFiClNiMhCjApMiCmMiOlCjAiCjApMjFpLiMpMiDeDiDjDiDgGiDgCiDeOiDfIiBeC_xHqqkZx_
			break;
		}

		// Fv:_xZkqqHx_jCfAjDmGjAiCjClMiMhCjApMjBeJjBpAjHmMiIoGiBgJ_xHqqkZx_AREA_RULED_SEL_MATRIX_VERT_xZkqqHx_iBgKiCmMiDhBiDgCiDgHiCpAjClCiCnHiCoJiBeC_xHqqkZx_
		iHid = stIds.lower_bound(FCHandleId((*rObj)->GetObjID(), AREA_RULED_SEL_MATRIX_VERT, -1, -1));
		if ((*iHid).first == (*rObj)->GetObjID() &&
			(*iHid).second == AREA_RULED_SEL_MATRIX_VERT)
		{
			m_pHitObj = (FCObjTable*)*rObj;			// _xZkqqHx_iDhBiDgCiDgHiClFiClNjFfMjFjEjFgJiBeC_xHqqkZx_
			m_areaHit = Area((*iHid).second);		// _xZkqqHx_iDhBiDgCiDgHiClFiClNiDeHiDiKiDeBiBeC_xHqqkZx_
			m_lHitFrontRuledIndex = (*iHid).third;	// _xZkqqHx_iDhBiDgCiDgHiClFiClNiMhCjApMiCmMiOlCjFpLiMpMiDeDiDjDiDgGiDgCiDeOiDfIiBeC_xHqqkZx_
			m_lHitSideRuledIndex = (*iHid).fourth;	// _xZkqqHx_iDhBiDgCiDgHiClFiClNiMhCjApMiCmMiOlCjAiCjApMjFpLiMpMiDeDiDjDiDgGiDgCiDeOiDfIiBeC_xHqqkZx_
			break;
		}

		// Fh:_xZkqqHx_jCfAjDmGjAiFjFlNiMhCjApMjBeJjBpAjHmMiIoGiBgJ_xHqqkZx_AREA_RULED_SEL_MATRIX_HORZ_xZkqqHx_iBgKiCmMiDhBiDgCiDgHiCpAjClCiCnHiCoJiBeC_xHqqkZx_
		iHid = stIds.lower_bound(FCHandleId((*rObj)->GetObjID(), AREA_RULED_SEL_MATRIX_HORZ, -1, -1));
		if ((*iHid).first == (*rObj)->GetObjID() &&
			(*iHid).second == AREA_RULED_SEL_MATRIX_HORZ)
		{
			m_pHitObj = (FCObjTable*)*rObj;			// _xZkqqHx_iDhBiDgCiDgHiClFiClNjFfMjFjEjFgJiBeC_xHqqkZx_
			m_areaHit = Area((*iHid).second);		// _xZkqqHx_iDhBiDgCiDgHiClFiClNiDeHiDiKiDeBiBeC_xHqqkZx_
			m_lHitFrontRuledIndex = (*iHid).third;	// _xZkqqHx_iDhBiDgCiDgHiClFiClNiMhCjApMiCmMiOlCjFpLiMpMiDeDiDjDiDgGiDgCiDeOiDfIiBeC_xHqqkZx_
			m_lHitSideRuledIndex = (*iHid).fourth;	// _xZkqqHx_iDhBiDgCiDgHiClFiClNiMhCjApMiCmMiOlCjAiCjApMjFpLiMpMiDeDiDjDiDgGiDgCiDeOiDfIiBeC_xHqqkZx_
			break;
		}
	}
	// _xZkqqHx_iDhBiDgCiDgHiPpDjBnEiCpAjFnEiClHiBeC_xHqqkZx_
	return m_areaHit;
} // FCToolTableEdit::CheckHitRuled.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::CheckHitCell
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDhNiDeFiDfIiImKjChFiCkKiDfKiDiLjFnCiPfHjApMiCmJiDhBiDgCiDgHiClFiCmEiCkCiCoJiCkJiCmHiCkEiCkJiCpAjClCiCnHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jFnEjCgM_xHqqkZx_>	_xZkqqHx_iDhBiDgCiDgHiPpDjBnEiCpAjFnEiClHiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iJpAjAoA_xHqqkZx_>	_xZkqqHx_jFnCiPfHjApMiCpAiImIiJlKiCmJiOkGiClHiBeC_xHqqkZx_
 *
 *                            _xZkqqHx_iEkBiEjPiEkC_xHqqkZx_      _xZkqqHx_iEkBiEjPiEkC_xHqqkZx_          _xZkqqHx_iEkBiEjPiEkC_xHqqkZx_                  
 *              _xZkqqHx_iBfOiEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_Cv_xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_Cv_xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_Cv_xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkAiBfP_xHqqkZx_    
 *            _xZkqqHx_iBfO_xHqqkZx_A0_xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_A1_xZkqqHx_iBfP_xHqqkZx_  
 *            _xZkqqHx_iEjPiEjPiEkD_xHqqkZx_          _xZkqqHx_iEkEiEkGiEkD_xHqqkZx_      _xZkqqHx_iEkEiEkGiEkD_xHqqkZx_          _xZkqqHx_iEkEiEkGiEkD_xHqqkZx_          _xZkqqHx_iEkEiEjPiEjP_xHqqkZx_  
 *                  _xZkqqHx_iEkBiEjPiEjPiEjPiEkC_xHqqkZx_  _xZkqqHx_iEkFiEjPiEjPiEjPiEjPiEjPiEkJiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEkH_xHqqkZx_  _xZkqqHx_iEkBiEjPiEjPiEjPiEkC_xHqqkZx_        
 *                  _xZkqqHx_iEkA_xHqqkZx_  B0  _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_     Ev   Dv      Ev      Dv  _xZkqqHx_iEkA_xHqqkZx_  B1  _xZkqqHx_iEkA_xHqqkZx_        
 *                  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_              _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_        
 *                  _xZkqqHx_iEkEiEjPiEjPiEjPiEkD_xHqqkZx_  _xZkqqHx_iEkEiEjPiEjPiEjPiEjPiEjPiEkIiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEkD_xHqqkZx_  _xZkqqHx_iEkEiEjPiEjPiEjPiEkD_xHqqkZx_        
 *          _xZkqqHx_iEkBiEjPiEjPiEkC_xHqqkZx_                                                      _xZkqqHx_iEkBiEjPiEjPiEkC_xHqqkZx_
 *          _xZkqqHx_iEkA_xHqqkZx_ Ch _xZkqqHx_iEkFiEkGiEjPiEjPiEjPiEkC_xHqqkZx_  _xZkqqHx_iEkBiEjPiEjP_xHqqkZx_Fh_xZkqqHx_iEjPiEjPiEkGiEjPiEjPiEjP_xHqqkZx_Fh_xZkqqHx_iEjPiEjPiEjPiEkC_xHqqkZx_  _xZkqqHx_iEkBiEjPiEjPiEjPiEkGiEkH_xHqqkZx_ Ch _xZkqqHx_iEkA_xHqqkZx_
 *          _xZkqqHx_iEkEiEjPiEjPiEkDiEkA_xHqqkZx_  Eh  _xZkqqHx_iEkA_xHqqkZx_  Fv    G     Fv      G       Fv  _xZkqqHx_iEkA_xHqqkZx_  Eh  _xZkqqHx_iEkAiEkEiEjPiEjPiEkD_xHqqkZx_
 *          _xZkqqHx_iEkBiEjPiEjPiEkCiEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_              _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkAiEkBiEjPiEjPiEkC_xHqqkZx_
 *          _xZkqqHx_iEkA_xHqqkZx_ Ch _xZkqqHx_iEkFiEkJiEjP_xHqqkZx_Dh_xZkqqHx_iEjPiEkH_xHqqkZx_  _xZkqqHx_iEkFiEjPiEjP_xHqqkZx_Fh_xZkqqHx_iEjPiEjPiEkJiEjPiEjPiEjP_xHqqkZx_Fh_xZkqqHx_iEjPiEjPiEjPiEkH_xHqqkZx_  _xZkqqHx_iEkFiEjP_xHqqkZx_Dh_xZkqqHx_iEjPiEkJiEkH_xHqqkZx_ Ch _xZkqqHx_iEkA_xHqqkZx_
 *          _xZkqqHx_iEkEiEjPiEjPiEkDiEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_              _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkAiEkEiEjPiEjPiEkD_xHqqkZx_
 *                  _xZkqqHx_iEkA_xHqqkZx_  Eh  _xZkqqHx_iEkA_xHqqkZx_  Fv    G     Fv      G       Fv  _xZkqqHx_iEkA_xHqqkZx_  Eh  _xZkqqHx_iEkA_xHqqkZx_        
 *          _xZkqqHx_iEkBiEjPiEjPiEkCiEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_              _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkAiEkBiEjPiEjPiEkC_xHqqkZx_
 *          _xZkqqHx_iEkA_xHqqkZx_ Ch _xZkqqHx_iEkFiEkJiEjP_xHqqkZx_Dh_xZkqqHx_iEjPiEkH_xHqqkZx_  _xZkqqHx_iEkFiEjPiEjP_xHqqkZx_Fh_xZkqqHx_iEjPiEjPiEkJiEjPiEjPiEjP_xHqqkZx_Fh_xZkqqHx_iEjPiEjPiEjPiEkH_xHqqkZx_  _xZkqqHx_iEkFiEjP_xHqqkZx_Dh_xZkqqHx_iEjPiEkJiEkH_xHqqkZx_ Ch _xZkqqHx_iEkA_xHqqkZx_
 *          _xZkqqHx_iEkEiEjPiEjPiEkDiEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_              _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkAiEkEiEjPiEjPiEkD_xHqqkZx_
 *                  _xZkqqHx_iEkA_xHqqkZx_  Eh  _xZkqqHx_iEkA_xHqqkZx_  Fv    G     Fv      G       Fv  _xZkqqHx_iEkA_xHqqkZx_  Eh  _xZkqqHx_iEkA_xHqqkZx_        
 *                  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_              _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_        
 *          _xZkqqHx_iEkBiEjPiEjPiEkCiEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_              _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkAiEkBiEjPiEjPiEkC_xHqqkZx_
 *          _xZkqqHx_iEkA_xHqqkZx_ Ch _xZkqqHx_iEkFiEkIiEjP_xHqqkZx_Dh_xZkqqHx_iEjPiEkD_xHqqkZx_  _xZkqqHx_iEkEiEjPiEjP_xHqqkZx_Fh_xZkqqHx_iEjPiEjPiEkIiEjPiEjPiEjP_xHqqkZx_Fh_xZkqqHx_iEjPiEjPiEjPiEkD_xHqqkZx_  _xZkqqHx_iEkEiEjP_xHqqkZx_Dh_xZkqqHx_iEjPiEkIiEkH_xHqqkZx_ Ch _xZkqqHx_iEkA_xHqqkZx_
 *          _xZkqqHx_iEkEiEjPiEjPiEkD_xHqqkZx_                                                      _xZkqqHx_iEkEiEjPiEjPiEkD_xHqqkZx_
 *                  _xZkqqHx_iEkBiEjPiEjPiEjPiEkC_xHqqkZx_  _xZkqqHx_iEkBiEjPiEjPiEjPiEjPiEjPiEkGiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEkC_xHqqkZx_  _xZkqqHx_iEkBiEjPiEjPiEjPiEkC_xHqqkZx_        
 *                  _xZkqqHx_iEkA_xHqqkZx_  B3  _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_     Ev   Dv      Ev      Dv  _xZkqqHx_iEkA_xHqqkZx_  B2  _xZkqqHx_iEkA_xHqqkZx_        
 *                  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_              _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_        
 *                  _xZkqqHx_iEkEiEjPiEjPiEjPiEkD_xHqqkZx_  _xZkqqHx_iEkFiEjPiEjPiEjPiEjPiEjPiEkJiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEkH_xHqqkZx_  _xZkqqHx_iEkEiEjPiEjPiEjPiEkD_xHqqkZx_        
 *            _xZkqqHx_iEjPiEjPiEkC_xHqqkZx_          _xZkqqHx_iEkBiEkIiEkC_xHqqkZx_      _xZkqqHx_iEkBiEkIiEkC_xHqqkZx_          _xZkqqHx_iEkBiEkIiEkC_xHqqkZx_          _xZkqqHx_iEkBiEjPiEjP_xHqqkZx_  
 *            _xZkqqHx_iBfP_xHqqkZx_A3_xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_Cv_xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_Cv_xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_Cv_xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_A2_xZkqqHx_iBfO_xHqqkZx_  
 *              _xZkqqHx_iBfPiEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_          _xZkqqHx_iEkAiBfO_xHqqkZx_    
 *                            _xZkqqHx_iEkEiEjPiEkD_xHqqkZx_      _xZkqqHx_iEkEiEjPiEkD_xHqqkZx_          _xZkqqHx_iEkEiEjPiEkD_xHqqkZx_                  
 *
 *           An:_xZkqqHx_jBfDiMhCjApMjBeJjBpAjHmMiIoGiBgJ_xHqqkZx_AREA_RULED_SEL_ALL_xZkqqHx_iBgK_xHqqkZx_
 *           Bn:_xZkqqHx_jBfDiDfKiDiLjBeJjBpAjHmMiIoGiBgJ_xHqqkZx_AREA_CELL_SEL_ALL_xZkqqHx_iBgK_xHqqkZx_
 *           Cv:_xZkqqHx_jAiCjClMiMhCjApMjBeJjBpAjHmMiIoGiBgJ_xHqqkZx_AREA_RULED_SEL_VERT_xZkqqHx_iBgK_xHqqkZx_
 *           Ch:_xZkqqHx_jAiFjFlNiMhCjApMjBeJjBpAjHmMiIoGiBgJ_xHqqkZx_AREA_RULED_SEL_HORZ_xZkqqHx_iBgK_xHqqkZx_
 *           Dv:_xZkqqHx_jAiCjClMiMhCjApMiInKjDkOjHmMiIoGiBgJ_xHqqkZx_AREA_RULED_MOVE_VERT_xZkqqHx_iBgK_xHqqkZx_
 *           Dh:_xZkqqHx_jAiFjFlNiMhCjApMiInKjDkOjHmMiIoGiBgJ_xHqqkZx_AREA_RULED_MOVE_HORZ_xZkqqHx_iBgK_xHqqkZx_
 *           Ev:_xZkqqHx_jAiCjClMiDfKiDiLjBeJjBpAjHmMiIoGiBgJ_xHqqkZx_AREA_CELL_SEL_LINE_xZkqqHx_iBgK_xHqqkZx_
 *           Eh:_xZkqqHx_jAiFjFlNiDfKiDiLjBeJjBpAjHmMiIoGiBgJ_xHqqkZx_AREA_CELL_SEL_COLUMN_xZkqqHx_iBgK_xHqqkZx_
 *           Fv:_xZkqqHx_jCfAjDmGjAiCjClMiMhCjApMjBeJjBpAjHmMiIoGiBgJ_xHqqkZx_AREA_RULED_SEL_MATRIX_VERT_xZkqqHx_iBgK_xHqqkZx_
 *           Fh:_xZkqqHx_jCfAjDmGjAiFjFlNiMhCjApMjBeJjBpAjHmMiIoGiBgJ_xHqqkZx_AREA_RULED_SEL_MATRIX_HORZ_xZkqqHx_iBgK_xHqqkZx_
 *           G :_xZkqqHx_jCfAjDmGiDfKiDiLjBeJjBpAjHmMiIoGiBgJ_xHqqkZx_AREA_CELL_SEL_MATRIX_xZkqqHx_iBgK_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.01.28 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
FCToolTableEdit::Area FCToolTableEdit::CheckHitCell ()
{
	m_pHitObj = NULL;			// _xZkqqHx_iDhBiDgCiDgHiClFiClNjFfMjFjEjFgJiBeC_xHqqkZx_
	m_areaHit = AREA_NONE;		// _xZkqqHx_iDhBiDgCiDgHiClFiClNiDeHiDiKiDeBiBeC_xHqqkZx_
	m_lHitLineCellIndex = -1;	// _xZkqqHx_iDhBiDgCiDgHiClFiClNiNhDiBeC_xHqqkZx_
	m_lHitColumnCellIndex = -1;	// _xZkqqHx_iDhBiDgCiDgHiClFiClNjHpBiBeC_xHqqkZx_

	// _xZkqqHx_iMlLiNnNiCmMiDhNiDeFiDfIiNmAjFfHiCmJiDhBiDgCiDgHiClHiCoJjFnCiPfHiDgOiDjDiDgIiDiLiCpAjClCiCnHiCoJiBeC_xHqqkZx_
	set<FCHandleId> stIds;
	CheckHitHandle(stIds, m_mmptMsc);

	ObjDynabaseVector::const_reverse_iterator rObj;
	for (rObj = g_pView->SelectObjVector().rbegin();
		 rObj != g_pView->SelectObjVector().rend();
		 rObj++)
	{
		// Bn:_xZkqqHx_jBfDiDfKiDiLjBeJjBpAjHmMiIoGiBgJ_xHqqkZx_AREA_CELL_SEL_ALL_xZkqqHx_iBgKiCmMiDhBiDgCiDgHiCpAjClCiCnHiCoJiBeC_xHqqkZx_
		set<FCHandleId>::const_iterator iHid;
		iHid = stIds.find(FCHandleId((*rObj)->GetObjID(), AREA_CELL_SEL_ALL, -1, -1));
		if (iHid != stIds.end())
		{
			m_pHitObj = (FCObjTable*)*rObj;			// _xZkqqHx_iDhBiDgCiDgHiClFiClNjFfMjFjEjFgJiBeC_xHqqkZx_
			m_areaHit = Area((*iHid).second);		// _xZkqqHx_iDhBiDgCiDgHiClFiClNiDeHiDiKiDeBiBeC_xHqqkZx_
			m_lHitLineCellIndex = (*iHid).third;	// _xZkqqHx_iDhBiDgCiDgHiClFiClNiMhCjApMiCmMiOlCjFpLiMpMiDeDiDjDiDgGiDgCiDeOiDfIiBeC_xHqqkZx_
			m_lHitColumnCellIndex = (*iHid).fourth;	// _xZkqqHx_iDhBiDgCiDgHiClFiClNiMhCjApMiCmMiOlCjAiCjApMjFpLiMpMiDeDiDjDiDgGiDgCiDeOiDfIiBeC_xHqqkZx_
			break;
		}

		// Ev:_xZkqqHx_jAiCjClMiDfKiDiLjBeJjBpAjHmMiIoGiBgJ_xHqqkZx_AREA_CELL_SEL_LINE_xZkqqHx_iBgKiCmMiDhBiDgCiDgHiCpAjClCiCnHiCoJiBeC_xHqqkZx_
		iHid = stIds.lower_bound(FCHandleId((*rObj)->GetObjID(), AREA_CELL_SEL_LINE, -1, -1));
		if ((*iHid).first == (*rObj)->GetObjID() &&
			(*iHid).second == AREA_CELL_SEL_LINE)
		{
			m_pHitObj = (FCObjTable*)*rObj;			// _xZkqqHx_iDhBiDgCiDgHiClFiClNjFfMjFjEjFgJiBeC_xHqqkZx_
			m_areaHit = Area((*iHid).second);		// _xZkqqHx_iDhBiDgCiDgHiClFiClNiDeHiDiKiDeBiBeC_xHqqkZx_
			m_lHitLineCellIndex = (*iHid).third;	// _xZkqqHx_iDhBiDgCiDgHiClFiClNiMhCjApMiCmMiOlCjFpLiMpMiDeDiDjDiDgGiDgCiDeOiDfIiBeC_xHqqkZx_
			m_lHitColumnCellIndex = (*iHid).fourth;	// _xZkqqHx_iDhBiDgCiDgHiClFiClNiMhCjApMiCmMiOlCjAiCjApMjFpLiMpMiDeDiDjDiDgGiDgCiDeOiDfIiBeC_xHqqkZx_
			break;
		}

		// Eh:_xZkqqHx_jAiFjFlNiDfKiDiLjBeJjBpAjHmMiIoGiBgJ_xHqqkZx_AREA_CELL_SEL_COLUMN_xZkqqHx_iBgKiCmMiDhBiDgCiDgHiCpAjClCiCnHiCoJiBeC_xHqqkZx_
		iHid = stIds.lower_bound(FCHandleId((*rObj)->GetObjID(), AREA_CELL_SEL_COLUMN, -1, -1));
		if ((*iHid).first == (*rObj)->GetObjID() &&
			(*iHid).second == AREA_CELL_SEL_COLUMN)
		{
			m_pHitObj = (FCObjTable*)*rObj;			// _xZkqqHx_iDhBiDgCiDgHiClFiClNjFfMjFjEjFgJiBeC_xHqqkZx_
			m_areaHit = Area((*iHid).second);		// _xZkqqHx_iDhBiDgCiDgHiClFiClNiDeHiDiKiDeBiBeC_xHqqkZx_
			m_lHitLineCellIndex = (*iHid).third;	// _xZkqqHx_iDhBiDgCiDgHiClFiClNiMhCjApMiCmMiOlCjFpLiMpMiDeDiDjDiDgGiDgCiDeOiDfIiBeC_xHqqkZx_
			m_lHitColumnCellIndex = (*iHid).fourth;	// _xZkqqHx_iDhBiDgCiDgHiClFiClNiMhCjApMiCmMiOlCjAiCjApMjFpLiMpMiDeDiDjDiDgGiDgCiDeOiDfIiBeC_xHqqkZx_
			break;
		}

		// G :_xZkqqHx_jCfAjDmGiDfKiDiLjBeJjBpAjHmMiIoGiBgJ_xHqqkZx_AREA_CELL_SEL_MATRIX_xZkqqHx_iBgKiCmMiDhBiDgCiDgHiCpAjClCiCnHiCoJiBeC_xHqqkZx_
		iHid = stIds.lower_bound(FCHandleId((*rObj)->GetObjID(), AREA_CELL_SEL_MATRIX, -1, -1));
		if ((*iHid).first == (*rObj)->GetObjID() &&
			(*iHid).second == AREA_CELL_SEL_MATRIX)
		{
			m_pHitObj = (FCObjTable*)*rObj;			// _xZkqqHx_iDhBiDgCiDgHiClFiClNjFfMjFjEjFgJiBeC_xHqqkZx_
			m_areaHit = Area((*iHid).second);		// _xZkqqHx_iDhBiDgCiDgHiClFiClNiDeHiDiKiDeBiBeC_xHqqkZx_
			m_lHitLineCellIndex = (*iHid).third;	// _xZkqqHx_iDhBiDgCiDgHiClFiClNiMhCjApMiCmMiOlCjFpLiMpMiDeDiDjDiDgGiDgCiDeOiDfIiBeC_xHqqkZx_
			m_lHitColumnCellIndex = (*iHid).fourth;	// _xZkqqHx_iDhBiDgCiDgHiClFiClNiMhCjApMiCmMiOlCjAiCjApMjFpLiMpMiDeDiDjDiDgGiDgCiDeOiDfIiBeC_xHqqkZx_
			break;
		}
	}
	// _xZkqqHx_iDhBiDgCiDgHiPpDjBnEiCpAjFnEiClHiBeC_xHqqkZx_
	return m_areaHit;
} // FCToolTableEdit::CheckHitCell.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::IsHitOnSelectedCell
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDhBiDgCiDgHiClFiClNiDfKiDiLiCkKjBeJjBpAjCiGiCmMiDfKiDiLiCmFiCkAiCoJiCkJiCmHiCkEiCkJiCpAjClCiCnHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jFnEjCgM_xHqqkZx_>	_xZkqqHx_jBeJjBpAjCiGiCmMiDfKiDiLiCmFiCkAiCoJiPoKiNiHiCmN_xHqqkZx_TRUE_xZkqqHx_iCpAjFnEiClHiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.01.28 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
BOOL FCToolTableEdit::IsHitOnSelectedCell () const
{
	// _xZkqqHx_iDhBiDgCiDgHjFjEjFgJiCmGjBeJjBpAjFjEjFgJiCkKiInJiCmIiCoJiPoKiNiHiCmN_xHqqkZx_FALSE_xZkqqHx_iBeC_xHqqkZx_
	if (m_pHitObj != m_pSelectedObjTable) return FALSE;
	switch (m_areaHit)
	{
	case AREA_CELL_SEL_LINE:	// _xZkqqHx_iDfKiDiLiNhDiDeHiDiKiDeBiBeC_xHqqkZx_
	  {
//----- 05.02.17 Fukushiro M. _xZkqqHx_jFmPiNfIjBeP_xHqqkZx_ ()-----
//		set<FCLineColumn>::const_iterator iLc;
//		// _xZkqqHx_iOhHjCoIiClDiCoKiClNiNhDiCpAiOjNiCmCjBeJjBpAjCiGiCmMiDfKiDiLiCpAiMjPiNpFiBeC_xHqqkZx_
//		iLc = m_stSelectedCell.lower_bound(FCLineColumn(m_lHitLineCellIndex, 0));
//		// _xZkqqHx_jDkPiClGiNhDiCpAiCoAiCmCiDfKiDiLiCkKiMkJiCmCiCkJiCmBiClNiPoKiNiHiCmN_xHqqkZx_TRUE_xZkqqHx_iBeC_xHqqkZx_
//		if (iLc != m_stSelectedCell.end() &&
//			(*iLc).GetLineIndex() == m_lHitLineCellIndex) return TRUE;
//----- 05.02.17 Fukushiro M. _xZkqqHx_jFmPiNfIiMoD_xHqqkZx_ ()-----
		// _xZkqqHx_iOhHjCoIiClDiCoKiClNiNhDiCmJiOpLiCnMiCoJiDfKiDiLiCmMiCnNiPfHiCnPiCoJiBeC_xHqqkZx_
		set<FCLineColumn> stCellIndex;
		m_pSelectedObjTable->GetIncludedCell(stCellIndex,
											 FCLineColumn(m_lHitLineCellIndex, 0),
											 FCLineColumn(m_lHitLineCellIndex, m_pSelectedObjTable->GetColumnCount() - 1));
		// _xZkqqHx_iOhHjCoIiClDiCoKiClNiNhDiCmMiDfGiDjDiDePiDiLiDfKiDiLiCmGiBeBjBeJjBpAiClDiCoKiCmEiCkCiCoJiDfKiDiLiCmJiLkEjCmKiCmMiDfKiDiLiCpAiLiBiCnPiCoJiBeC_xHqqkZx_
		set<FCLineColumn> stIntersectCell;
		FFIntersection(stIntersectCell, set<FCLineColumn>(stCellIndex), set<FCLineColumn>(m_stSelectedCell));
		// _xZkqqHx_jDkPiClGiNhDiCpAiCoAiCmCiDfKiDiLiCkKiMkJiCmCiCkJiCmBiClNiPoKiNiHiCmN_xHqqkZx_TRUE_xZkqqHx_iBeC_xHqqkZx_
		if (!stIntersectCell.empty()) return TRUE;
//----- 05.02.17 Fukushiro M. _xZkqqHx_jFmPiNfIiPeJ_xHqqkZx_ ()-----
		break;
	  }
	case AREA_CELL_SEL_COLUMN:	// _xZkqqHx_iDfKiDiLjHpBiDeHiDiKiDeBiBeC_xHqqkZx_
	  {
		// _xZkqqHx_iOhHjCoIiClDiCoKiClNjHpBiCmJiOpLiCnMiCoJiDfKiDiLiCmMiCnNiPfHiCnPiCoJiBeC_xHqqkZx_
		set<FCLineColumn> stCellIndex;
		m_pSelectedObjTable->GetIncludedCell(stCellIndex,
											 FCLineColumn(0, m_lHitColumnCellIndex),
											 FCLineColumn(m_pSelectedObjTable->GetLineCount() - 1, m_lHitColumnCellIndex));
		// _xZkqqHx_iOhHjCoIiClDiCoKiClNiNhDiCmMiDfGiDjDiDePiDiLiDfKiDiLiCmGiBeBjBeJjBpAiClDiCoKiCmEiCkCiCoJiDfKiDiLiCmJiLkEjCmKiCmMiDfKiDiLiCpAiLiBiCnPiCoJiBeC_xHqqkZx_
		set<FCLineColumn> stIntersectCell;
		FFIntersection(stIntersectCell, set<FCLineColumn>(stCellIndex), set<FCLineColumn>(m_stSelectedCell));
		// _xZkqqHx_jDkPiClGiNhDiCpAiCoAiCmCiDfKiDiLiCkKiMkJiCmCiCkJiCmBiClNiPoKiNiHiCmN_xHqqkZx_TRUE_xZkqqHx_iBeC_xHqqkZx_
		if (!stIntersectCell.empty()) return TRUE;
		break;
	  }
	case AREA_CELL_SEL_ALL:		// _xZkqqHx_jBfDiDfKiDiLiDeHiDiKiDeBiBeC_xHqqkZx_
		// _xZkqqHx_iIoKiCmCiCmFiCoAjBeJjBpAjCiGiCmMiDfKiDiLiCkKiCkAiCoKiCmO_xHqqkZx_TRUE_xZkqqHx_iBeC_xHqqkZx_
		if (!m_stSelectedCell.empty()) return TRUE;
		break;
	case AREA_CELL_SEL_MATRIX:	// _xZkqqHx_iDfKiDiLiDhNiDgHiDiKiDgCiDeOiDfIiDeHiDiKiDeBiBeC_xHqqkZx_
		if (m_stSelectedCell.find(FCLineColumn(m_lHitLineCellIndex, m_lHitColumnCellIndex)) != m_stSelectedCell.end())
			return TRUE;
		break;
	case AREA_RULED_SEL_HORZ:	// _xZkqqHx_jAiFjFlNiMhCjApMjBeJjBpAiDeHiDiKiDeBiBeC_xHqqkZx_
	  {
		set<FCFrontSide>::const_iterator iFs;
		// _xZkqqHx_iOhHjCoIiClDiCoKiClNiOlCiCpAiOjNiCmCjBeJjBpAjCiGiCmMiMhCjApMiCpAiMjPiNpFiBeC_xHqqkZx_
		iFs = m_stSelectedHorzRuled.lower_bound(FCFrontSide(m_lHitFrontRuledIndex, 0));
		// _xZkqqHx_jDkPiClGiOlCiCpAiCoAiCmCiMhCjApMiCkKiMkJiCmCiCkJiCmBiClNiPoKiNiHiCmN_xHqqkZx_TRUE_xZkqqHx_iBeC_xHqqkZx_
		if (iFs != m_stSelectedHorzRuled.end() &&
			(*iFs).GetFrontIndex() == m_lHitFrontRuledIndex) return TRUE;
		break;
	  }
	case AREA_RULED_SEL_VERT:	// _xZkqqHx_jAiCjClMiMhCjApMjBeJjBpAiDeHiDiKiDeBiBeC_xHqqkZx_
	  {
		set<FCFrontSide>::const_iterator iFs;
		// _xZkqqHx_iOhHjCoIiClDiCoKiClNiOlCiCpAiOjNiCmCjBeJjBpAjCiGiCmMiMhCjApMiCpAiMjPiNpFiBeC_xHqqkZx_
		iFs = m_stSelectedVertRuled.lower_bound(FCFrontSide(m_lHitFrontRuledIndex, 0));
		// _xZkqqHx_jDkPiClGiOlCiCpAiCoAiCmCiMhCjApMiCkKiMkJiCmCiCkJiCmBiClNiPoKiNiHiCmN_xHqqkZx_TRUE_xZkqqHx_iBeC_xHqqkZx_
		if (iFs != m_stSelectedVertRuled.end() &&
			(*iFs).GetFrontIndex() == m_lHitFrontRuledIndex) return TRUE;
		break;
	  }
	case AREA_RULED_SEL_ALL:	// _xZkqqHx_jBfDiMhCjApMiDeHiDiKiDeBiBeC_xHqqkZx_
		// _xZkqqHx_iIoKiCmCiCmFiCoAjBeJjBpAjCiGiCmMiMhCjApMiCkKiCkAiCoKiCmO_xHqqkZx_TRUE_xZkqqHx_iBeC_xHqqkZx_
		if (!m_stSelectedHorzRuled.empty()) return TRUE;
		if (!m_stSelectedVertRuled.empty()) return TRUE;
		break;

	case AREA_RULED_SEL_MATRIX_HORZ:	// _xZkqqHx_jAiFjFlNiMhCjApMjBeJjBpAiDhNiDgHiDiKiDgCiDeOiDfIiDeHiDiKiDeBiBeC_xHqqkZx_
		if (m_stSelectedHorzRuled.find(FCFrontSide(m_lHitFrontRuledIndex, m_lHitSideRuledIndex)) != m_stSelectedHorzRuled.end())
			return TRUE;
		break;
	case AREA_RULED_SEL_MATRIX_VERT:	// _xZkqqHx_jAiCjClMiMhCjApMjBeJjBpAiDhNiDgHiDiKiDgCiDeOiDfIiDeHiDiKiDeBiBeC_xHqqkZx_
		if (m_stSelectedVertRuled.find(FCFrontSide(m_lHitFrontRuledIndex, m_lHitSideRuledIndex)) != m_stSelectedVertRuled.end())
			return TRUE;
		break;
	}
	return FALSE;
} // FCToolTableEdit::IsHitOnSelectedCell.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::DrawMovingRuled
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iMhCjApMiCmMiInKjDkOjCiGiCmMiBeBiDhEiDiMiBfLiDiAjFgAiJoGiCpAiNhDiCkEiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	pDC	:_xZkqqHx_iDgGiDgPiDeDiDfIiDfCiDjDiDgFiDeMiDfIiDgHiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.01.28 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::DrawMovingRuled (CDC* pDC) const
{
	// _xZkqqHx_iPeDjAlDjApMjFgAiJoGjHhAiDeOiDiJiDfIiCpAiNoMjAkMiBeC_xHqqkZx_
	FCEditDraw eDraw(pDC, 0);
	DBLRect mmrtFrame = m_pHitObj->GetResizeFrame();
	CRect lgrtFrame = mm2lg(mmrtFrame);
	if (m_areaHit == AREA_RULED_MOVE_HORZ)
	//----- _xZkqqHx_jAiFjFlNiMhCjApMiCmMiInKjDkO_xHqqkZx_ -----
	{
		long lgPrevY = mm2lg(m_pHitObj->GetCellTopCoord(m_lHitFrontRuledIndex - 1));
		mmetol mmY = m_mmMovingRuledCoord;
		long lgY = mm2lg(mmY);
		// _xZkqqHx_iNlGjBkEiDfKiDiLjFnCiPfHjApMiCpAiLkNjClCjFgAiJoGiBeC_xHqqkZx_
		eDraw.RectFill(CRect(LG_B_LFT0(lgrtFrame) + 1,
							 lgPrevY + 1,
							 LG_B_LFT1(lgrtFrame),
							 lgY));
		// _xZkqqHx_iJeFjBkEiDfKiDiLjFnCiPfHjApMiCpAiLkNjClCjFgAiJoGiBeC_xHqqkZx_
		eDraw.RectFill(CRect(LG_B_RIT0(lgrtFrame) + 1,
							 lgPrevY + 1,
							 LG_B_RIT1(lgrtFrame),
							 lgY));
		// _xZkqqHx_iInKjDkOiClHiCoJiMhCjApMiCpAjFgAiJoGiBeC_xHqqkZx_
		eDraw.Line(	&CPoint(LG_B_LFT0(lgrtFrame), lgY),
					&CPoint(LG_B_RIT1(lgrtFrame), lgY));
		long lLineIndex;
		for (lLineIndex = m_lHitFrontRuledIndex; lLineIndex != m_pHitObj->GetLineCount(); lLineIndex++)
		{
			mmY += m_pHitObj->GetLineHeight(lLineIndex);
			lgY = mm2lg(mmY);
			// _xZkqqHx_iInKjDkOiClHiCoJiMhCjApMiCpAjFgAiJoGiBeC_xHqqkZx_
			eDraw.Line(	&CPoint(LG_B_LFT0(lgrtFrame), lgY),
						&CPoint(LG_B_RIT1(lgrtFrame), lgY));
		}
	} else
	//----- _xZkqqHx_jAiCjClMiMhCjApMiCmMiInKjDkO_xHqqkZx_ -----
	{
		long lgPrevX = mm2lg(m_pHitObj->GetCellLeftCoord(m_lHitFrontRuledIndex - 1));
		mmetol mmX = m_mmMovingRuledCoord;
		long lgX = mm2lg(mmX);
		// _xZkqqHx_iPoDjBkEiDfKiDiLjFnCiPfHjApMiCpAiLkNjClCjFgAiJoGiBeC_xHqqkZx_
		eDraw.RectFill(CRect(lgPrevX + 1,
							 LG_B_TOP0(lgrtFrame) + 1,
							 lgX,
							 LG_B_TOP1(lgrtFrame)));
		// _xZkqqHx_iJlKjBkEiDfKiDiLjFnCiPfHjApMiCpAiLkNjClCjFgAiJoGiBeC_xHqqkZx_
		eDraw.RectFill(CRect(lgPrevX + 1,
							 LG_B_BTM1(lgrtFrame) + 1,
							 lgX,
							 LG_B_BTM0(lgrtFrame)));
		// _xZkqqHx_iInKjDkOiClHiCoJiMhCjApMiCpAjFgAiJoGiBeC_xHqqkZx_
		eDraw.Line(	&CPoint(lgX, LG_B_TOP0(lgrtFrame)),
					&CPoint(lgX, LG_B_BTM0(lgrtFrame)));
		long lColumnIndex;
		for (lColumnIndex = m_lHitFrontRuledIndex; lColumnIndex != m_pHitObj->GetColumnCount(); lColumnIndex++)
		{
			mmX += m_pHitObj->GetColumnWidth(lColumnIndex);
			lgX = mm2lg(mmX);
			// _xZkqqHx_iInKjDkOiClHiCoJiMhCjApMiCpAjFgAiJoGiBeC_xHqqkZx_
			eDraw.Line(	&CPoint(lgX, LG_B_TOP0(lgrtFrame)),
						&CPoint(lgX, LG_B_BTM0(lgrtFrame)));
		}
	}
} // FCToolTableEdit::DrawMovingRuled.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::DrawSelectedCell
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iOhHjCoIiClDiCoKiClNjFfMjFjEjFgJiCmMiDfKiDiLiCmMjBeJjBpAiPpDjBnEiCpAjFgAiJoGiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	pDC			:_xZkqqHx_jFgAiJoGjHhAiDgGiDgPiDeDiDfIiDfCiDjDiDgFiDeMiDfIiDgHiCpAiOhHjCoIiBeC_xHqqkZx_
 *			pObjTable	:_xZkqqHx_jFfMjFjEjFgJiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.01.28 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::DrawSelectedCell (CDC* pDC, const FCObjTable* pObjTable) const
{
	// _xZkqqHx_jBeJjBpAiClDiCoKiClNjFfMjFjEjFgJiCmFiCmIiCkPiCoKiCmOjFgAiJoGiClFiCmIiCkCiBeC_xHqqkZx_
	if (pObjTable == NULL || pObjTable != m_pSelectedObjTable) return;

	// _xZkqqHx_iPeDjAlDjApMjFgAiJoGjHhAiDeOiDiJiDfIiCpAiNoMjAkMiBeC_xHqqkZx_
	FCEditDraw eDraw(pDC, 2, COLORREF(-1), PS_DASH);
	set<FCLineColumn> stSelectedCell = m_stSelectedCell;
	FFInsert(stSelectedCell, m_stSelectedCellTmp);

	set<FCLineColumn>::const_iterator iLc;
	for (iLc = stSelectedCell.begin(); iLc != stSelectedCell.end(); iLc++)
	{
		set<FCFrontSide> stLeftRuledIndex;
		set<FCFrontSide> stTopRuledIndex;
		set<FCFrontSide> stRightRuledIndex;
		set<FCFrontSide> stBottomRuledIndex;
		pObjTable->GetCellFrameRuled(	&stLeftRuledIndex,
										&stTopRuledIndex,
										&stRightRuledIndex,
										&stBottomRuledIndex,
										*iLc);
		fmmetol mmfLeftWeight = 0.0;
		fmmetol mmfTopWeight = 0.0;
		fmmetol mmfRightWeight = 0.0;
		fmmetol mmfBottomWeight = 0.0;
		set<FCFrontSide>::const_iterator iFs;
		for (iFs = stLeftRuledIndex.begin(); iFs != stLeftRuledIndex.end(); iFs++)
			if (mmfLeftWeight < pObjTable->GetRuled(FALSE, *iFs)->GetPenWeight())
				mmfLeftWeight = pObjTable->GetRuled(FALSE, *iFs)->GetPenWeight();
		for (iFs = stTopRuledIndex.begin(); iFs != stTopRuledIndex.end(); iFs++)
			if (mmfTopWeight < pObjTable->GetRuled(TRUE, *iFs)->GetPenWeight())
				mmfTopWeight = pObjTable->GetRuled(TRUE, *iFs)->GetPenWeight();
		for (iFs = stRightRuledIndex.begin(); iFs != stRightRuledIndex.end(); iFs++)
			if (mmfRightWeight < pObjTable->GetRuled(FALSE, *iFs)->GetPenWeight())
				mmfRightWeight = pObjTable->GetRuled(FALSE, *iFs)->GetPenWeight();
		for (iFs = stBottomRuledIndex.begin(); iFs != stBottomRuledIndex.end(); iFs++)
			if (mmfBottomWeight < pObjTable->GetRuled(TRUE, *iFs)->GetPenWeight())
				mmfBottomWeight = pObjTable->GetRuled(TRUE, *iFs)->GetPenWeight();
		const FCObjTextRect* pObjCell = pObjTable->GetCell(*iLc);
		DBLRect mmrtCell = pObjCell->GetResizeFrame();
		// _xZkqqHx_iDfKiDiLiCmJjIgHiCpAjFgAiJoGiBeC_xHqqkZx_
		CRect lgrt(	mm2lg(mmrtCell.left + mmfLeftWeight / 2.0) + 9,
					mm2lg(mmrtCell.top + mmfTopWeight / 2.0) + 9,
					mm2lg(mmrtCell.right - mmfRightWeight / 2.0) - 9,
					mm2lg(mmrtCell.bottom - mmfBottomWeight / 2.0) -9);
		eDraw.RectLine(lgrt);
		eDraw.Line(	&CPoint(lgrt.left, lgrt.top),
					&CPoint(lgrt.right, lgrt.bottom));
		eDraw.Line(	&CPoint(lgrt.right, lgrt.top),
					&CPoint(lgrt.left, lgrt.bottom));
	}

	set<FCFrontSide> stSelectedRuled;
	set<FCFrontSide>::const_iterator iFs;

	stSelectedRuled = m_stSelectedHorzRuled;
	FFInsert(stSelectedRuled, m_stSelectedHorzRuledTmp);
	for (iFs = stSelectedRuled.begin(); iFs != stSelectedRuled.end(); iFs++)
	{
		fmmetol mmfHalfWeight = pObjTable->GetRuled(TRUE, *iFs)->GetPenWeight() / 2.0;
		DBLRect mmRuled = pObjTable->GetRuled(TRUE, *iFs)->GetResizeFrame();
		CRect lgrt(	mm2lg(mmRuled.left + mmfHalfWeight) + 5,
					mm2lg(mmRuled.top - mmfHalfWeight) - 5,
					mm2lg(mmRuled.right - mmfHalfWeight) - 5,
					mm2lg(mmRuled.top + mmfHalfWeight) + 5);
		// _xZkqqHx_jApMiCpAjFgAiJoGiBeC_xHqqkZx_
		eDraw.RectLine(lgrt);
	}

	stSelectedRuled = m_stSelectedVertRuled;
	FFInsert(stSelectedRuled, m_stSelectedVertRuledTmp);
	for (iFs = stSelectedRuled.begin(); iFs != stSelectedRuled.end(); iFs++)
	{
		fmmetol mmfHalfWeight = pObjTable->GetRuled(FALSE, *iFs)->GetPenWeight() / 2.0;
		DBLRect mmRuled = pObjTable->GetRuled(FALSE, *iFs)->GetResizeFrame();
		CRect lgrt(	mm2lg(mmRuled.left - mmfHalfWeight) - 5,
					mm2lg(mmRuled.top + mmfHalfWeight) + 5,
					mm2lg(mmRuled.left + mmfHalfWeight) + 5,
					mm2lg(mmRuled.bottom - mmfHalfWeight) - 5);
		// _xZkqqHx_jApMiCpAjFgAiJoGiBeC_xHqqkZx_
		eDraw.RectLine(lgrt);
	}
} // FCToolTableEdit::DrawSelectedCell.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::ClearCellSelectionInfo
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDfKiDiLjBeJjBpAiCmJiKnGiClHiCoJjFmPjAjEiCpAiDeOiDiKiDeBiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.01.29 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::ClearCellSelectionInfo ()
{
	// _xZkqqHx_jBeJjBpAiClDiCoKiClNiDfKiDiLiBeC_xHqqkZx_
	ClearSelectCell();
	// _xZkqqHx_iNmFiMoDiCmJjBeJjBpAiClDiCoKiClNiDfKiDiLiBeC_xHqqkZx_
	m_lcLastSelectedCell.Set(-1, -1);

	// _xZkqqHx_jBeJjBpAiClDiCoKiClNjAiFjFlNiMhCjApMiBeC_xHqqkZx_
	ClearSelectRuled(TRUE);
	// _xZkqqHx_iNmFiMoDiCmJjBeJjBpAiClDiCoKiClNjAiFjFlNiMhCjApMiBeC_xHqqkZx_
	m_lcLastSelectedHorzRuled.Set(-1, -1);

	// _xZkqqHx_jBeJjBpAiClDiCoKiClNjAiCjClMiMhCjApMiBeC_xHqqkZx_
	ClearSelectRuled(FALSE);
	// _xZkqqHx_iNmFiMoDiCmJjBeJjBpAiClDiCoKiClNjAiCjClMiMhCjApMiBeC_xHqqkZx_
	m_lcLastSelectedVertRuled.Set(-1, -1);

	// _xZkqqHx_jBeJjBpAiClDiCoKiClNjFfMjFjEjFgJiBeC_xHqqkZx_ClearSelectXXX_xZkqqHx_iCmFiOgHiCoNiCoKiCoJiCmMiCmFiBeBiNmFiMoDiCmJ_xHqqkZx_NULL_xZkqqHx_jAnNjCoIiBeC_xHqqkZx_
	m_pSelectedObjTable = NULL;
} // FCToolTableEdit::ClearCellSelectionInfo.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::SetSelectedObjTable
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_jBeJjBpAjBmOiPnLiCmMjFfMjFjEjFgJiCpAjAnNjCoIiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	pObjTable	:_xZkqqHx_jFfMjFjEjFgJiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iJpAjAoA_xHqqkZx_>	_xZkqqHx_jDkPiClGjFjEjFgJiCkKjBeJjBpAiClDiCoKiCmEiCkCiCoJiPoKiNiHiCmNiCmIiCmJiCoAiClFiCmIiCkCiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.02.01 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::SetSelectedObjTable (FCObjTable* pObjTable)
{
	if (m_pSelectedObjTable != pObjTable)
	{
		m_pSelectedObjTable = pObjTable;
		m_lcLastSelectedCell.Set(-1, -1);
		ClearSelectCell();	// _xZkqqHx_jBeJjBpAiClDiCoKiClNiDfKiDiLiBeC_xHqqkZx_

		// _xZkqqHx_iNmFiMoDiCmJjBeJjBpAiClDiCoKiClNjAiFjFlNiMhCjApMiBeC_xHqqkZx_
		m_lcLastSelectedHorzRuled.Set(-1, -1);
		// _xZkqqHx_jBeJjBpAiClDiCoKiClNjAiFjFlNiMhCjApMiBeC_xHqqkZx_
		ClearSelectRuled(TRUE);

		// _xZkqqHx_iNmFiMoDiCmJjBeJjBpAiClDiCoKiClNjAiCjClMiMhCjApMiBeC_xHqqkZx_
		m_lcLastSelectedVertRuled.Set(-1, -1);
		// _xZkqqHx_jBeJjBpAiClDiCoKiClNjAiCjClMiMhCjApMiBeC_xHqqkZx_
		ClearSelectRuled(FALSE);
	}
} // FCToolTableEdit::SetSelectedObjTable.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::InsertLine
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iOhHjCoIiClDiCoKiClNiDeDiDjDiDgGiDgCiDeOiDfIiCmJiNhDiCpAjBhNjDpMiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	lLineIndex	:_xZkqqHx_jBhNjDpMiImKjChFiCpAiOhHjCoIiBeCjBhNjDpMiMoDiCmMiNhDiCkKiClBiCmMiDeDiDjDiDgGiDgCiDeOiDfIiCmJiCmIiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iJpAjAoA_xHqqkZx_>	_xZkqqHx_jFfMiCmMiNmFiMoDiCmMiNhDiCpAjBhNjDpMiClFiClNiCkCiPoKiNiHiCmNiBeB_xHqqkZx_lLineIndex_xZkqqHx_iCmJiNmFiMoDiCmMiNhDiBhLiCfAiCpAiOhHjCoIiClHiCoJiBeC_xHqqkZx_
 *			_xZkqqHx_jDoAjFjEiCmFiCmNiDfCiDhNiDjDiDgIiCpAjEkNiNhDiClHiCoJiCkKiBeBiDfKiDgCiDfGiDiHiDjDiKeKiOgOiBeFiPeJjHlJiBeBiNmEjFgAiJoGiPiIjHjNiCpA_xHqqkZx_
 *			_xZkqqHx_iIoKjAnIiNhDiCoNiCmIiCkCiBeC_xHqqkZx_
 *
 *                             _xZkqqHx_iBhJjBhNjDpMjBePiBhK_xHqqkZx_
 *
 *                  0              1              2          
 *                                                           
 *          _xZkqqHx_iEkBiEjPiEjP_xHqqkZx_[0,0]_xZkqqHx_iEjPiEjPiEkGiEjPiEjP_xHqqkZx_[0,1]_xZkqqHx_iEjPiEjPiEkGiEjPiEjP_xHqqkZx_[0,2]_xZkqqHx_iEjPiEjPiEkC_xHqqkZx_  
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_  
 *     0   [0,0]  [0,0]   [1,0]  [0,1]   [2,0]  [0,2]   [3,0]
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_  
 *          _xZkqqHx_iEkFiEjPiEjP_xHqqkZx_[1,0]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[1,1]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[1,2]_xZkqqHx_iEjPiEjPiEkH_xHqqkZx_  
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_  
 *     1   [0,1]  [1,0]   [1,1]  [1,1]   [2,1]  [1,2]   [3,1]
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_  
 *          _xZkqqHx_iEkFiEjPiEjP_xHqqkZx_[2,0]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[2,1]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[2,2]_xZkqqHx_iEjPiEjPiEkH_xHqqkZx_  
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_  
 *     2   [0,2]  [2,0]   [1,2]  [2,1]   [2,2]  [2,2]   [3,2]
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_  
 *          _xZkqqHx_iEkFiEjPiEjP_xHqqkZx_[3,0]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[3,1]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[3,2]_xZkqqHx_iEjPiEjPiEkH_xHqqkZx_  
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_  
 *     3   [0,3]  [3,0]   [1,3]  [3,1]   [2,3]  [3,2]   [3,3]
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_    _xZkqqHx_iEkBiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEkC_xHqqkZx_
 *          _xZkqqHx_iEkEiEjPiEjP_xHqqkZx_[4,0]_xZkqqHx_iEjPiEjPiEkIiEjPiEjP_xHqqkZx_[4,1]_xZkqqHx_iEjPiEjPiEkIiEjPiEjP_xHqqkZx_[4,2]_xZkqqHx_iEjPiEjPiEkD_xHqqkZx_    _xZkqqHx_iEkA_xHqqkZx_                                  _xZkqqHx_iEkA_xHqqkZx_   
 *                                                             _xZkqqHx_iEkEiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEkC_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_   
 *                               _xZkqqHx_iEkBiEjPiEkC_xHqqkZx_                                                        _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_   
 *                             _xZkqqHx_iEkBiEkD_xHqqkZx_  _xZkqqHx_iEkEiEkC_xHqqkZx_                                                    _xZkqqHx_iEkBiEkD_xHqqkZx_  _xZkqqHx_iEkEiEkC_xHqqkZx_ 
 *                              _xZkqqHx_iBfP_xHqqkZx_    _xZkqqHx_iBfO_xHqqkZx_                                                      _xZkqqHx_iBfP_xHqqkZx_    _xZkqqHx_iBfO_xHqqkZx_  
 *                                _xZkqqHx_iBfPiBfO_xHqqkZx_                                                          _xZkqqHx_iBfPiBfO_xHqqkZx_    
 *
 *                  0              1              2                                0              1              2          
 *                                                                                                                          
 *          _xZkqqHx_iEkBiEjPiEjP_xHqqkZx_[0,0]_xZkqqHx_iEjPiEjPiEkGiEjPiEjP_xHqqkZx_[0,1]_xZkqqHx_iEjPiEjPiEkGiEjPiEjP_xHqqkZx_[0,2]_xZkqqHx_iEjPiEjPiEkC_xHqqkZx_                _xZkqqHx_iEkBiEjPiEjP_xHqqkZx_[0,0]_xZkqqHx_iEjPiEjPiEkGiEjPiEjP_xHqqkZx_[0,1]_xZkqqHx_iEjPiEjPiEkGiEjPiEjP_xHqqkZx_[0,2]_xZkqqHx_iEjPiEjPiEkC_xHqqkZx_  
 *          _xZkqqHx_iBeG_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_                _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_  
 *     0   [0,0]  [0,0]   [1,0]  [0,1]   [2,0]  [0,2]   [3,0]         0   [0,0]  [0,0]   [1,0]  [0,1]   [2,0]  [0,2]   [3,0]
 *          _xZkqqHx_iBeG_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_                _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_  
 *          _xZkqqHx_iEkEiBgDiBgD_xHqqkZx_[1,0]_xZkqqHx_iBgDiBgDiEkIiBgDiBgD_xHqqkZx_[1,1]_xZkqqHx_iBgDiBgDiEkIiBgDiBgD_xHqqkZx_[1,2]_xZkqqHx_iBgDiBgDiEkD_xHqqkZx_                _xZkqqHx_iEkFiEjPiEjP_xHqqkZx_[1,0]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[1,1]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[1,2]_xZkqqHx_iEjPiEjPiEkH_xHqqkZx_  
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_                _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_  
 *     0   [0,0]  [0,0]   [1,0]  [0,1]   [2,0]  [0,2]   [3,0]         1   [0,1]  [1,0]   [1,1]  [1,1]   [2,1]  [1,2]   [3,1]
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_                _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_  
 *          _xZkqqHx_iEkFiEjPiEjP_xHqqkZx_[1,0]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[1,1]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[1,2]_xZkqqHx_iEjPiEjPiEkH_xHqqkZx_                _xZkqqHx_iEkFiEjPiEjP_xHqqkZx_[2,0]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[2,1]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[2,2]_xZkqqHx_iEjPiEjPiEkH_xHqqkZx_  
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_                _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_  
 *     1   [0,1]  [1,0]   [1,1]  [1,1]   [2,1]  [1,2]   [3,1]         2   [0,2]  [2,0]   [1,2]  [2,1]   [2,2]  [2,2]   [3,2]
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_                _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_  
 *          _xZkqqHx_iEkFiEjPiEjP_xHqqkZx_[2,0]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[2,1]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[2,2]_xZkqqHx_iEjPiEjPiEkH_xHqqkZx_                _xZkqqHx_iEkFiEjPiEjP_xHqqkZx_[3,0]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[3,1]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[3,2]_xZkqqHx_iEjPiEjPiEkH_xHqqkZx_  
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_                _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_  
 *     2   [0,2]  [2,0]   [1,2]  [2,1]   [2,2]  [2,2]   [3,2]         3   [0,3]  [3,0]   [1,3]  [3,1]   [2,3]  [3,2]   [3,3]
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_                _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_  
 *          _xZkqqHx_iEkFiEjPiEjP_xHqqkZx_[3,0]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[3,1]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[3,2]_xZkqqHx_iEjPiEjPiEkH_xHqqkZx_                _xZkqqHx_iEkFiEjPiEjP_xHqqkZx_[4,0]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[4,1]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[4,2]_xZkqqHx_iEjPiEjPiEkH_xHqqkZx_  
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_                _xZkqqHx_iBeG_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_  
 *     3   [0,3]  [3,0]   [1,3]  [3,1]   [2,3]  [3,2]   [3,3]         4   [0,4]  [4,0]   [1,4]  [4,1]   [2,4]  [4,2]   [3,4]
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_                _xZkqqHx_iBeG_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_  
 *          _xZkqqHx_iEkEiEjPiEjP_xHqqkZx_[4,0]_xZkqqHx_iEjPiEjPiEkIiEjPiEjP_xHqqkZx_[4,1]_xZkqqHx_iEjPiEjPiEkIiEjPiEjP_xHqqkZx_[4,2]_xZkqqHx_iEjPiEjPiEkD_xHqqkZx_                _xZkqqHx_iEkEiBgDiBgD_xHqqkZx_[5,0]_xZkqqHx_iBgDiBgDiEkIiBgDiBgD_xHqqkZx_[5,1]_xZkqqHx_iBgDiBgDiEkIiBgDiBgD_xHqqkZx_[5,2]_xZkqqHx_iBgDiBgDiEkD_xHqqkZx_  
 *
 *                           _xZkqqHx_iBhJiCePiNhDiCmJjBhNjDpMiBhK_xHqqkZx_                                                  _xZkqqHx_iBhJiCfDiNhDiCmJjBhNjDpMiBhK_xHqqkZx_
 *
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.02.08 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::InsertLine (long lLineIndex)
{
	// _xZkqqHx_jBhNjDpMiClDiCoKiCoJiDeDiDjDiDgGiDgCiDeOiDfIiBgI_xHqqkZx_lLineIndex_xZkqqHx_iBgIiCmJjBmOiClFiCmEiBeB_xHqqkZx_
	// _xZkqqHx_iDfKiDiLiCmN_xHqqkZx_ [lLineIndex,n]_xZkqqHx_iImIiPoDiBeBjAiFjFlNiMhCjApMiCmN_xHqqkZx_ [lLineIndex+1,n]_xZkqqHx_iImIiPoDiBeB_xHqqkZx_
	// _xZkqqHx_jAiCjClMiMhCjApMiCmN_xHqqkZx_ [n,lLineIndex]_xZkqqHx_iImIiPoD_xHqqkZx_ _xZkqqHx_iCkKiInKjDkOjBmOiPnLiCmGiCmIiCoJiBeC_xHqqkZx_

	// _xZkqqHx_iNmFiMoDiCmJjBeJjBpAiClDiCoKiClNiDfKiDiLiCpAiInKjDkOiBeC_xHqqkZx_
	if (lLineIndex <= m_lcLastSelectedCell.GetLineIndex())
		m_lcLastSelectedCell.SetLineIndex(m_lcLastSelectedCell.GetLineIndex() + 1);
	// _xZkqqHx_jBeJjBpAiClDiCoKiCmEiCkCiCoJiDfKiDiLiCpAiInKjDkOiBeC_xHqqkZx_
	set<FCLineColumn>::reverse_iterator rLc;
	for (rLc = m_stSelectedCell.rbegin(); rLc != m_stSelectedCell.rend(); rLc++)
	{
		if (lLineIndex <= (*rLc).GetLineIndex())
			(*rLc).SetLineIndex((*rLc).GetLineIndex() + 1);
	}

	// _xZkqqHx_iNmFiMoDiCmJjBeJjBpAiClDiCoKiClNjAiFjFlNiMhCjApMiCpAiInKjDkOiBeC_xHqqkZx_
	if (lLineIndex < m_lcLastSelectedHorzRuled.GetFrontIndex())
		m_lcLastSelectedHorzRuled.SetFrontIndex(m_lcLastSelectedHorzRuled.GetFrontIndex() + 1);
	// _xZkqqHx_jBeJjBpAiClDiCoKiCmEiCkCiCoJjAiFjFlNiMhCjApMiCpAiInKjDkOiBeC_xHqqkZx_
	set<FCFrontSide>::reverse_iterator rFs;
	for (rFs = m_stSelectedHorzRuled.rbegin(); rFs != m_stSelectedHorzRuled.rend(); rFs++)
	{
		if (lLineIndex < (*rFs).GetFrontIndex())
			(*rFs).SetFrontIndex((*rFs).GetFrontIndex() + 1);
	}

	// _xZkqqHx_iNmFiMoDiCmJjBeJjBpAiClDiCoKiClNjAiCjClMiMhCjApMiCpAiInKjDkOiBeC_xHqqkZx_
	if (lLineIndex <= m_lcLastSelectedVertRuled.GetSideIndex())
		m_lcLastSelectedVertRuled.SetSideIndex(m_lcLastSelectedVertRuled.GetSideIndex() + 1);
	// _xZkqqHx_jBeJjBpAiClDiCoKiCmEiCkCiCoJjAiCjClMiMhCjApMiCpAiInKjDkOiBeC_xHqqkZx_
	for (rFs = m_stSelectedVertRuled.rbegin(); rFs != m_stSelectedVertRuled.rend(); rFs++)
	{
		if (lLineIndex <= (*rFs).GetSideIndex())
			(*rFs).SetSideIndex((*rFs).GetSideIndex() + 1);
	}

	// _xZkqqHx_iDfCiDhNiDjDiDgIiOmAiNhDiBeC_xHqqkZx_
	g_pDoc->CmdInsertTableCellLine(m_pSelectedObjTable, lLineIndex, -1.0);
} // FCToolTableEdit::InsertLine.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::InsertColumn
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iOhHjCoIiClDiCoKiClNiDeDiDjDiDgGiDgCiDeOiDfIiCmJjHpBiCpAjBhNjDpMiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	lColumnIndex	:_xZkqqHx_jBhNjDpMiImKjChFiCpAiOhHjCoIiBeCjBhNjDpMiMoDiCmMjHpBiCkKiClBiCmMiDeDiDjDiDgGiDgCiDeOiDfIiCmJiCmIiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iJpAjAoA_xHqqkZx_>	_xZkqqHx_jFfMiCmMiNmFiMoDiCmMjHpBiCpAjBhNjDpMiClFiClNiCkCiPoKiNiHiCmNiBeB_xHqqkZx_lColumnIndex_xZkqqHx_iCmJiNmFiMoDiCmMjHpBiBhLiCfAiCpAiOhHjCoIiClHiCoJiBeC_xHqqkZx_
 *			_xZkqqHx_jDoAjFjEiCmFiCmNiDfCiDhNiDjDiDgIiCpAjEkNiNhDiClHiCoJiCkKiBeBiDfKiDgCiDfGiDiHiDjDiKeKiOgOiBeFiPeJjHlJiBeBiNmEjFgAiJoGiPiIjHjNiCpA_xHqqkZx_
 *			_xZkqqHx_iIoKjAnIiNhDiCoNiCmIiCkCiBeC_xHqqkZx_
 *
 *                               _xZkqqHx_iBhJjBhNjDpMjBePiBhK_xHqqkZx_
 *
 *                  0              1              2          
 *                                                           
 *          _xZkqqHx_iEkBiEjPiEjP_xHqqkZx_[0,0]_xZkqqHx_iEjPiEjPiEkGiEjPiEjP_xHqqkZx_[0,1]_xZkqqHx_iEjPiEjPiEkGiEjPiEjP_xHqqkZx_[0,2]_xZkqqHx_iEjPiEjPiEkC_xHqqkZx_  
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_  
 *     0   [0,0]  [0,0]   [1,0]  [0,1]   [2,0]  [0,2]   [3,0]
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_  
 *          _xZkqqHx_iEkFiEjPiEjP_xHqqkZx_[1,0]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[1,1]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[1,2]_xZkqqHx_iEjPiEjPiEkH_xHqqkZx_  
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_  
 *     1   [0,1]  [1,0]   [1,1]  [1,1]   [2,1]  [1,2]   [3,1]
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_  
 *          _xZkqqHx_iEkFiEjPiEjP_xHqqkZx_[2,0]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[2,1]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[2,2]_xZkqqHx_iEjPiEjPiEkH_xHqqkZx_  
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_  
 *     2   [0,2]  [2,0]   [1,2]  [2,1]   [2,2]  [2,2]   [3,2]
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_  
 *          _xZkqqHx_iEkFiEjPiEjP_xHqqkZx_[3,0]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[3,1]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[3,2]_xZkqqHx_iEjPiEjPiEkH_xHqqkZx_  
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_  
 *     3   [0,3]  [3,0]   [1,3]  [3,1]   [2,3]  [3,2]   [3,3]
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_    _xZkqqHx_iEkBiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEkC_xHqqkZx_
 *          _xZkqqHx_iEkEiEjPiEjP_xHqqkZx_[4,0]_xZkqqHx_iEjPiEjPiEkIiEjPiEjP_xHqqkZx_[4,1]_xZkqqHx_iEjPiEjPiEkIiEjPiEjP_xHqqkZx_[4,2]_xZkqqHx_iEjPiEjPiEkD_xHqqkZx_    _xZkqqHx_iEkA_xHqqkZx_                                    _xZkqqHx_iEkA_xHqqkZx_   
 *                                                             _xZkqqHx_iEkEiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEjPiEkC_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_   
 *                                _xZkqqHx_iEkBiEjPiEkC_xHqqkZx_                                                         _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_   
 *                              _xZkqqHx_iEkBiEkD_xHqqkZx_  _xZkqqHx_iEkEiEkC_xHqqkZx_                                                     _xZkqqHx_iEkBiEkD_xHqqkZx_  _xZkqqHx_iEkEiEkC_xHqqkZx_ 
 *                               _xZkqqHx_iBfP_xHqqkZx_    _xZkqqHx_iBfO_xHqqkZx_                                                       _xZkqqHx_iBfP_xHqqkZx_    _xZkqqHx_iBfO_xHqqkZx_  
 *                                 _xZkqqHx_iBfPiBfO_xHqqkZx_                                                           _xZkqqHx_iBfPiBfO_xHqqkZx_    
 *                                                                       
 *                  0               0              1              2                              0              1              2             0           
 *                                                                                                                                                       
 *          _xZkqqHx_iEkBiBgDiBgD_xHqqkZx_[0,0]_xZkqqHx_iBgDiBgDiEkCiEjPiEjP_xHqqkZx_[0,0]_xZkqqHx_iEjPiEjPiEkGiEjPiEjP_xHqqkZx_[0,1]_xZkqqHx_iEjPiEjPiEkGiEjPiEjP_xHqqkZx_[0,2]_xZkqqHx_iEjPiEjPiEkC_xHqqkZx_              _xZkqqHx_iEkBiEjPiEjP_xHqqkZx_[0,0]_xZkqqHx_iEjPiEjPiEkGiEjPiEjP_xHqqkZx_[0,1]_xZkqqHx_iEjPiEjPiEkGiEjPiEjP_xHqqkZx_[0,2]_xZkqqHx_iEjPiEjPiEkCiBgDiBgD_xHqqkZx_[0,3]_xZkqqHx_iBgDiBgDiEkC_xHqqkZx_   
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_              _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_   
 *     0   [0,0]  [0,0]   [1,0]  [0,0]   [1,0]  [0,1]   [2,0]  [0,2]   [3,0]       0   [0,0]  [0,0]   [1,0]  [0,1]   [2,0]  [0,2]   [3,0]  [0,3]   [4,0] 
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_              _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_   
 *          _xZkqqHx_iEkFiBgDiBgD_xHqqkZx_[1,0]_xZkqqHx_iBgDiBgDiEkHiEjPiEjP_xHqqkZx_[1,0]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[1,1]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[1,2]_xZkqqHx_iEjPiEjPiEkH_xHqqkZx_              _xZkqqHx_iEkFiEjPiEjP_xHqqkZx_[1,0]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[1,1]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[1,2]_xZkqqHx_iEjPiEjPiEkHiBgDiBgD_xHqqkZx_[1,3]_xZkqqHx_iBgDiBgDiEkH_xHqqkZx_   
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_              _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_   
 *     0   [0,1]  [1,0]   [1,1]  [1,0]   [1,1]  [1,1]   [2,1]  [1,2]   [3,1]       0   [0,1]  [1,0]   [1,1]  [1,1]   [2,1]  [1,2]   [3,1]  [1,3]   [4,1] 
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_              _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_   
 *          _xZkqqHx_iEkFiBgDiBgD_xHqqkZx_[2,0]_xZkqqHx_iBgDiBgDiEkHiEjPiEjP_xHqqkZx_[2,0]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[2,1]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[2,2]_xZkqqHx_iEjPiEjPiEkH_xHqqkZx_              _xZkqqHx_iEkFiEjPiEjP_xHqqkZx_[2,0]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[2,1]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[2,2]_xZkqqHx_iEjPiEjPiEkHiBgDiBgD_xHqqkZx_[2,3]_xZkqqHx_iBgDiBgDiEkH_xHqqkZx_   
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_              _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_   
 *     1   [0,2]  [2,0]   [1,2]  [2,0]   [1,2]  [2,1]   [2,2]  [2,2]   [3,2]       1   [0,2]  [2,0]   [1,2]  [2,1]   [2,2]  [2,2]   [3,2]  [2,3]   [4,2] 
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_              _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_   
 *          _xZkqqHx_iEkFiBgDiBgD_xHqqkZx_[3,0]_xZkqqHx_iBgDiBgDiEkHiEjPiEjP_xHqqkZx_[3,0]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[3,1]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[3,2]_xZkqqHx_iEjPiEjPiEkH_xHqqkZx_              _xZkqqHx_iEkFiEjPiEjP_xHqqkZx_[3,0]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[3,1]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[3,2]_xZkqqHx_iEjPiEjPiEkHiBgDiBgD_xHqqkZx_[3,3]_xZkqqHx_iBgDiBgDiEkH_xHqqkZx_   
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_              _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_   
 *     2   [0,3]  [3,0]   [1,3]  [3,0]   [1,3]  [3,1]   [2,3]  [3,2]   [3,3]       2   [0,3]  [3,0]   [1,3]  [3,1]   [2,3]  [3,2]   [3,3]  [3,3]   [4,3] 
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_              _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_   
 *          _xZkqqHx_iEkEiBgDiBgD_xHqqkZx_[4,0]_xZkqqHx_iBgDiBgDiEkDiEjPiEjP_xHqqkZx_[4,0]_xZkqqHx_iEjPiEjPiEkIiEjPiEjP_xHqqkZx_[4,1]_xZkqqHx_iEjPiEjPiEkIiEjPiEjP_xHqqkZx_[4,2]_xZkqqHx_iEjPiEjPiEkD_xHqqkZx_              _xZkqqHx_iEkEiEjPiEjP_xHqqkZx_[4,0]_xZkqqHx_iEjPiEjPiEkIiEjPiEjP_xHqqkZx_[4,1]_xZkqqHx_iEjPiEjPiEkIiEjPiEjP_xHqqkZx_[4,2]_xZkqqHx_iEjPiEjPiEkDiBgDiBgD_xHqqkZx_[4,3]_xZkqqHx_iBgDiBgDiEkD_xHqqkZx_   
 *
 *                             _xZkqqHx_iBhJiCePjHpBiCmJjBhNjDpMiBhK_xHqqkZx_                                                      _xZkqqHx_iBhJiCfCjHpBiCmJjBhNjDpMiBhK_xHqqkZx_
 *
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.02.08 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::InsertColumn (long lColumnIndex)
{
	// _xZkqqHx_jBhNjDpMiClDiCoKiCoJiDeDiDjDiDgGiDgCiDeOiDfIiBgI_xHqqkZx_lColumnIndex_xZkqqHx_iBgIiCmJjBmOiClFiCmEiBeB_xHqqkZx_
	// _xZkqqHx_iDfKiDiLiCmN_xHqqkZx_ [n,lColumnIndex]_xZkqqHx_iImIiPoDiBeBjAiCjClMiMhCjApMiCmN_xHqqkZx_ [lColumnIndex+1,n]_xZkqqHx_iImIiPoDiBeB_xHqqkZx_
	// _xZkqqHx_jAiFjFlNiMhCjApMiCmN_xHqqkZx_ [n,lColumnIndex]_xZkqqHx_iImIiPoD_xHqqkZx_ _xZkqqHx_iCkKiInKjDkOjBmOiPnLiCmGiCmIiCoJiBeC_xHqqkZx_

	// _xZkqqHx_iNmFiMoDiCmJjBeJjBpAiClDiCoKiClNiDfKiDiLiCpAiInKjDkOiBeC_xHqqkZx_
	if (lColumnIndex <= m_lcLastSelectedCell.GetColumnIndex())
		m_lcLastSelectedCell.SetColumnIndex(m_lcLastSelectedCell.GetColumnIndex() + 1);
	// _xZkqqHx_jBeJjBpAiClDiCoKiCmEiCkCiCoJiDfKiDiLiCpAiInKjDkOiBeC_xHqqkZx_
	set<FCLineColumn>::reverse_iterator rLc;
	for (rLc = m_stSelectedCell.rbegin(); rLc != m_stSelectedCell.rend(); rLc++)
	{
		if (lColumnIndex <= (*rLc).GetColumnIndex())
			(*rLc).SetColumnIndex((*rLc).GetColumnIndex() + 1);
	}

	// _xZkqqHx_iNmFiMoDiCmJjBeJjBpAiClDiCoKiClNjAiCjClMiMhCjApMiCpAiInKjDkOiBeC_xHqqkZx_
	if (lColumnIndex < m_lcLastSelectedVertRuled.GetFrontIndex())
		m_lcLastSelectedVertRuled.SetFrontIndex(m_lcLastSelectedVertRuled.GetFrontIndex() + 1);
	// _xZkqqHx_jBeJjBpAiClDiCoKiCmEiCkCiCoJjAiCjClMiMhCjApMiCpAiInKjDkOiBeC_xHqqkZx_
	set<FCFrontSide>::reverse_iterator rFs;
	for (rFs = m_stSelectedVertRuled.rbegin(); rFs != m_stSelectedVertRuled.rend(); rFs++)
	{
		if (lColumnIndex < (*rFs).GetFrontIndex())
			(*rFs).SetFrontIndex((*rFs).GetFrontIndex() + 1);
	}

	// _xZkqqHx_iNmFiMoDiCmJjBeJjBpAiClDiCoKiClNjAiFjFlNiMhCjApMiCpAiInKjDkOiBeC_xHqqkZx_
	if (lColumnIndex <= m_lcLastSelectedHorzRuled.GetSideIndex())
		m_lcLastSelectedHorzRuled.SetSideIndex(m_lcLastSelectedHorzRuled.GetSideIndex() + 1);
	// _xZkqqHx_jBeJjBpAiClDiCoKiCmEiCkCiCoJjAiFjFlNiMhCjApMiCpAiInKjDkOiBeC_xHqqkZx_
	for (rFs = m_stSelectedHorzRuled.rbegin(); rFs != m_stSelectedHorzRuled.rend(); rFs++)
	{
		if (lColumnIndex <= (*rFs).GetSideIndex())
			(*rFs).SetSideIndex((*rFs).GetSideIndex() + 1);
	}

	// _xZkqqHx_iDfCiDhNiDjDiDgIiOmAiNhDiBeC_xHqqkZx_
	g_pDoc->CmdInsertTableCellColumn(m_pSelectedObjTable, lColumnIndex, -1.0);
} // FCToolTableEdit::InsertColumn.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::DeleteLine
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iOhHjCoIiClDiCoKiClNiNhDiCpAiNoNiPjMiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	lLineIndex			:_xZkqqHx_iNoNiPjMiClHiCoJiNhDiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iJpAjAoA_xHqqkZx_>	_xZkqqHx_jDoAjFjEiCmFiCmNiDfCiDhNiDjDiDgIiCpAjEkNiNhDiClHiCoJiCkKiBeBiDfKiDgCiDfGiDiHiDjDiKeKiOgOiBeFiPeJjHlJiBeBiNmEjFgAiJoGiPiIjHjNiCpA_xHqqkZx_
 *			_xZkqqHx_iIoKjAnIiNhDiCoNiCmIiCkCiBeC_xHqqkZx_
 *
 *                  0              1              2          
 *                                                           
 *          _xZkqqHx_iEkBiEjPiEjP_xHqqkZx_[0,0]_xZkqqHx_iEjPiEjPiEkGiEjPiEjP_xHqqkZx_[0,1]_xZkqqHx_iEjPiEjPiEkGiEjPiEjP_xHqqkZx_[0,2]_xZkqqHx_iEjPiEjPiEkC_xHqqkZx_  
 *          _xZkqqHx_iBeG_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_  
 *     0   [0,0]  [0,0]   [1,0]  [0,1]   [2,0]  [0,2]   [3,0]
 *          _xZkqqHx_iBeG_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_  
 *          _xZkqqHx_iEkEiBgDiBgD_xHqqkZx_[1,0]_xZkqqHx_iBgDiBgDiEkIiBgDiBgD_xHqqkZx_[1,1]_xZkqqHx_iBgDiBgDiEkIiBgDiBgD_xHqqkZx_[1,2]_xZkqqHx_iBgDiBgDiEkD_xHqqkZx_  
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_  
 *     1   [0,1]  [1,0]   [1,1]  [1,1]   [2,1]  [1,2]   [3,1]
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_  
 *          _xZkqqHx_iEkFiEjPiEjP_xHqqkZx_[2,0]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[2,1]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[2,2]_xZkqqHx_iEjPiEjPiEkH_xHqqkZx_  
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_  
 *     2   [0,2]  [2,0]   [1,2]  [2,1]   [2,2]  [2,2]   [3,2]
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_  
 *          _xZkqqHx_iEkFiEjPiEjP_xHqqkZx_[3,0]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[3,1]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[3,2]_xZkqqHx_iEjPiEjPiEkH_xHqqkZx_  
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_  
 *     3   [0,3]  [3,0]   [1,3]  [3,1]   [2,3]  [3,2]   [3,3]
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_  
 *          _xZkqqHx_iEkFiEjPiEjP_xHqqkZx_[4,0]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[4,1]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[4,2]_xZkqqHx_iEjPiEjPiEkH_xHqqkZx_  
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_  
 *     4   [0,4]  [4,0]   [1,4]  [4,1]   [2,4]  [4,2]   [3,4]
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_  
 *          _xZkqqHx_iEkEiEjPiEjP_xHqqkZx_[5,0]_xZkqqHx_iEjPiEjPiEkIiEjPiEjP_xHqqkZx_[5,1]_xZkqqHx_iEjPiEjPiEkIiEjPiEjP_xHqqkZx_[5,2]_xZkqqHx_iEjPiEjPiEkD_xHqqkZx_  
 *
 *                      _xZkqqHx_iBhJiCePiNhDiCpAiNoNiPjMiClHiCoJiPoKiNiHiBhK_xHqqkZx_               
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.02.08 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::DeleteLine (long lLineIndex)
{
	// _xZkqqHx_iNoNiPjMiClDiCoKiCoJiDeDiDjDiDgGiDgCiDeOiDfIiBgI_xHqqkZx_lLineIndex_xZkqqHx_iBgIiCmJjBmOiClFiCmEiBeB_xHqqkZx_
	// _xZkqqHx_iDfKiDiLiCmN_xHqqkZx_ [lLineIndex,n]_xZkqqHx_iBeBjAiFjFlNiMhCjApMiCmN_xHqqkZx_ [lLineIndex+1,n]_xZkqqHx_iBeB_xHqqkZx_
	// _xZkqqHx_jAiCjClMiMhCjApMiCmN_xHqqkZx_ [n,lLineIndex] _xZkqqHx_iCkKiNoNiPjMjBmOiPnLiCmGiCmIiCoJiBeC_xHqqkZx_

	// _xZkqqHx_iNmFiMoDiCmJjBeJjBpAiClDiCoKiClNiDfKiDiLiCpAiInKjDkOiBeC_xHqqkZx_
	if (lLineIndex == m_lcLastSelectedCell.GetLineIndex())
		m_lcLastSelectedCell.Set(-1, -1);
	else if (lLineIndex < m_lcLastSelectedCell.GetLineIndex())
		m_lcLastSelectedCell.SetLineIndex(m_lcLastSelectedCell.GetLineIndex() - 1);
	// _xZkqqHx_jBeJjBpAiClDiCoKiCmEiCkCiCoJiDfKiDiLiCpAiInKjDkOiBeC_xHqqkZx_
	set<FCLineColumn> stNewSelectedCell;
	set<FCLineColumn>::reverse_iterator rLc;
	for (rLc = m_stSelectedCell.rbegin(); rLc != m_stSelectedCell.rend(); rLc++)
	{
		// lLineIndex _xZkqqHx_iCmGjDkPiClGiNhDiCmNiNoNiPjMiBeBiImIiNhOiCmMiNhDiCmN_xHqqkZx_ -1_xZkqqHx_iBeC_xHqqkZx_
		if ((*rLc).GetLineIndex() < lLineIndex)
			stNewSelectedCell.insert(FCLineColumn(	(*rLc).GetLineIndex(),
													(*rLc).GetColumnIndex()));
		else if (lLineIndex < (*rLc).GetLineIndex())
			stNewSelectedCell.insert(FCLineColumn(	(*rLc).GetLineIndex() - 1,
													(*rLc).GetColumnIndex()));
	}
	SetSelectCell(stNewSelectedCell);

	// _xZkqqHx_iNmFiMoDiCmJjBeJjBpAiClDiCoKiClNjAiFjFlNiMhCjApMiCpAiInKjDkOiBeC_xHqqkZx_
	if (lLineIndex + 1 == m_lcLastSelectedHorzRuled.GetFrontIndex())
		m_lcLastSelectedHorzRuled.Set(-1, -1);
	else if (lLineIndex + 1 < m_lcLastSelectedHorzRuled.GetFrontIndex())
		m_lcLastSelectedHorzRuled.SetFrontIndex(m_lcLastSelectedHorzRuled.GetFrontIndex() - 1);
	// _xZkqqHx_jBeJjBpAiClDiCoKiCmEiCkCiCoJjAiFjFlNiMhCjApMiCpAiInKjDkOiBeC_xHqqkZx_
	set<FCFrontSide> stNewSelectedHorzRuled;
	set<FCFrontSide>::reverse_iterator rFs;
	for (rFs = m_stSelectedHorzRuled.rbegin(); rFs != m_stSelectedHorzRuled.rend(); rFs++)
	{
		if ((*rFs).GetFrontIndex() < lLineIndex + 1)
			stNewSelectedHorzRuled.insert(FCFrontSide(	(*rFs).GetFrontIndex(),
														(*rFs).GetSideIndex()));
		else if (lLineIndex + 1 < (*rFs).GetFrontIndex())
			stNewSelectedHorzRuled.insert(FCFrontSide(	(*rFs).GetFrontIndex() - 1,
														(*rFs).GetSideIndex()));
	}
	SetSelectRuled(TRUE, stNewSelectedHorzRuled);


	// _xZkqqHx_iNmFiMoDiCmJjBeJjBpAiClDiCoKiClNjAiCjClMiMhCjApMiCpAiInKjDkOiBeC_xHqqkZx_
	if (lLineIndex == m_lcLastSelectedVertRuled.GetSideIndex())
		m_lcLastSelectedVertRuled.Set(-1, -1);
	else if (lLineIndex < m_lcLastSelectedVertRuled.GetSideIndex())
		m_lcLastSelectedVertRuled.SetSideIndex(m_lcLastSelectedVertRuled.GetSideIndex() - 1);
	// _xZkqqHx_jBeJjBpAiClDiCoKiCmEiCkCiCoJjAiCjClMiMhCjApMiCpAiInKjDkOiBeC_xHqqkZx_
	set<FCFrontSide> stNewSelectedVertRuled;
	for (rFs = m_stSelectedVertRuled.rbegin(); rFs != m_stSelectedVertRuled.rend(); rFs++)
	{
		if ((*rFs).GetSideIndex() < lLineIndex)
			stNewSelectedVertRuled.insert(FCFrontSide(	(*rFs).GetFrontIndex(),
														(*rFs).GetSideIndex()));
		else if (lLineIndex < (*rFs).GetSideIndex())
			stNewSelectedVertRuled.insert(FCFrontSide(	(*rFs).GetFrontIndex(),
														(*rFs).GetSideIndex() - 1));
	}
	SetSelectRuled(FALSE, stNewSelectedVertRuled);

	// _xZkqqHx_iDfCiDhNiDjDiDgIiOmAiNhDiBeC_xHqqkZx_
	g_pDoc->CmdDeleteTableCellLine(m_pSelectedObjTable, lLineIndex);
} // FCToolTableEdit::DeleteLine.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::DeleteColumn
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iOhHjCoIiClDiCoKiClNjHpBiCpAiNoNiPjMiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	lColumnIndex	:_xZkqqHx_iNoNiPjMiClHiCoJjHpBiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iJpAjAoA_xHqqkZx_>	_xZkqqHx_jDoAjFjEiCmFiCmNiDfCiDhNiDjDiDgIiCpAjEkNiNhDiClHiCoJiCkKiBeBiDfKiDgCiDfGiDiHiDjDiKeKiOgOiBeFiPeJjHlJiBeBiNmEjFgAiJoGiPiIjHjNiCpA_xHqqkZx_
 *			_xZkqqHx_iIoKjAnIiNhDiCoNiCmIiCkCiBeC_xHqqkZx_
 *
 *                  0               1              2              3         
 *                                                                          
 *          _xZkqqHx_iEkBiBgDiBgD_xHqqkZx_[0,0]_xZkqqHx_iBgDiBgDiEkCiEjPiEjP_xHqqkZx_[0,1]_xZkqqHx_iEjPiEjPiEkGiEjPiEjP_xHqqkZx_[0,2]_xZkqqHx_iEjPiEjPiEkGiEjPiEjP_xHqqkZx_[0,3]_xZkqqHx_iEjPiEjPiEkC_xHqqkZx_  
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_  
 *     0   [0,0]  [0,0]   [1,0]  [0,1]   [2,0]  [0,2]   [3,0]  [0,3]   [4,0]
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_  
 *          _xZkqqHx_iEkFiBgDiBgD_xHqqkZx_[1,0]_xZkqqHx_iBgDiBgDiEkHiEjPiEjP_xHqqkZx_[1,1]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[1,2]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[1,3]_xZkqqHx_iEjPiEjPiEkH_xHqqkZx_  
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_  
 *     0   [0,1]  [1,0]   [1,1]  [1,1]   [2,1]  [1,2]   [3,1]  [1,3]   [4,1]
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_  
 *          _xZkqqHx_iEkFiBgDiBgD_xHqqkZx_[2,0]_xZkqqHx_iBgDiBgDiEkHiEjPiEjP_xHqqkZx_[2,1]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[2,2]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[2,3]_xZkqqHx_iEjPiEjPiEkH_xHqqkZx_  
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_  
 *     1   [0,2]  [2,0]   [1,2]  [2,1]   [2,2]  [2,2]   [3,2]  [2,3]   [4,2]
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_  
 *          _xZkqqHx_iEkFiBgDiBgD_xHqqkZx_[3,0]_xZkqqHx_iBgDiBgDiEkHiEjPiEjP_xHqqkZx_[3,1]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[3,2]_xZkqqHx_iEjPiEjPiEkJiEjPiEjP_xHqqkZx_[3,3]_xZkqqHx_iEjPiEjPiEkH_xHqqkZx_  
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_  
 *     2   [0,3]  [3,0]   [1,3]  [3,1]   [2,3]  [3,2]   [3,3]  [3,3]   [4,3]
 *          _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iBeG_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_             _xZkqqHx_iEkA_xHqqkZx_  
 *          _xZkqqHx_iEkEiBgDiBgD_xHqqkZx_[4,0]_xZkqqHx_iBgDiBgDiEkDiEjPiEjP_xHqqkZx_[4,1]_xZkqqHx_iEjPiEjPiEkIiEjPiEjP_xHqqkZx_[4,2]_xZkqqHx_iEjPiEjPiEkIiEjPiEjP_xHqqkZx_[4,3]_xZkqqHx_iEjPiEjPiEkD_xHqqkZx_  
 *
 *                              _xZkqqHx_iBhJiCePjHpBiCpAiNoNiPjMiClHiCoJiPoKiNiHiBhK_xHqqkZx_                      
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.02.08 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::DeleteColumn (long lColumnIndex)
{
	// _xZkqqHx_iNoNiPjMiClDiCoKiCoJiDeDiDjDiDgGiDgCiDeOiDfIiBgI_xHqqkZx_lColumnIndex_xZkqqHx_iBgIiCmJjBmOiClFiCmEiBeB_xHqqkZx_
	// _xZkqqHx_iDfKiDiLiCmN_xHqqkZx_ [n,lColumnIndex]_xZkqqHx_iBeBjAiCjClMiMhCjApMiCmN_xHqqkZx_ [lColumnIndex+1,n]_xZkqqHx_iBeB_xHqqkZx_
	// _xZkqqHx_jAiFjFlNiMhCjApMiCmN_xHqqkZx_ [n,lColumnIndex] _xZkqqHx_iCkKiNoNiPjMjBmOiPnLiCmGiCmIiCoJiBeC_xHqqkZx_

	// _xZkqqHx_iNmFiMoDiCmJjBeJjBpAiClDiCoKiClNiDfKiDiLiCpAiInKjDkOiBeC_xHqqkZx_
	if (lColumnIndex == m_lcLastSelectedCell.GetColumnIndex())
		m_lcLastSelectedCell.Set(-1, -1);
	else if (lColumnIndex < m_lcLastSelectedCell.GetColumnIndex())
		m_lcLastSelectedCell.SetColumnIndex(m_lcLastSelectedCell.GetColumnIndex() - 1);
	// _xZkqqHx_jBeJjBpAiClDiCoKiCmEiCkCiCoJiDfKiDiLiCpAiInKjDkOiBeC_xHqqkZx_
	set<FCLineColumn> stNewSelectedCell;
	set<FCLineColumn>::reverse_iterator rLc;
	for (rLc = m_stSelectedCell.rbegin(); rLc != m_stSelectedCell.rend(); rLc++)
	{
		// lColumnIndex _xZkqqHx_iCmGjDkPiClGjHpBiCmNiNoNiPjMiBeBiImIiNhOiCmMjHpBiCmN_xHqqkZx_ -1_xZkqqHx_iBeC_xHqqkZx_
		if ((*rLc).GetColumnIndex() < lColumnIndex)
			stNewSelectedCell.insert(FCLineColumn(	(*rLc).GetLineIndex(),
													(*rLc).GetColumnIndex()));
		else if (lColumnIndex < (*rLc).GetColumnIndex())
			stNewSelectedCell.insert(FCLineColumn(	(*rLc).GetLineIndex(),
													(*rLc).GetColumnIndex() - 1));
	}
	SetSelectCell(stNewSelectedCell);

	// _xZkqqHx_iNmFiMoDiCmJjBeJjBpAiClDiCoKiClNjAiCjClMiMhCjApMiCpAiInKjDkOiBeC_xHqqkZx_
	if (lColumnIndex + 1 == m_lcLastSelectedVertRuled.GetFrontIndex())
		m_lcLastSelectedVertRuled.Set(-1, -1);
	else if (lColumnIndex + 1 < m_lcLastSelectedVertRuled.GetFrontIndex())
		m_lcLastSelectedVertRuled.SetFrontIndex(m_lcLastSelectedVertRuled.GetFrontIndex() - 1);
	// _xZkqqHx_jBeJjBpAiClDiCoKiCmEiCkCiCoJjAiCjClMiMhCjApMiCpAiInKjDkOiBeC_xHqqkZx_
	set<FCFrontSide> stNewSelectedVertRuled;
	set<FCFrontSide>::reverse_iterator rFs;
	for (rFs = m_stSelectedVertRuled.rbegin(); rFs != m_stSelectedVertRuled.rend(); rFs++)
	{
		if ((*rFs).GetFrontIndex() < lColumnIndex + 1)
			stNewSelectedVertRuled.insert(FCFrontSide(	(*rFs).GetFrontIndex(),
														(*rFs).GetSideIndex()));
		else if (lColumnIndex + 1 < (*rFs).GetFrontIndex())
			stNewSelectedVertRuled.insert(FCFrontSide(	(*rFs).GetFrontIndex() - 1,
														(*rFs).GetSideIndex()));
	}
	SetSelectRuled(FALSE, stNewSelectedVertRuled);

	// _xZkqqHx_iNmFiMoDiCmJjBeJjBpAiClDiCoKiClNjAiFjFlNiMhCjApMiCpAiInKjDkOiBeC_xHqqkZx_
	if (lColumnIndex == m_lcLastSelectedHorzRuled.GetSideIndex())
		m_lcLastSelectedHorzRuled.Set(-1, -1);
	else if (lColumnIndex < m_lcLastSelectedHorzRuled.GetSideIndex())
		m_lcLastSelectedHorzRuled.SetSideIndex(m_lcLastSelectedHorzRuled.GetSideIndex() - 1);
	// _xZkqqHx_jBeJjBpAiClDiCoKiCmEiCkCiCoJjAiFjFlNiMhCjApMiCpAiInKjDkOiBeC_xHqqkZx_
	set<FCFrontSide> stNewSelectedHorzRuled;
	for (rFs = m_stSelectedHorzRuled.rbegin(); rFs != m_stSelectedHorzRuled.rend(); rFs++)
	{
		if ((*rFs).GetSideIndex() < lColumnIndex)
			stNewSelectedHorzRuled.insert(FCFrontSide(	(*rFs).GetFrontIndex(),
														(*rFs).GetSideIndex()));
		else if (lColumnIndex < (*rFs).GetSideIndex())
			stNewSelectedHorzRuled.insert(FCFrontSide(	(*rFs).GetFrontIndex(),
														(*rFs).GetSideIndex() - 1));
	}
	SetSelectRuled(TRUE, stNewSelectedHorzRuled);

	// _xZkqqHx_iDfCiDhNiDjDiDgIiOmAiNhDiBeC_xHqqkZx_
	g_pDoc->CmdDeleteTableCellColumn(m_pSelectedObjTable, lColumnIndex);
} // FCToolTableEdit::DeleteColumn.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::SelectCellTmpMatrix
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iOhHjCoIiClDiCoKiClNjEmNiImNiCmMiDhNiDgHiDiKiDgCiDeOiDfIiCmMiDfKiDiLiCpAiBeBiIoKiOjOjBeJjBpAiCmJjCmHiJmBiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	cellIndexFrom	:_xZkqqHx_iDhNiDgHiDiKiDgCiDeOiDfIiCmMiKeKiOgOiDeDiDjDiDgGiDgCiDeOiDfIiCpAiOhHjCoIiBeC_xHqqkZx_
 *							 _xZkqqHx_jCmHiJmBjBmOiPnLiCmMiDfKiDiLiCmNiClBiCmMjCgMiCpAiKnMiCnOiBeC_xHqqkZx_
 *			cellIndexUntil	:_xZkqqHx_iDhNiDgHiDiKiDgCiDeOiDfIiCmMiPeJjHlJiDeDiDjDiDgGiDgCiDeOiDfIiCpAiOhHjCoIiBeC_xHqqkZx_
 *							 _xZkqqHx_jCmHiJmBjBmOiPnLiCmMiDfKiDiLiCmNiClBiCmMjCgMiCpAiKnMiCnOiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iJpAjAoA_xHqqkZx_>	_xZkqqHx_jEmNiImNiCmJiMiLiNiHiDfKiDiLiCkKiKnMiCnMiCoKiCoJiPoKiNiHiCmNiBeBiMiLiNiHiDfKiDiLiCpAiIoKiOjOjBeJjBpAiCmMjBmOiPnLiCmGiClFiBeB_xHqqkZx_
 *			_xZkqqHx_iNfIiCmJiMiLiNiHiDfKiDiLiCmJiCkJiCnEiCoJjEmNiImNiCmMjBlMiCmMiDfKiDiLiCoAiIoKiOjOjBeJjBpAiCmMjBmOiPnLiCmJjCmHiJmBiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.02.09 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::SelectCellTmpMatrix (	FCLineColumn cellIndexFrom,
										 	FCLineColumn cellIndexUntil)
{
	// _xZkqqHx_jBeJjBpAjEmNiImNiCmJiDfKiDiLiDhFiDiNiDgCiDeOiCpAiNgMjHlGiClFiCmEiBeBiNmFiPeJjDeJiCmIjBeJjBpAjEmNiImNiCpAiLiBiCnPiCoJiBeC_xHqqkZx_
	FCLineColumn cellIndexFromFinal;
	FCLineColumn cellIndexUntilFinal;
	m_pSelectedObjTable->GetFinalCellBlock(	cellIndexFromFinal,
											cellIndexUntilFinal,
											cellIndexFrom,
											cellIndexUntil);
	// _xZkqqHx_iDfKiDiLiCpAjCmHiJmBiBeC_xHqqkZx_
	long lLineIndex;
	long lColumnIndex;
	for (lLineIndex = cellIndexFromFinal.GetLineIndex();
		 lLineIndex <= cellIndexUntilFinal.GetLineIndex(); lLineIndex++)
	{
		for (lColumnIndex = cellIndexFromFinal.GetColumnIndex();
			 lColumnIndex <= cellIndexUntilFinal.GetColumnIndex(); lColumnIndex++)
		{
			AppendSelectCellTmp(FCLineColumn(lLineIndex, lColumnIndex));
		}
	}
} // FCToolTableEdit::SelectCellTmpMatrix.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::SelectCellTmpIncluded
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iOhHjCoIiClDiCoKiClNjEmNiImNiCmJiKkOjBfDiCmJiOpLiCnMiCoJiDfKiDiLiCpAiBeBiIoKiOjOjBeJjBpAiCmJjCmHiJmBiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	cellIndexFrom	:_xZkqqHx_iDhNiDgHiDiKiDgCiDeOiDfIiCmMiKeKiOgOiDeDiDjDiDgGiDgCiDeOiDfIiCpAiOhHjCoIiBeC_xHqqkZx_
 *							 _xZkqqHx_jCmHiJmBjBmOiPnLiCmMiDfKiDiLiCmNiClBiCmMjCgMiCpAiKnMiCnOiBeC_xHqqkZx_
 *			cellIndexUntil	:_xZkqqHx_iDhNiDgHiDiKiDgCiDeOiDfIiCmMiPeJjHlJiDeDiDjDiDgGiDgCiDeOiDfIiCpAiOhHjCoIiBeC_xHqqkZx_
 *							 _xZkqqHx_jCmHiJmBjBmOiPnLiCmMiDfKiDiLiCmNiClBiCmMjCgMiCpAiKnMiCnOiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iJpAjAoA_xHqqkZx_>	_xZkqqHx_jEmNiImNiCmJiMiLiNiHiDfKiDiLiCkKiKnMiCnMiCoKiBeBiIoKjFjEiCkKiCmNiCnNiPgPiClFiCmEiCkCiCoJiPoKiNiHiCmNiBeB_xHqqkZx_
 *			_xZkqqHx_iIoKiOjOjBeJjBpAiCmMjBmOiPnLiCkJiCoHiPjMiKePiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.02.17 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::SelectCellTmpIncluded (	FCLineColumn cellIndexFrom,
											 	FCLineColumn cellIndexUntil)
{
	// _xZkqqHx_iKkOjBfDiCmJiKnMiCnMiCoKiCoJiDfKiDiLiCmMiCnNiPfHiCnPiCoJiBeC_xHqqkZx_
	set<FCLineColumn> stCellIndex;
	m_pSelectedObjTable->GetIncludedCell(stCellIndex, cellIndexFrom, cellIndexUntil);
	set<FCLineColumn>::const_iterator iLc;
	for (iLc = stCellIndex.begin(); iLc != stCellIndex.end(); iLc++)
		AppendSelectCellTmp(*iLc);
} // FCToolTableEdit::SelectCellTmpIncluded.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::SelectRuledTmpMatrix
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iOhHjCoIiClDiCoKiClNjEmNiImNiCmMiDhNiDgHiDiKiDgCiDeOiDfIiCmMiMhCjApMiCpAiBeBiIoKiOjOjBeJjBpAiCmJjCmHiJmBiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	bIsHorz			:_xZkqqHx_jAiFjFlNiMhCjApMiCmMiPoKiNiHiCmN_xHqqkZx_TRUE_xZkqqHx_iBeBjAiCjClMiMhCjApMiCmMiPoKiNiHiCmN_xHqqkZx_FALSE_xZkqqHx_iCpAiOhHjCoIiBeC_xHqqkZx_
 *			ruledIndexFrom	:_xZkqqHx_iDhNiDgHiDiKiDgCiDeOiDfIiCmMiKeKiOgOiDeDiDjDiDgGiDgCiDeOiDfIiCpAiOhHjCoIiBeC_xHqqkZx_
 *							 _xZkqqHx_jCmHiJmBjBmOiPnLiCmMiMhCjApMiCmNiClBiCmMjCgMiCpAiKnMiCnOiBeC_xHqqkZx_
 *			ruledIndexUntil	:_xZkqqHx_iDhNiDgHiDiKiDgCiDeOiDfIiCmMiPeJjHlJiDeDiDjDiDgGiDgCiDeOiDfIiCpAiOhHjCoIiBeC_xHqqkZx_
 *							 _xZkqqHx_jCmHiJmBjBmOiPnLiCmMiMhCjApMiCmNiClBiCmMjCgMiCpAiKnMiCnOiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.02.09 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::SelectRuledTmpMatrix (BOOL bIsHorz,
											FCFrontSide ruledIndexFrom,
											FCFrontSide ruledIndexUntil)
{
	if (ruledIndexUntil.GetFrontIndex() < ruledIndexFrom.GetFrontIndex())
		::Exchange(ruledIndexUntil.first, ruledIndexFrom.first);
	if (ruledIndexUntil.GetSideIndex() < ruledIndexFrom.GetSideIndex())
		::Exchange(ruledIndexUntil.second, ruledIndexFrom.second);
	// _xZkqqHx_iMhCjApMiCpAjCmHiJmBiBeC_xHqqkZx_
	for (long lFrontIndex = ruledIndexFrom.GetFrontIndex();
		 lFrontIndex <= ruledIndexUntil.GetFrontIndex(); lFrontIndex++)
	{
		for (long lSideIndex = ruledIndexFrom.GetSideIndex();
			 lSideIndex <= ruledIndexUntil.GetSideIndex(); lSideIndex++)
		{
			if (AppendSelectRuledTmp(bIsHorz, FCFrontSide(lFrontIndex, lSideIndex)))
			{
				if (bIsHorz && m_lcLastSelectedHorzRuled.GetFrontIndex() == -1)
					m_lcLastSelectedHorzRuled.Set(lFrontIndex, lSideIndex);
				else
				if (!bIsHorz && m_lcLastSelectedVertRuled.GetFrontIndex() == -1)
					m_lcLastSelectedVertRuled.Set(lFrontIndex, lSideIndex);
			}
		}
	}
} // FCToolTableEdit::SelectRuledTmpMatrix.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::ClearSelectCellTmp
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDfKiDiLiCmMiIoKiOjOjBeJjBpAiCpAiDeOiDiKiDeBiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.02.17 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::ClearSelectCellTmp ()
{
	m_stSelectedCellTmp.clear();
} // FCToolTableEdit::ClearSelectCellTmp.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::AppendSelectCellTmp
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iOhHjCoIiClDiCoKiClNiDfKiDiLiCpAiIoKiOjOjBeJjBpAiCmJjCmHiJmBiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	cellIndex	:_xZkqqHx_iDfKiDiLiCmMiDeDiDjDiDgGiDgCiDeOiDfIiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jFnEjCgM_xHqqkZx_>	_xZkqqHx_jBeJjBpAiCmFiCkLiClNiPoKiNiHiCmN_xHqqkZx_TRUE_xZkqqHx_iBeC_xHqqkZx_
 *
 * <_xZkqqHx_jCiNiInD_xHqqkZx_>	_xZkqqHx_iNmFiMoDiCmJjBeJjBpAiClDiCoKiClNiDfKiDiL_xHqqkZx_ m_lcLastSelectedCell _xZkqqHx_iCkKjGkCjAnNjCoIiCmMiPoKiNiHiCmN_xHqqkZx_
 *			_xZkqqHx_iClBiCoKiCpAjAnNjCoIiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.02.09 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
BOOL FCToolTableEdit::AppendSelectCellTmp (const FCLineColumn& cellIndex)
{
	// _xZkqqHx_iOhHjCoIiCmMiDfKiDiLiCkKjBlGiNnNiClHiCoJiPoKiNiHiCmNiBeBiIoKiOjOjDeJiCmJjBeJjBpAiClDiCoKiClNiDfKiDiLiCmJjDgPjIfOiBeC_xHqqkZx_
	if (m_pSelectedObjTable->GetCell(cellIndex) != NULL)
	{
		m_stSelectedCellTmp.insert(cellIndex);

		// _xZkqqHx_iNmFiMoDiCmJjBeJjBpAiClDiCoKiClNiDfKiDiLiCpAjAnNjCoIiBeC_xHqqkZx_
		if (m_lcLastSelectedCell.GetLineIndex() == -1)
			m_lcLastSelectedCell = cellIndex;
		return TRUE;
	}
	return FALSE;
} // FCToolTableEdit::AppendSelectCellTmp.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::ClearRuledTmp
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iMhCjApMiCmMiIoKiOjOjBeJjBpAiCpAiDeOiDiKiDeBiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	bIsHorz		:_xZkqqHx_jAiFjFlNiMhCjApMiCmMiPoKiNiHiCmN_xHqqkZx_TRUE_xZkqqHx_iBeBjAiCjClMiMhCjApMiCmMiPoKiNiHiCmN_xHqqkZx_FALSE_xZkqqHx_iCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.02.22 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::ClearRuledTmp (BOOL bIsHorz)
{
	if (bIsHorz)
		m_stSelectedHorzRuledTmp.clear();
	else
		m_stSelectedVertRuledTmp.clear();
} // FCToolTableEdit::ClearRuledTmp.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::AppendSelectRuledTmp
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iOhHjCoIiClDiCoKiClNiMhCjApMiCpAiIoKiOjOjBeJjBpAiCmJjCmHiJmBiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	bIsHorz		:_xZkqqHx_jAiFjFlNiMhCjApMiCmMiPoKiNiHiCmN_xHqqkZx_TRUE_xZkqqHx_iBeBjAiCjClMiMhCjApMiCmMiPoKiNiHiCmN_xHqqkZx_FALSE_xZkqqHx_iCpAiOhHjCoIiBeC_xHqqkZx_
 *			ruledIndex	:_xZkqqHx_iMhCjApMiCmMiDeDiDjDiDgGiDgCiDeOiDfIiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jFnEjCgM_xHqqkZx_>	_xZkqqHx_jBeJjBpAiCmFiCkLiClNiPoKiNiHiCmN_xHqqkZx_TRUE_xZkqqHx_iBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.02.09 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
BOOL FCToolTableEdit::AppendSelectRuledTmp (BOOL bIsHorz, const FCFrontSide& ruledIndex)
{
	// _xZkqqHx_iOhHjCoIiCmMiMhCjApMiCkKjBlGiNnNiClHiCoJiPoKiNiHiCmNiBeBiIoKiOjOjDeJiCmJjBeJjBpAiClDiCoKiClNiMhCjApMiCmJjDgPjIfOiBeC_xHqqkZx_
	if (m_pSelectedObjTable->GetRuled(bIsHorz, ruledIndex) != NULL)
	{
		if (bIsHorz)
			m_stSelectedHorzRuledTmp.insert(ruledIndex);	// _xZkqqHx_iIoKiOjOjDeJiCmJjBeJjBpAiClDiCoKiClNjAiFjFlNiMhCjApMiBeC_xHqqkZx_
		else
			m_stSelectedVertRuledTmp.insert(ruledIndex);	// _xZkqqHx_iIoKiOjOjDeJiCmJjBeJjBpAiClDiCoKiClNjAiCjClMiMhCjApMiBeC_xHqqkZx_
		return TRUE;
	}
	return FALSE;
} // FCToolTableEdit::AppendSelectRuledTmp.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::ClearSelectCell
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDfKiDiLiCmMjBeJjBpAiCpAiDeOiDiKiDeBiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.02.22 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::ClearSelectCell ()
{
	set<FCLineColumn> stSelectedCell = m_stSelectedCell;
	RemoveSelectCell(stSelectedCell);
} // FCToolTableEdit::ClearSelectCell.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::AppendSelectCell
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iOhHjCoIiClDiCoKiClNiDfKiDiLiCpAjBeJjBpAiPpDjBnEiCmJjCmHiJmBiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	cellIndex	:_xZkqqHx_iDfKiDiLiCmMiDeDiDjDiDgGiDgCiDeOiDfIiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.02.22 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::AppendSelectCell (const FCLineColumn& cellIndex)
{
	set<FCLineColumn> stCellIndex;
	stCellIndex.insert(cellIndex);
	AppendSelectCell(stCellIndex);
} // FCToolTableEdit::AppendSelectCell.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::AppendSelectCell
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iOhHjCoIiClDiCoKiClNiDfKiDiLiCpAjBeJjBpAiPpDjBnEiCmJjCmHiJmBiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	stCellIndex	:_xZkqqHx_iDfKiDiLiCmMiDeDiDjDiDgGiDgCiDeOiDfIiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.02.22 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::AppendSelectCell (const set<FCLineColumn>& stCellIndex)
{
	ASSERT(m_pSelectedObjTable != NULL);
	FFInsert(m_stSelectedCell, stCellIndex);
	set<FCLineColumn>::const_iterator iLc;
	for (iLc = stCellIndex.begin(); iLc != stCellIndex.end(); iLc++)
	{
		if (m_pSelectedObjTable->GetCell(*iLc) != NULL)
			m_vSelectedCellRuledObj.push_back(m_pSelectedObjTable->GetCell(*iLc));
	}
	// _xZkqqHx_iDhEiDiMiBfLiDiAiCmJjBeJjBpAjFmPiNfIjCmKjCgNiBeC_xHqqkZx_
	FFGetMainWnd()->PostMessage(WM_USER_OBJ_SELECT_CHANGED);
} // FCToolTableEdit::AppendSelectCell.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::SetSelectCell
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_jBeJjBpAiCpAjBfDiCmEiJpAiPjMiClFiBeBiOhHjCoIiClDiCoKiClNiDfKiDiLiCpAjBeJjBpAiPpDjBnEiCmJjAnNjCoIiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	stCellIndex	:_xZkqqHx_iDfKiDiLiCmMiDeDiDjDiDgGiDgCiDeOiDfIiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.02.22 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::SetSelectCell (const set<FCLineColumn>& stCellIndex)
{
	ASSERT(m_pSelectedObjTable != NULL);
	ClearSelectCell();
	AppendSelectCell(stCellIndex);
} // FCToolTableEdit::SetSelectCell.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::RemoveSelectCell
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iOhHjCoIiClDiCoKiClNiDfKiDiLiCpAjBeJjBpAiPpDjBnEiCkJiCoHiJpAiPjMiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	cellIndex	:_xZkqqHx_iDfKiDiLiCmMiDeDiDjDiDgGiDgCiDeOiDfIiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.02.22 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::RemoveSelectCell (const FCLineColumn& cellIndex)
{
	set<FCLineColumn> stCellIndex;
	stCellIndex.insert(cellIndex);
	RemoveSelectCell(stCellIndex);
} // FCToolTableEdit::RemoveSelectCell.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::RemoveSelectCell
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iOhHjCoIiClDiCoKiClNiDfKiDiLiCpAjBeJjBpAiPpDjBnEiCkJiCoHiJpAiPjMiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	stCellIndex	:_xZkqqHx_iDfKiDiLiCmMiDeDiDjDiDgGiDgCiDeOiDfIiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.02.22 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::RemoveSelectCell (const set<FCLineColumn>& stCellIndex)
{
	FFErase(m_stSelectedCell, stCellIndex);

	// ObjDynabaseSet_xZkqqHx_iCmJjBeJjBpAjFjEjFgJiCpAiInKiClFiCmEiCkJiCoHiNoNiPjMiNoMiLmGiBeCiClLiCmMjFpLiCkKjBkMiCkCiBeC_xHqqkZx_
	ObjDynabaseSet stObjDynabase;
	FFInsert(stObjDynabase, m_vSelectedCellRuledObj);
	set<FCLineColumn>::const_iterator iLc;
	for (iLc = stCellIndex.begin(); iLc != stCellIndex.end(); iLc++)
	{
		if (m_pSelectedObjTable->GetCell(*iLc) != NULL)
			stObjDynabase.erase(m_pSelectedObjTable->GetCell(*iLc));
	}
	// ObjDynabaseSet_xZkqqHx_iCmJiInKiClFiClNjFjEjFgJiCpA_xHqqkZx_m_pSelectedObjTable_xZkqqHx_iCmJjGnPiClHiBeC_xHqqkZx_
	m_vSelectedCellRuledObj.clear();
	FFPushBack(m_vSelectedCellRuledObj, stObjDynabase);
	// _xZkqqHx_iDhEiDiMiBfLiDiAiCmJjBeJjBpAjFmPiNfIjCmKjCgNiBeC_xHqqkZx_
	FFGetMainWnd()->PostMessage(WM_USER_OBJ_SELECT_CHANGED);
} // FCToolTableEdit::RemoveSelectCell.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::ClearSelectRuled
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDfKiDiLiCmMjBeJjBpAiCpAiDeOiDiKiDeBiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	bIsHorz		:_xZkqqHx_jAiFjFlNiMhCjApMiCmMiPoKiNiHiCmN_xHqqkZx_TRUE_xZkqqHx_iBeBjAiCjClMiMhCjApMiCmMiPoKiNiHiCmN_xHqqkZx_FALSE_xZkqqHx_iCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.02.22 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::ClearSelectRuled (BOOL bIsHorz)
{
	set<FCFrontSide> stSelectedRuled = bIsHorz ? m_stSelectedHorzRuled : m_stSelectedVertRuled;
	RemoveSelectRuled(bIsHorz, stSelectedRuled);
} // FCToolTableEdit::ClearSelectRuled.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::AppendSelectRuled
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iOhHjCoIiClDiCoKiClNiDfKiDiLiCpAjBeJjBpAiPpDjBnEiCmJjCmHiJmBiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	bIsHorz		:_xZkqqHx_jAiFjFlNiMhCjApMiCmMiPoKiNiHiCmN_xHqqkZx_TRUE_xZkqqHx_iBeBjAiCjClMiMhCjApMiCmMiPoKiNiHiCmN_xHqqkZx_FALSE_xZkqqHx_iCpAiOhHjCoIiBeC_xHqqkZx_
 *			ruledIndex	:_xZkqqHx_iDfKiDiLiCmMiDeDiDjDiDgGiDgCiDeOiDfIiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.02.22 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::AppendSelectRuled (BOOL bIsHorz, const FCFrontSide& ruledIndex)
{
	set<FCFrontSide> stRuledIndex;
	stRuledIndex.insert(ruledIndex);
	AppendSelectRuled(bIsHorz, stRuledIndex);
} // FCToolTableEdit::AppendSelectRuled.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::AppendSelectRuled
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iOhHjCoIiClDiCoKiClNiDfKiDiLiCpAjBeJjBpAiPpDjBnEiCmJjCmHiJmBiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	bIsHorz		:_xZkqqHx_jAiFjFlNiMhCjApMiCmMiPoKiNiHiCmN_xHqqkZx_TRUE_xZkqqHx_iBeBjAiCjClMiMhCjApMiCmMiPoKiNiHiCmN_xHqqkZx_FALSE_xZkqqHx_iCpAiOhHjCoIiBeC_xHqqkZx_
 *			stRuledIndex	:_xZkqqHx_iDfKiDiLiCmMiDeDiDjDiDgGiDgCiDeOiDfIiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.02.22 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::AppendSelectRuled (BOOL bIsHorz, const set<FCFrontSide>& stRuledIndex)
{
	ASSERT(m_pSelectedObjTable != NULL);
	if (bIsHorz)
		FFInsert(m_stSelectedHorzRuled, stRuledIndex);
	else
		FFInsert(m_stSelectedVertRuled, stRuledIndex);
	set<FCFrontSide>::const_iterator iFs;
	for (iFs = stRuledIndex.begin(); iFs != stRuledIndex.end(); iFs++)
	{
		if (m_pSelectedObjTable->GetRuled(bIsHorz, *iFs) != NULL)
			m_vSelectedCellRuledObj.push_back(m_pSelectedObjTable->GetRuled(bIsHorz, *iFs));
	}
	// _xZkqqHx_iDhEiDiMiBfLiDiAiCmJjBeJjBpAjFmPiNfIjCmKjCgNiBeC_xHqqkZx_
	FFGetMainWnd()->PostMessage(WM_USER_OBJ_SELECT_CHANGED);
} // FCToolTableEdit::AppendSelectRuled.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::SetSelectRuled
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_jBeJjBpAiCpAjBfDiCmEiJpAiPjMiClFiBeBiOhHjCoIiClDiCoKiClNiDfKiDiLiCpAjBeJjBpAiPpDjBnEiCmJjAnNjCoIiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	bIsHorz		:_xZkqqHx_jAiFjFlNiMhCjApMiCmMiPoKiNiHiCmN_xHqqkZx_TRUE_xZkqqHx_iBeBjAiCjClMiMhCjApMiCmMiPoKiNiHiCmN_xHqqkZx_FALSE_xZkqqHx_iCpAiOhHjCoIiBeC_xHqqkZx_
 *			stRuledIndex	:_xZkqqHx_iDfKiDiLiCmMiDeDiDjDiDgGiDgCiDeOiDfIiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.02.22 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::SetSelectRuled (BOOL bIsHorz, const set<FCFrontSide>& stRuledIndex)
{
	ASSERT(m_pSelectedObjTable != NULL);
	ClearSelectRuled(bIsHorz);
	AppendSelectRuled(bIsHorz, stRuledIndex);
} // FCToolTableEdit::SetSelectRuled.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::RemoveSelectRuled
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iOhHjCoIiClDiCoKiClNiDfKiDiLiCpAjBeJjBpAiPpDjBnEiCkJiCoHiJpAiPjMiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	bIsHorz		:_xZkqqHx_jAiFjFlNiMhCjApMiCmMiPoKiNiHiCmN_xHqqkZx_TRUE_xZkqqHx_iBeBjAiCjClMiMhCjApMiCmMiPoKiNiHiCmN_xHqqkZx_FALSE_xZkqqHx_iCpAiOhHjCoIiBeC_xHqqkZx_
 *			ruledIndex	:_xZkqqHx_iDfKiDiLiCmMiDeDiDjDiDgGiDgCiDeOiDfIiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.02.22 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::RemoveSelectRuled (BOOL bIsHorz, const FCFrontSide& ruledIndex)
{
	set<FCFrontSide> stRuledIndex;
	stRuledIndex.insert(ruledIndex);
	RemoveSelectRuled(bIsHorz, stRuledIndex);
} // FCToolTableEdit::RemoveSelectRuled.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::RemoveSelectRuled
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iOhHjCoIiClDiCoKiClNiDfKiDiLiCpAjBeJjBpAiPpDjBnEiCkJiCoHiJpAiPjMiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	bIsHorz		:_xZkqqHx_jAiFjFlNiMhCjApMiCmMiPoKiNiHiCmN_xHqqkZx_TRUE_xZkqqHx_iBeBjAiCjClMiMhCjApMiCmMiPoKiNiHiCmN_xHqqkZx_FALSE_xZkqqHx_iCpAiOhHjCoIiBeC_xHqqkZx_
 *			stRuledIndex	:_xZkqqHx_iDfKiDiLiCmMiDeDiDjDiDgGiDgCiDeOiDfIiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.02.22 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::RemoveSelectRuled (BOOL bIsHorz, const set<FCFrontSide>& stRuledIndex)
{
	if (bIsHorz)
		FFErase(m_stSelectedHorzRuled, stRuledIndex);
	else
		FFErase(m_stSelectedVertRuled, stRuledIndex);

	// ObjDynabaseSet_xZkqqHx_iCmJjBeJjBpAjFjEjFgJiCpAiInKiClFiCmEiCkJiCoHiNoNiPjMiNoMiLmGiBeCiClLiCmMjFpLiCkKjBkMiCkCiBeC_xHqqkZx_
	ObjDynabaseSet stObjDynabase;
	FFInsert(stObjDynabase, m_vSelectedCellRuledObj);
	set<FCFrontSide>::const_iterator iFs;
	for (iFs = stRuledIndex.begin(); iFs != stRuledIndex.end(); iFs++)
	{
		if (m_pSelectedObjTable->GetRuled(bIsHorz, *iFs) != NULL)
			stObjDynabase.erase(m_pSelectedObjTable->GetRuled(bIsHorz, *iFs));
	}
	// ObjDynabaseSet_xZkqqHx_iCmJiInKiClFiClNjFjEjFgJiCpA_xHqqkZx_m_pSelectedObjTable_xZkqqHx_iCmJjGnPiClHiBeC_xHqqkZx_
	m_vSelectedCellRuledObj.clear();
	FFPushBack(m_vSelectedCellRuledObj, stObjDynabase);
	// _xZkqqHx_iDhEiDiMiBfLiDiAiCmJjBeJjBpAjFmPiNfIjCmKjCgNiBeC_xHqqkZx_
	FFGetMainWnd()->PostMessage(WM_USER_OBJ_SELECT_CHANGED);
} // FCToolTableEdit::RemoveSelectRuled.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::TbLocalObjMovedBefore
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_jFjEjFgJiInKjDkOiBeFiDiKiDfEiDeDiDfJiCmMjBePiPiIjHjNiCpAiNhDiCkEiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iJpAjAoA_xHqqkZx_>	FCToolTableEdit_xZkqqHx_iCmMiPoKiNiHiBeBiDePiDiLiBfLiDhGiDiBiDjDiDgPiBfLiKnEiCmMiDiKiDjDiDeOiCoAjGlDiCkCiClNiCnPiBeB_xHqqkZx_
 *			_xZkqqHx_iDgHiDgCiDhGiCmMjFfMjFjEjFgJiCpAiOhHjCoIiClHiCoKiCmOiCoGiCkCiBeC_xHqqkZx_
 *			_xZkqqHx_iCnOiClFiCoLiBeBiNhDiCoCjHpBiNoNiPjMiCmFiCoAjHjIjHhAiClHiCoJiCmMiCmFiBeBiDiBiDjDiDgPiBfLiCkKiOhHjCoIiClDiCoKiCoJiCmGiCnMiClIiCkCiBeC_xHqqkZx_
 *			_xZkqqHx_jFnCiPfHiDgDiBfLiDiLiCmFjFkBjAjEiCmMjFfMjFjEjFgJiCkKjBeJjBpAiCmFiCkLiCoJiCkKiBeBiIoKjDhIiCmJjFnCiPfHiClDiCoKiCoJjFfMjFjEjFgJiCmN_xHqqkZx_
 *			_xZkqqHx_iIoKiCmCiClOiCkPiCmIiCmMiCmFiBeBjFnCiPfHiClDiCoKiCoJjFfMjFjEjFgJiClOiCkPiCpAiOhHjCoIiCmFiCkLiCoJiCoGiCkEiCmJiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	06.06.13 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::TbLocalObjMovedBefore ()
{
	// _xZkqqHx_jFnCiPfHjBmOiPnLiCmMjFfMjFjEjFgJ_xHqqkZx_ m_pHitObj _xZkqqHx_iCpAjAnNjCoIiBeC_xHqqkZx_
	ObjDynabaseVector vSelObj;
	vSelObj.push_back(m_pHitObj);
	// _xZkqqHx_iInKjDkOjBePiCmMjAnNjCoIiBeC_xHqqkZx_
	LocalObjMovedBefore(vSelObj);
} // FCToolTableEdit::TbLocalObjMovedBefore.

//----- 06.12.09 Fukushiro M. _xZkqqHx_jCmHiJmBiOgO_xHqqkZx_ ()-----
/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::OnDrawState
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	View_xZkqqHx_iCmM_xHqqkZx_OnDraw_xZkqqHx_iCkJiCoHiOmAiNhDiClDiCoKiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	pDC		:_xZkqqHx_jFfMiOkGjHhAiDgGiDgPiDeDiDfIiDfCiDjDiDgFiDeMiDfIiDgHiCpAiOhHjCoIiBeC_xHqqkZx_
 *			pmmrtRgn:_xZkqqHx_iDiKiBfLiDfHiDiHiDjDjEhKjHpBiCpAiOhHjCoIiBeCiOgHiCoNiCmIiCkCiPoKiNiHiCmN_xHqqkZx_NULL_xZkqqHx_iCpAiOhHjCoIiBeC_xHqqkZx_
 *			lRgnSize:pmmrtRgn_xZkqqHx_iCmMjEhKjHpBiDfEiDeDiDfJiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.01.28 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::OnDrawState (CDC* pDC, int iState)
{
//----- 06.12.11 Fukushiro M. _xZkqqHx_jFmPiNfIjBeP_xHqqkZx_ ()-----
//	// FDA_xZkqqHx_iCmMiMlLiNnNiCmMiPpDjBnEiBeC_xHqqkZx_
//	switch (iState)
//	{
//	case STATE_MOVING_RULED:		// _xZkqqHx_iMhCjApMiInKjDkOjCiGiBeC_xHqqkZx_
//	  {
//		// Superclass_xZkqqHx_iKnGjAjEiOmAiNhDiBeC_xHqqkZx_
//		BASE_CLASS::OnDrawState(pDC, iState);
//		// _xZkqqHx_iInKjDkOjCiGiCmMjApMiCpAjFgAiJoGiBeC_xHqqkZx_
//		DrawMovingRuled(pDC);
//		break;
//	  }
//	default:	// STATE_ENTER_MOVE_RULED:	// _xZkqqHx_iMhCjApMiInKjDkOjDpMiMpLiBeC_xHqqkZx_
//				// STATE_EXIT_MOVE_RULED:	// _xZkqqHx_iMhCjApMiInKjDkOiPgPiMpLiBeC_xHqqkZx_
//				// STATE_START_MOVE_RULED:	// _xZkqqHx_iMhCjApMiInKjDkOiKeKiOgOiBeC_xHqqkZx_
//				// STATE_STOP_MOVE_RULED:	// _xZkqqHx_iMhCjApMiInKjDkOiPeJjHlJiBeC_xHqqkZx_
//		// Superclass_xZkqqHx_iKnGjAjEiOmAiNhDiBeC_xHqqkZx_
//		BASE_CLASS::OnDrawState(pDC, iState);
//	}
//----- 06.12.11 Fukushiro M. _xZkqqHx_jFmPiNfIiMoD_xHqqkZx_ ()-----
	// FDA_xZkqqHx_iCmMiMlLiNnNiCmMiPpDjBnEiBeC_xHqqkZx_
	switch (iState)
	{
	case STATE_MOVING_RULED:		// _xZkqqHx_iMhCjApMiInKjDkOjCiGiBeC_xHqqkZx_
	  {
		// _xZkqqHx_iInKjDkOjCiGiCmMjApMiCpAjFgAiJoGiBeC_xHqqkZx_
		DrawMovingRuled(pDC);
		break;
	  }
	default:	// STATE_ENTER_MOVE_RULED:	// _xZkqqHx_iMhCjApMiInKjDkOjDpMiMpLiBeC_xHqqkZx_
				// STATE_EXIT_MOVE_RULED:	// _xZkqqHx_iMhCjApMiInKjDkOiPgPiMpLiBeC_xHqqkZx_
				// STATE_START_MOVE_RULED:	// _xZkqqHx_iMhCjApMiInKjDkOiKeKiOgOiBeC_xHqqkZx_
				// STATE_STOP_MOVE_RULED:	// _xZkqqHx_iMhCjApMiInKjDkOiPeJjHlJiBeC_xHqqkZx_
		break;
	}
	// Superclass_xZkqqHx_iKnGjAjEiOmAiNhDiBeC_xHqqkZx_
	BASE_CLASS::OnDrawState(pDC, iState);
//----- 06.12.11 Fukushiro M. _xZkqqHx_jFmPiNfIiPeJ_xHqqkZx_ ()-----
} // FCToolTableEdit::OnDrawState.
//----- 06.12.09 Fukushiro M. _xZkqqHx_jCmHiJmBiPeJ_xHqqkZx_ ()-----

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::TransFDA
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iMiIjCoIjAkLjHeMiMmAiDeJiBfLiDgHiDhNiDgHiDjDiCmMjBeKiInKiCpAjFnEiClHiBeC_xHqqkZx_ToolTableEdit.mdrw_xZkqqHx_iCpAiOfBiPmGiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	iState	:_xZkqqHx_iMlLiNnNiCmMiPpDjBnEiCpAiOhHjCoIiBeC_xHqqkZx_
 *			iEvent	:_xZkqqHx_iDeDiDhIiDjDiDgHiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jFnEjCgM_xHqqkZx_>	_xZkqqHx_jBeKiInKiMoDiCmMiPpDjBnEiCpAjFnEiClHiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.01.28 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
int FCToolTableEdit::TransFDA (int iState, int iEvent)
{
	// _xZkqqHx_iInKiNhDjAoGiPpDjBnEiBeC_xHqqkZx_
	int iNextState = STATE_NONE;	// _xZkqqHx_iPpDjBnEjGlDiClFiBeC_xHqqkZx_
	// FDA_xZkqqHx_iCmMiMlLiNnNiCmMiPpDjBnEiBeC_xHqqkZx_
	switch (iState)
	{
	case STATE_IDLE:			// _xZkqqHx_jBnCiClPiBeC_xHqqkZx_
		if (FFCanEditObject())
		//----- _xZkqqHx_jFjEjFgJjFnCiPfHiJmCjEfMiCmMiPoKiNiH_xHqqkZx_ -----
		{
			switch (iEvent)
			{
			case WM_LBUTTONDOWN:	// _xZkqqHx_iNlGiDhLiDfOiDjDiDfPiDeFiDjDiBeC_xHqqkZx_
			case WM_RBUTTONDOWN:	// _xZkqqHx_iJeFiDhLiDfOiDjDiDfPiDeFiDjDiBeC_xHqqkZx_
				// _xZkqqHx_iKeKiOgOiOjOiCmMiJeFiBeFiNlGiDhLiDfOiDjDiDfPiDeFiDjDiBeC_xHqqkZx_
				m_iStartBtnDown = iEvent;
				switch (CheckHitRuled())
				{
				case AREA_RULED_MOVE_HORZ:	// _xZkqqHx_jAiFjFlNiMhCjApMiInKjDkOiDeHiDiKiDeBiBeC_xHqqkZx_
				case AREA_RULED_MOVE_VERT:	// _xZkqqHx_jAiCjClMiMhCjApMiInKjDkOiDeHiDiKiDeBiBeC_xHqqkZx_
					iNextState = STATE_ENTER_MOVE_RULED;	// _xZkqqHx_iMhCjApMiInKjDkOjDpMiMpLiBeC_xHqqkZx_
					break;
				case AREA_RULED_SEL_HORZ:	// _xZkqqHx_jAiFjFlNiMhCjApMjBeJjBpAiDeHiDiKiDeBiBeC_xHqqkZx_
				case AREA_RULED_SEL_VERT:	// _xZkqqHx_jAiCjClMiMhCjApMjBeJjBpAiDeHiDiKiDeBiBeC_xHqqkZx_
				case AREA_RULED_SEL_ALL:	// _xZkqqHx_jBfDiMhCjApMiDeHiDiKiDeBiBeC_xHqqkZx_
				case AREA_RULED_SEL_MATRIX_HORZ:	// _xZkqqHx_jAiFjFlNiMhCjApMjBeJjBpAiDhNiDgHiDiKiDgCiDeOiDfIiDeHiDiKiDeBiBeC_xHqqkZx_
				case AREA_RULED_SEL_MATRIX_VERT:	// _xZkqqHx_jAiCjClMiMhCjApMjBeJjBpAiDhNiDgHiDiKiDgCiDeOiDfIiDeHiDiKiDeBiBeC_xHqqkZx_
					iNextState = STATE_ENTER_SELECT_CELL;	// _xZkqqHx_jBeJjBpAjDpMiMpLiBeC_xHqqkZx_
					break;
				default:					// AREA_NONE _xZkqqHx_iDeHiDiKiDeBjGlDiClFiBeC_xHqqkZx_
					switch (CheckHitCell())
					{
					case AREA_CELL_SEL_LINE:	// _xZkqqHx_iDfKiDiLiNhDiDeHiDiKiDeBiBeC_xHqqkZx_
					case AREA_CELL_SEL_COLUMN:	// _xZkqqHx_iDfKiDiLjHpBiDeHiDiKiDeBiBeC_xHqqkZx_
					case AREA_CELL_SEL_ALL:		// _xZkqqHx_jBfDiDfKiDiLiDeHiDiKiDeBiBeC_xHqqkZx_
					case AREA_CELL_SEL_MATRIX:	// _xZkqqHx_iDfKiDiLiDhNiDgHiDiKiDgCiDeOiDfIiDeHiDiKiDeBiBeC_xHqqkZx_
						iNextState = STATE_ENTER_SELECT_CELL;	// _xZkqqHx_jBeJjBpAjDpMiMpLiBeC_xHqqkZx_
						break;
					default:			// AREA_NONE _xZkqqHx_iDhBiDgCiDgHiClFiCmEiCkCiCmIiCkCiPoKiNiHiBeC_xHqqkZx_
						if (!(m_dwFlags & MK_SHIFT) &&
							!(m_dwFlags & MK_CONTROL) &&
							!GetSelectLocalObjVector().empty())
						{
							iNextState = STATE_CLEAR_SELECT_CELL;	// _xZkqqHx_jBeJjBpAjBfDiJpAiPjMiBeC_xHqqkZx_
						}
					}
				}
				break;
			}
		}
		break;
	case STATE_ENTER_MOVE_RULED:	// _xZkqqHx_iMhCjApMiInKjDkOjDpMiMpLiBeC_xHqqkZx_
		switch (iEvent)
		{
		case WM_MOUSEMOVE:	// _xZkqqHx_iDhNiDeFiDfIiInKjDkOiBeC_xHqqkZx_
			iNextState = STATE_START_MOVE_RULED;		// _xZkqqHx_iMhCjApMiInKjDkOiKeKiOgOiBeC_xHqqkZx_
			break;
		case WM_LBUTTONUP:	// _xZkqqHx_iNlGiDhLiDfOiDjDiDeBiDgCiDhGiBeC_xHqqkZx_
		case WM_RBUTTONUP:	// _xZkqqHx_iJeFiDhLiDfOiDjDiDeBiDgCiDhGiBeC_xHqqkZx_
			iNextState = STATE_EXIT_MOVE_RULED;		// _xZkqqHx_iMhCjApMiInKjDkOiPgPiMpLiBeC_xHqqkZx_
			break;
		}
		break;
	case STATE_START_MOVE_RULED:	// _xZkqqHx_iMhCjApMiInKjDkOiKeKiOgOiBeC_xHqqkZx_
		iNextState = STATE_MOVING_RULED;		// _xZkqqHx_iMhCjApMiInKjDkOjCiGiBeC_xHqqkZx_
		break;
	case STATE_MOVING_RULED:		// _xZkqqHx_iMhCjApMiInKjDkOjCiGiBeC_xHqqkZx_
		switch (iEvent)
		{
		case WM_MOUSEMOVE:	// _xZkqqHx_iDhNiDeFiDfIiInKjDkOiBeC_xHqqkZx_
			iNextState = STATE_MOVING_RULED;		// _xZkqqHx_iMhCjApMiInKjDkOjCiGiBeC_xHqqkZx_
			break;
		case WM_LBUTTONUP:	// _xZkqqHx_iNlGiDhLiDfOiDjDiDeBiDgCiDhGiBeC_xHqqkZx_
		case WM_RBUTTONUP:	// _xZkqqHx_iJeFiDhLiDfOiDjDiDeBiDgCiDhGiBeC_xHqqkZx_
			iNextState = STATE_STOP_MOVE_RULED;	// _xZkqqHx_iMhCjApMiInKjDkOiPeJjHlJiBeC_xHqqkZx_
			break;
		}
		break;
	case STATE_STOP_MOVE_RULED:	// _xZkqqHx_iMhCjApMiInKjDkOiPeJjHlJiBeC_xHqqkZx_
		iNextState = STATE_EXIT_MOVE_RULED;		// _xZkqqHx_iMhCjApMiInKjDkOiPgPiMpLiBeC_xHqqkZx_
		break;
	case STATE_EXIT_MOVE_RULED:	// _xZkqqHx_iMhCjApMiInKjDkOiPgPiMpLiBeC_xHqqkZx_
		iNextState = STATE_IDLE;			// _xZkqqHx_jBnCiClPiBeC_xHqqkZx_
		break;
	case STATE_ENTER_SELECT_CELL:	// _xZkqqHx_jBeJjBpAjDpMiMpLiBeC_xHqqkZx_
		if (m_pHitObj == m_pSelectedObjTable)
		//----- _xZkqqHx_jBeJjBpAjCiGjFjEjFgJiPoD_xHqqkZx_ -----
		{
			if (m_dwFlags & MK_SHIFT)
			{
				iNextState = STATE_CLEAR_SELECT_CELL_3;	// _xZkqqHx_jBeJjBpAjBfDiJpAiPjM_xHqqkZx_3_xZkqqHx_iBeC_xHqqkZx_
			} else
			if (m_dwFlags & MK_CONTROL)
			{
				if (IsHitOnSelectedCell())
					iNextState = STATE_REMOVE_SELECT_CELL;	// _xZkqqHx_jBeJjBpAiJpAiPjMiBeC_xHqqkZx_
				else
					iNextState = STATE_ADD_SELECT_CELL;		// _xZkqqHx_jCmHiJmBjBeJjBpAiBeC_xHqqkZx_
			} else
			if (m_iStartBtnDown == WM_RBUTTONDOWN)
			// _xZkqqHx_iKeKiOgOiOjOiCkKiJeFiDhLiDfOiDjDiDfPiDeFiDjDiCmMiPoKiNiH_xHqqkZx_ -----
			{
				if (IsHitOnSelectedCell())
					iNextState = STATE_ADD_SELECT_CELL;		// _xZkqqHx_jCmHiJmBjBeJjBpAiBeC_xHqqkZx_
				else
					iNextState = STATE_CLEAR_SELECT_CELL_2;	// _xZkqqHx_jBeJjBpAjBfDiJpAiPjM_xHqqkZx_2_xZkqqHx_iBeC_xHqqkZx_
			} else
			{
				iNextState = STATE_CLEAR_SELECT_CELL_2;	// _xZkqqHx_jBeJjBpAjBfDiJpAiPjM_xHqqkZx_2_xZkqqHx_iBeC_xHqqkZx_
			}
		} else
		//----- _xZkqqHx_jEpBjBeJjBpAjCiGjFjEjFgJiPoD_xHqqkZx_ -----
		{
			iNextState = STATE_CLEAR_SELECT_CELL_2;	// _xZkqqHx_jBeJjBpAjBfDiJpAiPjM_xHqqkZx_2_xZkqqHx_iBeC_xHqqkZx_
		}
		break;
	case STATE_RANGE_SELECT_CELL:	// _xZkqqHx_jEmNiImNjBeJjBpAiBeC_xHqqkZx_
		iNextState = STATE_MEMORY_HIT_INFO;		// _xZkqqHx_iDhBiDgCiDgHiPoOjFpBiLeMiJkPiBeC_xHqqkZx_
		break;

	case STATE_REMOVE_SELECT_CELL:	// _xZkqqHx_jBeJjBpAiJpAiPjMiBeC_xHqqkZx_
		switch (iEvent)
		{
		case WM_LBUTTONUP:		// _xZkqqHx_iNlGiDhLiDfOiDjDiDeBiDgCiDhGiBeC_xHqqkZx_
		case WM_RBUTTONUP:	// _xZkqqHx_iJeFiDhLiDfOiDjDiDeBiDgCiDhGiBeC_xHqqkZx_
			iNextState = STATE_EXIT_SELECT_CELL;		// _xZkqqHx_jBeJjBpAiPgPiMpLiBeC_xHqqkZx_
			break;
		}
		break;

	case STATE_ADD_SELECT_CELL:		// _xZkqqHx_jCmHiJmBjBeJjBpAiBeC_xHqqkZx_
		iNextState = STATE_MEMORY_HIT_INFO;		// _xZkqqHx_iDhBiDgCiDgHiPoOjFpBiLeMiJkPiBeC_xHqqkZx_
		break;
	case STATE_CLEAR_SELECT_CELL_2:	// _xZkqqHx_jBeJjBpAjBfDiJpAiPjM_xHqqkZx_2_xZkqqHx_iBeC_xHqqkZx_
		iNextState = STATE_ADD_SELECT_CELL;		// _xZkqqHx_jCmHiJmBjBeJjBpAiBeC_xHqqkZx_
		break;

	case STATE_CLEAR_SELECT_CELL_3:	// _xZkqqHx_jBeJjBpAjBfDiJpAiPjM_xHqqkZx_3_xZkqqHx_iBeC_xHqqkZx_
		iNextState = STATE_RANGE_SELECT_CELL;	// _xZkqqHx_jEmNiImNjBeJjBpAiBeC_xHqqkZx_
		break;

	case STATE_EXIT_SELECT_CELL:		// _xZkqqHx_jBeJjBpAiPgPiMpLiBeC_xHqqkZx_
		iNextState = STATE_IDLE;						// _xZkqqHx_jBnCiClPiBeC_xHqqkZx_
		break;
	case STATE_CLEAR_SELECT_CELL:	// _xZkqqHx_jBeJjBpAjBfDiJpAiPjMiBeC_xHqqkZx_
		iNextState = STATE_IDLE;						// _xZkqqHx_jBnCiClPiBeC_xHqqkZx_
		break;
	case STATE_MEMORY_HIT_INFO:		// _xZkqqHx_iDhBiDgCiDgHiPoOjFpBiLeMiJkPiBeC_xHqqkZx_
		iNextState = STATE_AREA_SELECTING;		// _xZkqqHx_iDeHiDiKiDeBjBeJjBpAjCiGiBeC_xHqqkZx_
		break;
	case STATE_AREA_SELECTING:		// _xZkqqHx_iDeHiDiKiDeBjBeJjBpAjCiGiBeC_xHqqkZx_
		switch (iEvent)
		{
		case WM_LBUTTONUP:		// _xZkqqHx_iNlGiDhLiDfOiDjDiDeBiDgCiDhGiBeC_xHqqkZx_
		case WM_RBUTTONUP:	// _xZkqqHx_iJeFiDhLiDfOiDjDiDeBiDgCiDhGiBeC_xHqqkZx_
			iNextState = STATE_EXIT_SELECT_CELL;		// _xZkqqHx_jBeJjBpAiPgPiMpLiBeC_xHqqkZx_
			break;
		case WM_MOUSEMOVE:	// _xZkqqHx_iDhNiDeFiDfIiInKjDkOiBeC_xHqqkZx_
			switch (m_areaPrevHit)
			{
			case AREA_CELL_SEL_LINE:	// _xZkqqHx_iDfKiDiLiNhDiDeHiDiKiDeBiBeC_xHqqkZx_
			case AREA_CELL_SEL_COLUMN:	// _xZkqqHx_iDfKiDiLjHpBiDeHiDiKiDeBiBeC_xHqqkZx_
			case AREA_CELL_SEL_ALL:		// _xZkqqHx_jBfDiDfKiDiLiDeHiDiKiDeBiBeC_xHqqkZx_
			case AREA_CELL_SEL_MATRIX:	// _xZkqqHx_iDfKiDiLiDhNiDgHiDiKiDgCiDeOiDfIiDeHiDiKiDeBiBeC_xHqqkZx_
				if (CheckHitCell() == m_areaPrevHit &&
					m_pHitObj == m_pPrevHitObj)
				{
					switch (m_areaPrevHit)
					{
					case AREA_CELL_SEL_LINE:	// _xZkqqHx_iDfKiDiLiNhDiDeHiDiKiDeBiBeC_xHqqkZx_
						if (m_lPrevHitLineCellIndex != m_lHitLineCellIndex)
							iNextState = STATE_RANGE_SELECT_CELL;	// _xZkqqHx_jEmNiImNjBeJjBpAiBeC_xHqqkZx_
						break;
					case AREA_CELL_SEL_COLUMN:	// _xZkqqHx_iDfKiDiLjHpBiDeHiDiKiDeBiBeC_xHqqkZx_
						if (m_lPrevHitColumnCellIndex != m_lHitColumnCellIndex)
							iNextState = STATE_RANGE_SELECT_CELL;	// _xZkqqHx_jEmNiImNjBeJjBpAiBeC_xHqqkZx_
						break;
					case AREA_CELL_SEL_MATRIX:	// _xZkqqHx_iDfKiDiLiDhNiDgHiDiKiDgCiDeOiDfIiDeHiDiKiDeBiBeC_xHqqkZx_
						if (m_lPrevHitLineCellIndex != m_lHitLineCellIndex ||
							m_lPrevHitColumnCellIndex != m_lHitColumnCellIndex)
							iNextState = STATE_RANGE_SELECT_CELL;	// _xZkqqHx_jEmNiImNjBeJjBpAiBeC_xHqqkZx_
						break;
					}
				}
				if (iNextState == STATE_NONE)
					iNextState = STATE_AREA_SELECTING;		// _xZkqqHx_iDeHiDiKiDeBjBeJjBpAjCiGiBeC_xHqqkZx_
				break;

			case AREA_RULED_SEL_HORZ:	// _xZkqqHx_jAiFjFlNiMhCjApMjBeJjBpAiDeHiDiKiDeBiBeC_xHqqkZx_
			case AREA_RULED_SEL_VERT:	// _xZkqqHx_jAiCjClMiMhCjApMjBeJjBpAiDeHiDiKiDeBiBeC_xHqqkZx_
			case AREA_RULED_SEL_ALL:	// _xZkqqHx_jBfDiMhCjApMiDeHiDiKiDeBiBeC_xHqqkZx_
			case AREA_RULED_SEL_MATRIX_HORZ:	// _xZkqqHx_jAiFjFlNiMhCjApMjBeJjBpAiDhNiDgHiDiKiDgCiDeOiDfIiDeHiDiKiDeBiBeC_xHqqkZx_
			case AREA_RULED_SEL_MATRIX_VERT:	// _xZkqqHx_jAiCjClMiMhCjApMjBeJjBpAiDhNiDgHiDiKiDgCiDeOiDfIiDeHiDiKiDeBiBeC_xHqqkZx_
				if (CheckHitRuled() == m_areaPrevHit &&
					m_pHitObj == m_pPrevHitObj)
				{
					switch (m_areaPrevHit)
					{
					case AREA_RULED_SEL_HORZ:	// _xZkqqHx_jAiFjFlNiMhCjApMjBeJjBpAiDeHiDiKiDeBiBeC_xHqqkZx_
						if (m_lPrevHitFrontRuledIndex != m_lHitFrontRuledIndex)
							iNextState = STATE_RANGE_SELECT_CELL;	// _xZkqqHx_jEmNiImNjBeJjBpAiBeC_xHqqkZx_
						break;
					case AREA_RULED_SEL_VERT:	// _xZkqqHx_jAiCjClMiMhCjApMjBeJjBpAiDeHiDiKiDeBiBeC_xHqqkZx_
						if (m_lPrevHitFrontRuledIndex != m_lHitFrontRuledIndex)
							iNextState = STATE_RANGE_SELECT_CELL;	// _xZkqqHx_jEmNiImNjBeJjBpAiBeC_xHqqkZx_
						break;
					case AREA_RULED_SEL_MATRIX_HORZ:	// _xZkqqHx_jAiFjFlNiMhCjApMjBeJjBpAiDhNiDgHiDiKiDgCiDeOiDfIiDeHiDiKiDeBiBeC_xHqqkZx_
					case AREA_RULED_SEL_MATRIX_VERT:	// _xZkqqHx_jAiCjClMiMhCjApMjBeJjBpAiDhNiDgHiDiKiDgCiDeOiDfIiDeHiDiKiDeBiBeC_xHqqkZx_
						if (m_lPrevHitFrontRuledIndex != m_lHitFrontRuledIndex ||
							m_lPrevHitSideRuledIndex != m_lHitSideRuledIndex)
							iNextState = STATE_RANGE_SELECT_CELL;	// _xZkqqHx_jEmNiImNjBeJjBpAiBeC_xHqqkZx_
						break;
					}
				}
				if (iNextState == STATE_NONE)
					iNextState = STATE_AREA_SELECTING;		// _xZkqqHx_iDeHiDiKiDeBjBeJjBpAjCiGiBeC_xHqqkZx_
				break;
			}
		}
		break;
	}
	// _xZkqqHx_iPpDjBnEjBeKiInKjGlDiClFiCmMiPoKiNiHiCmNiDfIiBfLiDhAiBfLiDeOiDiJiDfIiCmMiPpDjBnEjBeKiInKiCpAiMmEiCnBiPgPiClHiBeC_xHqqkZx_
	if (iNextState == STATE_NONE)
		iNextState = BASE_CLASS::TransFDA(iState, iEvent);
	return iNextState;
} // FCToolTableEdit::TransFDA.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::StateFDA
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iPpDjBnEiCmJiJjOiClGiClNiPiIjHjNiCpAiOmAiNhDiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	iState	:_xZkqqHx_iMlLiNnNiCmMiPpDjBnEiCpAiOhHjCoIiBeC_xHqqkZx_
 *			pDC		:_xZkqqHx_jFgAiJoGjHhAiDgGiDgPiDeDiDfIiDfCiDjDiDgFiDeMiDfIiDgHiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.01.28 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::StateFDA (int iState, CDC* pDC)
{
	// FDA_xZkqqHx_iCmMiOjPiCmMiPpDjBnEiBeC_xHqqkZx_
	switch (iState)
	{
	case STATE_ENTER_MOVE_RULED:	// _xZkqqHx_iMhCjApMiInKjDkOjDpMiMpLiBeC_xHqqkZx_
		StateEnterMoveRuled(pDC);
		break;
	case STATE_START_MOVE_RULED:	// _xZkqqHx_iMhCjApMiInKjDkOiKeKiOgOiBeC_xHqqkZx_
		StateStartMoveRuled(pDC);
		break;
	case STATE_MOVING_RULED:		// _xZkqqHx_iMhCjApMiInKjDkOjCiGiBeC_xHqqkZx_
		StateMovingRuled(pDC);
		break;
	case STATE_STOP_MOVE_RULED:		// _xZkqqHx_iMhCjApMiInKjDkOiPeJjHlJiBeC_xHqqkZx_
		StateStopMoveRuled(pDC);
		break;
	case STATE_EXIT_MOVE_RULED:		// _xZkqqHx_iMhCjApMiInKjDkOiPgPiMpLiBeC_xHqqkZx_
		StateExitMoveRuled(pDC);
		break;
	case STATE_ENTER_SELECT_CELL:	// _xZkqqHx_jBeJjBpAjDpMiMpLiBeC_xHqqkZx_
		StateEnterSelectCell(pDC);
		break;
	case STATE_RANGE_SELECT_CELL:	// _xZkqqHx_jEmNiImNjBeJjBpAiBeC_xHqqkZx_
		StateRangeSelectCell(pDC);
		break;
	case STATE_REMOVE_SELECT_CELL:	// _xZkqqHx_jBeJjBpAiJpAiPjMiBeC_xHqqkZx_
		StateRemoveSelectCell(pDC);
		break;
	case STATE_ADD_SELECT_CELL:		// _xZkqqHx_jCmHiJmBjBeJjBpAiBeC_xHqqkZx_
		StateAddSelectCell(pDC);
		break;
	case STATE_EXIT_SELECT_CELL:	// _xZkqqHx_jBeJjBpAiPgPiMpLiBeC_xHqqkZx_
		StateExitSelectCell(pDC);
		break;
	case STATE_CLEAR_SELECT_CELL:	// _xZkqqHx_jBeJjBpAjBfDiJpAiPjMiBeC_xHqqkZx_
	case STATE_CLEAR_SELECT_CELL_2:	// _xZkqqHx_jBeJjBpAjBfDiJpAiPjM_xHqqkZx_2_xZkqqHx_iBeC_xHqqkZx_
	case STATE_CLEAR_SELECT_CELL_3:	// _xZkqqHx_jBeJjBpAjBfDiJpAiPjM_xHqqkZx_3_xZkqqHx_iBeC_xHqqkZx_
		StateClearSelectCell(pDC);
		break;
	case STATE_MEMORY_HIT_INFO:		// _xZkqqHx_iDhBiDgCiDgHiPoOjFpBiLeMiJkPiBeC_xHqqkZx_
		StateMemoryHitInfo(pDC);
		break;
	case STATE_AREA_SELECTING:		// _xZkqqHx_iDeHiDiKiDeBjBeJjBpAjCiGiBeC_xHqqkZx_
		StateAreaSelecting(pDC);
		break;
	default:
		BASE_CLASS::StateFDA(iState, pDC);
	}
} // FCToolTableEdit::StateFDA.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::StateIdle
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_jBnCiClPiPiIjHjNiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	pDC	:_xZkqqHx_jFgAiJoGjHhAiDgGiDgPiDeDiDfIiDfCiDjDiDgFiDeMiDfIiDgHiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.01.28 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::StateIdle (CDC* pDC)
{
//	TRACE(_T("StateIdle\r\n"));
	// _xZkqqHx_iDhBiDgCiDgHiCmMiPoKiNiHiCmNiDeKiBfLiDfMiDiLjFmPiNfIiBeC_xHqqkZx_
	switch (CheckHitRuled())
	{
	case AREA_RULED_MOVE_HORZ:	// _xZkqqHx_jAiFjFlNiMhCjApMiInKjDkOiDeHiDiKiDeBiBeC_xHqqkZx_
		SetIdleCursor(FFGetApp()->LoadStandardCursor(IDC_SIZENS));
		break;
	case AREA_RULED_MOVE_VERT:	// _xZkqqHx_jAiCjClMiMhCjApMiInKjDkOiDeHiDiKiDeBiBeC_xHqqkZx_
		SetIdleCursor(FFGetApp()->LoadStandardCursor(IDC_SIZEWE));
		break;
	case AREA_RULED_SEL_HORZ:	// _xZkqqHx_jAiFjFlNiMhCjApMjBeJjBpAiDeHiDiKiDeBiBeC_xHqqkZx_
	case AREA_RULED_SEL_VERT:	// _xZkqqHx_jAiCjClMiMhCjApMjBeJjBpAiDeHiDiKiDeBiBeC_xHqqkZx_
	case AREA_RULED_SEL_ALL:	// _xZkqqHx_jBfDiMhCjApMiDeHiDiKiDeBiBeC_xHqqkZx_
	case AREA_RULED_SEL_MATRIX_HORZ:	// _xZkqqHx_jAiFjFlNiMhCjApMjBeJjBpAiDhNiDgHiDiKiDgCiDeOiDfIiDeHiDiKiDeBiBeC_xHqqkZx_
	case AREA_RULED_SEL_MATRIX_VERT:	// _xZkqqHx_jAiCjClMiMhCjApMjBeJjBpAiDhNiDgHiDiKiDgCiDeOiDfIiDeHiDiKiDeBiBeC_xHqqkZx_
		SetIdleCursor(FFGetApp()->LoadCursor(IDC_CURSOR_THIN_CROSS));
		break;
	default:	// AREA_NONE _xZkqqHx_iDeHiDiKiDeBjGlDiClFiBeC_xHqqkZx_
		if (CheckHitCell() != AREA_NONE)
		//----- _xZkqqHx_iDfKiDiLiCmJiDhBiDgCiDgHiClFiClNiPoKiNiH_xHqqkZx_ -----
		{
			SetIdleCursor(FFGetApp()->LoadCursor(IDC_CURSOR_CROSS));
		}
	}
	// _xZkqqHx_iDhBiDgCiDgHiDeKiBfLiDfMiDiLiCpAjGlDiMpIiCmJiClHiCoJiBeC_xHqqkZx_
	m_iCursorNew = FDPA_HIT_NONE;
	// _xZkqqHx_iDiLiBfLiDiJiBfLiDhNiDeFiDfIiDhNiBfLiDeKiBfLjFfMiOkGjDjJiBeC_xHqqkZx_
	BASE_CLASS::StateIdle(pDC);
} // FCToolTableEdit::StateIdle.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::StateEnterMoveRuled
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iMhCjApMiInKjDkOjDpMiMpLiPiIjHjNiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	pDC	:_xZkqqHx_jFgAiJoGjHhAiDgGiDgPiDeDiDfIiDfCiDjDiDgFiDeMiDfIiDgHiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.01.28 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::StateEnterMoveRuled (CDC* pDC)
{
	TRACE(_T("StateEnterMoveRuled\r\n"));
	// OnLButtonUp_xZkqqHx_iCnMiCmFiClBiCmM_xHqqkZx_Window_xZkqqHx_iCmJiDeDiDhIiDjDiDgHiBeC_xHqqkZx_
	::FFSetCapture(g_pView->m_hWnd);
	// _xZkqqHx_iDeKiBfLiDfMiDiLjFmPiNfIiBeC_xHqqkZx_
	if (m_areaHit == AREA_RULED_MOVE_HORZ)
		FFGetMainWnd()->SetCurCursor(g_pView, FFGetApp()->LoadStandardCursor(IDC_SIZENS));
	else
		FFGetMainWnd()->SetCurCursor(g_pView, FFGetApp()->LoadStandardCursor(IDC_SIZEWE));
} // FCToolTableEdit::StateEnterMoveRuled.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::StateStartMoveRuled
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iMhCjApMiInKjDkOiKeKiOgOiPiIjHjNiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	pDC	:_xZkqqHx_jFgAiJoGjHhAiDgGiDgPiDeDiDfIiDfCiDjDiDgFiDeMiDfIiDgHiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.01.28 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::StateStartMoveRuled (CDC* pDC)
{
	TRACE(_T("StateStartMoveRuled\r\n"));
	// _xZkqqHx_iOkJjDkOiDfIiDeOiDiNiBfLiDiLiBgJiJoGjGmKiCpAiCmNiCnNiPgPiClFiClNiOjOiBgKiCpAiCgOiCgNiBeC_xHqqkZx_
	g_pView->SetAutoScroll(TRUE);
	// _xZkqqHx_iInKjDkOiClHiCoJiMhCjApMiCmMiImKjChFiCpAiOoGjDlOiBeC_xHqqkZx_
	if (m_areaHit == AREA_RULED_MOVE_HORZ)	// _xZkqqHx_jAiFjFlNiMhCjApMiCmMiInKjDkOiBeC_xHqqkZx_
		m_mmMovingRuledCoord = m_pHitObj->GetCellTopCoord(m_lHitFrontRuledIndex);
	else
		m_mmMovingRuledCoord = m_pHitObj->GetCellLeftCoord(m_lHitFrontRuledIndex);
	// _xZkqqHx_iInKjDkOjCiGiCmMjApMiCpAjFgAiJoGiBeC_xHqqkZx_
	DrawMovingRuled(pDC);
} // FCToolTableEdit::StateStartMoveRuled.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::StateMovingRuled
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iMhCjApMiInKjDkOjCiGiPiIjHjNiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	pDC	:_xZkqqHx_jFgAiJoGjHhAiDgGiDgPiDeDiDfIiDfCiDjDiDgFiDeMiDfIiDgHiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.01.28 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::StateMovingRuled (CDC* pDC)
{
	TRACE(_T("StateMovingRuled\r\n"));

	// _xZkqqHx_iDeKiBfLiDfMiDiLjFmPiNfIiBeC_xHqqkZx_
	if (m_areaHit == AREA_RULED_MOVE_HORZ)
		FFGetMainWnd()->SetCurCursor(g_pView, FFGetApp()->LoadStandardCursor(IDC_SIZENS));
	else
		FFGetMainWnd()->SetCurCursor(g_pView, FFGetApp()->LoadStandardCursor(IDC_SIZEWE));
	// _xZkqqHx_jAfGiClFiCkCiImKjChFiBeC_xHqqkZx_
	mmetol mmMovingRuledCoordNew = m_mmMovingRuledCoord;
	if (m_areaHit == AREA_RULED_MOVE_HORZ)
	//----- _xZkqqHx_jAiFjFlNiMhCjApMiCmMiInKjDkO_xHqqkZx_ -----
	{
		const mmetol mmPrevY = m_pHitObj->GetCellTopCoord(m_lHitFrontRuledIndex - 1);
		// _xZkqqHx_iNhDiCmMiNmFiPkMiNiCiCpAiPoDiJpBiCoJiPoKiNiHiCmMiCnNjFmPiNfIiCpAiLjGiJmCiClHiCoJiBeC_xHqqkZx_
		// _xZkqqHx_iDfIiDgJiDgCiDhGiCkKjHeMiMpIiCmMiPoKiNiHiCpAiNgMjHlGiClHiCoJiCmGiBeBiNmFiPkMjCgMiCpAiJlKiJpBiCoJiPoKiNiHiCmJjFoCjAlDiClHiCoJ_xHqqkZx_
		// _xZkqqHx_iCoGiCoIiCoAiBeBiJlKiJpBiCoJiPoKiNiHiCmNiLjGiJmCiClFiCmIiCkCjFpLiCkKiNeEiCnMiClFiCkCiBeC_xHqqkZx_
		mmetol mmHeight = m_mmptMsc.y - mmPrevY;
		FFSnapMP(NULL, &mmHeight);
		if (FD_OBJ_TABLE_MIN_CELL_HEIGHT < mmHeight)
			mmMovingRuledCoordNew = mmPrevY + mmHeight;
	} else
	//----- _xZkqqHx_jAiCjClMiMhCjApMiCmMiInKjDkO_xHqqkZx_ -----
	{
		const mmetol mmPrevX = m_pHitObj->GetCellLeftCoord(m_lHitFrontRuledIndex - 1);
		// _xZkqqHx_jHpBiCmMiNmFiPkMjFjNiCpAiPoDiJpBiCoJiPoKiNiHiCmMiCnNjFmPiNfIiCpAiLjGiJmCiClHiCoJiBeC_xHqqkZx_
		// _xZkqqHx_iDfIiDgJiDgCiDhGiCkKjHeMiMpIiCmMiPoKiNiHiCpAiNgMjHlGiClHiCoJiCmGiBeBiNmFiPkMjCgMiCpAiJlKiJpBiCoJiPoKiNiHiCmJjFoCjAlDiClHiCoJ_xHqqkZx_
		// _xZkqqHx_iCoGiCoIiCoAiBeBiJlKiJpBiCoJiPoKiNiHiCmNiLjGiJmCiClFiCmIiCkCjFpLiCkKiNeEiCnMiClFiCkCiBeC_xHqqkZx_
		mmetol mmWidth = m_mmptMsc.x - mmPrevX;
		FFSnapMP(&mmWidth, NULL);
		if (FD_OBJ_TABLE_MIN_CELL_WIDTH < mmWidth)
			mmMovingRuledCoordNew = mmPrevX + mmWidth;
	}
	if (!almosteq(m_mmMovingRuledCoord, mmMovingRuledCoordNew))
	//----- _xZkqqHx_iInKjDkOiClFiClNiPoKiNiH_xHqqkZx_ -----
	{
		// _xZkqqHx_iInKjDkOjCiGiCmMjApMiCpAjFgAiJoGiBeC_xHqqkZx_
		DrawMovingRuled(pDC);
		// _xZkqqHx_jAfGiClFiCkCiImKjChFiCpAjAnNjCoIiBeC_xHqqkZx_
		m_mmMovingRuledCoord = mmMovingRuledCoordNew;
		// _xZkqqHx_iInKjDkOjCiGiCmMjApMiCpAjFgAiJoGiBeC_xHqqkZx_
		DrawMovingRuled(pDC);
	}
} // FCToolTableEdit::StateMovingRuled.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::StateStopMoveRuled
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iMhCjApMiInKjDkOiPeJjHlJiPiIjHjNiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	pDC	:_xZkqqHx_jFgAiJoGjHhAiDgGiDgPiDeDiDfIiDfCiDjDiDgFiDeMiDfIiDgHiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.01.28 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::StateStopMoveRuled (CDC* pDC)
{
	TRACE(_T("StateStopMoveRuled\r\n"));

	// _xZkqqHx_iOkJjDkOiDfIiDeOiDiNiBfLiDiLiBgJiJoGjGmKiCpAiCmNiCnNiPgPiClFiClNiOjOiBgKiCpAiDeJiDhEiBeC_xHqqkZx_
	g_pView->SetAutoScroll(FALSE);

//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
//	// _xZkqqHx_jFnCiPfHjApMiCpAjFgAiJoGiBeC_xHqqkZx_
//	DrawSelectMark(pDC, m_pHitObj);
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----

	// _xZkqqHx_iInKjDkOjCiGiCpAjFfMiOkGiClHiCoJjApMiCpAiPmBiLiOiBeC_xHqqkZx_
	DrawMovingRuled(pDC);

	// _xZkqqHx_iDfCiDhNiDjDiDgIiDfKiDgCiDfGiDiHiDjDiCmMiKeKiOgOiBeC_xHqqkZx_
	g_pDoc->SessionBegin();
//----- 06.02.23 Fukushiro M. _xZkqqHx_jCmHiJmBiOgO_xHqqkZx_ ()-----
//----- 06.03.13 Fukushiro M. _xZkqqHx_jFmPiNfIjBeP_xHqqkZx_ ()-----
//	// _xZkqqHx_iInKjDkOjBePiCmMjAnNjCoIiBeC_xHqqkZx_
//	LocalObjMovedBefore(GetSelectLocalObjVector());
//----- 06.03.13 Fukushiro M. _xZkqqHx_jFmPiNfIiMoD_xHqqkZx_ ()-----

	// _xZkqqHx_iClBiClBiCmFiCmNiBeB_xHqqkZx_LocalObjMovedBefore _xZkqqHx_iCmJiCmN_xHqqkZx_ GetSelectLocalObjVector() _xZkqqHx_iCmFiCmNiCmIiCkNiBeB_xHqqkZx_
	// m_pHitObj _xZkqqHx_iCmM_xHqqkZx_ ObjdynabaseVector _xZkqqHx_iCpAiOhHjCoIiClFiCmIiCkPiCoKiCmOiCmIiCoHiCmIiCkCiBeC_xHqqkZx_
	// _xZkqqHx_iMhCjApMiInKjDkOiCmNiBeBjBeJjBpAiClDiCoKiClNiDfKiDiLiBgJ_xHqqkZx_GetSelectLocalObjVector_xZkqqHx_iBgKiCmFiCmNiCmIiCkNiBeB_xHqqkZx_
	// _xZkqqHx_iDeOiDiKiDgCiDeOiClDiCoKiClNiMhCjApMiBeBjBkGiClPjFfMjFjEjFgJ_xHqqkZx_ m_pHitObj _xZkqqHx_iCmMiMhCjApMiCpAiInKjDkOiClHiCoJiCmMiCmFiBeB_xHqqkZx_
	// m_pHitObj _xZkqqHx_iCpAiOhHjCoIiClHiCoJjFeLjHhGiCkKiCkAiCoJiBeC_xHqqkZx_
//----- 06.06.13 Fukushiro M. _xZkqqHx_jFmPiNfIjBeP_xHqqkZx_ ()-----
//	ObjDynabaseVector vSelObj;
//	vSelObj.push_back(m_pHitObj);
//	// _xZkqqHx_iInKjDkOjBePiCmMjAnNjCoIiBeC_xHqqkZx_
//	LocalObjMovedBefore(vSelObj);
//----- 06.06.13 Fukushiro M. _xZkqqHx_jFmPiNfIiMoD_xHqqkZx_ ()-----
	// _xZkqqHx_iInKjDkOjBePiCmMjAnNjCoIiBeC_xHqqkZx_
	TbLocalObjMovedBefore();
//----- 06.06.13 Fukushiro M. _xZkqqHx_jFmPiNfIiPeJ_xHqqkZx_ ()-----

//----- 06.03.13 Fukushiro M. _xZkqqHx_jFmPiNfIiPeJ_xHqqkZx_ ()-----
//----- 06.02.23 Fukushiro M. _xZkqqHx_jCmHiJmBiPeJ_xHqqkZx_ ()-----
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
//	// _xZkqqHx_jFmPiNfIjBePiCmMiMmFjHeMiDiKiBfLiDfHiDiHiDjDiCpAjAnNjCoIiBeC_xHqqkZx_
//	g_pView->AddRgn(m_pHitObj);
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----

	if (m_areaHit == AREA_RULED_MOVE_HORZ)
	//----- _xZkqqHx_jAiFjFlNiMhCjApMiCmMiInKjDkO_xHqqkZx_ -----
	{
		// _xZkqqHx_jAfGiClFiCkCiNhDiNiCiCpAiOfKiPgPiBeC_xHqqkZx_
		mmetol mmHeight = m_mmMovingRuledCoord - m_pHitObj->GetCellTopCoord(m_lHitFrontRuledIndex - 1);

		if (!almosteq(mmHeight, m_pHitObj->GetLineHeight(m_lHitFrontRuledIndex - 1)))
		//----- _xZkqqHx_iNhDiCmMiNiCiClDiCmJjFmPiJlLiCkKiCkAiCoJiPoKiNiH_xHqqkZx_ -----
		{
			// _xZkqqHx_jBeJjBpAiClDiCoKiClNiDfKiDiLiCmMiNhDiCpAjCiKiPgPiBeC_xHqqkZx_
			longSet stSelectedCellLine;
			set<FCLineColumn>::const_iterator iLc;
			for (iLc = m_stSelectedCell.begin(); iLc != m_stSelectedCell.end(); iLc++)
				stSelectedCellLine.insert((*iLc).GetLineIndex());
			if (m_pHitObj == m_pSelectedObjTable &&
				stSelectedCellLine.find(m_lHitFrontRuledIndex - 1) != stSelectedCellLine.end())
			//----- _xZkqqHx_jFmPiNfIjCiGiCmMiNhDiCkKjBeJjBpAjCiGiCmMiNhDiCmJiKnMiCnMiCoKiCoJiPoKiNiH_xHqqkZx_ -----
			{
				// _xZkqqHx_iDfCiDhNiDjDiDgIiCpAiOmAiNhDiBeC_xHqqkZx_
				longSet::const_iterator iIdx;
				for (iIdx = stSelectedCellLine.begin(); iIdx != stSelectedCellLine.end(); iIdx++)
					g_pDoc->CmdSetTableLineHeight(m_pHitObj, *iIdx, mmHeight);
			} else
			//----- _xZkqqHx_jFmPiNfIjCiGiCmMiNhDiCkKjBeJjBpAjCiGiCmMiNhDiCmJiKnMiCnMiCoKiCmIiCkCiPoKiNiH_xHqqkZx_ -----
			{
				// _xZkqqHx_iDfCiDhNiDjDiDgIiCpAiOmAiNhDiBeC_xHqqkZx_
				g_pDoc->CmdSetTableLineHeight(m_pHitObj, m_lHitFrontRuledIndex - 1, mmHeight);
			}
		}
	} else
	//----- _xZkqqHx_jAiCjClMiMhCjApMiCmMiInKjDkO_xHqqkZx_ -----
	{
		// _xZkqqHx_jAfGiClFiCkCjHpBjFjNiCpAiOfKiPgPiBeC_xHqqkZx_
		mmetol mmWidth = m_mmMovingRuledCoord - m_pHitObj->GetCellLeftCoord(m_lHitFrontRuledIndex - 1);
		if (!almosteq(mmWidth, m_pHitObj->GetColumnWidth(m_lHitFrontRuledIndex - 1)))
		//----- _xZkqqHx_jHpBiCmMjFjNiCmJjFmPiJlLiCkKiCkAiCoJiPoKiNiH_xHqqkZx_ -----
		{
			// _xZkqqHx_jBeJjBpAiClDiCoKiClNiDfKiDiLiCmMjHpBiCpAjCiKiPgPiBeC_xHqqkZx_
			longSet stSelectedCellColumn;
			set<FCLineColumn>::const_iterator iLc;
			for (iLc = m_stSelectedCell.begin(); iLc != m_stSelectedCell.end(); iLc++)
				stSelectedCellColumn.insert((*iLc).GetColumnIndex());
			if (m_pHitObj == m_pSelectedObjTable &&
				stSelectedCellColumn.find(m_lHitFrontRuledIndex - 1) != stSelectedCellColumn.end())
			//----- _xZkqqHx_jFmPiNfIjCiGiCmMjHpBiCkKjBeJjBpAjCiGiCmMjHpBiCmJiKnMiCnMiCoKiCoJiPoKiNiH_xHqqkZx_ -----
			{
				// _xZkqqHx_iDfCiDhNiDjDiDgIiCpAiOmAiNhDiBeC_xHqqkZx_
				longSet::const_iterator iIdx;
				for (iIdx = stSelectedCellColumn.begin(); iIdx != stSelectedCellColumn.end(); iIdx++)
					g_pDoc->CmdSetTableColumnWidth(m_pHitObj, *iIdx, mmWidth);
			} else
			//----- _xZkqqHx_jFmPiNfIjCiGiCmMjHpBiCkKjBeJjBpAjCiGiCmMjHpBiCmJiKnMiCnMiCoKiCmIiCkCiPoKiNiH_xHqqkZx_ -----
			{
				// _xZkqqHx_iDfCiDhNiDjDiDgIiCpAiOmAiNhDiBeC_xHqqkZx_
				g_pDoc->CmdSetTableColumnWidth(m_pHitObj, m_lHitFrontRuledIndex - 1, mmWidth);
			}
		}
	}

//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
//	// _xZkqqHx_jFmPiNfIiMoDiCmMiMmFjHeMiDiKiBfLiDfHiDiHiDjDiCpAjAnNjCoIiBeC_xHqqkZx_
//	// _xZkqqHx_jFnCiPfHjApMjFkKiCpAiKgHjCkDiClHiCoJiBeC_xHqqkZx_
//	g_pView->AppendToLastRgn(m_pHitObj->GetResizeFrame().ExtendRect(lg2mm(FD_TABLE_EDIT_MARGIN + 1)));
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----
	// _xZkqqHx_iDhBiDgCiDgHjFjEjFgJiPoOjFpBiCpAiJpAiPjMiBeCiOjPiCmMiNmEjFgAiJoGiOjOiCmJiMoLjFgAiJoGiCpAjEpAiCkPiCoJiClNiCnPiBeC_xHqqkZx_
	m_pHitObj = NULL;
//----- 06.02.23 Fukushiro M. _xZkqqHx_jCmHiJmBiOgO_xHqqkZx_ ()-----
	// _xZkqqHx_iInKjDkOiMoDiCmMjAnNjCoIiBeC_xHqqkZx_
	LocalObjMovedAfter();
//----- 06.02.23 Fukushiro M. _xZkqqHx_jCmHiJmBiPeJ_xHqqkZx_ ()-----
	// _xZkqqHx_iDfCiDhNiDjDiDgIiDfKiDgCiDfGiDiHiDjDiCmMiPeJjHlJiBeC_xHqqkZx_
	g_pDoc->SessionEnd();
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
//	// _xZkqqHx_jBeJjBpAjFjEjFgJiCmMjFmPiNfIiCpAiClBiCmMiDgDiBfLiDiLiCmJjCmKjCgNiBeC_xHqqkZx_
//	OnSelectObjModified();
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
//	// _xZkqqHx_iMmFjHeMiDiKiBfLiDfHiDiHiDjDiCpAiNmEjFgAiJoGiBeC_xHqqkZx_
//	g_pView->SendRgnRedraw();
//----- 06.02.23 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----
} // FCToolTableEdit::StateStopMoveRuled.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::StateExitMoveRuled
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iMhCjApMiInKjDkOiPgPiMpLiPiIjHjNiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	pDC	:_xZkqqHx_jFgAiJoGjHhAiDgGiDgPiDeDiDfIiDfCiDjDiDgFiDeMiDfIiDgHiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.01.28 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::StateExitMoveRuled (CDC* pDC)
{
	TRACE(_T("StateExitMoveRuled\r\n"));
	// _xZkqqHx_iDhNiDeFiDfIiCmMjFnPiKgMiCpAiJpAiPjMiBeC_xHqqkZx_
	::FFReleaseCapture();
} // FCToolTableEdit::StateExitMoveRuled.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::StateEnterSelectCell
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_jBeJjBpAjDpMiMpLiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	pDC	:_xZkqqHx_jFgAiJoGjHhAiDgGiDgPiDeDiDfIiDfCiDjDiDgFiDeMiDfIiDgHiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.01.29 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::StateEnterSelectCell (CDC* pDC)
{
	TRACE(_T("FCToolTableEdit::StateEnterSelectCell\n"));
	// OnLButtonUp_xZkqqHx_iCnMiCmFiClBiCmM_xHqqkZx_Window_xZkqqHx_iCmJiDeDiDhIiDjDiDgHiBeC_xHqqkZx_
	::FFSetCapture(g_pView->m_hWnd);
} // FCToolTableEdit::StateEnterSelectCell.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::StateRangeSelectCell
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_jEmNiImNjBeJjBpAiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	pDC	:_xZkqqHx_jFgAiJoGjHhAiDgGiDgPiDeDiDfIiDfCiDjDiDgFiDeMiDfIiDgHiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.01.28 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::StateRangeSelectCell (CDC* pDC)
{
	TRACE(_T("FCToolTableEdit::StateRangeSelectCell\n"));

	// _xZkqqHx_jBeJjBpAiNhDiCpAiDeOiDiKiDeBiBeC_xHqqkZx_
	DrawSelectedCell(pDC, m_pSelectedObjTable);
	// _xZkqqHx_jBeJjBpAjBmOiPnLiCmMjFfMjFjEjFgJiCpAjAnNjCoIiClHiCoJiBeC_xHqqkZx_
	SetSelectedObjTable(m_pHitObj);
	if (m_lcLastSelectedCell.GetLineIndex() == -1)
		m_lcLastSelectedCell.Set(0, 0);
	// _xZkqqHx_iNmFiMoDiCmJjBeJjBpAiClDiCoKiClNjAiFjFlNiMhCjApMiBeC_xHqqkZx_
	if (m_lcLastSelectedHorzRuled.GetFrontIndex() == -1)
		m_lcLastSelectedHorzRuled.Set(0, 0);
	// _xZkqqHx_iNmFiMoDiCmJjBeJjBpAiClDiCoKiClNjAiCjClMiMhCjApMiBeC_xHqqkZx_
	if (m_lcLastSelectedVertRuled.GetFrontIndex() == -1)
		m_lcLastSelectedVertRuled.Set(0, 0);

	// _xZkqqHx_iDfKiDiLiCmMiIoKiOjOjBeJjBpAiCpAiDeOiDiKiDeBiClHiCoJiBeC_xHqqkZx_
	ClearSelectCellTmp();
	// _xZkqqHx_iIoKiOjOjDeJiCmJjBeJjBpAiClDiCoKiClNjAiFjFlNiMhCjApMiBeC_xHqqkZx_
	ClearRuledTmp(TRUE);
	// _xZkqqHx_iIoKiOjOjDeJiCmJjBeJjBpAiClDiCoKiClNjAiCjClMiMhCjApMiBeC_xHqqkZx_
	ClearRuledTmp(FALSE);

	switch (m_areaHit)
	{
	case AREA_CELL_SEL_LINE:	// _xZkqqHx_iDfKiDiLiNhDiDeHiDiKiDeBiBeC_xHqqkZx_
		SelectCellTmpIncluded(FCLineColumn(m_lcLastSelectedCell.GetLineIndex(), 0),
							FCLineColumn(m_lHitLineCellIndex, m_pHitObj->GetColumnCount() - 1));
		break;
	case AREA_CELL_SEL_COLUMN:	// _xZkqqHx_iDfKiDiLjHpBiDeHiDiKiDeBiBeC_xHqqkZx_
		SelectCellTmpIncluded(FCLineColumn(0, m_lcLastSelectedCell.GetColumnIndex()),
							FCLineColumn(m_pHitObj->GetLineCount() - 1, m_lHitColumnCellIndex));
		break;
	case AREA_CELL_SEL_ALL:		// _xZkqqHx_jBfDiDfKiDiLiDeHiDiKiDeBiBeC_xHqqkZx_
		SelectCellTmpMatrix(FCLineColumn(0, 0),
							FCLineColumn(m_pHitObj->GetLineCount() - 1, m_pHitObj->GetColumnCount() - 1));
		break;
	case AREA_CELL_SEL_MATRIX:	// _xZkqqHx_iDfKiDiLiDhNiDgHiDiKiDgCiDeOiDfIiDeHiDiKiDeBiBeC_xHqqkZx_
		SelectCellTmpMatrix(FCLineColumn(m_lcLastSelectedCell.GetLineIndex(), m_lcLastSelectedCell.GetColumnIndex()),
							FCLineColumn(m_lHitLineCellIndex, m_lHitColumnCellIndex));
		break;
	case AREA_RULED_SEL_HORZ:		// _xZkqqHx_jAiFjFlNiMhCjApMjBeJjBpAiDeHiDiKiDeBiBeC_xHqqkZx_
		SelectRuledTmpMatrix(TRUE,
							FCFrontSide(m_lcLastSelectedHorzRuled.GetFrontIndex(), 0),
							FCFrontSide(m_lHitFrontRuledIndex, m_pHitObj->GetColumnCount() - 1));
		break;
	case AREA_RULED_SEL_VERT:		// _xZkqqHx_jAiCjClMiMhCjApMjBeJjBpAiDeHiDiKiDeBiBeC_xHqqkZx_
		SelectRuledTmpMatrix(FALSE,
							FCFrontSide(m_lcLastSelectedVertRuled.GetFrontIndex(), 0),
							FCFrontSide(m_lHitFrontRuledIndex, m_pHitObj->GetLineCount() - 1));
		break;
	case AREA_RULED_SEL_ALL:		// _xZkqqHx_jBfDiMhCjApMiDeHiDiKiDeBiBeC_xHqqkZx_
		SelectRuledTmpMatrix(TRUE,
							FCFrontSide(0, 0),
							FCFrontSide(m_pHitObj->GetLineCount(), m_pHitObj->GetColumnCount() - 1));
		SelectRuledTmpMatrix(FALSE,
							FCFrontSide(0, 0),
							FCFrontSide(m_pHitObj->GetColumnCount(), m_pHitObj->GetLineCount() - 1));
		break;
	case AREA_RULED_SEL_MATRIX_HORZ:	// _xZkqqHx_jAiFjFlNiMhCjApMjBeJjBpAiDhNiDgHiDiKiDgCiDeOiDfIiDeHiDiKiDeBiBeC_xHqqkZx_
		SelectRuledTmpMatrix(TRUE,
							FCFrontSide(m_lcLastSelectedHorzRuled.GetFrontIndex(), m_lcLastSelectedHorzRuled.GetSideIndex()),
							FCFrontSide(m_lHitFrontRuledIndex, m_lHitSideRuledIndex));
		break;
	case AREA_RULED_SEL_MATRIX_VERT:	// _xZkqqHx_jAiCjClMiMhCjApMjBeJjBpAiDhNiDgHiDiKiDgCiDeOiDfIiDeHiDiKiDeBiBeC_xHqqkZx_
		SelectRuledTmpMatrix(FALSE,
							FCFrontSide(m_lcLastSelectedVertRuled.GetFrontIndex(), m_lcLastSelectedVertRuled.GetSideIndex()),
							FCFrontSide(m_lHitFrontRuledIndex, m_lHitSideRuledIndex));
		break;
	}
	// _xZkqqHx_jBeJjBpAiNhDiCpAjFgAiJoGiBeC_xHqqkZx_
	DrawSelectedCell(pDC, m_pSelectedObjTable);

} // FCToolTableEdit::StateRangeSelectCell.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::StateRemoveSelectCell
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_jBeJjBpAiJpAiPjMiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	pDC	:_xZkqqHx_jFgAiJoGjHhAiDgGiDgPiDeDiDfIiDfCiDjDiDgFiDeMiDfIiDgHiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.01.28 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::StateRemoveSelectCell (CDC* pDC)
{
	TRACE(_T("FCToolTableEdit::StateRemoveSelectCell\n"));
	// _xZkqqHx_jBeJjBpAiCpAiDeOiDiKiDeBiBeC_xHqqkZx_
	DrawSelectedCell(pDC, m_pSelectedObjTable);
	switch (m_areaHit)
	{
	case AREA_CELL_SEL_LINE:	// _xZkqqHx_iDfKiDiLiNhDiDeHiDiKiDeBiBeC_xHqqkZx_
	  {
		for (long lColumnIndex = 0;
			 lColumnIndex != m_pSelectedObjTable->GetColumnCount();
			 lColumnIndex++)
		{
			// _xZkqqHx_iDfGiDjDiDePiDiLiDfKiDiLiCmMiPoKiNiHiCmNjBeJjBpAiJpAiPjMiBeC_xHqqkZx_
			if (m_pSelectedObjTable->GetCellBlock(FCLineColumn(m_lHitLineCellIndex, lColumnIndex)) == 1)
				RemoveSelectCell(FCLineColumn(m_lHitLineCellIndex, lColumnIndex));
		}
		break;
	  }
	case AREA_CELL_SEL_COLUMN:	// _xZkqqHx_iDfKiDiLjHpBiDeHiDiKiDeBiBeC_xHqqkZx_
	  {
		for (long lLineIndex = 0;
			 lLineIndex != m_pSelectedObjTable->GetLineCount();
			 lLineIndex++)
		{
			// _xZkqqHx_iDfGiDjDiDePiDiLiDfKiDiLiCmMiPoKiNiHiCmNjBeJjBpAiJpAiPjMiBeC_xHqqkZx_
			if (m_pSelectedObjTable->GetCellBlock(FCLineColumn(lLineIndex, m_lHitColumnCellIndex)) == 1)
				RemoveSelectCell(FCLineColumn(lLineIndex, m_lHitColumnCellIndex));
		}
		break;
	  }
	case AREA_CELL_SEL_ALL:		// _xZkqqHx_jBfDiDfKiDiLiDeHiDiKiDeBiBeC_xHqqkZx_
		ClearSelectCell();
		break;
	case AREA_CELL_SEL_MATRIX:	// _xZkqqHx_iDfKiDiLiDhNiDgHiDiKiDgCiDeOiDfIiDeHiDiKiDeBiBeC_xHqqkZx_
		RemoveSelectCell(FCLineColumn(m_lHitLineCellIndex, m_lHitColumnCellIndex));
		break;

	case AREA_RULED_SEL_HORZ:			// _xZkqqHx_jAiFjFlNiMhCjApMjBeJjBpAiDeHiDiKiDeBiBeC_xHqqkZx_
	  {
		for (long lColumnIndex = 0;
			 lColumnIndex != m_pSelectedObjTable->GetColumnCount();
			 lColumnIndex++)
			RemoveSelectRuled(TRUE, FCFrontSide(m_lHitFrontRuledIndex, lColumnIndex));
		break;
	  }
	case AREA_RULED_SEL_VERT:			// _xZkqqHx_jAiCjClMiMhCjApMjBeJjBpAiDeHiDiKiDeBiBeC_xHqqkZx_
	  {
		for (long lLineIndex = 0;
			 lLineIndex != m_pSelectedObjTable->GetLineCount();
			 lLineIndex++)
			RemoveSelectRuled(FALSE, FCFrontSide(m_lHitFrontRuledIndex, lLineIndex));
		break;
	  }
	case AREA_RULED_SEL_ALL:			// _xZkqqHx_jBfDiMhCjApMiDeHiDiKiDeBiBeC_xHqqkZx_
		ClearSelectRuled(TRUE);
		ClearSelectRuled(FALSE);
		break;
	case AREA_RULED_SEL_MATRIX_HORZ:	// _xZkqqHx_jAiFjFlNiMhCjApMjBeJjBpAiDhNiDgHiDiKiDgCiDeOiDfIiDeHiDiKiDeBiBeC_xHqqkZx_
		RemoveSelectRuled(TRUE, FCFrontSide(m_lHitFrontRuledIndex, m_lHitSideRuledIndex));
		break;
	case AREA_RULED_SEL_MATRIX_VERT:	// _xZkqqHx_jAiCjClMiMhCjApMjBeJjBpAiDhNiDgHiDiKiDgCiDeOiDfIiDeHiDiKiDeBiBeC_xHqqkZx_
		RemoveSelectRuled(FALSE, FCFrontSide(m_lHitFrontRuledIndex, m_lHitSideRuledIndex));
		break;
	}
	// _xZkqqHx_jBeJjBpAiCpAjFgAiJoGiBeC_xHqqkZx_
	DrawSelectedCell(pDC, m_pSelectedObjTable);
} // FCToolTableEdit::StateRemoveSelectCell.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::StateAddSelectCell
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_jCmHiJmBjBeJjBpAiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	pDC	:_xZkqqHx_jFgAiJoGjHhAiDgGiDgPiDeDiDfIiDfCiDjDiDgFiDeMiDfIiDgHiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.01.28 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::StateAddSelectCell (CDC* pDC)
{
	TRACE(_T("FCToolTableEdit::StateAddSelectCell\n"));
	// _xZkqqHx_jBeJjBpAiCpAiDeOiDiKiDeBiBeC_xHqqkZx_
	DrawSelectedCell(pDC, m_pSelectedObjTable);
	// _xZkqqHx_jBeJjBpAjBmOiPnLiCmMjFfMjFjEjFgJiCpAjAnNjCoIiClHiCoJiBeC_xHqqkZx_
	SetSelectedObjTable(m_pHitObj);
	// _xZkqqHx_iDfKiDiLiCmMiIoKiOjOjBeJjBpAiCpAiDeOiDiKiDeBiClHiCoJiBeC_xHqqkZx_
	ClearSelectCellTmp();
	switch (m_areaHit)
	{
	case AREA_CELL_SEL_LINE:	// _xZkqqHx_iDfKiDiLiNhDiDeHiDiKiDeBiBeC_xHqqkZx_
		// _xZkqqHx_iNmFiMoDiCmJjBeJjBpAiClDiCoKiClNiDfKiDiLiCpAiDiKiDfKiDgCiDgHiBeC_xHqqkZx_SelectCellTmpIncluded_xZkqqHx_iCmFjAnNjCoIiClDiClJiCoJiClNiCnPiBeC_xHqqkZx_
		m_lcLastSelectedCell.Set(-1, -1);
		SelectCellTmpIncluded(FCLineColumn(m_lHitLineCellIndex, 0),
							FCLineColumn(m_lHitLineCellIndex, m_pHitObj->GetColumnCount() - 1));
//		m_lcLastSelectedCell.Set(m_lHitLineCellIndex, 0);
		break;
	case AREA_CELL_SEL_COLUMN:	// _xZkqqHx_iDfKiDiLjHpBiDeHiDiKiDeBiBeC_xHqqkZx_
		// _xZkqqHx_iNmFiMoDiCmJjBeJjBpAiClDiCoKiClNiDfKiDiLiCpAiDiKiDfKiDgCiDgHiBeC_xHqqkZx_SelectCellTmpIncluded_xZkqqHx_iCmFjAnNjCoIiClDiClJiCoJiClNiCnPiBeC_xHqqkZx_
		m_lcLastSelectedCell.Set(-1, -1);
		SelectCellTmpIncluded(FCLineColumn(0, m_lHitColumnCellIndex),
							FCLineColumn(m_pSelectedObjTable->GetLineCount() - 1, m_lHitColumnCellIndex));
//		m_lcLastSelectedCell.Set(0, m_lHitColumnCellIndex);
		break;
	case AREA_CELL_SEL_ALL:		// _xZkqqHx_jBfDiDfKiDiLiDeHiDiKiDeBiBeC_xHqqkZx_
		// _xZkqqHx_iNmFiMoDiCmJjBeJjBpAiClDiCoKiClNiDfKiDiLiCpAiDiKiDfKiDgCiDgHiBeC_xHqqkZx_SelectCellTmpMatrix_xZkqqHx_iCmFjAnNjCoIiClDiClJiCoJiClNiCnPiBeC_xHqqkZx_
		m_lcLastSelectedCell.Set(-1, -1);
		SelectCellTmpMatrix(FCLineColumn(0, 0),
							FCLineColumn(m_pHitObj->GetLineCount() - 1, m_pHitObj->GetColumnCount() - 1));
//		m_lcLastSelectedCell.Set(0, 0);
		break;
	case AREA_CELL_SEL_MATRIX:	// _xZkqqHx_iDfKiDiLiDhNiDgHiDiKiDgCiDeOiDfIiDeHiDiKiDeBiBeC_xHqqkZx_
		// _xZkqqHx_iNmFiMoDiCmJjBeJjBpAiClDiCoKiClNiDfKiDiLiCpAiDiKiDfKiDgCiDgHiBeC_xHqqkZx_SelectCellTmpMatrix_xZkqqHx_iCmFjAnNjCoIiClDiClJiCoJiClNiCnPiBeC_xHqqkZx_
		m_lcLastSelectedCell.Set(-1, -1);
		SelectCellTmpMatrix(FCLineColumn(m_lHitLineCellIndex, m_lHitColumnCellIndex),
							FCLineColumn(m_lHitLineCellIndex, m_lHitColumnCellIndex));
//		m_lcLastSelectedCell.Set(m_lHitLineCellIndex, m_lHitColumnCellIndex);
		break;

	case AREA_RULED_SEL_HORZ:	// _xZkqqHx_jAiFjFlNiMhCjApMjBeJjBpAiDeHiDiKiDeBiBeC_xHqqkZx_
		// _xZkqqHx_iNmFiMoDiCmJjBeJjBpAiClDiCoKiClNjAiFjFlNiMhCjApMiCpAiDiKiDfKiDgCiDgHiBeC_xHqqkZx_SelectRuledTmpMatrix_xZkqqHx_iCmFjAnNjCoIiClDiClJiCoJiClNiCnPiBeC_xHqqkZx_
		m_lcLastSelectedHorzRuled.Set(-1, -1);
		SelectRuledTmpMatrix(TRUE,
							FCFrontSide(m_lHitFrontRuledIndex, 0),
							FCFrontSide(m_lHitFrontRuledIndex, m_pSelectedObjTable->GetColumnCount() - 1));
//----- 05.02.10 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
//		// _xZkqqHx_iNmFiMoDiCmJjBeJjBpAiClDiCoKiClNjAiCjClMiMhCjApMiBeC_xHqqkZx_
//		m_lcLastSelectedHorzRuled.Set(m_lHitFrontRuledIndex, 0);
//----- 05.02.10 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----
		break;
	case AREA_RULED_SEL_VERT:	// _xZkqqHx_jAiCjClMiMhCjApMjBeJjBpAiDeHiDiKiDeBiBeC_xHqqkZx_
		// _xZkqqHx_iNmFiMoDiCmJjBeJjBpAiClDiCoKiClNjAiCjClMiMhCjApMiCpAiDiKiDfKiDgCiDgHiBeC_xHqqkZx_SelectRuledTmpMatrix_xZkqqHx_iCmFjAnNjCoIiClDiClJiCoJiClNiCnPiBeC_xHqqkZx_
		m_lcLastSelectedVertRuled.Set(-1, -1);
		SelectRuledTmpMatrix(FALSE,
							FCFrontSide(m_lHitFrontRuledIndex, 0),
							FCFrontSide(m_lHitFrontRuledIndex, m_pSelectedObjTable->GetLineCount() - 1));
//----- 05.02.10 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
//		// _xZkqqHx_iNmFiMoDiCmJjBeJjBpAiClDiCoKiClNjAiCjClMiMhCjApMiBeC_xHqqkZx_
//		m_lcLastSelectedVertRuled.Set(m_lHitFrontRuledIndex, 0);
//----- 05.02.10 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----
		break;
	case AREA_RULED_SEL_ALL:		// _xZkqqHx_jBfDiMhCjApMiDeHiDiKiDeBiBeC_xHqqkZx_
		// _xZkqqHx_iNmFiMoDiCmJjBeJjBpAiClDiCoKiClNjAiFjFlNiMhCjApMiCpAiDiKiDfKiDgCiDgHiBeC_xHqqkZx_SelectRuledTmpMatrix_xZkqqHx_iCmFjAnNjCoIiClDiClJiCoJiClNiCnPiBeC_xHqqkZx_
		m_lcLastSelectedHorzRuled.Set(-1, -1);
		SelectRuledTmpMatrix(TRUE,
							FCFrontSide(0, 0),
							FCFrontSide(m_pHitObj->GetLineCount(), m_pHitObj->GetColumnCount() - 1));
		// _xZkqqHx_iNmFiMoDiCmJjBeJjBpAiClDiCoKiClNjAiCjClMiMhCjApMiCpAiDiKiDfKiDgCiDgHiBeC_xHqqkZx_SelectRuledTmpMatrix_xZkqqHx_iCmFjAnNjCoIiClDiClJiCoJiClNiCnPiBeC_xHqqkZx_
		m_lcLastSelectedVertRuled.Set(-1, -1);
		SelectRuledTmpMatrix(FALSE,
							FCFrontSide(0, 0),
							FCFrontSide(m_pHitObj->GetColumnCount(), m_pHitObj->GetLineCount() - 1));
//----- 05.02.10 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
//		// _xZkqqHx_iNmFiMoDiCmJjBeJjBpAiClDiCoKiClNjAiFjFlNiMhCjApMiBeC_xHqqkZx_
//		m_lcLastSelectedHorzRuled.Set(0, 0);
//		// _xZkqqHx_iNmFiMoDiCmJjBeJjBpAiClDiCoKiClNjAiCjClMiMhCjApMiBeC_xHqqkZx_
//		m_lcLastSelectedVertRuled.Set(0, 0);
//----- 05.02.10 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----
		break;
	case AREA_RULED_SEL_MATRIX_HORZ:	// _xZkqqHx_jAiFjFlNiMhCjApMjBeJjBpAiDhNiDgHiDiKiDgCiDeOiDfIiDeHiDiKiDeBiBeC_xHqqkZx_
		// _xZkqqHx_iNmFiMoDiCmJjBeJjBpAiClDiCoKiClNjAiFjFlNiMhCjApMiCpAiDiKiDfKiDgCiDgHiBeC_xHqqkZx_SelectRuledTmpMatrix_xZkqqHx_iCmFjAnNjCoIiClDiClJiCoJiClNiCnPiBeC_xHqqkZx_
		m_lcLastSelectedHorzRuled.Set(-1, -1);
		SelectRuledTmpMatrix(TRUE,
							FCFrontSide(m_lHitFrontRuledIndex, m_lHitSideRuledIndex),
							FCFrontSide(m_lHitFrontRuledIndex, m_lHitSideRuledIndex));
//----- 05.02.10 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
//		// _xZkqqHx_iNmFiMoDiCmJjBeJjBpAiClDiCoKiClNjAiFjFlNiMhCjApMiBeC_xHqqkZx_
//		m_lcLastSelectedHorzRuled.Set(m_lHitFrontRuledIndex, m_lHitSideRuledIndex);
//----- 05.02.10 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----
		break;
	case AREA_RULED_SEL_MATRIX_VERT:	// _xZkqqHx_jAiCjClMiMhCjApMjBeJjBpAiDhNiDgHiDiKiDgCiDeOiDfIiDeHiDiKiDeBiBeC_xHqqkZx_
		// _xZkqqHx_iNmFiMoDiCmJjBeJjBpAiClDiCoKiClNjAiCjClMiMhCjApMiCpAiDiKiDfKiDgCiDgHiBeC_xHqqkZx_SelectRuledTmpMatrix_xZkqqHx_iCmFjAnNjCoIiClDiClJiCoJiClNiCnPiBeC_xHqqkZx_
		m_lcLastSelectedVertRuled.Set(-1, -1);
		SelectRuledTmpMatrix(FALSE,
							FCFrontSide(m_lHitFrontRuledIndex, m_lHitSideRuledIndex),
							FCFrontSide(m_lHitFrontRuledIndex, m_lHitSideRuledIndex));
//----- 05.02.10 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
//		// _xZkqqHx_iNmFiMoDiCmJjBeJjBpAiClDiCoKiClNjAiCjClMiMhCjApMiBeC_xHqqkZx_
//		m_lcLastSelectedVertRuled.Set(m_lHitFrontRuledIndex, m_lHitSideRuledIndex);
//----- 05.02.10 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----
		break;
	}
	// _xZkqqHx_jBeJjBpAiCpAjFgAiJoGiBeC_xHqqkZx_
	DrawSelectedCell(pDC, m_pSelectedObjTable);
} // FCToolTableEdit::StateAddSelectCell.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::StateExitSelectCell
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_jBeJjBpAiPgPiMpLiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	pDC	:_xZkqqHx_jFgAiJoGjHhAiDgGiDgPiDeDiDfIiDfCiDjDiDgFiDeMiDfIiDgHiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.01.29 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::StateExitSelectCell (CDC* pDC)
{
	TRACE(_T("FCToolTableEdit::StateExitSelectCell\n"));
	// _xZkqqHx_iDhNiDeFiDfIiCmMjFnPiKgMiCpAiJpAiPjMiBeC_xHqqkZx_
	::FFReleaseCapture();
	AppendSelectCell(m_stSelectedCellTmp);
	// _xZkqqHx_iDfKiDiLiCmMiIoKiOjOjBeJjBpAiCpAiDeOiDiKiDeBiClHiCoJiBeC_xHqqkZx_
	ClearSelectCellTmp();

	AppendSelectRuled(TRUE, m_stSelectedHorzRuledTmp);
	ClearRuledTmp(TRUE);

	AppendSelectRuled(FALSE, m_stSelectedVertRuledTmp);
	ClearRuledTmp(FALSE);
} // FCToolTableEdit::StateExitSelectCell.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::StateClearSelectCell
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_jBeJjBpAjBfDiJpAiPjMiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	pDC	:_xZkqqHx_jFgAiJoGjHhAiDgGiDgPiDeDiDfIiDfCiDjDiDgFiDeMiDfIiDgHiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.01.29 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::StateClearSelectCell (CDC* pDC)
{
	TRACE(_T("FCToolTableEdit::StateClearSelectCell\n"));
	// _xZkqqHx_jBeJjBpAiNhDiCpAiDeOiDiKiDeBiBeC_xHqqkZx_
	DrawSelectedCell(pDC, m_pSelectedObjTable);
	// _xZkqqHx_jBeJjBpAiClDiCoKiClNiDfKiDiLiCpAiDeOiDiKiDeBiClHiCoJiBeC_xHqqkZx_m_pSelectedObjTable_xZkqqHx_iBeB_xHqqkZx_m_lcLastSelectedCell _xZkqqHx_iCmN_xHqqkZx_
	// _xZkqqHx_iMoDiCmFjHjIjHhAiClHiCoJiClNiCnPiBeBiPmBiLiOiClFiCmIiCkCiBeC_xHqqkZx_
	ClearSelectCell();

	// _xZkqqHx_jBeJjBpAiClDiCoKiClNjAiFjFlNiMhCjApMiBeC_xHqqkZx_
	ClearSelectRuled(TRUE);
	// _xZkqqHx_jBeJjBpAiClDiCoKiClNjAiCjClMiMhCjApMiBeC_xHqqkZx_
	ClearSelectRuled(FALSE);
} // FCToolTableEdit::StateClearSelectCell.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::StateMemoryHitInfo
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDhBiDgCiDgHiPoOjFpBiLeMiJkPiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	pDC	:_xZkqqHx_jFgAiJoGjHhAiDgGiDgPiDeDiDfIiDfCiDjDiDgFiDeMiDfIiDgHiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.02.01 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::StateMemoryHitInfo (CDC* pDC)
{
	TRACE(_T("FCToolTableEdit::StateMemoryHitInfo\n"));
	// AREA_SELECTING _xZkqqHx_iCmJjEpFiCkGiCmEjFmPjAjEiCpAiDgPiDgCiDeOiDeBiDgCiDhGiBeC_xHqqkZx_
	m_pPrevHitObj = m_pHitObj;
	m_areaPrevHit = m_areaHit;
	m_lPrevHitLineCellIndex = m_lHitLineCellIndex;		// _xZkqqHx_jBePiJpBiDhBiDgCiDgHiClFiClNiNhDiBeC_xHqqkZx_
	m_lPrevHitColumnCellIndex = m_lHitColumnCellIndex;	// _xZkqqHx_jBePiJpBiDhBiDgCiDgHiClFiClNjHpBiBeC_xHqqkZx_

	m_lPrevHitFrontRuledIndex = m_lHitFrontRuledIndex;	// _xZkqqHx_jBePiJpBiDhBiDgCiDgHiClFiClNiMhCjApMiCmMiOlCjFpLiMpMiDeDiDjDiDgGiDgCiDeOiDfIiBeC_xHqqkZx_
	m_lPrevHitSideRuledIndex = m_lHitSideRuledIndex;	// _xZkqqHx_jBePiJpBiDhBiDgCiDgHiClFiClNiMhCjApMiCmMiOlCjAiCjApMjFpLiMpMiDeDiDjDiDgGiDgCiDeOiDfIiBeC_xHqqkZx_

} // FCToolTableEdit::StateMemoryHitInfo.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::StateAreaSelecting
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDeHiDiKiDeBjBeJjBpAjCiGiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	pDC	:_xZkqqHx_jFgAiJoGjHhAiDgGiDgPiDeDiDfIiDfCiDjDiDgFiDeMiDfIiDgHiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.01.30 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::StateAreaSelecting (CDC* pDC)
{
	TRACE(_T("FCToolTableEdit::StateAreaSelecting\n"));
	if (m_pHitObj == m_pPrevHitObj &&
		m_areaPrevHit == m_areaHit)
		FFGetMainWnd()->SetCurCursor(g_pView, FFGetApp()->LoadCursor(IDC_CURSOR_CROSS));
	else
		FFGetMainWnd()->SetCurCursor(g_pView, GetDefaultIdleCursor());
} // FCToolTableEdit::StateAreaSelecting.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::GetSubMenuIndex
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	FCToolTableEdit::StateContextMenu _xZkqqHx_iCmFjFfMiOkGiClHiCoJiDfEiDhFiDiBiDgKiDiFiBfLiCmM_xHqqkZx_
 *			_xZkqqHx_iDeDiDjDiDgGiDgCiDeOiDfIiCpAjFnEiClHiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.01.30 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
int FCToolTableEdit::GetSubMenuIndex () const
{
	return FD_MENU_TOOL_TABLE_EDIT;
} // FCToolTableEdit::GetSubMenuIndex.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::ResetEditHandleList
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_jFnCiPfHiDgOiDjDiDgIiDiLiDiKiDfIiDgHiCpAiNmEjAnNjCoIiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.06.03 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolTableEdit::ResetEditHandleList ()
{
	// _xZkqqHx_jFnCiPfHjApMiCpAiImIiJlKiCmJiOkGiClHiBeC_xHqqkZx_
	//
	//                 _xZkqqHx_iEkMiEkKiEkKiEkN_xHqqkZx_          _xZkqqHx_iEkMiEkKiEkN_xHqqkZx_        _xZkqqHx_iEkMiEkKiEkN_xHqqkZx_          _xZkqqHx_iEkMiEkKiEkN_xHqqkZx_          _xZkqqHx_iEkMiEkKiEkKiEkN_xHqqkZx_
	//                 _xZkqqHx_iEkL_xHqqkZx_    _xZkqqHx_iEkL_xHqqkZx_          _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_        _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_          _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_          _xZkqqHx_iEkL_xHqqkZx_    _xZkqqHx_iEkL_xHqqkZx_
	//                 _xZkqqHx_iEkL_xHqqkZx_    _xZkqqHx_iEkL_xHqqkZx_          _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_        _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_          _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_          _xZkqqHx_iEkL_xHqqkZx_    _xZkqqHx_iEkL_xHqqkZx_
	//                 _xZkqqHx_iEkPiEkKiEkKiEkO_xHqqkZx_          _xZkqqHx_iEkPiElBiEkO_xHqqkZx_        _xZkqqHx_iEkPiElBiEkO_xHqqkZx_          _xZkqqHx_iEkPiElBiEkO_xHqqkZx_          _xZkqqHx_iEkPiEkKiEkKiEkO_xHqqkZx_
	//                         _xZkqqHx_iEkMiEkKiEkKiEkKiEkN_xHqqkZx_  _xZkqqHx_iElAiEkKiEkKiEkKiEkKiEkKiEkKiElEiEkKiEkKiEkKiEkKiEkKiEkKiEkKiElC_xHqqkZx_  _xZkqqHx_iEkMiEkKiEkKiEkKiEkN_xHqqkZx_  
	//                         _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_            _xZkqqHx_iEkL_xHqqkZx_              _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  
	//                         _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_            _xZkqqHx_iEkL_xHqqkZx_              _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  
	//                         _xZkqqHx_iEkPiEkKiEkKiEkKiEkO_xHqqkZx_  _xZkqqHx_iEkPiEkKiEkKiEkKiEkKiEkKiEkKiElDiEkKiEkKiEkKiEkKiEkKiEkKiEkKiEkO_xHqqkZx_  _xZkqqHx_iEkPiEkKiEkKiEkKiEkO_xHqqkZx_  
	//                 _xZkqqHx_iEkMiEkKiEkKiEkN_xHqqkZx_                                                        _xZkqqHx_iEkMiEkKiEkKiEkN_xHqqkZx_
	//                 _xZkqqHx_iEkL_xHqqkZx_    _xZkqqHx_iElAiElBiEkKiEkKiEkKiEkN_xHqqkZx_  _xZkqqHx_iEkMiEkKiEkKiEkKiEkKiEkKiEkKiElBiEkKiEkKiEkKiEkKiEkKiEkKiEkKiEkN_xHqqkZx_  _xZkqqHx_iEkMiEkKiEkKiEkKiElBiElC_xHqqkZx_    _xZkqqHx_iEkL_xHqqkZx_
	//                 _xZkqqHx_iEkPiEkKiEkKiEkOiEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_            _xZkqqHx_iEkL_xHqqkZx_              _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkLiEkPiEkKiEkKiEkO_xHqqkZx_
	//                         _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_            _xZkqqHx_iEkL_xHqqkZx_              _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  
	//                 _xZkqqHx_iEkMiEkKiEkKiEkNiEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_            _xZkqqHx_iEkL_xHqqkZx_              _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkLiEkMiEkKiEkKiEkN_xHqqkZx_
	//                 _xZkqqHx_iEkL_xHqqkZx_    _xZkqqHx_iElAiElEiEkKiEkKiEkKiElC_xHqqkZx_  _xZkqqHx_iElAiEkKiEkKiEkKiEkKiEkKiEkKiElEiEkKiEkKiEkKiEkKiEkKiEkKiEkKiElC_xHqqkZx_  _xZkqqHx_iElAiEkKiEkKiEkKiElEiElC_xHqqkZx_    _xZkqqHx_iEkL_xHqqkZx_
	//                 _xZkqqHx_iEkPiEkKiEkKiEkOiEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_            _xZkqqHx_iEkL_xHqqkZx_              _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkLiEkPiEkKiEkKiEkO_xHqqkZx_
	//                         _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_            _xZkqqHx_iEkL_xHqqkZx_              _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  
	//                         _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_            _xZkqqHx_iEkL_xHqqkZx_              _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  
	//                 _xZkqqHx_iEkMiEkKiEkKiEkNiEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_            _xZkqqHx_iEkL_xHqqkZx_              _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkLiEkMiEkKiEkKiEkN_xHqqkZx_
	//                 _xZkqqHx_iEkL_xHqqkZx_    _xZkqqHx_iElAiElEiEkKiEkKiEkKiElC_xHqqkZx_  _xZkqqHx_iElAiEkKiEkKiEkKiEkKiEkKiEkKiElEiEkKiEkKiEkKiEkKiEkKiEkKiEkKiElC_xHqqkZx_  _xZkqqHx_iElAiEkKiEkKiEkKiElEiElC_xHqqkZx_    _xZkqqHx_iEkL_xHqqkZx_
	//                 _xZkqqHx_iEkPiEkKiEkKiEkOiEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_            _xZkqqHx_iEkL_xHqqkZx_              _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkLiEkPiEkKiEkKiEkO_xHqqkZx_
	//      EditRuledHandle  _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_            _xZkqqHx_iEkL_xHqqkZx_              _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  
	//             _xZkqqHx_iBkL_xHqqkZx_          _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_            _xZkqqHx_iEkL_xHqqkZx_              _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  
	//             _xZkqqHx_iEkJiEjPiEkMiEkKiEkKiEkNiEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_            _xZkqqHx_iEkL_xHqqkZx_              _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkLiEkMiEkKiEkKiEkN_xHqqkZx_
	//             _xZkqqHx_iEkJiEjPiEkL_xHqqkZx_    _xZkqqHx_iElAiElDiEkKiEkKiEkKiEkO_xHqqkZx_  _xZkqqHx_iEkPiEkKiEkKiEkKiEkKiEkKiEkKiElDiEkKiEkKiEkKiEkKiEkKiEkKiEkKiEkO_xHqqkZx_  _xZkqqHx_iEkPiEkKiEkKiEkKiElDiElC_xHqqkZx_    _xZkqqHx_iEkL_xHqqkZx_
	//             _xZkqqHx_iBkK_xHqqkZx_  _xZkqqHx_iEkPiEkKiEkKiEkOiEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_                                _xZkqqHx_iBkK_xHqqkZx_        _xZkqqHx_iEkPiEkKiEkKiEkO_xHqqkZx_
	//                 _xZkqqHx_iEkA_xHqqkZx_    _xZkqqHx_iEkAiEkA_xHqqkZx_    _xZkqqHx_iBkIiEkJiEjPiEkJiBkJ_xHqqkZx_                            _xZkqqHx_iDfKiDiLjFnCiPfHjApM_xHqqkZx_
	//                 _xZkqqHx_iEkA_xHqqkZx_    _xZkqqHx_iEkAiEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iEkA_xHqqkZx_EditCellGap
	//                 _xZkqqHx_iEkA_xHqqkZx_    _xZkqqHx_iEkAiEkA_xHqqkZx_          _xZkqqHx_iEkA_xHqqkZx_
	//                 _xZkqqHx_iEkA_xHqqkZx_    _xZkqqHx_iEkAiEkJiBkJiEjPiEjPiEjPiBkIiEkJiEjP_xHqqkZx_
	//                 _xZkqqHx_iEkA_xHqqkZx_    _xZkqqHx_iEkA_xHqqkZx_            _xZkqqHx_iEkA_xHqqkZx_EditCellLength
	//                 _xZkqqHx_iEkA_xHqqkZx_    _xZkqqHx_iEkA_xHqqkZx_            _xZkqqHx_iEkA_xHqqkZx_
	//                 _xZkqqHx_iEkA_xHqqkZx_    _xZkqqHx_iEkFiBkJiEjPiEjPiEjPiEjPiBkIiEkH_xHqqkZx_
	//                 _xZkqqHx_iEkA_xHqqkZx_      EditRuledGap_xZkqqHx_iEkA_xHqqkZx_
	//                 _xZkqqHx_iEkFiBkJiEjPiEjPiEjPiEjPiEjPiEjPiEjPiBkIiEkH_xHqqkZx_
	//                    EditRuledLength
	//
	//
	//                       _xZkqqHx_iEkMiEkKiEkN_xHqqkZx_      _xZkqqHx_iEkMiEkKiEkN_xHqqkZx_          _xZkqqHx_iEkMiEkKiEkN_xHqqkZx_                  _xZkqqHx_iEjPiEjP_xHqqkZx_ A_TOP0
	//         _xZkqqHx_iBfOiEkL_xHqqkZx_          _xZkqqHx_iEkL_xHqqkZx_Cv_xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_Cv_xZkqqHx_iEkL_xHqqkZx_          _xZkqqHx_iEkL_xHqqkZx_Cv_xZkqqHx_iEkL_xHqqkZx_          _xZkqqHx_iEkLiBfP_xHqqkZx_    
	//       _xZkqqHx_iBfO_xHqqkZx_A0_xZkqqHx_iEkL_xHqqkZx_          _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_          _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_          _xZkqqHx_iEkL_xHqqkZx_A1_xZkqqHx_iBfP_xHqqkZx_  
	//       _xZkqqHx_iEkKiEkKiEkO_xHqqkZx_          _xZkqqHx_iEkPiElBiEkO_xHqqkZx_      _xZkqqHx_iEkPiElBiEkO_xHqqkZx_          _xZkqqHx_iEkPiElBiEkO_xHqqkZx_          _xZkqqHx_iEkPiEkKiEkK_xHqqkZx_  _xZkqqHx_iEjPiEjP_xHqqkZx_ A_TOP1
	//             _xZkqqHx_iEkMiEkKiEkKiEkKiEkN_xHqqkZx_  _xZkqqHx_iElAiEkKiEkKiEkKiEkKiEkKiElEiEkKiEkKiEkKiEkKiEkKiEkKiEkKiElC_xHqqkZx_  _xZkqqHx_iEkMiEkKiEkKiEkKiEkN_xHqqkZx_        _xZkqqHx_iEjPiEjP_xHqqkZx_ B_TOP0
	//             _xZkqqHx_iEkL_xHqqkZx_  B0  _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_     Ev   Dv      Ev      Dv  _xZkqqHx_iEkL_xHqqkZx_  B1  _xZkqqHx_iEkL_xHqqkZx_        
	//             _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_          _xZkqqHx_iEkL_xHqqkZx_              _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_        
	//             _xZkqqHx_iEkPiEkKiEkKiEkKiEkO_xHqqkZx_  _xZkqqHx_iEkPiEkKiEkKiEkKiEkKiEkKiElDiEkKiEkKiEkKiEkKiEkKiEkKiEkKiEkO_xHqqkZx_  _xZkqqHx_iEkPiEkKiEkKiEkKiEkO_xHqqkZx_        _xZkqqHx_iEjPiEjP_xHqqkZx_ B_TOP1
	//     _xZkqqHx_iEkMiEkKiEkKiEkN_xHqqkZx_                                                      _xZkqqHx_iEkMiEkKiEkKiEkN_xHqqkZx_
	//     _xZkqqHx_iEkL_xHqqkZx_ Ch _xZkqqHx_iElAiElBiEkKiEkKiEkKiEkN_xHqqkZx_  _xZkqqHx_iEkMiEkKiEkK_xHqqkZx_Fh_xZkqqHx_iEkKiEkKiElBiEkKiEkKiEkK_xHqqkZx_Fh_xZkqqHx_iEkKiEkKiEkKiEkN_xHqqkZx_  _xZkqqHx_iEkMiEkKiEkKiEkKiElBiElC_xHqqkZx_ Ch _xZkqqHx_iEkL_xHqqkZx_
	//     _xZkqqHx_iEkPiEkKiEkKiEkOiEkL_xHqqkZx_  Eh  _xZkqqHx_iEkL_xHqqkZx_  Fv    G     Fv      G       Fv  _xZkqqHx_iEkL_xHqqkZx_  Eh  _xZkqqHx_iEkLiEkPiEkKiEkKiEkO_xHqqkZx_
	//     _xZkqqHx_iEkMiEkKiEkKiEkNiEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_          _xZkqqHx_iEkL_xHqqkZx_              _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkLiEkMiEkKiEkKiEkN_xHqqkZx_
	//     _xZkqqHx_iEkL_xHqqkZx_ Ch _xZkqqHx_iElAiElEiEkK_xHqqkZx_Dh_xZkqqHx_iEkKiElC_xHqqkZx_  _xZkqqHx_iElAiEkKiEkK_xHqqkZx_Fh_xZkqqHx_iEkKiEkKiElEiEkKiEkKiEkK_xHqqkZx_Fh_xZkqqHx_iEkKiEkKiEkKiElC_xHqqkZx_  _xZkqqHx_iElAiEkK_xHqqkZx_Dh_xZkqqHx_iEkKiElEiElC_xHqqkZx_ Ch _xZkqqHx_iEkL_xHqqkZx_
	//     _xZkqqHx_iEkPiEkKiEkKiEkOiEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_          _xZkqqHx_iEkL_xHqqkZx_              _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkLiEkPiEkKiEkKiEkO_xHqqkZx_
	//             _xZkqqHx_iEkL_xHqqkZx_  Eh  _xZkqqHx_iEkL_xHqqkZx_  Fv    G     Fv      G       Fv  _xZkqqHx_iEkL_xHqqkZx_  Eh  _xZkqqHx_iEkL_xHqqkZx_        
	//     _xZkqqHx_iEkMiEkKiEkKiEkNiEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_          _xZkqqHx_iEkL_xHqqkZx_              _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkLiEkMiEkKiEkKiEkN_xHqqkZx_
	//     _xZkqqHx_iEkL_xHqqkZx_ Ch _xZkqqHx_iElAiElEiEkK_xHqqkZx_Dh_xZkqqHx_iEkKiElC_xHqqkZx_  _xZkqqHx_iElAiEkKiEkK_xHqqkZx_Fh_xZkqqHx_iEkKiEkKiElEiEkKiEkKiEkK_xHqqkZx_Fh_xZkqqHx_iEkKiEkKiEkKiElC_xHqqkZx_  _xZkqqHx_iElAiEkK_xHqqkZx_Dh_xZkqqHx_iEkKiElEiElC_xHqqkZx_ Ch _xZkqqHx_iEkL_xHqqkZx_
	//     _xZkqqHx_iEkPiEkKiEkKiEkOiEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_          _xZkqqHx_iEkL_xHqqkZx_              _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkLiEkPiEkKiEkKiEkO_xHqqkZx_
	//             _xZkqqHx_iEkL_xHqqkZx_  Eh  _xZkqqHx_iEkL_xHqqkZx_  Fv    G     Fv      G       Fv  _xZkqqHx_iEkL_xHqqkZx_  Eh  _xZkqqHx_iEkL_xHqqkZx_        
	//             _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_          _xZkqqHx_iEkL_xHqqkZx_              _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_        
	//     _xZkqqHx_iEkMiEkKiEkKiEkNiEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_          _xZkqqHx_iEkL_xHqqkZx_              _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkLiEkMiEkKiEkKiEkN_xHqqkZx_
	//     _xZkqqHx_iEkL_xHqqkZx_ Ch _xZkqqHx_iElAiElDiEkK_xHqqkZx_Dh_xZkqqHx_iEkKiEkO_xHqqkZx_  _xZkqqHx_iEkPiEkKiEkK_xHqqkZx_Fh_xZkqqHx_iEkKiEkKiElDiEkKiEkKiEkK_xHqqkZx_Fh_xZkqqHx_iEkKiEkKiEkKiEkO_xHqqkZx_  _xZkqqHx_iEkPiEkK_xHqqkZx_Dh_xZkqqHx_iEkKiElDiElC_xHqqkZx_ Ch _xZkqqHx_iEkL_xHqqkZx_
	//     _xZkqqHx_iEkPiEkKiEkKiEkO_xHqqkZx_                                                      _xZkqqHx_iEkPiEkKiEkKiEkO_xHqqkZx_
	//             _xZkqqHx_iEkMiEkKiEkKiEkKiEkN_xHqqkZx_  _xZkqqHx_iEkMiEkKiEkKiEkKiEkKiEkKiElBiEkKiEkKiEkKiEkKiEkKiEkKiEkKiEkN_xHqqkZx_  _xZkqqHx_iEkMiEkKiEkKiEkKiEkN_xHqqkZx_        _xZkqqHx_iEjPiEjP_xHqqkZx_ B_BTM0
	//             _xZkqqHx_iEkL_xHqqkZx_  B3  _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_     Ev   Dv      Ev      Dv  _xZkqqHx_iEkL_xHqqkZx_  B2  _xZkqqHx_iEkL_xHqqkZx_        
	//             _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_          _xZkqqHx_iEkL_xHqqkZx_              _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_        
	//             _xZkqqHx_iEkPiEkKiEkKiEkKiEkO_xHqqkZx_  _xZkqqHx_iElAiEkKiEkKiEkKiEkKiEkKiElEiEkKiEkKiEkKiEkKiEkKiEkKiEkKiElC_xHqqkZx_  _xZkqqHx_iEkPiEkKiEkKiEkKiEkO_xHqqkZx_        _xZkqqHx_iEjPiEjP_xHqqkZx_ B_BTM1
	//       _xZkqqHx_iEkKiEkKiEkN_xHqqkZx_          _xZkqqHx_iEkMiElDiEkN_xHqqkZx_      _xZkqqHx_iEkMiElDiEkN_xHqqkZx_          _xZkqqHx_iEkMiElDiEkN_xHqqkZx_          _xZkqqHx_iEkMiEkKiEkK_xHqqkZx_  _xZkqqHx_iEjPiEjP_xHqqkZx_ A_BTM0
	//       _xZkqqHx_iBfP_xHqqkZx_A3_xZkqqHx_iEkL_xHqqkZx_          _xZkqqHx_iEkL_xHqqkZx_Cv_xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_Cv_xZkqqHx_iEkL_xHqqkZx_          _xZkqqHx_iEkL_xHqqkZx_Cv_xZkqqHx_iEkL_xHqqkZx_          _xZkqqHx_iEkL_xHqqkZx_A2_xZkqqHx_iBfO_xHqqkZx_  
	//     _xZkqqHx_iEkA_xHqqkZx_  _xZkqqHx_iBfPiEkL_xHqqkZx_          _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_      _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_          _xZkqqHx_iEkL_xHqqkZx_  _xZkqqHx_iEkL_xHqqkZx_          _xZkqqHx_iEkLiBfO_xHqqkZx_    
	//     _xZkqqHx_iEkA_xHqqkZx_                _xZkqqHx_iEkPiEkKiEkO_xHqqkZx_      _xZkqqHx_iEkPiEkKiEkO_xHqqkZx_          _xZkqqHx_iEkPiEkKiEkO_xHqqkZx_                  _xZkqqHx_iEjPiEjP_xHqqkZx_ A_BTM1
	//     _xZkqqHx_iEkA_xHqqkZx_    _xZkqqHx_iEkAiEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_                                  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkAiEkA_xHqqkZx_    _xZkqqHx_iEkA_xHqqkZx_
	//     _xZkqqHx_iEkA_xHqqkZx_    _xZkqqHx_iEkAiEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_                                  _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkAiEkA_xHqqkZx_    _xZkqqHx_iEkA_xHqqkZx_
	//   A_LFT0 A_LFT1     _xZkqqHx_iEkA_xHqqkZx_                                B_RIT0   B_RIT1   _xZkqqHx_iEkA_xHqqkZx_
	//             _xZkqqHx_iEkA_xHqqkZx_      _xZkqqHx_iEkA_xHqqkZx_                                            _xZkqqHx_iEkA_xHqqkZx_    _xZkqqHx_iEkA_xHqqkZx_
	//           B_LFT0  B_LFT1                                        A_RIT0 A_RIT1
	//
	//
	//     _xZkqqHx_iCgAiBeGiMhCjApMjBeJjBpAjHmMiIoG_xHqqkZx_
	//     _xZkqqHx_iCgBiBeGiDfKiDiLjBeJjBpAjHmMiIoG_xHqqkZx_
	//     _xZkqqHx_iCgCiBeGiMhCjApMjBeJjBpAjHmMiIoG_xHqqkZx_
	//     _xZkqqHx_iCgDiBeGiMhCjApMiInKjDkOjHmMiIoG_xHqqkZx_
	//     _xZkqqHx_iCgEiBeGiMhCjApMjBeJjBpAjHmMiIoG_xHqqkZx_
	//

	// _xZkqqHx_jFnCiPfHiDgOiDjDiDgIiDiLiDiKiDfIiDgHiCpAiDeOiDiKiDeBiBeC_xHqqkZx_
	ClearEditHandleList();

	const mmetol mmEditRuledHandle= lg2mm(FD_RULED_HANDLE);
	ObjDynabaseVector::const_iterator iObj;
	for (iObj = g_pView->SelectObjVector().begin();
		 iObj != g_pView->SelectObjVector().end(); iObj++)
	{
		FCObjTable* pObjTable = (FCObjTable*)*iObj;
		DBLRect mmrtFrame = pObjTable->GetResizeFrame();

		//----- _xZkqqHx_jBfDiMhCjApMjBeJjBpAjHmMiIoG_xHqqkZx_(A)_xZkqqHx_iCmMjDgPjIfO_xHqqkZx_ -----

		// _xZkqqHx_iLoJiMgA_xHqqkZx_A0_xZkqqHx_iCpAjDgPjIfOiBeC_xHqqkZx_ID=(_xZkqqHx_jFjEjFgJ_xHqqkZx_ID, AREA_RULED_SEL_ALL, -1, -1)_xZkqqHx_iBeC_xHqqkZx_
		AddEditHandle(	DBLRect(MM_A_LFT0(mmrtFrame), MM_A_TOP0(mmrtFrame), MM_A_LFT1(mmrtFrame), MM_A_TOP1(mmrtFrame)),
						FCHandleId(long(pObjTable->GetObjID()), AREA_RULED_SEL_ALL, -1, -1));

		// _xZkqqHx_iLoJiMgA_xHqqkZx_A1_xZkqqHx_iCpAjDgPjIfOiBeC_xHqqkZx_ID=(_xZkqqHx_jFjEjFgJ_xHqqkZx_ID, AREA_RULED_SEL_ALL, -1, -1)_xZkqqHx_iBeC_xHqqkZx_
		AddEditHandle(	DBLRect(MM_A_RIT0(mmrtFrame), MM_A_TOP0(mmrtFrame), MM_A_RIT1(mmrtFrame), MM_A_TOP1(mmrtFrame)),
						FCHandleId(long(pObjTable->GetObjID()), AREA_RULED_SEL_ALL, -1, -1));

		// _xZkqqHx_iLoJiMgA_xHqqkZx_A2_xZkqqHx_iCpAjDgPjIfOiBeC_xHqqkZx_ID=(_xZkqqHx_jFjEjFgJ_xHqqkZx_ID, AREA_RULED_SEL_ALL, -1, -1)_xZkqqHx_iBeC_xHqqkZx_
		AddEditHandle(	DBLRect(MM_A_RIT0(mmrtFrame), MM_A_BTM0(mmrtFrame), MM_A_RIT1(mmrtFrame), MM_A_BTM1(mmrtFrame)),
						FCHandleId(long(pObjTable->GetObjID()), AREA_RULED_SEL_ALL, -1, -1));

		// _xZkqqHx_iLoJiMgA_xHqqkZx_A3_xZkqqHx_iCpAjDgPjIfOiBeC_xHqqkZx_ID=(_xZkqqHx_jFjEjFgJ_xHqqkZx_ID, AREA_RULED_SEL_ALL, -1, -1)_xZkqqHx_iBeC_xHqqkZx_
		AddEditHandle(	DBLRect(MM_A_LFT0(mmrtFrame), MM_A_BTM0(mmrtFrame), MM_A_LFT1(mmrtFrame), MM_A_BTM1(mmrtFrame)),
						FCHandleId(long(pObjTable->GetObjID()), AREA_RULED_SEL_ALL, -1, -1));

		//----- _xZkqqHx_jBfDiDfKiDiLjBeJjBpAjHmMiIoG_xHqqkZx_(B)_xZkqqHx_iCmMjDgPjIfO_xHqqkZx_ -----

		// _xZkqqHx_iLoJiMgA_xHqqkZx_B0_xZkqqHx_iCpAjDgPjIfOiBeC_xHqqkZx_ID=(_xZkqqHx_jFjEjFgJ_xHqqkZx_ID, AREA_CELL_SEL_ALL, -1, -1)_xZkqqHx_iBeC_xHqqkZx_
		AddEditHandle(	DBLRect(MM_B_LFT0(mmrtFrame), MM_B_TOP0(mmrtFrame), MM_B_LFT1(mmrtFrame), MM_B_TOP1(mmrtFrame)),
						FCHandleId(long(pObjTable->GetObjID()), AREA_CELL_SEL_ALL, -1, -1));

		// _xZkqqHx_iLoJiMgA_xHqqkZx_B1_xZkqqHx_iCpAjDgPjIfOiBeC_xHqqkZx_ID=(_xZkqqHx_jFjEjFgJ_xHqqkZx_ID, AREA_CELL_SEL_ALL, -1, -1)_xZkqqHx_iBeC_xHqqkZx_
		AddEditHandle(	DBLRect(MM_B_RIT0(mmrtFrame), MM_B_TOP0(mmrtFrame), MM_B_RIT1(mmrtFrame), MM_B_TOP1(mmrtFrame)),
						FCHandleId(long(pObjTable->GetObjID()), AREA_CELL_SEL_ALL, -1, -1));

		// _xZkqqHx_iLoJiMgA_xHqqkZx_B2_xZkqqHx_iCpAjDgPjIfOiBeC_xHqqkZx_ID=(_xZkqqHx_jFjEjFgJ_xHqqkZx_ID, AREA_CELL_SEL_ALL, -1, -1)_xZkqqHx_iBeC_xHqqkZx_
		AddEditHandle(	DBLRect(MM_B_RIT0(mmrtFrame), MM_B_BTM0(mmrtFrame), MM_B_RIT1(mmrtFrame), MM_B_BTM1(mmrtFrame)),
						FCHandleId(long(pObjTable->GetObjID()), AREA_CELL_SEL_ALL, -1, -1));

		// _xZkqqHx_iLoJiMgA_xHqqkZx_B3_xZkqqHx_iCpAjDgPjIfOiBeC_xHqqkZx_ID=(_xZkqqHx_jFjEjFgJ_xHqqkZx_ID, AREA_CELL_SEL_ALL, -1, -1)_xZkqqHx_iBeC_xHqqkZx_
		AddEditHandle(	DBLRect(MM_B_LFT0(mmrtFrame), MM_B_BTM0(mmrtFrame), MM_B_LFT1(mmrtFrame), MM_B_BTM1(mmrtFrame)),
						FCHandleId(long(pObjTable->GetObjID()), AREA_CELL_SEL_ALL, -1, -1));

		//----- _xZkqqHx_iMhCjApMjBeJjBpAjHmMiIoG_xHqqkZx_(C)_xZkqqHx_iCmMjDgPjIfO_xHqqkZx_ -----

		mmetol mmX;
		long lVertRuledIndex;
		for (lVertRuledIndex = 0;
			 pObjTable->GetVertRuledX(mmX, lVertRuledIndex);
			 lVertRuledIndex++)
		{
			// _xZkqqHx_iLoJiMgA_xHqqkZx_Cv(_xZkqqHx_iPoD_xHqqkZx_)_xZkqqHx_iCpAjDgPjIfOiBeC_xHqqkZx_ID=(_xZkqqHx_jFjEjFgJ_xHqqkZx_ID, AREA_RULED_SEL_VERT, lVertRuledIndex, -1)_xZkqqHx_iBeC_xHqqkZx_
			AddEditHandle(	DBLRect(mmX - mmEditRuledHandle,
									MM_A_TOP0(mmrtFrame),
									mmX + mmEditRuledHandle,
									MM_A_TOP1(mmrtFrame)),
							FCHandleId(long(pObjTable->GetObjID()), AREA_RULED_SEL_VERT, lVertRuledIndex, -1));
			// _xZkqqHx_iLoJiMgA_xHqqkZx_Cv(_xZkqqHx_iJlK_xHqqkZx_)_xZkqqHx_iCpAjDgPjIfOiBeC_xHqqkZx_ID=(_xZkqqHx_jFjEjFgJ_xHqqkZx_ID, AREA_RULED_SEL_VERT, lVertRuledIndex, -1)_xZkqqHx_iBeC_xHqqkZx_
			AddEditHandle(	DBLRect(mmX - mmEditRuledHandle,
									MM_A_BTM0(mmrtFrame),
									mmX + mmEditRuledHandle,
									MM_A_BTM1(mmrtFrame)),
							FCHandleId(long(pObjTable->GetObjID()), AREA_RULED_SEL_VERT, lVertRuledIndex, -1));
		}
		mmetol mmY;
		long lHorzRuledIndex;
		for (lHorzRuledIndex = 0;
			 pObjTable->GetHorzRuledY(mmY, lHorzRuledIndex);
			 lHorzRuledIndex++)
		{
			// _xZkqqHx_iLoJiMgA_xHqqkZx_Ch(_xZkqqHx_iNlG_xHqqkZx_)_xZkqqHx_iCpAjDgPjIfOiBeC_xHqqkZx_ID=(_xZkqqHx_jFjEjFgJ_xHqqkZx_ID, AREA_RULED_SEL_HORZ, lHorzRuledIndex, -1)_xZkqqHx_iBeC_xHqqkZx_
			AddEditHandle(	DBLRect(MM_A_LFT0(mmrtFrame),
									mmY - mmEditRuledHandle,
									MM_A_LFT1(mmrtFrame),
									mmY + mmEditRuledHandle),
							FCHandleId(long(pObjTable->GetObjID()), AREA_RULED_SEL_HORZ, lHorzRuledIndex, -1));
			// _xZkqqHx_iLoJiMgA_xHqqkZx_Ch(_xZkqqHx_iJeF_xHqqkZx_)_xZkqqHx_iCpAjDgPjIfOiBeC_xHqqkZx_ID=(_xZkqqHx_jFjEjFgJ_xHqqkZx_ID, AREA_RULED_SEL_HORZ, lHorzRuledIndex, -1)_xZkqqHx_iBeC_xHqqkZx_
			AddEditHandle(	DBLRect(MM_A_RIT0(mmrtFrame),
									mmY - mmEditRuledHandle,
									MM_A_RIT1(mmrtFrame),
									mmY + mmEditRuledHandle),
							FCHandleId(long(pObjTable->GetObjID()), AREA_RULED_SEL_HORZ, lHorzRuledIndex, -1));
		}

		//----- _xZkqqHx_iMhCjApMiInKjDkOjHmMiIoG_xHqqkZx_(D)_xZkqqHx_iCmMjDgPjIfO_xHqqkZx_ -----

		for (lVertRuledIndex = 0;
			 pObjTable->GetVertRuledX(mmX, lVertRuledIndex);
			 lVertRuledIndex++)
		{
			// _xZkqqHx_iNlGjCfLiCmMjAiCjClMiMhCjApMiCmNiInKjDkOiDeHiDiKiDeBiCkKjGlDiCkCiBeC_xHqqkZx_
			if (lVertRuledIndex == 0) continue;
			// _xZkqqHx_jApMjFkK_xHqqkZx_Dv(_xZkqqHx_iPoD_xHqqkZx_)_xZkqqHx_iCpAjDgPjIfOiBeC_xHqqkZx_ID=(_xZkqqHx_jFjEjFgJ_xHqqkZx_ID, AREA_RULED_MOVE_VERT, lVertRuledIndex, -1)_xZkqqHx_iBeC_xHqqkZx_
			AddEditHandle(	DBLShortLine(mmX, MM_B_TOP0(mmrtFrame), mmX, MM_B_TOP1(mmrtFrame)),
							FCHandleId(long(pObjTable->GetObjID()), AREA_RULED_MOVE_VERT, lVertRuledIndex, -1));
			// _xZkqqHx_jApMjFkK_xHqqkZx_Dv(_xZkqqHx_iJlK_xHqqkZx_)_xZkqqHx_iCpAjDgPjIfOiBeC_xHqqkZx_ID=(_xZkqqHx_jFjEjFgJ_xHqqkZx_ID, AREA_RULED_MOVE_VERT, lVertRuledIndex, -1)_xZkqqHx_iBeC_xHqqkZx_
			AddEditHandle(	DBLShortLine(mmX, MM_B_BTM0(mmrtFrame), mmX, MM_B_BTM1(mmrtFrame)),
							FCHandleId(long(pObjTable->GetObjID()), AREA_RULED_MOVE_VERT, lVertRuledIndex, -1));
		}
		for (lHorzRuledIndex = 0;
			 pObjTable->GetHorzRuledY(mmY, lHorzRuledIndex);
			 lHorzRuledIndex++)
		{
			// _xZkqqHx_iPoDjCfLiCmMjAiFjFlNiMhCjApMiCmNiInKjDkOiDeHiDiKiDeBiCkKjGlDiCkCiBeC_xHqqkZx_
			if (lHorzRuledIndex == 0) continue;
			// _xZkqqHx_jApMjFkK_xHqqkZx_Dh(_xZkqqHx_iNlG_xHqqkZx_)_xZkqqHx_iCpAjDgPjIfOiBeC_xHqqkZx_ID=(_xZkqqHx_jFjEjFgJ_xHqqkZx_ID, AREA_RULED_MOVE_HORZ, lHorzRuledIndex, -1)_xZkqqHx_iBeC_xHqqkZx_
			AddEditHandle(	DBLShortLine(MM_B_LFT0(mmrtFrame), mmY, MM_B_LFT1(mmrtFrame), mmY),
							FCHandleId(long(pObjTable->GetObjID()), AREA_RULED_MOVE_HORZ, lHorzRuledIndex, -1));
			// _xZkqqHx_jApMjFkK_xHqqkZx_Dh(_xZkqqHx_iJeF_xHqqkZx_)_xZkqqHx_iCpAjDgPjIfOiBeC_xHqqkZx_ID=(_xZkqqHx_jFjEjFgJ_xHqqkZx_ID, AREA_RULED_MOVE_HORZ, lHorzRuledIndex, -1)_xZkqqHx_iBeC_xHqqkZx_
			AddEditHandle(	DBLShortLine(MM_B_RIT0(mmrtFrame), mmY, MM_B_RIT1(mmrtFrame), mmY),
							FCHandleId(long(pObjTable->GetObjID()), AREA_RULED_MOVE_HORZ, lHorzRuledIndex, -1));
		}

		//----- _xZkqqHx_iDfKiDiLjBeJjBpAjHmMiIoG_xHqqkZx_(E)_xZkqqHx_iCmMjDgPjIfO_xHqqkZx_ -----

		// _xZkqqHx_jBfDjHpBiCmMiNlGiMhCjApMiBeFiJeFiMhCjApMiCmMiNmAjFfHiDfKiDgCiDgHiCpAiOfKiPgPiBeC_xHqqkZx_
		vector< pair<mmetol, mmetol> > vLeftRight;
		pObjTable->CalcColumnLeftRightArray(vLeftRight);
		// _xZkqqHx_jBfDiNhDiCmMiPoDiMhCjApMiBeFiJlKiMhCjApMiCmMiNmAjFfHiDfKiDgCiDgHiCpAiOfKiPgPiBeC_xHqqkZx_
		vector< pair<mmetol, mmetol> > vTopBottom;
		pObjTable->CalcLineTopBottomArray(vTopBottom);

		long lColumnIndex;
		for (lColumnIndex = 0; lColumnIndex != vLeftRight.size(); lColumnIndex++)
		{
			// _xZkqqHx_iLoJiMgA_xHqqkZx_Eh(_xZkqqHx_iPoD_xHqqkZx_)_xZkqqHx_iCpAjDgPjIfOiBeC_xHqqkZx_ID=(_xZkqqHx_jFjEjFgJ_xHqqkZx_ID, AREA_CELL_SEL_COLUMN, lColumnIndex, -1)_xZkqqHx_iBeC_xHqqkZx_
			AddEditHandle(	DBLRect(vLeftRight[lColumnIndex].first,
									MM_B_TOP0(mmrtFrame),
									vLeftRight[lColumnIndex].second,
									MM_B_TOP1(mmrtFrame)),
							FCHandleId(long(pObjTable->GetObjID()), AREA_CELL_SEL_COLUMN, -1, lColumnIndex));
			// _xZkqqHx_iLoJiMgA_xHqqkZx_Eh(_xZkqqHx_iJlK_xHqqkZx_)_xZkqqHx_iCpAjDgPjIfOiBeC_xHqqkZx_ID=(_xZkqqHx_jFjEjFgJ_xHqqkZx_ID, AREA_CELL_SEL_COLUMN, lColumnIndex, -1)_xZkqqHx_iBeC_xHqqkZx_
			AddEditHandle(	DBLRect(vLeftRight[lColumnIndex].first,
									MM_B_BTM0(mmrtFrame),
									vLeftRight[lColumnIndex].second,
									MM_B_BTM1(mmrtFrame)),
							FCHandleId(long(pObjTable->GetObjID()), AREA_CELL_SEL_COLUMN, -1, lColumnIndex));
		}

		long lLineIndex;
		for (lLineIndex = 0; lLineIndex != vTopBottom.size(); lLineIndex++)
		{
			// _xZkqqHx_iLoJiMgA_xHqqkZx_Ev(_xZkqqHx_iNlG_xHqqkZx_)_xZkqqHx_iCpAjDgPjIfOiBeC_xHqqkZx_ID=(_xZkqqHx_jFjEjFgJ_xHqqkZx_ID, AREA_CELL_SEL_LINE, lLineIndex, -1)_xZkqqHx_iBeC_xHqqkZx_
			AddEditHandle(	DBLRect(MM_B_LFT0(mmrtFrame),
									vTopBottom[lLineIndex].first,
									MM_B_LFT1(mmrtFrame),
									vTopBottom[lLineIndex].second),
							FCHandleId(long(pObjTable->GetObjID()), AREA_CELL_SEL_LINE, lLineIndex, -1));
			// _xZkqqHx_iLoJiMgA_xHqqkZx_Ev(_xZkqqHx_iJeF_xHqqkZx_)_xZkqqHx_iCpAjDgPjIfOiBeC_xHqqkZx_ID=(_xZkqqHx_jFjEjFgJ_xHqqkZx_ID, AREA_CELL_SEL_LINE, lLineIndex, -1)_xZkqqHx_iBeC_xHqqkZx_
			AddEditHandle(	DBLRect(MM_B_RIT0(mmrtFrame),
									vTopBottom[lLineIndex].first,
									MM_B_RIT1(mmrtFrame),
									vTopBottom[lLineIndex].second),
							FCHandleId(long(pObjTable->GetObjID()), AREA_CELL_SEL_LINE, lLineIndex, -1));
		}

		//----- _xZkqqHx_iMhCjApM_xHqqkZx_(F)_xZkqqHx_iCmMjDgPjIfO_xHqqkZx_ -----

		for (lVertRuledIndex = 0;
			 pObjTable->GetVertRuledX(mmX, lVertRuledIndex);
			 lVertRuledIndex++)
		{
			for (lLineIndex = 0; lLineIndex != vTopBottom.size(); lLineIndex++)
			{
				// _xZkqqHx_iMhCjApMiCkKjBlGiNnNiClFiCmIiCkCiPoKiNiHiCmNiDfIiDeMiDgCiDhGiBeC_xHqqkZx_
				if (pObjTable->GetRuled(FALSE, FCFrontSide(lVertRuledIndex, lLineIndex)) == NULL) continue;
				// _xZkqqHx_iMhCjApM_xHqqkZx_Fv_xZkqqHx_iCpAjDgPjIfOiBeC_xHqqkZx_ID=(_xZkqqHx_jFjEjFgJ_xHqqkZx_ID, AREA_RULED_SEL_MATRIX_VERT, lVertRuledIndex, lLineIndex)_xZkqqHx_iBeC_xHqqkZx_
				AddEditHandle(	DBLShortLine(mmX, vTopBottom[lLineIndex].first, mmX, vTopBottom[lLineIndex].second),
								FCHandleId(long(pObjTable->GetObjID()), AREA_RULED_SEL_MATRIX_VERT, lVertRuledIndex, lLineIndex));
			}
		}

		for (lHorzRuledIndex = 0;
			 pObjTable->GetHorzRuledY(mmY, lHorzRuledIndex);
			 lHorzRuledIndex++)
		{
			for (lColumnIndex = 0; lColumnIndex != vLeftRight.size(); lColumnIndex++)
			{
				// _xZkqqHx_iMhCjApMiCkKjBlGiNnNiClFiCmIiCkCiPoKiNiHiCmNiDfIiDeMiDgCiDhGiBeC_xHqqkZx_
				if (pObjTable->GetRuled(TRUE, FCFrontSide(lHorzRuledIndex, lColumnIndex)) == NULL) continue;
				// _xZkqqHx_iMhCjApM_xHqqkZx_Fh_xZkqqHx_iCpAjDgPjIfOiBeC_xHqqkZx_ID=(_xZkqqHx_jFjEjFgJ_xHqqkZx_ID, AREA_RULED_SEL_MATRIX_HORZ, lHorzRuledIndex, lColumnIndex)_xZkqqHx_iBeC_xHqqkZx_
				AddEditHandle(	DBLShortLine(vLeftRight[lColumnIndex].first, mmY, vLeftRight[lColumnIndex].second, mmY),
								FCHandleId(long(pObjTable->GetObjID()), AREA_RULED_SEL_MATRIX_HORZ, lHorzRuledIndex, lColumnIndex));
			}
		}

		//----- _xZkqqHx_iDfKiDiL_xHqqkZx_(G)_xZkqqHx_iCmMjDgPjIfO_xHqqkZx_ -----

		for (lLineIndex = 0; lLineIndex != vTopBottom.size(); lLineIndex++)
		{
			for (lColumnIndex = 0; lColumnIndex != vLeftRight.size(); lColumnIndex++)
			{
				// _xZkqqHx_iDfKiDiLiCkKjBlGiNnNiClFiCmIiCkCiPoKiNiHiCmNiDfIiDeMiDgCiDhGiBeC_xHqqkZx_
				if (pObjTable->GetCell(FCLineColumn(lLineIndex, lColumnIndex)) == NULL) continue;
				// _xZkqqHx_iClBiCmMiDfKiDiLiCmMjEmNiImNiCpAiOoGjDlOiBeC_xHqqkZx_
				FCLineColumn cellIndexUntil;
				pObjTable->GetCellBlock(FCLineColumn(lLineIndex, lColumnIndex), NULL, &cellIndexUntil);
				// _xZkqqHx_iDfKiDiL_xHqqkZx_G_xZkqqHx_iCpAjDgPjIfOiBeC_xHqqkZx_ID=(_xZkqqHx_jFjEjFgJ_xHqqkZx_ID, AREA_CELL_SEL_MATRIX, lLineIndex, lColumnIndex)_xZkqqHx_iBeC_xHqqkZx_
				AddEditHandle(	DBLRect(vLeftRight[lColumnIndex].first,
										vTopBottom[lLineIndex].first,
										vLeftRight[cellIndexUntil.GetColumnIndex()].second,
										vTopBottom[cellIndexUntil.GetLineIndex()].second),
								FCHandleId(long(pObjTable->GetObjID()), AREA_CELL_SEL_MATRIX, lLineIndex, lColumnIndex));
			}
		}
	}
} // FCToolTableEdit::ResetEditHandleList.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolTableEdit::IsIntersectXXX
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iOhHjCoIiClDiCoKiClN_xHqqkZx_XXX_xZkqqHx_iDeJiDhFiDfHiDeGiDeOiDgHiCkKiBeBiOhHjCoIiClDiCoKiClNiNmAjFfHiCmGiMpAiNlHiClHiCoJiCkJjClCiNlIiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	pObj	:XXX_xZkqqHx_iDeJiDhFiDfHiDeGiDeOiDgHiCpAiOhHjCoIiBeC_xHqqkZx_
 *			mmpt	:_xZkqqHx_iNmAjFfHiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jFnEjCgM_xHqqkZx_>	_xZkqqHx_iMpAiNlHiClHiCoJiPoKiNiHiCmN_xHqqkZx_TRUE_xZkqqHx_iBeC_xHqqkZx_
 *
 * <_xZkqqHx_iJpAjAoA_xHqqkZx_>	FCToolBaseEdit::BASE_CLASS::IsIntersectXXX _xZkqqHx_iCmMiDeDiDjDiDhGiDiKiDiBiDjDiDgHiCmFiCkAiCoJ_xHqqkZx_
 *			_xZkqqHx_iClBiCmGiCmJjCiNiInDiBeC_xHqqkZx_
 *			_xZkqqHx_iDfGiDhEiDgHiDeMiBfLiCpAiJjPiClFiCmIiCkKiCoHiBeBjBeJjBpAiNmPiCnNiCmMjFfMjFjEjFgJiCpAiDeOiDiKiDgCiDeOiClFiCmE_xHqqkZx_
 *			_xZkqqHx_jFnCiPfHjBmOiPnLiCkJiCoHiJpAiPjMiClFiClNiCkCiPoKiNiHiBeBjFfMjFjEjFgJiCmMiDiBiDjDiDgPiBfLjFjEjFgJiCpA_xHqqkZx_
 *			_xZkqqHx_iDeOiDiKiDgCiDeOiClFiCmEiCoAiBeBiClLiCmMiDiBiDjDiDgPiBfLiCkKjFnCiPfHjBmOiPnLiCmGiClFiCmEjBeJjBpAiClDiCoKiCmEiClFiCnMiCkEiBeC_xHqqkZx_
 *			_xZkqqHx_jBeJjBpAiNmPiCnNiCmMjFfMjFjEjFgJiCmMiPoKiNiHiBeBiKePjBkEiCmJiDhEiDiMiBfLiDiAiCkKjFfMiOkGiClDiCoKiCmEiCkCiCoJiCmMiCmFiBeB_xHqqkZx_
 *			_xZkqqHx_iDhEiDiMiBfLiDiAiCpAiDeOiDiKiDgCiDeOiClHiCoJiClBiCmGiCmFjFnCiPfHjBmOiPnLiCkJiCoHiJpAiPjMiClDiCoKiCoJiCoGiCkEiCmJiBeB_xHqqkZx_
 *			_xZkqqHx_iClBiCmMiKnGjAjEiCmFjFjEjFgJiMpAiNlHiCmMiPiIjHjNiCpAjClCjAkOiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	05.06.11 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
BOOL FCToolTableEdit::IsIntersectXXX (XXX_EditObjDynabase, FCObjDynabase* pObj, const DBLPoint& mmpt) const
{
	// _xZkqqHx_jBeJjBpAiNmPiCnNiCmN_xHqqkZx_ IsSelectedXXX(XXX_EDIT_OBJ_BASE, pObj) _xZkqqHx_iCmFjClCiCnHiClNiCkCiCkKiBeB_xHqqkZx_
	// _xZkqqHx_iDfCiDjDiDhAiDeDiDiJiCkK_xHqqkZx_ XXX_EDIT_OBJ_BASE _xZkqqHx_iCmG_xHqqkZx_ XXX_OBJ_BASE _xZkqqHx_iCmMiIoBiCkCiCpA_xHqqkZx_
	// _xZkqqHx_iCkEiCnMiCkNjEeGiOkPiCmFiCkLiCmIiCkCiClNiCnPiBeB_xHqqkZx_View::IsSelectObj _xZkqqHx_iCpAiOgHiCkEiBeC_xHqqkZx_
	if (g_pView->IsSelectObj(pObj))
	//----- _xZkqqHx_jBeJjBpAiNmPiCnNiCmMjFfMjFjEjFgJiCmMiPoKiNiH_xHqqkZx_ -----
	{
		// _xZkqqHx_jFfMjFjEjFgJiCmMjIgHjApMiCmGiCmMiLjHjHkDiCkK_xHqqkZx_ mmMargin _xZkqqHx_iImIjDoAiCmFiCkAiCoKiCmO_xHqqkZx_TRUE_xZkqqHx_iBeC_xHqqkZx_
		const mmetol mmMargin = lg2mm(FD_TABLE_EDIT_MARGIN);
		if (pObj->GetResizeFrame().ExtendRect(mmMargin).PtInRect(mmpt) &&
			!pObj->GetResizeFrame().ReduceRect(mmMargin).PtInRect(mmpt))
			return TRUE;
	}
	return pObj->IsIntersect(mmpt, FALSE);
} // FCToolTableEdit::IsIntersectXXX.
